#include "rt_config.h"


/* 
 * generate ADDBA request to 
 * set up BA agreement
 */
VOID BAOriSessionSetUp(
			IN PRTMP_ADAPTER    pAd, 
			IN MAC_TABLE_ENTRY	*pEntry,
			IN UCHAR			TID,
			IN USHORT			TimeOut,
					  IN ULONG            DelayTime,
					  IN BOOLEAN          isForced)

{
	//MLME_ADDBA_REQ_STRUCT	AddbaReq;
//	BA_ORI_ENTRY			*pBAEntry = NULL;
//	USHORT					Idx;
//	BOOLEAN					Cancelled;
	UCHAR					nMSDU=64;
	MLME_ADDBA_REQ_STRUCT	AddbaReq;
	
	if ((pAd->CommonCfg.BACapability.field.AutoBA != TRUE)  &&  (isForced == FALSE)) //(pAd->CommonCfg.BACapability.field.Policy != BA_NOTUSE)
		return;

	if(TID >= NUM_OF_TID)
	{
		DBGPRINT(RT_DEBUG_TRACE, ("break on invalid TID.----:%d\n", TID));
		return; //Invalid argument;
	}

	// As ad-hoc mode, BA pair is not limited to only BSSID. so add via OID.
	// in ad hoc mode, when adding BA pair, we should insert this entry into MACEntry too
	// pEntry = MacTableLookup(pAd, mac);
	if (!pEntry)
	{
		DBGPRINT(RT_DEBUG_TRACE, ("break on no connection.\n"));
		return; //Invalid argument;
	}

	NdisZeroMemory(&AddbaReq, sizeof(AddbaReq));
	if (pEntry->bIAmBadAtheros == TRUE)
		pEntry->BaSizeInUse = 0x10;

	if (pAd->CommonCfg.IOTestParm.bNextDisableRxBA == TRUE)
	{
		if ((pEntry->bIAmBadAtheros == TRUE))
		{
			CLIENT_STATUS_SET_FLAG(pEntry, fCLIENT_STATUS_AMSDU_INUSED);
		}
		else
		{
			BATableInsertEntry(pAd, pEntry->Aid, 0, 0x0, TID, nMSDU, Originator_WaitRes,FALSE);
			AddbaReq.BaBufSize = ( (nMSDU <= 64)? nMSDU : pEntry->BaSizeInUse);
			DBGPRINT(RT_DEBUG_TRACE, (" Size of MSDU Buffer : %d\n", nMSDU));
		}

	}
	else if ((nMSDU != pEntry->BaSizeInUse) && (nMSDU <= 64))
	{
		BATableInsertEntry(pAd, pEntry->Aid, 0, 0x0, TID, nMSDU, Originator_WaitRes, FALSE);
		AddbaReq.BaBufSize = nMSDU;
	}
	else
	{
		BATableInsertEntry(pAd, pEntry->Aid, 0, 0x0, TID, pEntry->BaSizeInUse, Originator_WaitRes, FALSE);
		AddbaReq.BaBufSize = pEntry->BaSizeInUse;
	}
	COPY_MAC_ADDR(AddbaReq.pAddr, pEntry->Addr);
	AddbaReq.Wcid = (UCHAR)(pEntry->Aid);
	AddbaReq.TID = TID;
	AddbaReq.TimeOutValue = 0;
	AddbaReq.Token = 1;
	MlmeEnqueue(pAd, ACTION_STATE_MACHINE, MT2_MLME_ADD_BA_CATE, sizeof(MLME_ADDBA_REQ_STRUCT), (PVOID)&AddbaReq);
	RTUSBCMDUp(pAd);
	return;
}

VOID BAOriSessionTearDown(
	IN OUT	PRTMP_ADAPTER	pAd, 
	IN		UCHAR			Wcid,
	IN		UCHAR			TID,
						 IN      BOOLEAN         bPassive,
						 IN      BOOLEAN         bForceSend)
{
	BOOLEAN			bALL=FALSE;

	if ((pAd->CommonCfg.BACapability.field.Policy != BA_NOTUSE) && (pAd->CommonCfg.BACapability.field.AutoBA == 0))
	{
		if (TID > NUM_OF_TID)
		{				
			DBGPRINT(RT_DEBUG_TRACE, ("break on invalid TID.----:%d\n", TID));
			return; //Invalid argument;
		}

		if (TID == NUM_OF_TID)	// tear all down
			bALL = TRUE;
		
//		if ((pEntry->Sst == SST_ASSOC))
//		{
//			BATableTearORIEntry( pAd, TID, Wcid, FALSE, bALL);
//		}
//		else 
		if (INFRA_ON(pAd) && (pAd->OpMode == OPMODE_STA))
		{
			BATableTearORIEntry( pAd, TID, Wcid, FALSE, bALL);
		}
		else
		{
			BATableTearORIEntry( pAd, TID, Wcid, TRUE, bALL);
		}
	}
	return;
}

VOID BARecSessionTearDown(
	IN OUT	PRTMP_ADAPTER	pAd, 
	IN		UCHAR			Wcid,
	IN		UCHAR			TID,
	IN		BOOLEAN			bPassive)
{
	BOOLEAN			bALL=FALSE;

	if ((pAd->CommonCfg.BACapability.field.Policy != BA_NOTUSE) && (pAd->CommonCfg.BACapability.field.AutoBA == 0))
	{
		if (TID > NUM_OF_TID)
		{				
			DBGPRINT(RT_DEBUG_TRACE, ("break on invalid TID.----:%d\n", TID));
			return; //Invalid argument;
		}
	
		if (TID == NUM_OF_TID)	// tear all down
			bALL = TRUE;

		BATableTearRECEntry( pAd, TID, Wcid, bALL);
	}
	return;
}
