/*
 ***************************************************************************
 * Ralink Tech Inc.
 * 4F, No. 2 Technology	5th	Rd.
 * Science-based Industrial	Park
 * Hsin-chu, Taiwan, R.O.C.
 *
 * (c) Copyright 2002-2005, Ralink Technology, Inc.
 *
 * All rights reserved.	Ralink's source	code is	an unpublished work	and	the
 * use of a	copyright notice does not imply	otherwise. This	source code
 * contains	confidential trade secret material of Ralink Tech. Any attemp
 * or participation	in deciphering,	decoding, reverse engineering or in	any
 * way altering	the	source code	is stricitly prohibited, unless	the	prior
 * written consent of Ralink Technology, Inc. is obtained.
 ***************************************************************************

    Module Name:
    rtmp_main.c

    Abstract:
    main initialization routines

    Revision History:
    Who         When            What
    --------    ----------      ----------------------------------------------
    Name        Date            Modification logs
    Jan Lee		01-10-2005	    modified
*/

#include "rt_config.h"

//ULONG	RTDebugLevel = RT_DEBUG_TRACE;	// move to rt_linux.c


// Following information will be show when you run 'modinfo'
// *** If you have a solution for the bug in current version of driver, please mail to me.
// Otherwise post to forum in ralinktech's web site(www.ralinktech.com) and let all users help you. ***
MODULE_AUTHOR("Paul Lin <paul_lin@ralinktech.com>");
MODULE_DESCRIPTION("RT2870 Wireless Lan Linux Driver");


/* Kernel thread and vars, which handles packets that are completed. Only
 * packets that have a "complete" function are sent here. This way, the
 * completion is run out of kernel context, and doesn't block the rest of
 * the stack. */
static int mlme_kill;
static int RTUSBCmd_kill;

extern	const struct iw_handler_def rt_iw_handler_def;


/* module table */
struct usb_device_id    rtusb_usb_id[] = RT2870_USB_DEVICES;
INT const               rtusb_usb_id_len = sizeof(rtusb_usb_id) / sizeof(struct usb_device_id);   
MODULE_DEVICE_TABLE(usb, rtusb_usb_id);

#ifndef PF_NOFREEZE
#define PF_NOFREEZE  0
#endif


/**************************************************************************/
/**************************************************************************/
//tested for kernel 2.4 series
/**************************************************************************/
/**************************************************************************/
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)

static void rtusb_disconnect(struct usb_device *dev, void *ptr);
static void *rtusb_probe(struct usb_device *dev, UINT interface,
						const struct usb_device_id *id_table);
						
struct usb_driver rtusb_driver = {
		name:"rt2870",
		probe:rtusb_probe,
		disconnect:rtusb_disconnect,
		id_table:rtusb_usb_id,
	};
	
#else
/**************************************************************************/
/**************************************************************************/
//tested for kernel 2.6series
/**************************************************************************/
/**************************************************************************/
static int rtusb_probe (struct usb_interface *intf,
						const struct usb_device_id *id);
static void rtusb_disconnect(struct usb_interface *intf);

struct usb_driver rtusb_driver = {
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,15)
	.owner = THIS_MODULE,
#endif	
	.name="rt2870",
	.probe=rtusb_probe,
	.disconnect=rtusb_disconnect,
	.id_table=rtusb_usb_id,
	};


#endif

// Init driver module
INT __init rtusb_init(void)
{
	printk("rtusb init --->\n");   
	return usb_register(&rtusb_driver);
}

// Deinit driver module
VOID __exit rtusb_exit(void)
{
	usb_deregister(&rtusb_driver);	
	printk("<--- rtusb exit\n");
}
module_init(rtusb_init);
module_exit(rtusb_exit);



/*---------------------------------------------------------------------	*/
/* function declarations												*/
/*---------------------------------------------------------------------	*/
struct net_device_stats *rtusb_get_ether_stats(IN struct net_device *net_dev);
#if ((WIRELESS_EXT >= 12) && (WIRELESS_EXT <= 20 ))
struct iw_statistics *rtusb_get_wireless_stats(IN struct net_device *net_dev);
#endif
static int rtusb_open(IN struct net_device *net_dev);
static int rtusb_close(IN struct net_device *net_dev);
static void rt2870_init(IN struct net_device *net_dev);

struct net_device_stats *rtusb_get_ether_stats(IN struct net_device *net_dev)
{
	PRTMP_ADAPTER pAd = (PRTMP_ADAPTER) net_dev->priv;

	DBGPRINT(RT_DEBUG_INFO, ("rtusb_get_ether_stats --->\n"));

	pAd->stats.rx_packets = pAd->WlanCounters.ReceivedFragmentCount.LowPart;        // total packets received
	pAd->stats.tx_packets = pAd->WlanCounters.TransmittedFragmentCount.LowPart;     // total packets transmitted

	pAd->stats.rx_bytes= pAd->RalinkCounters.ReceivedByteCount;             // total bytes received
	pAd->stats.tx_bytes = pAd->RalinkCounters.TransmittedByteCount;         // total bytes transmitted

	pAd->stats.rx_errors = pAd->Counters8023.RxErrors;                      // bad packets received
	pAd->stats.tx_errors = pAd->Counters8023.TxErrors;                      // packet transmit problems

	pAd->stats.rx_dropped = pAd->Counters8023.RxNoBuffer;                   // no space in linux buffers
	pAd->stats.tx_dropped = pAd->WlanCounters.FailedCount.LowPart;                  // no space available in linux

	pAd->stats.multicast = pAd->WlanCounters.MulticastReceivedFrameCount.LowPart;   // multicast packets received
	pAd->stats.collisions = pAd->Counters8023.OneCollision + pAd->Counters8023.MoreCollisions;  // Collision packets

	pAd->stats.rx_length_errors = 0;
	pAd->stats.rx_over_errors = pAd->Counters8023.RxNoBuffer;               // receiver ring buff overflow
	pAd->stats.rx_crc_errors = 0;//pAd->WlanCounters.FCSErrorCount;         // recved pkt with crc error
	pAd->stats.rx_frame_errors = pAd->Counters8023.RcvAlignmentErrors;      // recv'd frame alignment error
	pAd->stats.rx_fifo_errors = pAd->Counters8023.RxNoBuffer;               // recv'r fifo overrun
	pAd->stats.rx_missed_errors = 0;                                        // receiver missed packet

	// detailed tx_errors
	pAd->stats.tx_aborted_errors = 0;
	pAd->stats.tx_carrier_errors = 0;
	pAd->stats.tx_fifo_errors = 0;
	pAd->stats.tx_heartbeat_errors = 0;
	pAd->stats.tx_window_errors = 0;

	// for cslip etc
	pAd->stats.rx_compressed = 0;
	pAd->stats.tx_compressed = 0;
   
	return &pAd->stats;
}

#if ((WIRELESS_EXT >= 12) && (WIRELESS_EXT <= 20 ))
// This function will be called when query /proc
struct iw_statistics *rtusb_get_wireless_stats(IN struct net_device *net_dev)
{
	PRTMP_ADAPTER pAd = (PRTMP_ADAPTER) net_dev->priv;
	UCHAR		R66;
	
	DBGPRINT(RT_DEBUG_TRACE, ("rtusb_get_wireless_stats --->\n"));
	
	// TODO: All elements are zero before be implemented

	pAd->iw_stats.status = 0;   // Status - device dependent for now

	pAd->iw_stats.qual.qual = pAd->Mlme.ChannelQuality; // link quality (%retries, SNR, %missed beacons or better...)

	// signal level (dBm)
#if 0
	pAd->iw_stats.qual.level = abs(pAd->StaCfg.LastRssi);
	pAd->iw_stats.qual.level += 256 - pAd->BbpRssiToDbmDelta;
#else
	pAd->iw_stats.qual.level = pAd->StaCfg.LastRssi - (CHAR)pAd->BbpRssiToDbmDelta;
#endif
	RTUSBReadBBPRegister(pAd, BBP_R66, &R66);
	pAd->iw_stats.qual.noise = R66; // noise level (dBm)
	
	pAd->iw_stats.qual.noise += 256 - 143;
	pAd->iw_stats.qual.updated = 1;     // Flags to know if updated

	pAd->iw_stats.discard.nwid = 0;     // Rx : Wrong nwid/essid
	pAd->iw_stats.miss.beacon = 0;      // Missed beacons/superframe
	
	// pAd->iw_stats.discard.code, discard.fragment, discard.retries, discard.misc has counted in other place

	return &pAd->iw_stats;
}
#endif

INT MlmeThread(
	IN void * Context)
{
	PRTMP_ADAPTER	pAd = (PRTMP_ADAPTER)Context;

#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,5,0)
	daemonize("rt2870");
	allow_signal(SIGTERM);
#else
	daemonize();
#endif
	current->flags |= PF_NOFREEZE;
	/* signal that we've started the thread */
	complete(&(pAd->notify));

	while (1)
	{
		if (mlme_kill == 1)
			break;
			
		/* lock the device pointers */
		down(&(pAd->mlme_semaphore));
			
		/* lock the device pointers , need to check if required*/
		down(&(pAd->usbdev_semaphore));
		
		MlmeHandler(pAd);		

		/* unlock the device pointers */
		up(&(pAd->usbdev_semaphore));
	}

	/* notify the exit routine that we're actually exiting now 
	 *
	 * complete()/wait_for_completion() is similar to up()/down(),
	 * except that complete() is safe in the case where the structure
	 * is getting deleted in a parallel mode of execution (i.e. just
	 * after the down() -- that's necessary for the thread-shutdown
	 * case.
	 *
	 * complete_and_exit() goes even further than this -- it is safe in
	 * the case that the thread of the caller is going away (not just
	 * the structure) -- this is necessary for the module-remove case.
	 * This is important in preemption kernels, which transfer the flow
	 * of execution immediately upon a complete().
	 */
	complete_and_exit (&pAd->notify, 0);
	DBGPRINT(RT_DEBUG_TRACE, ("<---MlmeThread\n"));
	return 0;

}

INT RTUSBCmdThread(
	IN void * Context)
{
	PRTMP_ADAPTER	pAd = (PRTMP_ADAPTER)Context;

	
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,5,0)
	daemonize("rt2870");
	allow_signal(SIGTERM);
#else
	daemonize();
#endif	
	current->flags |= PF_NOFREEZE;
	/* signal that we've started the thread */
	complete(&(pAd->notify));

	while (1)
	{
		if (RTUSBCmd_kill == 1)	
			break;
			
		/* lock the device pointers */
		down(&(pAd->RTUSBCmd_semaphore));

		/* lock the device pointers , need to check if required*/
		down(&(pAd->usbdev_semaphore));

		CMDHandler(pAd);		

		/* unlock the device pointers */
		up(&(pAd->usbdev_semaphore));
	}

	/* notify the exit routine that we're actually exiting now 
	 *
	 * complete()/wait_for_completion() is similar to up()/down(),
	 * except that complete() is safe in the case where the structure
	 * is getting deleted in a parallel mode of execution (i.e. just
	 * after the down() -- that's necessary for the thread-shutdown
	 * case.
	 *
	 * complete_and_exit() goes even further than this -- it is safe in
	 * the case that the thread of the caller is going away (not just
	 * the structure) -- this is necessary for the module-remove case.
	 * This is important in preemption kernels, which transfer the flow
	 * of execution immediately upon a complete().
	 */
	complete_and_exit (&pAd->notify, 0);
	DBGPRINT(RT_DEBUG_TRACE,( "<---RTUSBCmdThread\n"));
	return 0;

}

VOID RTMPHalt(
	IN	PRTMP_ADAPTER	pAd)
{
	MLME_DISASSOC_REQ_STRUCT	DisReq;
	MLME_QUEUE_ELEM				MsgElem;
//	UCHAR						i;
	BOOLEAN						Cancelled;
	INT							ret;
	POS_COOKIE					pObj = (POS_COOKIE) pAd->OS_Cookie;
	
	DBGPRINT(RT_DEBUG_TRACE, ("====> RTMPHalt\n"));

	//
	// before set flag fRTMP_ADAPTER_HALT_IN_PROGRESS, 
	// we should send a disassoc frame to our AP.
	//
	if (!RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_NIC_NOT_EXIST))
	{
		if (INFRA_ON(pAd)) 
		{
			COPY_MAC_ADDR(DisReq.Addr, pAd->CommonCfg.Bssid);
			DisReq.Reason =  REASON_DEAUTH_STA_LEAVING;

			MsgElem.Machine = ASSOC_STATE_MACHINE;
			MsgElem.MsgType = MT2_MLME_DISASSOC_REQ;
			MsgElem.MsgLen = sizeof(MLME_DISASSOC_REQ_STRUCT);
			NdisMoveMemory(MsgElem.Msg, &DisReq, sizeof(MLME_DISASSOC_REQ_STRUCT));

			MlmeDisassocReqAction(pAd, &MsgElem);
			NdisMSleep(1000);
		}

		//
		// Patch to fully turn off BBP, need to send a fake NULL frame.
		//
		/*RTUSBWriteMACRegister(pAd, MAC_CSR10, 0x0018);
		for (i=0; i<10; i++)
		{
			RTMPSendNullFrame(pAd, RATE_6);
			NdisMSleep(1000);
		}*/
	
		// disable BEACON generation and other BEACON related hardware timers
		AsicDisableSync(pAd);
		RTMPSetLED(pAd, LED_HALT);
	}
	
	RTMP_SET_FLAG(pAd, fRTMP_ADAPTER_HALT_IN_PROGRESS);

	RTUSBCleanUpMLMEWaitQueue(pAd);
	RTUSBCleanUpMLMEBulkOutQueue(pAd);

#ifdef CCX_SUPPORT
	RTMPCancelTimer(&pAd->StaCfg.LeapAuthTimer, &Cancelled);
#endif
	RTMPCancelTimer(&pAd->StaCfg.StaQuickResponeForRateUpTimer, &Cancelled);
	RTMPCancelTimer(&pAd->RxAnt.RxAntDiversityTimer, &Cancelled);

	// Free MLME stuff
	MlmeHalt(pAd);

	// Sleep 50 milliseconds so pending io might finish normally
	NdisMSleep(50000);

	// We want to wait until all pending receives and sends to the
	// device object. We cancel any
	// irps. Wait until sends and receives have stopped.
	//
	RTUSBCancelPendingIRPs(pAd);


	//
	// Terminate Threads
	//
	if (pObj->MLMEThr_pid >= 0) 
	{
		mlme_kill = 1;
		RTUSBMlmeUp(pAd);
		wmb(); // need to check
		ret = kill_proc (pObj->MLMEThr_pid, SIGTERM, 1);
		if (ret) 
		{
			printk (KERN_WARNING "%s: unable to Mlme thread, pid=%d\n", pAd->net_dev->name, pObj->MLMEThr_pid);
		}
		wait_for_completion (&pAd->notify);
		pObj->MLMEThr_pid = -1;
	}
	if (pObj->RTUSBCmdThr_pid >= 0) 
	{
		RTUSBCmd_kill = 1;
		RTUSBCMDUp(pAd);
		wmb(); // need to check
		ret = kill_proc (pObj->RTUSBCmdThr_pid, SIGTERM, 1);
		if (ret) 
		{
			printk (KERN_WARNING "%s: unable to RTUSBCmd thread, pid=%d\n", pAd->net_dev->name, pObj->RTUSBCmdThr_pid);
		}
		wait_for_completion (&pAd->notify);
		pObj->RTUSBCmdThr_pid = -1;
	}
	

	// Free the entire content of the adapter 
	ReleaseAdapter(pAd);
	  
	RTMP_CLEAR_FLAG(pAd, fRTMP_ADAPTER_HALT_IN_PROGRESS);
	
	DBGPRINT(RT_DEBUG_TRACE, ("<==== RTMPHalt\n"));

}

static void rt2870_init(IN struct net_device *net_dev)
{
	PRTMP_ADAPTER   pAd = (PRTMP_ADAPTER) net_dev->priv;
//	POS_COOKIE		pObj = (POS_COOKIE) pAd->OS_Cookie;
	NDIS_STATUS     Status = NDIS_STATUS_SUCCESS;
	UCHAR           TmpPhy;
	UINT			index;
	
	printk("rt2870 driver version - %s\n", DRIVER_VERSION);

	
	//
	// Allocate all other memory blocks including all
	// DMA descriptor & buffers.
	//
	Status = RTMPInitAdapterBlock(pAd);
	if (Status != NDIS_STATUS_SUCCESS)
	{
		goto out;
	}

#if 0
	//bottom half data is assign at each task_scheduler
	tasklet_init(&pObj->rx_bh, RTUSBBulkRxHandle, (unsigned long)pAd);
#endif

	// Initialize pAd->StaCfg, pAd->ApCfg, pAd->CommonCfg to manufacture default
	UserCfgInit(pAd);
	

	// Wait for hardware stable
	{
		UINT32 MacCsr0 = 0, Index = 0;
		
		do
		{
			Status = RTUSBReadMACRegister(pAd, MAC_CSR0, &MacCsr0);

			if (MacCsr0 != 0)
				break;
			
			RTMPusecDelay(1000);
		} while (Index++ < 1000);
		DBGPRINT(RT_DEBUG_TRACE, ("Init: MAC_CSR0=0x%08x, Status=0x%08x\n", MacCsr0, Status));
	}

	// Load 8051 firmware
	Status = NICLoadFirmware(pAd);
	if(Status != NDIS_STATUS_SUCCESS)
	{
		goto release_adp;
	}

	// Initialize Asics
	Status = NICInitializeAsic(pAd);
	if (Status != NDIS_STATUS_SUCCESS)
	{
		goto release_adp;
	}
		
	// Read from the profile
	Status = RTMPReadParametersHook(pAd);
	if (Status != NDIS_STATUS_SUCCESS)
	{
		DBGPRINT_ERR((" RTMPReadParametersHook failed, Status[=0x%08x]\n", Status));
		goto release_adp;
	}


	//rt2860c: MultipleIRP
	pAd->CommonCfg.bMultipleIRP =FALSE;
	if (pAd->CommonCfg.bMultipleIRP)
		pAd->CommonCfg.NumOfBulkInIRP = RX_RING_SIZE;
	else
		pAd->CommonCfg.NumOfBulkInIRP = 1;


	//
	// Read additional info from NIC such as MAC address
	// This function must called after register CSR base address
	//
#ifdef	INIT_FROM_EEPROM
	NICReadEEPROMParameters(pAd);
	NICInitAsicFromEEPROM(pAd);
#endif
	RTUSBWriteHWMACAddress(pAd);


	//
	// hardware initialization after all parameters are acquired from Registry or E2PROM
	// 

	// ==============================================================
	// Set PHY to appropriate mode 
	TmpPhy = pAd->CommonCfg.PhyMode;
	pAd->CommonCfg.PhyMode = 0xff;
	RTMPSetPhyMode(pAd, TmpPhy);

	//  Other Ba CApability parameters
	pAd->CommonCfg.SupportedHtPhy.MpduDensity = (UCHAR)pAd->CommonCfg.BACapability.field.MpduDensity;
	pAd->CommonCfg.DesiredHtPhy.AmsduEnable = (USHORT)pAd->CommonCfg.BACapability.field.AmsduEnable;
	pAd->CommonCfg.REGBACapability.word = pAd->CommonCfg.BACapability.word;
	// BA Windows Size
	if (pAd->CommonCfg.BACapability.field.RxBAWinLimit > MAX_RX_REORDERBUF)
		pAd->CommonCfg.BACapability.field.RxBAWinLimit = MAX_RX_REORDERBUF;
	if (pAd->CommonCfg.BACapability.field.TxBAWinLimit > MAX_RX_REORDERBUF)
		pAd->CommonCfg.BACapability.field.TxBAWinLimit = MAX_RX_REORDERBUF;	
		
#if 1	// for debugging
	DBGPRINT(RT_DEBUG_TRACE, ("BACapability = 0x%lx. RxBAWinLimit= 0x%x. TxBAWinLimit= 0x%x. AutoBA=%d, Policy=%d, MpduDensity=%d, AmsduEnable=%d, AmsduSize=%d, MMPSmode=%d\n", 
		pAd->CommonCfg.BACapability.word,
		pAd->CommonCfg.BACapability.field.RxBAWinLimit, 
		pAd->CommonCfg.BACapability.field.TxBAWinLimit,
		pAd->CommonCfg.BACapability.field.AutoBA,
		pAd->CommonCfg.BACapability.field.Policy,
		pAd->CommonCfg.BACapability.field.MpduDensity, 
		pAd->CommonCfg.BACapability.field.AmsduEnable,
		pAd->CommonCfg.BACapability.field.AmsduSize,
		pAd->CommonCfg.BACapability.field.MMPSmode));

	DBGPRINT(RT_DEBUG_TRACE, ("TransmitSetting = 0x%lx. BW= %d, HTMODE= %d, Extension channel= %d, MCS= %d, ShortGI= %d, STBC= %d\n", 
		pAd->CommonCfg.RegTransmitSetting.word, 
		pAd->CommonCfg.RegTransmitSetting.field.BW, 
		pAd->CommonCfg.RegTransmitSetting.field.HTMODE, 
		pAd->CommonCfg.RegTransmitSetting.field.EXTCHA, 
		pAd->CommonCfg.RegTransmitSetting.field.MCS,
		pAd->CommonCfg.RegTransmitSetting.field.ShortGI,
		pAd->CommonCfg.RegTransmitSetting.field.STBC)); 
#endif
	//==============================================================
	
	// initialize MLME
	Status = MlmeInit(pAd);
	if(Status != NDIS_STATUS_SUCCESS)
	{
		DBGPRINT_ERR(("MlmeInit failed, Status[=0x%08x]\n", Status));
		goto release_adp;
	}

	// Start threads 
	mlme_kill = 0;
	RTUSBCmd_kill =0;
	Status = CreateThreads(net_dev);
	if (Status != NDIS_STATUS_SUCCESS)
	{
		MlmeHalt(pAd);
		goto release_adp;
	}

	// Init operation flags
	OPSTATUS_CLEAR_FLAG(pAd, fOP_STATUS_MEDIA_STATE_CONNECTED);
	RTMP_SET_FLAG(pAd, fRTMP_ADAPTER_MEDIA_STATE_CHANGE);
	DBGPRINT(RT_DEBUG_TRACE, ("NDIS_STATUS_MEDIA_DISCONNECT Event B!\n"));

	RTMP_CLEAR_FLAG(pAd, fRTMP_ADAPTER_RESET_IN_PROGRESS);
	RTMP_CLEAR_FLAG(pAd, fRTMP_ADAPTER_REMOVE_IN_PROGRESS);


	if (!RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_RADIO_OFF))
	{
		//
		// Support multiple BulkIn IRP, the value on pAd->CommonCfg.NumOfBulkInIRP may be large than 1.
		//
		for (index = 0; index < pAd->CommonCfg.NumOfBulkInIRP; index ++)
		{
			RTUSBBulkReceive(pAd);
			DBGPRINT(RT_DEBUG_TRACE, ("RTUSBBulkReceive!\n" ));
		}
		// Now Enable RxTx
		//
		RTMPEnableRxTx(pAd);

		// Initialize RF register to default value
		AsicSwitchChannel(pAd, pAd->CommonCfg.Channel,FALSE);
		AsicLockChannel(pAd, pAd->CommonCfg.Channel);

	}	/* if (!RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_RADIO_OFF)) */

	
	// Set Group key to Asic
	//
	if (pAd->CommonCfg.WepStatus == Ndis802_11WEPEnabled)
	{	
		INT		idx, DefKeyIdx = pAd->CommonCfg.DefaultKeyId;
		ULONG	IV = 0;


#if WPA_SUPPLICANT_SUPPORT
		// Record the user desired wep setting
		pAd->StaCfg.DesireSharedKey[DefKeyIdx].KeyLen = pAd->SharedKey[BSS0][DefKeyIdx].KeyLen;
		NdisMoveMemory(pAd->StaCfg.DesireSharedKey[DefKeyIdx].Key, pAd->SharedKey[BSS0][DefKeyIdx].Key, pAd->SharedKey[BSS0][DefKeyIdx].KeyLen);						                        
		pAd->StaCfg.DesireSharedKey[DefKeyIdx].CipherAlg = pAd->SharedKey[BSS0][DefKeyIdx].CipherAlg;												
#endif						

		if (pAd->OpMode == OPMODE_STA)
		{
			pAd->MacTab.Content[BSSID_WCID].PairwiseKey.CipherAlg = pAd->SharedKey[BSS0][DefKeyIdx].CipherAlg;
			pAd->MacTab.Content[BSSID_WCID].PairwiseKey.KeyLen = pAd->SharedKey[BSS0][DefKeyIdx].KeyLen;
		}
		
		// Update WCID attribute table and IVEIV table for this group key table
 		IV |= (DefKeyIdx << 30);
		AsicUpdateWCIDIVEIV(pAd, BSSID_WCID, IV, 0);
		AsicUpdateWCIDAttribute(pAd, BSSID_WCID, BSS0, pAd->SharedKey[BSS0][DefKeyIdx].CipherAlg, FALSE);
 
		DBGPRINT(RT_DEBUG_TRACE, ("WEP Security!!! DefKeyIdx= %d\n" , DefKeyIdx));

		// Fill material
		for (idx=0; idx<4; idx++)
		{
			if (pAd->SharedKey[BSS0][idx].KeyLen > 0)
			{	
				UCHAR	CipherAlg;
				PUCHAR	Key;    		   			

				CipherAlg = pAd->SharedKey[BSS0][idx].CipherAlg;
				Key = pAd->SharedKey[BSS0][idx].Key;

				// Set Group key material to Asic
				AsicAddSharedKeyEntry(pAd, BSS0, idx, CipherAlg, Key, NULL, NULL);
			}

		}
	}

	// Adhoc mode
	if (pAd->StaCfg.BssType == BSS_ADHOC) 
	{	
		// Set rate
		if (pAd->CommonCfg.PhyMode == PHY_11B)
			pAd->StaCfg.AdhocMode = ADHOC_11B;
		else if (pAd->CommonCfg.PhyMode == PHY_11A)
			pAd->StaCfg.AdhocMode = ADHOC_11A;
		else if (pAd->CommonCfg.PhyMode == PHY_11ABG_MIXED)
			pAd->StaCfg.AdhocMode = ADHOC_11ABG_MIXED;
		//else if (pAd->CommonCfg.PhyMode == PHY_11ABGN_MIXED)
		//else if (pAd->CommonCfg.PhyMode == PHY_11BGN_MIXED)
		else
			pAd->StaCfg.AdhocMode = ADHOC_11BG_MIXED; //default

		DBGPRINT(RT_DEBUG_TRACE, ("AdhocMode Rate=%ld\n", pAd->StaCfg.AdhocMode));
		
		// Set wpa key
		if ((pAd->MlmeAux.SsidLen != 0) && 
			(pAd->CommonCfg.AuthMode == Ndis802_11AuthModeWPANone)&&
			((pAd->CommonCfg.WepStatus == Ndis802_11Encryption2Enabled) ||
			(pAd->CommonCfg.WepStatus == Ndis802_11Encryption3Enabled)))
		{	
			RTMPWPANoneAddKeyProc(pAd, pAd->StaCfg.PMK);
		}
	}

	
	return;

release_adp:
	// Free the entire content of the adapter
	ReleaseAdapter(pAd);
out:	
	panic("!!! RT2870 Initialized fail !!!\n");
	
}

static int rtusb_open(IN struct net_device *net_dev)
{
	PRTMP_ADAPTER   pAd = (PRTMP_ADAPTER) net_dev->priv;
	NDIS_STATUS     Status = NDIS_STATUS_SUCCESS;

	DBGPRINT(RT_DEBUG_TRACE,("-->rtusb_open \n"));
	
	rt2870_init(net_dev);
	
   	// set up mac address
	memcpy(pAd->net_dev->dev_addr, pAd->CurrentAddress, pAd->net_dev->addr_len);

	// Start net_dev interface tx /rx
	netif_start_queue(net_dev);
	netif_carrier_on(net_dev);
	netif_wake_queue(net_dev);

	DBGPRINT(RT_DEBUG_TRACE,("<--rtusb_open \n"));
	return Status;

}

static int rtusb_close(IN struct net_device *net_dev)
{
	PRTMP_ADAPTER   pAd = (PRTMP_ADAPTER) net_dev->priv;
//	POS_COOKIE		pObj = (POS_COOKIE) pAd->OS_Cookie;
	int	            i = 0;
	
	DECLARE_WAIT_QUEUE_HEAD (unlink_wakeup); 
	DECLARE_WAITQUEUE (wait, current);
	
	DBGPRINT(RT_DEBUG_TRACE,("-->rt2870_close \n"));

	RTMP_SET_FLAG(pAd, fRTMP_ADAPTER_REMOVE_IN_PROGRESS);

#if 0
	// kill rx tasklet
	tasklet_kill(&pObj->rx_bh);
#endif

	netif_carrier_off(pAd->net_dev);
	netif_stop_queue(pAd->net_dev);

	// ensure there are no more active urbs.
	//
	add_wait_queue (&unlink_wakeup, &wait);
	pAd->wait = &unlink_wakeup;
	
	// maybe wait for deletions to finish.
	while ((i < 25) && atomic_read(&pAd->PendingRx) > 0) 
	{
#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,9)
		msleep(UNLINK_TIMEOUT_MS);	//Time in millisecond
#else
		NdisMSleep(UNLINK_TIMEOUT_MS*1000);	//Time in microsecond
#endif
		i++;
	}
	pAd->wait = NULL;
	remove_wait_queue (&unlink_wakeup, &wait); 

	// Halt all of process
	RTMPHalt(pAd);

	DBGPRINT(RT_DEBUG_TRACE,("<--rt2870_close \n"));

	return 0;
}

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)	/* kernel 2.4 series */
static void *rtusb_probe(struct usb_device *dev, UINT interface,
						const struct usb_device_id *id_table)
{	
	PRTMP_ADAPTER       pAd = (PRTMP_ADAPTER)NULL;
	int                 i;
	struct net_device   *netdev;
	INT					status;
	PVOID				handle;
	
	for (i = 0; i < rtusb_usb_id_len; i++)
	{
		if (dev->descriptor.idVendor == rtusb_usb_id[i].idVendor &&
			dev->descriptor.idProduct == rtusb_usb_id[i].idProduct)
		{
			printk("idVendor = 0x%x, idProduct = 0x%x \n",dev->descriptor.idVendor, dev->descriptor.idProduct);
			break;
		}
	}
	if (i == rtusb_usb_id_len) 
	{
		printk("Device Descriptor not matching\n");
		goto out;
	}

	netdev = alloc_etherdev(sizeof(PRTMP_ADAPTER));
	if(!netdev)
	{
		printk("alloc_etherdev failed\n");
		MOD_DEC_USE_COUNT;
		goto out;
	}

	
	//
	// Allocate RTMP_ADAPTER adapter structure
	//
	handle = kmalloc(sizeof(struct os_cookie) , GFP_KERNEL);
	
	((POS_COOKIE)handle)->pUsb_Dev = dev;

	status = RTMPAllocAdapterBlock(handle, &pAd);	
	if (status != NDIS_STATUS_SUCCESS) 
	{
		goto out_free_netdev;
	}
	
	netdev->priv = (PVOID)pAd;
	pAd->net_dev = netdev;
	
	netif_stop_queue(netdev);
	pAd->config = dev->config;
	SET_MODULE_OWNER(pAd->net_dev);
	ether_setup(pAd->net_dev);
	
	netdev->open = rtusb_open;
	netdev->hard_start_xmit = RTMPSendPackets;
	netdev->stop = rtusb_close;
	netdev->get_stats = rtusb_get_ether_stats;
#if ((WIRELESS_EXT >= 12) && (WIRELESS_EXT <= 20 ))
	netdev->get_wireless_stats = rtusb_get_wireless_stats;
	netdev->wireless_handlers = (struct iw_handler_def *) &rt_iw_handler_def;
#endif
	netdev->do_ioctl = rt2870_ioctl;
	pAd->net_dev->hard_header_len = 14;
	pAd->net_dev->mtu = 1500;
	pAd->net_dev->addr_len = 6;
	pAd->net_dev->weight = 64;


	{// find available 
		int 	i=0;
		char	slot_name[IFNAMSIZ];
		struct  net_device	*device;
		struct  usb_interface *ifp;             
		struct	usb_interface_descriptor *iface_desc;
		struct	usb_endpoint_descriptor *endpoint;
		ULONG	BulkOutIdx;

		for (i = 0; i < 8; i++)
		{
			sprintf(slot_name, "ra%d", i);
			
			read_lock_bh(&dev_base_lock); // avoid multiple init
			for (device = dev_base; device != NULL; device = device->next)
			{
				if (strncmp(device->name, slot_name, 4) == 0)
				{
					break;
				}
			}
			read_unlock_bh(&dev_base_lock);

			if(device == NULL)	break;
		}
		if(i == 8)
		{
			DBGPRINT(RT_DEBUG_ERROR, ("No available slot name\n"));
			goto out_free_netdev;
		}

		sprintf(pAd->net_dev->name, "ra%d", i);
		DBGPRINT(RT_DEBUG_ERROR,( "usb device name %s\n",pAd->net_dev->name));



		//////////////////////////////
		//      USB Configuration
		//////////////////////////////
		
		/* get the active interface descriptor */
		ifp = &dev->actconfig->interface[interface];
		iface_desc = &ifp->altsetting[0];

		/* get # of enpoints */
		pAd->NumberOfPipes = (USHORT)iface_desc->bNumEndpoints;
		DBGPRINT(RT_DEBUG_TRACE, ("NumEndpoints=%d\n", iface_desc->bNumEndpoints));		 

		/* Configure Pipes */
		endpoint = &iface_desc->endpoint[0];
		BulkOutIdx = 0;
		for (i = 0; i < pAd->NumberOfPipes; i++)
		{ 
			if ((endpoint[i].bmAttributes == USB_ENDPOINT_XFER_BULK) && 
				((endpoint[i].bEndpointAddress & USB_ENDPOINT_DIR_MASK) == USB_DIR_IN))
			{
				pAd->BulkInEpAddr = endpoint[i].bEndpointAddress;
				pAd->BulkInMaxPacketSize = endpoint[i].wMaxPacketSize;
				DBGPRINT_RAW(RT_DEBUG_TRACE, ("BULK IN MaximumPacketSize = %d\n", pAd->BulkInMaxPacketSize));
				DBGPRINT_RAW(RT_DEBUG_TRACE, ("EP address = 0x%2x  \n", endpoint[i].bEndpointAddress));
			}
			else if ((endpoint[i].bmAttributes == USB_ENDPOINT_XFER_BULK) && 
					((endpoint[i].bEndpointAddress & USB_ENDPOINT_DIR_MASK) == USB_DIR_OUT))
			{
				// There are 6 bulk out EP. EP6 highest priority. EP1-4 is EDCA.  EP5 is HCCA.
				pAd->BulkOutEpAddr[BulkOutIdx++] = endpoint[i].bEndpointAddress;
				pAd->BulkOutMaxPacketSize = endpoint[i].wMaxPacketSize;
				DBGPRINT_RAW(RT_DEBUG_TRACE, ("BULK OUT MaximumPacketSize = %d\n", pAd->BulkOutMaxPacketSize));
				DBGPRINT_RAW(RT_DEBUG_TRACE, ("EP address = 0x%2x  \n", endpoint[i].bEndpointAddress));
			}
		
		}
	}

	if (!(pAd->BulkInEpAddr && pAd->BulkOutEpAddr[0])) 
	{
		printk("Could not find both bulk-in and bulk-out endpoints\n");
		goto out_free_netdev;
	}

	status = register_netdev(pAd->net_dev);
	if (status)
	{
		printk("register_netdev failed err=%d\n", status);
		goto out_free_netdev;
	}
	
	return pAd;

out_free_netdev:
	kfree(pAd->net_dev);
out:
	return NULL;


}

//Disconnect function is called within exit routine
static void rtusb_disconnect(struct usb_device *dev, void *ptr)
{
	PRTMP_ADAPTER pAd = (PRTMP_ADAPTER) ptr;
	struct net_device   *net_dev = NULL;

	DBGPRINT(RT_DEBUG_ERROR,("unregister usbnet usb-%s-%s\n", dev->bus->bus_name, dev->devpath));

	RTMP_SET_FLAG(pAd, fRTMP_ADAPTER_NIC_NOT_EXIST);
	if (!pAd)
		return;
	
	// for debug, wait to show some messages to /proc system
	udelay(1);
	
	net_dev = pAd->net_dev;
	if(pAd->net_dev != NULL)
	{
		printk("unregister_netdev()\n");
		unregister_netdev (pAd->net_dev);
	}
	udelay(1);
	udelay(1);
	
	// free net_device memory
	kfree(net_dev);
	
	// free adapter memory
	RTMPFreeAdapter(pAd);
		
	while (MOD_IN_USE > 0) 
	{
		MOD_DEC_USE_COUNT;
	}
	udelay(1);
	DBGPRINT(RT_DEBUG_ERROR,(" RTUSB disconnect successfully\n"));
}

#else	/* kernel 2.6 series */
static int rtusb_probe (struct usb_interface *intf,
						const struct usb_device_id *id)
{	
	struct usb_device   *dev = interface_to_usbdev(intf);
	PRTMP_ADAPTER       pAd = (PRTMP_ADAPTER)NULL;
	int                 i;
	struct net_device   *netdev;
	INT					status;
	PVOID				handle;

	/* increments the reference count of the usb device structure */
	usb_get_dev(dev);
	
	for (i = 0; i < rtusb_usb_id_len; i++)
	{
		if (dev->descriptor.idVendor == rtusb_usb_id[i].idVendor &&
			dev->descriptor.idProduct == rtusb_usb_id[i].idProduct)
		{
			printk("idVendor = 0x%x, idProduct = 0x%x \n",dev->descriptor.idVendor, dev->descriptor.idProduct);
			break;
		}
	}
	if (i == rtusb_usb_id_len) 
	{
		printk("Device Descriptor not matching\n");
		goto out;
	}

	netdev = alloc_etherdev(sizeof(PRTMP_ADAPTER));
	if(!netdev)
	{
		printk("alloc_etherdev failed\n");
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,15)		
		module_put(THIS_MODULE);
#endif		
		goto out;
	}

	//
	// Allocate RTMP_ADAPTER adapter structure
	//
	handle = kmalloc(sizeof(struct os_cookie) , GFP_KERNEL);
	
	((POS_COOKIE)handle)->pUsb_Dev = dev;

	status = RTMPAllocAdapterBlock(handle, &pAd);	
	if (status != NDIS_STATUS_SUCCESS) 
	{
		goto out_free_netdev;
	}
	
	netdev->priv = (PVOID)pAd;
	pAd->net_dev = netdev;
	
	netif_stop_queue(netdev);
	pAd->config = &dev->config->desc;
	SET_MODULE_OWNER(pAd->net_dev);
	ether_setup(pAd->net_dev);
	
	netdev->open = rtusb_open;
	netdev->stop = rtusb_close;
	netdev->hard_start_xmit = RTMPSendPackets;
	netdev->get_stats = rtusb_get_ether_stats;

#if ((WIRELESS_EXT >= 12) && (WIRELESS_EXT <= 20 ))
	netdev->get_wireless_stats = rtusb_get_wireless_stats;
	netdev->wireless_handlers = (struct iw_handler_def *) &rt_iw_handler_def;
#endif
	netdev->do_ioctl = rt2870_ioctl;

	pAd->net_dev->hard_header_len = 14;
	pAd->net_dev->mtu = 1500;
	pAd->net_dev->addr_len = 6;
	pAd->net_dev->weight = 64;

	SET_NETDEV_DEV(pAd->net_dev, &intf->dev);
    
	{// find available 
		int 	i=0;
		char	slot_name[IFNAMSIZ];
//		struct  net_device	*device;
		struct  usb_host_interface *iface_desc;
		ULONG	 BulkOutIdx;
		
		for (i = 0; i < 8; i++)
		{
			sprintf(slot_name, "ra%d", i);

#if 1          
			if(dev_get_by_name(slot_name)==NULL)                
				break;
#else			
			read_lock_bh(&dev_base_lock); // avoid multiple init
			for (device = dev_base; device != NULL; device = device->next)
			{
				if (strncmp(device->name, slot_name, 4) == 0)
				{
					break;
				}
			}
			read_unlock_bh(&dev_base_lock);
			
			if(device == NULL)	break;
#endif			
		}
		if(i == 8)
		{
			DBGPRINT(RT_DEBUG_ERROR, ("No available slot name\n"));
			goto out_free_netdev;
		}

		sprintf(pAd->net_dev->name, "ra%d", i);
		DBGPRINT(RT_DEBUG_ERROR, ("usb device name %s\n", pAd->net_dev->name));



		//////////////////////////////
		//      USB Configuration
		//////////////////////////////

		/* get the active interface descriptor */
		iface_desc = intf->cur_altsetting;

		/* get # of enpoints  */
		pAd->NumberOfPipes = (USHORT)iface_desc->desc.bNumEndpoints;
		DBGPRINT(RT_DEBUG_TRACE, ("NumEndpoints=%d\n", iface_desc->desc.bNumEndpoints));		  
        
		/* Configure Pipes */
		BulkOutIdx = 0;
		for (i = 0; i < pAd->NumberOfPipes; i++)
		{ 
			if ((iface_desc->endpoint[i].desc.bmAttributes == USB_ENDPOINT_XFER_BULK) && 
				((iface_desc->endpoint[i].desc.bEndpointAddress & USB_ENDPOINT_DIR_MASK) == USB_DIR_IN))
			{
				pAd->BulkInEpAddr = iface_desc->endpoint[i].desc.bEndpointAddress;
				pAd->BulkInMaxPacketSize = iface_desc->endpoint[i].desc.wMaxPacketSize;
				DBGPRINT_RAW(RT_DEBUG_TRACE, ("BULK IN MaximumPacketSize = %d\n", pAd->BulkInMaxPacketSize));
				DBGPRINT_RAW(RT_DEBUG_TRACE, ("EP address = 0x%2x  \n", iface_desc->endpoint[i].desc.bEndpointAddress));
			}
			else if ((iface_desc->endpoint[i].desc.bmAttributes == USB_ENDPOINT_XFER_BULK) && 
					((iface_desc->endpoint[i].desc.bEndpointAddress & USB_ENDPOINT_DIR_MASK) == USB_DIR_OUT))
			{
				// There are 6 bulk out EP. EP6 highest priority. EP1-4 is EDCA.  EP5 is HCCA.
				pAd->BulkOutEpAddr[BulkOutIdx++] = iface_desc->endpoint[i].desc.bEndpointAddress;
				pAd->BulkOutMaxPacketSize = iface_desc->endpoint[i].desc.wMaxPacketSize;
				DBGPRINT_RAW(RT_DEBUG_TRACE, ("BULK OUT MaximumPacketSize = %d\n", pAd->BulkOutMaxPacketSize));
				DBGPRINT_RAW(RT_DEBUG_TRACE, ("EP address = 0x%2x  \n", iface_desc->endpoint[i].desc.bEndpointAddress));
			}

		}
	}

	if (!(pAd->BulkInEpAddr && pAd->BulkOutEpAddr[0])) 
	{
		printk("Could not find both bulk-in and bulk-out endpoints\n");
		goto out_free_netdev;
	}


	status = register_netdev(pAd->net_dev);
	if (status)
	{
		printk("register_netdev failed err=%d\n", status);
		goto out_free_netdev;
	}
	
	/* save adapter data in usb interface device */
	usb_set_intfdata(intf, pAd);

	return 0;
	
out_free_netdev:
	free_netdev(netdev);
	return -ENOMEM;
out:
	return	-ENODEV;

}

static void rtusb_disconnect(struct usb_interface *intf)
{
	struct usb_device   *dev = interface_to_usbdev(intf);
	PRTMP_ADAPTER       pAd = (PRTMP_ADAPTER)NULL;
	struct net_device   *net_dev = NULL;

	DBGPRINT(RT_DEBUG_ERROR,("unregister usbnet usb-%s-%s\n", dev->bus->bus_name, dev->devpath));

	pAd = usb_get_intfdata(intf);
	usb_set_intfdata(intf, NULL);	
	RTMP_SET_FLAG(pAd, fRTMP_ADAPTER_NIC_NOT_EXIST);
	if (!pAd)
		return;
		
	// for debug, wait to show some messages to /proc system
	udelay(1);
	
	net_dev = pAd->net_dev;
	if(pAd->net_dev != NULL)
	{
		printk("unregister_netdev()\n");
		unregister_netdev (pAd->net_dev);
	}
	udelay(1);
	flush_scheduled_work ();
	udelay(1);

	// free net_device memory
	free_netdev(net_dev);

	// free adapter memory
	RTMPFreeAdapter(pAd);

	/* release a use of the usb device structure */
	usb_put_dev(dev);
	udelay(1);

	DBGPRINT(RT_DEBUG_ERROR, (" RTUSB disconnect successfully\n"));

}
#endif

