/*
 ***************************************************************************
 * Ralink Tech Inc.
 * 4F, No. 2 Technology	5th	Rd.
 * Science-based Industrial	Park
 * Hsin-chu, Taiwan, R.O.C.
 *
 * (c) Copyright 2002-2004, Ralink Technology, Inc.
 *
 * All rights reserved.	Ralink's source	code is	an unpublished work	and	the
 * use of a	copyright notice does not imply	otherwise. This	source code
 * contains	confidential trade secret material of Ralink Tech. Any attemp
 * or participation	in deciphering,	decoding, reverse engineering or in	any
 * way altering	the	source code	is stricitly prohibited, unless	the	prior
 * written consent of Ralink Technology, Inc. is obtained.
 ***************************************************************************

	Module Name:
	connect.c

	Abstract:

	Revision History:
	Who			When			What
	--------	----------		----------------------------------------------
	John		2004-08-08		Major modification from RT2560
*/
#include "rt_config.h"

extern UCHAR	EpToQueue[];

UCHAR	CipherSuiteWpaNoneTkip[] = {
		0x00, 0x50, 0xf2, 0x01,	// oui
		0x01, 0x00,				// Version
		0x00, 0x50, 0xf2, 0x02,	// Multicast
		0x01, 0x00,				// Number of unicast
		0x00, 0x50, 0xf2, 0x02,	// unicast
		0x01, 0x00,				// number of authentication method
		0x00, 0x50, 0xf2, 0x00	// authentication
		};
UCHAR	CipherSuiteWpaNoneTkipLen = (sizeof(CipherSuiteWpaNoneTkip) / sizeof(UCHAR));

UCHAR	CipherSuiteWpaNoneAes[] = {
		0x00, 0x50, 0xf2, 0x01,	// oui
		0x01, 0x00,				// Version
		0x00, 0x50, 0xf2, 0x04,	// Multicast
		0x01, 0x00,				// Number of unicast
		0x00, 0x50, 0xf2, 0x04,	// unicast
		0x01, 0x00,				// number of authentication method
		0x00, 0x50, 0xf2, 0x00	// authentication
		};
UCHAR	CipherSuiteWpaNoneAesLen = (sizeof(CipherSuiteWpaNoneAes) / sizeof(UCHAR));

// The following MACRO is called after 1. starting an new IBSS, 2. succesfully JOIN an IBSS,
// or 3. succesfully ASSOCIATE to a BSS, 4. successfully RE_ASSOCIATE to a BSS
// All settings successfuly negotiated furing MLME state machines become final settings
// and are copied to pAd->StaActive
#define COPY_SETTINGS_FROM_MLME_AUX_TO_ACTIVE_CFG(_pAd)                                 \
{                                                                                       \
	_pAd->CommonCfg.SsidLen = _pAd->MlmeAux.SsidLen;                                    \
	NdisMoveMemory(_pAd->CommonCfg.Ssid, _pAd->MlmeAux.Ssid, _pAd->MlmeAux.SsidLen);    \
	COPY_MAC_ADDR(_pAd->CommonCfg.Bssid, _pAd->MlmeAux.Bssid);                          \
	_pAd->CommonCfg.Channel = _pAd->MlmeAux.Channel;                                    \
	_pAd->CommonCfg.CentralChannel = _pAd->MlmeAux.CentralChannel;                                    \
	_pAd->StaActive.Aid = _pAd->MlmeAux.Aid;                                            \
	_pAd->StaActive.AtimWin = _pAd->MlmeAux.AtimWin;                                    \
	_pAd->StaActive.CapabilityInfo = _pAd->MlmeAux.CapabilityInfo;                      \
	_pAd->CommonCfg.BeaconPeriod = _pAd->MlmeAux.BeaconPeriod;                          \
	_pAd->StaActive.CfpMaxDuration = _pAd->MlmeAux.CfpMaxDuration;                      \
	_pAd->StaActive.CfpPeriod = _pAd->MlmeAux.CfpPeriod;                                \
	_pAd->StaActive.SupRateLen = _pAd->MlmeAux.SupRateLen;                              \
	NdisMoveMemory(_pAd->StaActive.SupRate, _pAd->MlmeAux.SupRate, _pAd->MlmeAux.SupRateLen);   \
	_pAd->StaActive.ExtRateLen = _pAd->MlmeAux.ExtRateLen;                                      \
	NdisMoveMemory(_pAd->StaActive.ExtRate, _pAd->MlmeAux.ExtRate, _pAd->MlmeAux.ExtRateLen);   \
	NdisMoveMemory(&_pAd->CommonCfg.APEdcaParm, &_pAd->MlmeAux.APEdcaParm, sizeof(EDCA_PARM));  \
	NdisMoveMemory(&_pAd->CommonCfg.APQosCapability, &_pAd->MlmeAux.APQosCapability, sizeof(QOS_CAPABILITY_PARM));  \
	NdisMoveMemory(&_pAd->CommonCfg.APQbssLoad, &_pAd->MlmeAux.APQbssLoad, sizeof(QBSS_LOAD_PARM)); \
	COPY_MAC_ADDR(_pAd->MacTab.Content[BSSID_WCID].Addr, _pAd->MlmeAux.Bssid);                          \
	_pAd->MacTab.Content[BSSID_WCID].Aid = _pAd->MlmeAux.Aid;                                            \
	_pAd->MacTab.Content[BSSID_WCID].PairwiseKey.CipherAlg = _pAd->CommonCfg.PairCipher;  \
	COPY_MAC_ADDR(_pAd->MacTab.Content[BSSID_WCID].PairwiseKey.BssId, _pAd->MlmeAux.Bssid);                        \
}

/*
	==========================================================================
	Description:

	IRQL = PASSIVE_LEVEL

	==========================================================================
*/
VOID MlmeCntlInit(
	IN PRTMP_ADAPTER pAd, 
	IN STATE_MACHINE *S, 
	OUT STATE_MACHINE_FUNC Trans[]) 
{
	// Control state machine differs from other state machines, the interface 
	// follows the standard interface
	pAd->Mlme.CntlMachine.CurrState = CNTL_IDLE;
}

/*
	==========================================================================
	Description:

	IRQL = DISPATCH_LEVEL
	
	==========================================================================
*/
VOID MlmeCntlMachinePerformAction(
	IN PRTMP_ADAPTER pAd, 
	IN STATE_MACHINE *S, 
	IN MLME_QUEUE_ELEM *Elem) 
{
	switch(pAd->Mlme.CntlMachine.CurrState) 
	{
		case CNTL_IDLE:
			CntlIdleProc(pAd, Elem);
			break;
		case CNTL_WAIT_DISASSOC:
			CntlWaitDisassocProc(pAd, Elem);
			break;
		case CNTL_WAIT_JOIN:
			CntlWaitJoinProc(pAd, Elem);
			break;

		// CNTL_WAIT_REASSOC is the only state in CNTL machine that does
		// not triggered directly or indirectly by "RTMPSetInformation(OID_xxx)". 
		// Therefore not protected by NDIS's "only one outstanding OID request" 
		// rule. Which means NDIS may SET OID in the middle of ROAMing attempts.
		// Current approach is to block new SET request at RTMPSetInformation()
		// when CntlMachine.CurrState is not CNTL_IDLE
		case CNTL_WAIT_REASSOC:
			CntlWaitReassocProc(pAd, Elem);
			break;

		case CNTL_WAIT_START:
			CntlWaitStartProc(pAd, Elem);
			break;
		case CNTL_WAIT_AUTH:
			CntlWaitAuthProc(pAd, Elem);
			break;
		case CNTL_WAIT_AUTH2:
			CntlWaitAuthProc2(pAd, Elem);
			break;
		case CNTL_WAIT_ASSOC:
			CntlWaitAssocProc(pAd, Elem);
			break;

		case CNTL_WAIT_OID_LIST_SCAN:
			if(Elem->MsgType == MT2_SCAN_CONF) 
			{
				// Resume TxRing after SCANING complete. We hope the out-of-service time
				// won't be too long to let upper layer time-out the waiting frames
				RTUSBResumeMsduTransmission(pAd);
#ifdef CCX_SUPPORT				
				if (pAd->StaCfg.CCXReqType != MSRN_TYPE_UNUSED)
				{
					// Cisco scan request is finished, prepare beacon report
					MlmeEnqueue(pAd, AIRONET_STATE_MACHINE, MT2_AIRONET_SCAN_DONE, 0, NULL);
				}
#endif				
				pAd->Mlme.CntlMachine.CurrState = CNTL_IDLE;
			}
			break;

		case CNTL_WAIT_OID_DISASSOC:
			if (Elem->MsgType == MT2_DISASSOC_CONF) 
			{
				LinkDown(pAd, FALSE);
				pAd->Mlme.CntlMachine.CurrState = CNTL_IDLE;
			}
			break;
		//
		// This state is for that we want to connect to an AP but
		// it didn't find on BSS List table. So we need to scan the air first,
		// after that we can try to connect to the desired AP if available.
		//
		case CNTL_WAIT_SCAN_FOR_CONNECT:
			if(Elem->MsgType == MT2_SCAN_CONF) 
			{
				// Resume TxRing after SCANING complete. We hope the out-of-service time
				// won't be too long to let upper layer time-out the waiting frames
				RTUSBResumeMsduTransmission(pAd);
#ifdef CCX_SUPPORT				
				if (pAd->StaCfg.CCXReqType != MSRN_TYPE_UNUSED)
				{
					// Cisco scan request is finished, prepare beacon report
					MlmeEnqueue(pAd, AIRONET_STATE_MACHINE, MT2_AIRONET_SCAN_DONE, 0, NULL);
				}
#endif				
				pAd->Mlme.CntlMachine.CurrState = CNTL_IDLE;

				//
				// Check if we can connect to.
				//
				BssTableSsidSort(pAd, &pAd->MlmeAux.SsidBssTab, pAd->MlmeAux.AutoReconnectSsid, pAd->MlmeAux.AutoReconnectSsidLen);

				if (pAd->MlmeAux.SsidBssTab.BssNr > 0)
				{
					MlmeAutoReconnectLastSSID(pAd);
				}
//				else
//				{
//					pAd->StaCfg.bDisallowWZC = FALSE;
//				}
			}
			break;

		default:
			DBGPRINT_ERR(("!ERROR! CNTL - Illegal message type(=%ld)", Elem->MsgType));
			break;
	}
}


/*
	==========================================================================
	Description:

	IRQL = DISPATCH_LEVEL
	
	==========================================================================
*/
VOID CntlIdleProc(
	IN PRTMP_ADAPTER pAd, 
	IN MLME_QUEUE_ELEM *Elem) 
{
	MLME_DISASSOC_REQ_STRUCT   DisassocReq;

	if (RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_RADIO_OFF))
		return;
		
	switch(Elem->MsgType) 
	{
		case OID_802_11_SSID:
			CntlOidSsidProc(pAd, Elem);
			break;

		case RT_OID_802_11_BSSID:
			CntlOidRTBssidProc(pAd,Elem);
			break;

		case OID_802_11_BSSID_LIST_SCAN:
			CntlOidScanProc(pAd,Elem);
			break;

		case OID_802_11_DISASSOCIATE:
			DisassocParmFill(pAd, &DisassocReq, pAd->CommonCfg.Bssid, REASON_DEAUTH_STA_LEAVING);
			MlmeEnqueue(pAd, ASSOC_STATE_MACHINE, MT2_MLME_DISASSOC_REQ, sizeof(MLME_DISASSOC_REQ_STRUCT), &DisassocReq);
			pAd->Mlme.CntlMachine.CurrState = CNTL_WAIT_OID_DISASSOC;
			// Set the AutoReconnectSsid to prevent it reconnect to old SSID
			// Since calling this indicate user don't want to connect to that SSID anymore.
#ifdef WPA_SUPPLICANT_SUPPORT
            if (pAd->StaCfg.WPA_Supplicant != 2)
#endif // WPA_SUPPLICANT_SUPPORT //
			{
			pAd->MlmeAux.AutoReconnectSsidLen= 32;
			NdisZeroMemory(pAd->MlmeAux.AutoReconnectSsid, pAd->MlmeAux.AutoReconnectSsidLen);
			}
			break;

		case MT2_MLME_ROAMING_REQ:
			CntlMlmeRoamingProc(pAd, Elem);
			break;

		default:
			DBGPRINT(RT_DEBUG_TRACE, ("CNTL - Illegal message in CntlIdleProc(MsgType=%ld)\n",Elem->MsgType));
			break;
	}
}

// IRQL = DISPATCH_LEVEL
VOID CntlOidScanProc(
	IN PRTMP_ADAPTER pAd,
	IN MLME_QUEUE_ELEM *Elem)
{
	MLME_SCAN_REQ_STRUCT       ScanReq;
	ULONG                      BssIdx = BSS_NOT_FOUND;
	BSS_ENTRY                  CurrBss;

	DBGPRINT(RT_DEBUG_INFO, ("CNTL - SCAN starts\n"));

	// record current BSS if network is connected. 
	// 2003-2-13 do not include current IBSS if this is the only STA in this IBSS.
	if (OPSTATUS_TEST_FLAG(pAd, fOP_STATUS_MEDIA_STATE_CONNECTED))
	{
		BssIdx = BssSsidTableSearch(&pAd->ScanTab, pAd->CommonCfg.Bssid, pAd->CommonCfg.Ssid, pAd->CommonCfg.SsidLen, pAd->CommonCfg.Channel);
		if (BssIdx != BSS_NOT_FOUND)
		{
			NdisMoveMemory(&CurrBss, &pAd->ScanTab.BssEntry[BssIdx], sizeof(BSS_ENTRY));

			// 2003-2-20 reset this RSSI to a low value but not zero. In normal case, the coming SCAN
			//     should return a correct RSSI to overwrite this. If no BEEACON received after SCAN, 
			//     at least we still report a "greater than 0" RSSI since we claim it's CONNECTED.
			// CurrBss.Rssi = pAd->BbpRssiToDbmDelta - 85; // assume -85 dB
		}
	}

	// clean up previous SCAN result, add current BSS back to table if any
	BssTableInit(&pAd->ScanTab); 
	if (BssIdx != BSS_NOT_FOUND)
	{
		// DDK Note: If the NIC is associated with a particular BSSID and SSID 
		//    that are not contained in the list of BSSIDs generated by this scan, the 
		//    BSSID description of the currently associated BSSID and SSID should be 
		//    appended to the list of BSSIDs in the NIC's database.
		// To ensure this, we append this BSS as the first entry in SCAN result
		NdisMoveMemory(&pAd->ScanTab.BssEntry[0], &CurrBss, sizeof(BSS_ENTRY));
		pAd->ScanTab.BssNr = 1;
	}

	ScanParmFill(pAd, &ScanReq, "", 0, BSS_ANY, SCAN_ACTIVE);
	MlmeEnqueue(pAd, SYNC_STATE_MACHINE, MT2_MLME_SCAN_REQ, 
		sizeof(MLME_SCAN_REQ_STRUCT), &ScanReq);
	pAd->Mlme.CntlMachine.CurrState = CNTL_WAIT_OID_LIST_SCAN;
}

/*
	==========================================================================
	Description:
		Before calling this routine, user desired SSID should already been
		recorded in CommonCfg.Ssid[]
	IRQL = DISPATCH_LEVEL
	
	==========================================================================
*/
VOID CntlOidSsidProc(
	IN PRTMP_ADAPTER pAd, 
	IN MLME_QUEUE_ELEM * Elem) 
{
	PNDIS_802_11_SSID          pOidSsid = (NDIS_802_11_SSID *)Elem->Msg;
	MLME_DISASSOC_REQ_STRUCT   DisassocReq;
	ULONG					   Now;

	// Step 1. record the desired user settings to MlmeAux
	NdisMoveMemory(pAd->MlmeAux.Ssid, pOidSsid->Ssid, pOidSsid->SsidLength);
	pAd->MlmeAux.SsidLen = (UCHAR)pOidSsid->SsidLength;
	NdisZeroMemory(pAd->MlmeAux.Bssid, MAC_ADDR_LEN);
	pAd->MlmeAux.BssType = pAd->StaCfg.BssType;

	//
	// Update Reconnect Ssid, that user desired to connect.
	//
	NdisMoveMemory(pAd->MlmeAux.AutoReconnectSsid, pAd->MlmeAux.Ssid, pAd->MlmeAux.SsidLen);
	pAd->MlmeAux.AutoReconnectSsidLen = pAd->MlmeAux.SsidLen;

	// step 2. find all matching BSS in the lastest SCAN result (inBssTab) 
	//    & log them into MlmeAux.SsidBssTab for later-on iteration. Sort by RSSI order
	BssTableSsidSort(pAd, &pAd->MlmeAux.SsidBssTab, pAd->MlmeAux.Ssid, pAd->MlmeAux.SsidLen);

	DBGPRINT(RT_DEBUG_TRACE, ("CNTL - %d BSS of %d BSS match the desire SSID - %s\n",
			pAd->MlmeAux.SsidBssTab.BssNr, pAd->ScanTab.BssNr, pAd->MlmeAux.Ssid));
	NdisGetSystemUpTime(&Now);

	if (OPSTATUS_TEST_FLAG(pAd, fOP_STATUS_MEDIA_STATE_CONNECTED) && 
		(pAd->CommonCfg.SsidLen == pAd->MlmeAux.SsidBssTab.BssEntry[0].SsidLen) &&
		NdisEqualMemory(pAd->CommonCfg.Ssid, pAd->MlmeAux.SsidBssTab.BssEntry[0].Ssid, pAd->CommonCfg.SsidLen) &&
		MAC_ADDR_EQUAL(pAd->CommonCfg.Bssid, pAd->MlmeAux.SsidBssTab.BssEntry[0].Bssid))
	{
		// Case 1. already connected with an AP who has the desired SSID 
		//         with highest RSSI

		// Add checking Mode "LEAP" for CCX 1.0
		if (((pAd->CommonCfg.AuthMode == Ndis802_11AuthModeWPA) ||
			 (pAd->CommonCfg.AuthMode == Ndis802_11AuthModeWPAPSK) ||
			 (pAd->CommonCfg.AuthMode == Ndis802_11AuthModeWPA2) ||
			 (pAd->CommonCfg.AuthMode == Ndis802_11AuthModeWPA2PSK) ||
			 (pAd->StaCfg.LeapAuthMode == CISCO_AuthModeLEAP)
#if WPA_SUPPLICANT_SUPPORT
			 || (pAd->StaCfg.IEEE8021X == TRUE)		
#endif
			 ) &&
			(pAd->StaCfg.PortSecured == WPA_802_1X_PORT_NOT_SECURED))
		{
			// case 1.1 For WPA, WPA-PSK, if the 1x port is not secured, we have to redo 
			//          connection process
			DBGPRINT(RT_DEBUG_TRACE, ("CNTL - disassociate with current AP...\n"));
			DisassocParmFill(pAd, &DisassocReq, pAd->CommonCfg.Bssid, REASON_DEAUTH_STA_LEAVING);
			MlmeEnqueue(pAd, ASSOC_STATE_MACHINE, MT2_MLME_DISASSOC_REQ, 
						sizeof(MLME_DISASSOC_REQ_STRUCT), &DisassocReq);
			pAd->Mlme.CntlMachine.CurrState = CNTL_WAIT_DISASSOC;
		}
		else if (pAd->bConfigChanged == TRUE)
		{
			// case 1.2 Important Config has changed, we have to reconnect to the same AP
			DBGPRINT(RT_DEBUG_TRACE, ("CNTL - disassociate with current AP Because config changed...\n"));
			DisassocParmFill(pAd, &DisassocReq, pAd->CommonCfg.Bssid, REASON_DEAUTH_STA_LEAVING);
			MlmeEnqueue(pAd, ASSOC_STATE_MACHINE, MT2_MLME_DISASSOC_REQ, 
						sizeof(MLME_DISASSOC_REQ_STRUCT), &DisassocReq);
			pAd->Mlme.CntlMachine.CurrState = CNTL_WAIT_DISASSOC;
		}
		else
		{
			// case 1.3. already connected to the SSID with highest RSSI.
			DBGPRINT(RT_DEBUG_TRACE, ("CNTL - already with this BSSID. ignore this SET_SSID request\n"));
			//
			// (HCT 12.1) 1c_wlan_mediaevents required
			// media connect events are indicated when associating with the same AP			 
			//
			if (INFRA_ON(pAd))
			{
				//
				// Since MediaState already is NdisMediaStateConnected
				// We just indicate the connect event again to meet the WHQL required.
				//
#ifdef WIN_NDIS				
				pAd->IndicateMediaState = NdisMediaStateConnected;				
				NdisMIndicateStatus(pAd->AdapterHandle, NDIS_STATUS_MEDIA_CONNECT, (PVOID)NULL, 0);
				NdisMIndicateStatusComplete(pAd->AdapterHandle);
#endif	 /* WIN_NDIS */
			}

			pAd->Mlme.CntlMachine.CurrState = CNTL_IDLE;
		} 
	} 
	else if (INFRA_ON(pAd)) 
	{
		//
		// For WHQL
		// [88888] OID_802_11_SSID should have returned NDTEST_WEP_AP2(Returned: )
		// Driver may lost SSID, and not connect to NDTEST_WEP_AP2 and will connect to NDTEST_WEP_AP2 by Autoreconnect
		// But media status is connected, so the SSID not report correctly.
		//
		if (!SSID_EQUAL(pAd->CommonCfg.Ssid, pAd->CommonCfg.SsidLen, pAd->MlmeAux.Ssid, pAd->MlmeAux.SsidLen))
		{
			//
			// Different SSID means not Roaming case, so we let LinkDown() to Indicate a disconnect event.
			// 
			pAd->MlmeAux.CurrReqIsFromNdis = TRUE;
		}
		// case 2. active INFRA association existent
		//    roaming is done within miniport driver, nothing to do with configuration
		//    utility. so upon a new SET(OID_802_11_SSID) is received, we just 
		//    disassociate with the current associated AP, 
		//    then perform a new association with this new SSID, no matter the 
		//    new/old SSID are the same or not.
		DBGPRINT(RT_DEBUG_TRACE, ("CNTL - disassociate with current AP...\n"));
		DisassocParmFill(pAd, &DisassocReq, pAd->CommonCfg.Bssid, REASON_DEAUTH_STA_LEAVING);
		MlmeEnqueue(pAd, ASSOC_STATE_MACHINE, MT2_MLME_DISASSOC_REQ, 
					sizeof(MLME_DISASSOC_REQ_STRUCT), &DisassocReq);
		pAd->Mlme.CntlMachine.CurrState = CNTL_WAIT_DISASSOC;
	}
	else
	{   
		if (ADHOC_ON(pAd))
		{
			DBGPRINT(RT_DEBUG_TRACE, ("CNTL - drop current ADHOC\n"));
			LinkDown(pAd, FALSE);
			OPSTATUS_CLEAR_FLAG(pAd, fOP_STATUS_MEDIA_STATE_CONNECTED);
#ifdef WIN_NDIS			
			pAd->IndicateMediaState = NdisMediaStateDisconnected;
			NdisMIndicateStatus(pAd->AdapterHandle, NDIS_STATUS_MEDIA_DISCONNECT, (PVOID)NULL, 0);
			NdisMIndicateStatusComplete(pAd->AdapterHandle);
#endif	 /* WIN_NDIS */
			DBGPRINT(RT_DEBUG_TRACE, ("NDIS_STATUS_MEDIA_DISCONNECT Event C!\n"));
		}

		if ((pAd->MlmeAux.SsidBssTab.BssNr == 0) && 
			(pAd->StaCfg.bAutoReconnect == TRUE) && 
			(pAd->MlmeAux.BssType == BSS_INFRA) &&
			(MlmeValidateSSID(pAd->MlmeAux.Ssid, pAd->MlmeAux.SsidLen) == TRUE))
		{
			MLME_SCAN_REQ_STRUCT       ScanReq;

			DBGPRINT(RT_DEBUG_TRACE, ("CNTL - No matching BSS, start a new scan\n"));
			ScanParmFill(pAd, &ScanReq, pAd->MlmeAux.Ssid, pAd->MlmeAux.SsidLen, BSS_ANY, SCAN_ACTIVE);
			MlmeEnqueue(pAd, SYNC_STATE_MACHINE, MT2_MLME_SCAN_REQ, sizeof(MLME_SCAN_REQ_STRUCT), &ScanReq);
			pAd->Mlme.CntlMachine.CurrState = CNTL_WAIT_SCAN_FOR_CONNECT;//CNTL_WAIT_OID_LIST_SCAN;
			// Reset Missed scan number
			pAd->StaCfg.LastScanTime = Now;
//			pAd->StaCfg.bDisallowWZC = TRUE;
		}
		else
		{
			pAd->MlmeAux.BssIdx = 0;
			IterateOnBssTab(pAd);
		}
	} 
}

/*
	==========================================================================
	Description:

	IRQL = DISPATCH_LEVEL
	
	==========================================================================
*/
VOID CntlOidRTBssidProc(
	IN PRTMP_ADAPTER pAd, 
	IN MLME_QUEUE_ELEM * Elem) 
{
	ULONG       BssIdx;
	PUCHAR      pOidBssid = (PUCHAR)Elem->Msg;
	MLME_DISASSOC_REQ_STRUCT    DisassocReq;
	MLME_JOIN_REQ_STRUCT        JoinReq;

	DBGPRINT(RT_DEBUG_TRACE, ("CNTL - CntlOidRTBssidProc ...\n"));
	// record user desired settings
	COPY_MAC_ADDR(pAd->MlmeAux.Bssid, pOidBssid);
	pAd->MlmeAux.BssType = pAd->StaCfg.BssType;

	// find the desired BSS in the latest SCAN result table
	BssIdx = BssTableSearch(&pAd->ScanTab, pOidBssid, pAd->MlmeAux.Channel);	
	if (BssIdx == BSS_NOT_FOUND) 
	{
		DBGPRINT(RT_DEBUG_TRACE, ("CNTL - BSSID not found. reply NDIS_STATUS_NOT_ACCEPTED\n"));
		pAd->Mlme.CntlMachine.CurrState = CNTL_IDLE;
		return;
	}

	// copy the matched BSS entry from ScanTab to MlmeAux.SsidBssTab. Why?
	// Because we need this entry to become the JOIN target in later on SYNC state machine
	pAd->MlmeAux.BssIdx = 0;
	pAd->MlmeAux.SsidBssTab.BssNr = 1;
	NdisMoveMemory(&pAd->MlmeAux.SsidBssTab.BssEntry[0], &pAd->ScanTab.BssEntry[BssIdx], sizeof(BSS_ENTRY));

	//
	// Update Reconnect Ssid, that user desired to connect.
	//
	pAd->MlmeAux.AutoReconnectSsidLen = pAd->ScanTab.BssEntry[BssIdx].SsidLen;
	NdisMoveMemory(pAd->MlmeAux.AutoReconnectSsid, pAd->ScanTab.BssEntry[BssIdx].Ssid, pAd->ScanTab.BssEntry[BssIdx].SsidLen);

	// Add SSID into MlmeAux for site surey joining hidden SSID
	pAd->MlmeAux.SsidLen = pAd->ScanTab.BssEntry[BssIdx].SsidLen;
	NdisMoveMemory(pAd->MlmeAux.Ssid, pAd->ScanTab.BssEntry[BssIdx].Ssid, pAd->MlmeAux.SsidLen);	

	// 2002-11-26 skip the following checking. i.e. if user wants to re-connect to same AP
	//   we just follow normal procedure. The reason of user doing this may because he/she changed
	//   AP to another channel, but we still received BEACON from it thus don't claim Link Down.
	//   Since user knows he's changed AP channel, he'll re-connect again. By skipping the following
	//   checking, we'll disassociate then re-do normal association with this AP at the new channel.
	// 2003-1-6 Re-enable this feature based on microsoft requirement which prefer not to re-do
	//   connection when setting the same BSSID.
	if (OPSTATUS_TEST_FLAG(pAd, fOP_STATUS_MEDIA_STATE_CONNECTED) && 
		MAC_ADDR_EQUAL(pAd->CommonCfg.Bssid, pOidBssid))
	{
		// already connected to the same BSSID, go back to idle state directly
		DBGPRINT(RT_DEBUG_TRACE, ("CNTL - already in this BSSID. ignore this SET_BSSID request\n"));
		pAd->Mlme.CntlMachine.CurrState = CNTL_IDLE;
	} 
	else 
	{
		if (INFRA_ON(pAd))
		{
			// disassoc from current AP first
			DBGPRINT(RT_DEBUG_TRACE, ("CNTL - disassociate with current AP ...\n"));
			DisassocParmFill(pAd, &DisassocReq, pAd->CommonCfg.Bssid, REASON_DEAUTH_STA_LEAVING);
			MlmeEnqueue(pAd, ASSOC_STATE_MACHINE, MT2_MLME_DISASSOC_REQ, 
						sizeof(MLME_DISASSOC_REQ_STRUCT), &DisassocReq);

			pAd->Mlme.CntlMachine.CurrState = CNTL_WAIT_DISASSOC;
		}
		else
		{
			if (ADHOC_ON(pAd))
			{
				DBGPRINT(RT_DEBUG_TRACE, ("CNTL - drop current ADHOC\n"));
				LinkDown(pAd, FALSE);
				OPSTATUS_CLEAR_FLAG(pAd, fOP_STATUS_MEDIA_STATE_CONNECTED);
#ifdef WIN_NDIS				
				pAd->IndicateMediaState = NdisMediaStateDisconnected;
				NdisMIndicateStatus(pAd->AdapterHandle, NDIS_STATUS_MEDIA_DISCONNECT, (PVOID)NULL, 0);
				NdisMIndicateStatusComplete(pAd->AdapterHandle);
#endif	 /* WIN_NDIS */
				DBGPRINT(RT_DEBUG_TRACE, ("NDIS_STATUS_MEDIA_DISCONNECT Event C!\n"));
			}
#if 0
			// Change the wepstatus to original wepstatus
			pAd->CommonCfg.WepStatus   = pAd->CommonCfg.OrigWepStatus;
			pAd->CommonCfg.PairCipher  = pAd->CommonCfg.OrigWepStatus;
			pAd->CommonCfg.GroupCipher = pAd->CommonCfg.OrigWepStatus;
#endif			
			pAd->CommonCfg.MixedModeGroupCipher = Cipher_Type_NONE;

			// Check cipher suite, AP must have more secured cipher than station setting
			// Set the Pairwise and Group cipher to match the intended AP setting
			// We can only connect to AP with less secured cipher setting
			if ((pAd->CommonCfg.AuthMode == Ndis802_11AuthModeWPA) || (pAd->CommonCfg.AuthMode == Ndis802_11AuthModeWPAPSK))
			{
				pAd->CommonCfg.GroupCipher = pAd->ScanTab.BssEntry[BssIdx].WPA.GroupCipher;
				
				if (pAd->CommonCfg.WepStatus == pAd->ScanTab.BssEntry[BssIdx].WPA.PairCipher)
					pAd->CommonCfg.PairCipher = pAd->ScanTab.BssEntry[BssIdx].WPA.PairCipher;
				else if (pAd->ScanTab.BssEntry[BssIdx].WPA.PairCipherAux != Ndis802_11WEPDisabled)
					pAd->CommonCfg.PairCipher = pAd->ScanTab.BssEntry[BssIdx].WPA.PairCipherAux;
				else	// There is no PairCipher Aux, downgrade our capability to TKIP
					pAd->CommonCfg.PairCipher = Ndis802_11Encryption2Enabled;			
				
				// Set the mixed mode group cipher suite
				pAd->CommonCfg.MixedModeGroupCipher = pAd->ScanTab.BssEntry[BssIdx].MixedModeGroupCipher;

			}
			else if ((pAd->CommonCfg.AuthMode == Ndis802_11AuthModeWPA2) || (pAd->CommonCfg.AuthMode == Ndis802_11AuthModeWPA2PSK))
			{
				pAd->CommonCfg.GroupCipher = pAd->ScanTab.BssEntry[BssIdx].WPA2.GroupCipher;
				
				if (pAd->CommonCfg.WepStatus == pAd->ScanTab.BssEntry[BssIdx].WPA2.PairCipher)
					pAd->CommonCfg.PairCipher = pAd->ScanTab.BssEntry[BssIdx].WPA2.PairCipher;
				else if (pAd->ScanTab.BssEntry[BssIdx].WPA2.PairCipherAux != Ndis802_11WEPDisabled)
					pAd->CommonCfg.PairCipher = pAd->ScanTab.BssEntry[BssIdx].WPA2.PairCipherAux;
				else	// There is no PairCipher Aux, downgrade our capability to TKIP
					pAd->CommonCfg.PairCipher = Ndis802_11Encryption2Enabled;			

				// RSN capability
				pAd->CommonCfg.RsnCapability = pAd->ScanTab.BssEntry[BssIdx].WPA2.RsnCapability;
				
			}

			// RTMPMakeRSNIE for WPA-PSK / WPA2-PSK if connect via BSSID (Both mode may have GroupCipher==TKIP)
			RTMPMakeRSNIE(pAd, pAd->CommonCfg.GroupCipher);

			// Set Mix cipher flag
			if (pAd->CommonCfg.PairCipher != pAd->CommonCfg.GroupCipher)
				pAd->CommonCfg.bMixCipher = TRUE;		

			// No active association, join the BSS immediately
			DBGPRINT(RT_DEBUG_TRACE, ("CNTL - joining %02x:%02x:%02x:%02x:%02x:%02x ...\n",
					pOidBssid[0],pOidBssid[1],pOidBssid[2],pOidBssid[3],pOidBssid[4],pOidBssid[5]));

			JoinParmFill(pAd, &JoinReq, pAd->MlmeAux.BssIdx);
			MlmeEnqueue(pAd, SYNC_STATE_MACHINE, MT2_MLME_JOIN_REQ, sizeof(MLME_JOIN_REQ_STRUCT), &JoinReq);

			pAd->Mlme.CntlMachine.CurrState = CNTL_WAIT_JOIN;
		} 
	}
}

// Roaming is the only external request triggering CNTL state machine
// despite of other "SET OID" operation. All "SET OID" related oerations 
// happen in sequence, because no other SET OID will be sent to this device
// until the the previous SET operation is complete (successful o failed).
// So, how do we quarantee this ROAMING request won't corrupt other "SET OID"?
// or been corrupted by other "SET OID"?
//
// IRQL = DISPATCH_LEVEL
VOID CntlMlmeRoamingProc(
	IN PRTMP_ADAPTER pAd, 
	IN MLME_QUEUE_ELEM *Elem) 
{
	// TODO: 
	// AP in different channel may show lower RSSI than actual value??
	// should we add a weighting factor to compensate it?
	DBGPRINT(RT_DEBUG_TRACE,("CNTL - Roaming in MlmeAux.RoamTab...\n"));
	
	NdisMoveMemory(&pAd->MlmeAux.SsidBssTab, &pAd->MlmeAux.RoamTab, sizeof(pAd->MlmeAux.RoamTab));
	pAd->MlmeAux.SsidBssTab.BssNr = pAd->MlmeAux.RoamTab.BssNr;

	BssTableSortByRssi(&pAd->MlmeAux.SsidBssTab);
	pAd->MlmeAux.BssIdx = 0;
	IterateOnBssTab(pAd);
}

/*
	==========================================================================
	Description:

	IRQL = DISPATCH_LEVEL
	
	==========================================================================
*/
VOID CntlWaitDisassocProc(
	IN PRTMP_ADAPTER pAd, 
	IN MLME_QUEUE_ELEM *Elem) 
{
	MLME_START_REQ_STRUCT     StartReq;

	if (Elem->MsgType == MT2_DISASSOC_CONF) 
	{
		DBGPRINT(RT_DEBUG_TRACE, ("CNTL - Dis-associate successful\n"));
		LinkDown(pAd, FALSE);
		
		// case 1. no matching BSS, and user wants ADHOC, so we just start a new one        
		if ((pAd->MlmeAux.SsidBssTab.BssNr==0) && (pAd->StaCfg.BssType == BSS_ADHOC))
		{
			DBGPRINT(RT_DEBUG_TRACE, ("CNTL - No matching BSS, start a new ADHOC (Ssid=%s)...\n",pAd->MlmeAux.Ssid));
			StartParmFill(pAd, &StartReq, pAd->MlmeAux.Ssid, pAd->MlmeAux.SsidLen);
			MlmeEnqueue(pAd, SYNC_STATE_MACHINE, MT2_MLME_START_REQ, sizeof(MLME_START_REQ_STRUCT), &StartReq);
			pAd->Mlme.CntlMachine.CurrState = CNTL_WAIT_START;
		}
		// case 2. try each matched BSS
		else
		{
			pAd->MlmeAux.BssIdx = 0;
			IterateOnBssTab(pAd);
		}
	}
}

/*
	==========================================================================
	Description:

	IRQL = DISPATCH_LEVEL
	
	==========================================================================
*/
VOID CntlWaitJoinProc(
	IN PRTMP_ADAPTER pAd, 
	IN MLME_QUEUE_ELEM *Elem) 
{
	USHORT                      Reason;
	MLME_AUTH_REQ_STRUCT        AuthReq;

	if (Elem->MsgType == MT2_JOIN_CONF) 
	{
		NdisMoveMemory(&Reason, Elem->Msg, sizeof(USHORT));
		if (Reason == MLME_SUCCESS) 
		{
			// 1. joined an IBSS, we are pretty much done here
			if (pAd->MlmeAux.BssType == BSS_ADHOC)
			{
				LinkUp(pAd, BSS_ADHOC);
				pAd->Mlme.CntlMachine.CurrState = CNTL_IDLE;
				DBGPRINT(RT_DEBUG_TRACE, ("CNTL - join the IBSS = %02x:%02x:%02x:%02x:%02x:%02x ...\n", 
						pAd->CommonCfg.Bssid[0],pAd->CommonCfg.Bssid[1],pAd->CommonCfg.Bssid[2],
						pAd->CommonCfg.Bssid[3],pAd->CommonCfg.Bssid[4],pAd->CommonCfg.Bssid[5]));
			} 
			// 2. joined a new INFRA network, start from authentication
			else 
			{
#ifdef CCX_SUPPORT			
				// Add AuthMode "LEAP" for CCX 1.X
				if (pAd->StaCfg.LeapAuthMode == CISCO_AuthModeLEAP)
				{
					AuthParmFill(pAd, &AuthReq, pAd->MlmeAux.Bssid, CISCO_AuthModeLEAP);
				}
				else
#endif			
				{
					// either Ndis802_11AuthModeShared or Ndis802_11AuthModeAutoSwitch, try shared key first
					if ((pAd->CommonCfg.AuthMode == Ndis802_11AuthModeShared) ||
						(pAd->CommonCfg.AuthMode == Ndis802_11AuthModeAutoSwitch))
					{
						AuthParmFill(pAd, &AuthReq, pAd->MlmeAux.Bssid, Ndis802_11AuthModeShared);
					}
					else
					{
						AuthParmFill(pAd, &AuthReq, pAd->MlmeAux.Bssid, Ndis802_11AuthModeOpen);
					}
				}
				MlmeEnqueue(pAd, AUTH_STATE_MACHINE, MT2_MLME_AUTH_REQ, 
							sizeof(MLME_AUTH_REQ_STRUCT), &AuthReq);

				pAd->Mlme.CntlMachine.CurrState = CNTL_WAIT_AUTH;
			}
		}
		else
		{
			// 3. failed, try next BSS
			pAd->MlmeAux.BssIdx++;
			IterateOnBssTab(pAd);
		} 
	}
}


/*
	==========================================================================
	Description:

	IRQL = DISPATCH_LEVEL
	
	==========================================================================
*/
VOID CntlWaitStartProc(
	IN PRTMP_ADAPTER pAd, 
	IN MLME_QUEUE_ELEM *Elem) 
{
	USHORT      Result;

	if (Elem->MsgType == MT2_START_CONF) 
	{
		NdisMoveMemory(&Result, Elem->Msg, sizeof(USHORT));
		if (Result == MLME_SUCCESS) 
		{
			LinkUp(pAd, BSS_ADHOC);
			pAd->Mlme.CntlMachine.CurrState = CNTL_IDLE;

			// Before send beacon, driver need do radar detection
			if (((pAd->CommonCfg.PhyMode == PHY_11A) || (pAd->CommonCfg.PhyMode == PHY_11ABG_MIXED))&& (pAd->CommonCfg.bIEEE80211H == 1) && RadarChannelCheck(pAd, pAd->CommonCfg.Channel))
			{
				pAd->CommonCfg.RadarDetect.RDMode = RD_SILENCE_MODE;
				pAd->CommonCfg.RadarDetect.RDCount = 0;
				RadarDetectionStart(pAd);
			}

			DBGPRINT(RT_DEBUG_TRACE, ("CNTL - start a new IBSS = %02x:%02x:%02x:%02x:%02x:%02x ...\n", 
				pAd->CommonCfg.Bssid[0],pAd->CommonCfg.Bssid[1],pAd->CommonCfg.Bssid[2],
				pAd->CommonCfg.Bssid[3],pAd->CommonCfg.Bssid[4],pAd->CommonCfg.Bssid[5]));
		}
		else
		{
			DBGPRINT(RT_DEBUG_TRACE, ("CNTL - Start IBSS fail. BUG!!!!!\n"));
			pAd->Mlme.CntlMachine.CurrState = CNTL_IDLE;
		}
	}
}

/*
	==========================================================================
	Description:

	IRQL = DISPATCH_LEVEL
	
	==========================================================================
*/
VOID CntlWaitAuthProc(
	IN PRTMP_ADAPTER pAd, 
	IN MLME_QUEUE_ELEM *Elem) 
{
	USHORT                       Reason;
	MLME_ASSOC_REQ_STRUCT        AssocReq;
	MLME_AUTH_REQ_STRUCT         AuthReq;

	if (Elem->MsgType == MT2_AUTH_CONF) 
	{
		NdisMoveMemory(&Reason, Elem->Msg, sizeof(USHORT));
		if (Reason == MLME_SUCCESS) 
		{
			DBGPRINT(RT_DEBUG_TRACE, ("CNTL - AUTH OK\n"));
			AssocParmFill(pAd, &AssocReq, pAd->MlmeAux.Bssid, pAd->MlmeAux.CapabilityInfo, 
						  ASSOC_TIMEOUT, pAd->StaCfg.DefaultListenCount);
#ifdef CCX_SUPPORT
			//
			// Cisco Leap CCKM supported Re-association.
			//
			if (LEAP_CCKM_ON(pAd) && (pAd->StaCfg.CCKMLinkUpFlag == TRUE))
			{ 
				//if CCKM is turn on , that's mean Fast Reauthentication 
				//Use CCKM Reassociation instead of normal association for Fast Roaming.
				MlmeEnqueue(pAd, ASSOC_STATE_MACHINE, MT2_MLME_REASSOC_REQ, 
							sizeof(MLME_ASSOC_REQ_STRUCT), &AssocReq);

				pAd->Mlme.CntlMachine.CurrState = CNTL_WAIT_REASSOC;
			}
			else
#endif			
			{
				MlmeEnqueue(pAd, ASSOC_STATE_MACHINE, MT2_MLME_ASSOC_REQ, 
							sizeof(MLME_ASSOC_REQ_STRUCT), &AssocReq);

				pAd->Mlme.CntlMachine.CurrState = CNTL_WAIT_ASSOC;
			}
		} 
		else
		{
			// This fail may because of the AP already keep us in its MAC table without 
			// ageing-out. The previous authentication attempt must have let it remove us.
			// so try Authentication again may help. For D-Link DWL-900AP+ compatibility.
			DBGPRINT(RT_DEBUG_TRACE, ("CNTL - AUTH FAIL, try again...\n"));
#ifdef CCX_SUPPORT			
			//Add AuthMode "LEAP" for CCX 1.X
			if (pAd->StaCfg.LeapAuthMode == CISCO_AuthModeLEAP)
			{
				AuthParmFill(pAd, &AuthReq, pAd->MlmeAux.Bssid, CISCO_AuthModeLEAP);
			}
			else
#endif			
			{
				if ((pAd->CommonCfg.AuthMode == Ndis802_11AuthModeShared) ||
					(pAd->CommonCfg.AuthMode == Ndis802_11AuthModeAutoSwitch))
				{
					// either Ndis802_11AuthModeShared or Ndis802_11AuthModeAutoSwitch, try shared key first
					AuthParmFill(pAd, &AuthReq, pAd->MlmeAux.Bssid, Ndis802_11AuthModeShared);
				}
				else
				{
					AuthParmFill(pAd, &AuthReq, pAd->MlmeAux.Bssid, Ndis802_11AuthModeOpen);
				}
			}
			MlmeEnqueue(pAd, AUTH_STATE_MACHINE, MT2_MLME_AUTH_REQ, 
						sizeof(MLME_AUTH_REQ_STRUCT), &AuthReq);

			pAd->Mlme.CntlMachine.CurrState = CNTL_WAIT_AUTH2;
		}
	}
}

/*
	==========================================================================
	Description:

	IRQL = DISPATCH_LEVEL
	
	==========================================================================
*/
VOID CntlWaitAuthProc2(
	IN PRTMP_ADAPTER pAd, 
	IN MLME_QUEUE_ELEM *Elem) 
{
	USHORT                       Reason;
	MLME_ASSOC_REQ_STRUCT        AssocReq;
	MLME_AUTH_REQ_STRUCT         AuthReq;

	if (Elem->MsgType == MT2_AUTH_CONF) 
	{
		NdisMoveMemory(&Reason, Elem->Msg, sizeof(USHORT));
		if (Reason == MLME_SUCCESS) 
		{
			DBGPRINT(RT_DEBUG_TRACE, ("CNTL - AUTH OK\n"));
			AssocParmFill(pAd, &AssocReq, pAd->MlmeAux.Bssid, pAd->MlmeAux.CapabilityInfo, 
						  ASSOC_TIMEOUT, pAd->StaCfg.DefaultListenCount);
			MlmeEnqueue(pAd, ASSOC_STATE_MACHINE, MT2_MLME_ASSOC_REQ, 
						sizeof(MLME_ASSOC_REQ_STRUCT), &AssocReq);

			pAd->Mlme.CntlMachine.CurrState = CNTL_WAIT_ASSOC;
		} 
		else
		{			
			// Process LEAP first, since it use different control variable
			// We don't want to affect other poven operation
			if (pAd->StaCfg.LeapAuthMode == CISCO_AuthModeLEAP)
			{
#ifdef CCX_SUPPORT			
				// LEAP Auth not success, try next BSS
				DBGPRINT(RT_DEBUG_TRACE, ("CNTL - *LEAP* AUTH FAIL, give up; try next BSS\n"));
				DBGPRINT(RT_DEBUG_TRACE, ("Total match BSSID [=%d]\n", pAd->MlmeAux.SsidBssTab.BssNr));
				pAd->Mlme.CntlMachine.CurrState = CNTL_IDLE;
				pAd->MlmeAux.BssIdx++;
				IterateOnBssTab(pAd);
#endif				
			}
			else if ((pAd->CommonCfg.AuthMode == Ndis802_11AuthModeAutoSwitch) &&
					(pAd->MlmeAux.Alg == Ndis802_11AuthModeShared))				 
			{
				DBGPRINT(RT_DEBUG_TRACE, ("CNTL - AUTH FAIL, try OPEN system...\n"));
				AuthParmFill(pAd, &AuthReq, pAd->MlmeAux.Bssid, Ndis802_11AuthModeOpen);
				MlmeEnqueue(pAd, AUTH_STATE_MACHINE, MT2_MLME_AUTH_REQ, 
							sizeof(MLME_AUTH_REQ_STRUCT), &AuthReq);

				pAd->Mlme.CntlMachine.CurrState = CNTL_WAIT_AUTH2;
			}
			else 
			{
				// not success, try next BSS
				DBGPRINT(RT_DEBUG_TRACE, ("CNTL - AUTH FAIL, give up; try next BSS\n"));
				pAd->Mlme.CntlMachine.CurrState = CNTL_IDLE; //???????
				pAd->MlmeAux.BssIdx++;
				IterateOnBssTab(pAd);
			}
		}
	}
}

/*
	==========================================================================
	Description:

	IRQL = DISPATCH_LEVEL
	
	==========================================================================
*/
VOID CntlWaitAssocProc(
	IN PRTMP_ADAPTER pAd, 
	IN MLME_QUEUE_ELEM *Elem) 
{
	USHORT      Reason;

	if (Elem->MsgType == MT2_ASSOC_CONF) 
	{
		NdisMoveMemory(&Reason, Elem->Msg, sizeof(USHORT));
		if (Reason == MLME_SUCCESS) 
		{
			LinkUp(pAd, BSS_INFRA);
			pAd->Mlme.CntlMachine.CurrState = CNTL_IDLE;
			DBGPRINT(RT_DEBUG_TRACE, ("CNTL - Association successful on BSS #%ld\n",pAd->MlmeAux.BssIdx));
		} 
		else 
		{
			// not success, try next BSS
			DBGPRINT(RT_DEBUG_TRACE, ("CNTL - Association fails on BSS #%ld\n",pAd->MlmeAux.BssIdx));
			pAd->MlmeAux.BssIdx++;
			IterateOnBssTab(pAd);
		}
	}
}

/*
	==========================================================================
	Description:

	IRQL = DISPATCH_LEVEL
	
	==========================================================================
*/
VOID CntlWaitReassocProc(
	IN PRTMP_ADAPTER pAd, 
	IN MLME_QUEUE_ELEM *Elem) 
{
	USHORT      Result;

	if (Elem->MsgType == MT2_REASSOC_CONF) 
	{
		NdisMoveMemory(&Result, Elem->Msg, sizeof(USHORT));
		if (Result == MLME_SUCCESS) 
		{
			// 
			// NDIS requires a new Link UP indication but no Link Down for RE-ASSOC
			//
			LinkUp(pAd, BSS_INFRA);
#ifdef CCX_SUPPORT
			if (LEAP_CCKM_ON(pAd))
			{
				pAd->StaCfg.PortSecured = WPA_802_1X_PORT_SECURED;
				pAd->StaCfg.WpaState = SS_FINISH;			
			}
#endif
			pAd->Mlme.CntlMachine.CurrState = CNTL_IDLE;
			DBGPRINT(RT_DEBUG_TRACE, ("CNTL - Re-assocition successful on BSS #%ld\n", pAd->MlmeAux.RoamIdx));
		} 
		else 
		{
			// reassoc failed, try to pick next BSS in the BSS Table
			DBGPRINT(RT_DEBUG_TRACE, ("CNTL - Re-assocition fails on BSS #%ld\n", pAd->MlmeAux.RoamIdx));
			pAd->MlmeAux.RoamIdx++;
			IterateOnBssTab2(pAd);
		}
	}
}

/*
	==========================================================================
	Description:

	IRQL = DISPATCH_LEVEL
	
	==========================================================================
*/
VOID LinkUp(
	IN PRTMP_ADAPTER pAd,
	IN UCHAR BssType) 
{
	ULONG	Now;
	BOOLEAN	Cancelled;
	UCHAR	idx;
	UINT32		Value = BW_40, MACValue;
	UCHAR		BBPValue;
	MAC_TABLE_ENTRY *pEntry;
	unsigned long   IrqFlags;
		
	//
	// ASSOC - DisassocTimeoutAction
	// CNTL - Dis-associate successful
	// !!! LINK DOWN !!!
	// [88888] OID_802_11_SSID should have returned NDTEST_WEP_AP2(Returned: )
	// 
	// To prevent DisassocTimeoutAction to call Link down after we link up,
	// cancel the DisassocTimer no matter what it start or not.
	//
	RTMPCancelTimer(&pAd->MlmeAux.DisassocTimer,  &Cancelled);

	COPY_SETTINGS_FROM_MLME_AUX_TO_ACTIVE_CFG(pAd);
	COPY_HTSETTINGS_FROM_MLME_AUX_TO_ACTIVE_CFG(pAd);

	DBGPRINT(RT_DEBUG_TRACE, ("!!! LINK UP !!(MaxRAmpduFactor=%d,)Desired-MpduDensity=%d, StaActive-MpduDensity=%d\n", 
		pAd->MacTab.Content[BSSID_WCID].MaxRAmpduFactor,pAd->CommonCfg.SupportedHtPhy.MpduDensity, pAd->StaActive.SupportedHtPhy.MpduDensity));
	// It's quite difficult to tell if a newly added KEY is WEP or CKIP until a new BSS
	// is formed (either ASSOC/RE-ASSOC done or IBSS started. LinkUP should be a safe place
	// to examine if cipher algorithm switching is required.
	SwitchBetweenWepAndCkip(pAd);

	if (BssType == BSS_ADHOC)
	{
		OPSTATUS_SET_FLAG(pAd, fOP_STATUS_ADHOC_ON);
		OPSTATUS_CLEAR_FLAG(pAd, fOP_STATUS_INFRA_ON);
		pAd->CommonCfg.BBPCurrentBW = BW_20;
		AsicSwitchChannel(pAd, pAd->CommonCfg.Channel, FALSE);
		AsicLockChannel(pAd, pAd->CommonCfg.Channel);

		RTUSBReadBBPRegister(pAd, BBP_R4, &BBPValue);
		BBPValue &= (~0x18);
		RTUSBWriteBBPRegister(pAd, BBP_R4, BBPValue);

		RTUSBReadMACRegister(pAd, TX_BAND_CFG, &Value);
		Value &= 0xfffffffe;
		RTUSBWriteMACRegister(pAd, TX_BAND_CFG, Value);

		RTUSBReadBBPRegister(pAd, BBP_R3, &BBPValue);
		BBPValue &= (~0x20);
		RTUSBWriteBBPRegister(pAd, BBP_R3, BBPValue);

		if (pAd->MACVersion == 0x28600100)
		{
			RTUSBWriteBBPRegister(pAd, BBP_R69, 0x16);
			RTUSBWriteBBPRegister(pAd, BBP_R70, 0x08);
			RTUSBWriteBBPRegister(pAd, BBP_R73, 0x11);
		}

		DBGPRINT(RT_DEBUG_TRACE, ("!!!20MHz Adhoc LINK UP !!! \n" ));
	}
	else
	{
		OPSTATUS_SET_FLAG(pAd, fOP_STATUS_INFRA_ON);
		OPSTATUS_CLEAR_FLAG(pAd, fOP_STATUS_ADHOC_ON);
		if ((pAd->CommonCfg.CentralChannel > pAd->CommonCfg.Channel) && (pAd->CommonCfg.DesiredHtPhy.ChannelWidth == BW_40))
		// Turn on BBP 20MHz mode by request here.
		{
			RTUSBReadMACRegister(pAd, TX_BAND_CFG, &MACValue);
			MACValue &= 0xfe;
			RTUSBWriteMACRegister(pAd, TX_BAND_CFG, MACValue);
				RTUSBReadBBPRegister(pAd, BBP_R4, &BBPValue);
				BBPValue&= (~0x18);
				BBPValue|= (0x10);
				RTUSBWriteBBPRegister(pAd, BBP_R4, BBPValue);
				RTUSBReadBBPRegister(pAd, BBP_R3, &BBPValue);
				BBPValue&= (~0x20);
				RTUSBWriteBBPRegister(pAd, BBP_R3, BBPValue);
			pAd->CommonCfg.BBPCurrentBW = BW_40;
			AsicSwitchChannel(pAd, pAd->CommonCfg.CentralChannel,FALSE);
			AsicLockChannel(pAd, pAd->CommonCfg.CentralChannel);
			if (pAd->MACVersion == 0x28600100)
			{
				RTUSBWriteBBPRegister(pAd, BBP_R69, 0x1A);
				RTUSBWriteBBPRegister(pAd, BBP_R70, 0x0A);
				RTUSBWriteBBPRegister(pAd, BBP_R73, 0x16);
				DBGPRINT(RT_DEBUG_TRACE, ("!!!rt2860C !!! \n" ));
			}
			DBGPRINT(RT_DEBUG_TRACE, ("!!!40MHz Lower LINK UP !!! Control Channel at Below. Central = %d \n", pAd->CommonCfg.CentralChannel ));
			
		}
		else if ((pAd->CommonCfg.CentralChannel < pAd->CommonCfg.Channel)&& (pAd->CommonCfg.DesiredHtPhy.ChannelWidth == BW_40))
		{	
			RTUSBReadMACRegister(pAd, TX_BAND_CFG, &MACValue);
			MACValue &= 0xfe;
			MACValue |= 0x1;
			RTUSBWriteMACRegister(pAd, TX_BAND_CFG, MACValue);
				RTUSBReadBBPRegister(pAd, BBP_R4, &BBPValue);
				BBPValue&= (~0x18);
				BBPValue|= (0x10);
				RTUSBWriteBBPRegister(pAd, BBP_R4, BBPValue);
				RTUSBReadBBPRegister(pAd, BBP_R3, &BBPValue);
				BBPValue&= (~0x20);
				BBPValue|= (0x20);
				RTUSBWriteBBPRegister(pAd, BBP_R3, BBPValue);
			pAd->CommonCfg.BBPCurrentBW = BW_40;
			AsicSwitchChannel(pAd, pAd->CommonCfg.CentralChannel,FALSE);
			AsicLockChannel(pAd, pAd->CommonCfg.CentralChannel);
			if (pAd->MACVersion == 0x28600100)
			{
				RTUSBWriteBBPRegister(pAd, BBP_R69, 0x1A);
				RTUSBWriteBBPRegister(pAd, BBP_R70, 0x0A);
				RTUSBWriteBBPRegister(pAd, BBP_R73, 0x16);
				DBGPRINT(RT_DEBUG_TRACE, ("!!!rt2860C !!! \n" ));
			}
			DBGPRINT(RT_DEBUG_TRACE, ("!!!40MHz Upper LINK UP !!! Control Channel at UpperCentral = %d \n", pAd->CommonCfg.CentralChannel ));
		}
		else
		{
			RTUSBReadBBPRegister(pAd, BBP_R4, &BBPValue);
			BBPValue&= (~0x18);
			RTUSBWriteBBPRegister(pAd, BBP_R4, BBPValue);
			if (pAd->MACVersion == 0x28600100)
			{
				RTUSBWriteBBPRegister(pAd, BBP_R69, 0x16);
				RTUSBWriteBBPRegister(pAd, BBP_R70, 0x08);
				RTUSBWriteBBPRegister(pAd, BBP_R73, 0x11);
				DBGPRINT(RT_DEBUG_TRACE, ("!!!rt2860C !!! \n" ));
			}
			pAd->CommonCfg.BBPCurrentBW = BW_20;
			DBGPRINT(RT_DEBUG_TRACE, ("!!!20MHz LINK UP !!! \n" ));
		}
	}

	if (pAd->LatchRfRegs.Channel <= 14)
	{
		if (pAd->CommonCfg.BBPCurrentBW == BW_20)
		{
			RTUSBWriteBBPRegister(pAd, BBP_R66, 0x30);
		}
		else
		{
			RTUSBWriteBBPRegister(pAd, BBP_R66, 0x38);
		}
	}
	else
	{
		if (pAd->CommonCfg.BBPCurrentBW == BW_20)
		{
			RTUSBWriteBBPRegister(pAd, BBP_R66, 0x40);
		}
		else
		{
			RTUSBWriteBBPRegister(pAd, BBP_R66, 0x48);
		}
	}

	AsicSetBssid(pAd, pAd->CommonCfg.Bssid);

	AsicSetSlotTime(pAd, TRUE); //FALSE);
	AsicSetEdcaParm(pAd, &pAd->CommonCfg.APEdcaParm);
	
	DBGPRINT(RT_DEBUG_TRACE, ("!!! LINK UP !!! (Infra=%d, AID=%d, ssid=%s, Channel=%d, CentralChannel = %d) (Density =%d, )n", 
		BssType, pAd->StaActive.Aid, pAd->CommonCfg.Ssid, pAd->CommonCfg.Channel, pAd->CommonCfg.CentralChannel, pAd->MacTab.Content[BSSID_WCID].MpduDensity));
	
 	NdisZeroMemory(&pAd->DrsCounters, sizeof(COUNTER_DRS));

	NdisGetSystemUpTime(&Now);
	pAd->StaCfg.LastBeaconRxTime = Now;   // last RX timestamp

	if ((pAd->CommonCfg.TxPreamble != Rt802_11PreambleLong) &&
		CAP_IS_SHORT_PREAMBLE_ON(pAd->StaActive.CapabilityInfo))
	{

		DBGPRINT(RT_DEBUG_INFO, ("CNTL - !!! Set to short preamble!!!\n"));
		MlmeSetTxPreamble(pAd, Rt802_11PreambleShort);
	}

	OPSTATUS_CLEAR_FLAG(pAd, fOP_STATUS_AGGREGATION_INUSED);

 	if (pAd->CommonCfg.RadarDetect.RDMode == RD_SILENCE_MODE)
	{
		RadarDetectionStop(pAd);
 	}
	pAd->CommonCfg.RadarDetect.RDMode = RD_NORMAL_MODE;

	if (BssType == BSS_ADHOC)
	{
		//
		// We also need to cancel the LinkDownTimer, no matter it was been set or not.
		// It may be set when we start an Infrastructure mode.
		// And not be canceled yet then we switch to Adohc at meanwhile.
		//
		RTMPCancelTimer(&pAd->Mlme.LinkDownTimer, &Cancelled);

		MakeIbssBeacon(pAd);
		
		if (((pAd->CommonCfg.PhyMode == PHY_11A) || (pAd->CommonCfg.PhyMode == PHY_11ABG_MIXED))&& (pAd->CommonCfg.bIEEE80211H == 1) && RadarChannelCheck(pAd, pAd->CommonCfg.Channel))
		{
			; //Do nothing
		}
		else
		{
			AsicEnableIbssSync(pAd);
		}
		
#ifdef	SINGLE_ADHOC_LINKUP
		// Although this did not follow microsoft's recommendation.
		//Change based on customer's request
		DBGPRINT(RT_DEBUG_TRACE, ("LinkUp - !!!SINGLE_ADHOC_LINKUP!!!\n"));
		OPSTATUS_SET_FLAG(pAd, fOP_STATUS_MEDIA_STATE_CONNECTED);
#ifdef WIN_NDIS		
		pAd->IndicateMediaState = NdisMediaStateConnected;
		NdisMIndicateStatus(pAd->AdapterHandle, NDIS_STATUS_MEDIA_CONNECT, (PVOID)NULL, 0);
		NdisMIndicateStatusComplete(pAd->AdapterHandle);
#endif	 /* WIN_NDIS */
#endif

	}
	else // BSS_INFRA
	{
		// First cancel linkdown timer
		RTMPCancelTimer(&pAd->Mlme.LinkDownTimer, &Cancelled);
		// Check the new SSID with last SSID
		while (Cancelled == TRUE)
		{
			if (pAd->CommonCfg.LastSsidLen == pAd->CommonCfg.SsidLen)
			{
				if (RTMPCompareMemory(pAd->CommonCfg.LastSsid, pAd->CommonCfg.Ssid, pAd->CommonCfg.LastSsidLen) == 0)
				{
					// Link to the old one no linkdown is required.
					break;
				}
			}
			// Send link down event before set to link up
#ifdef WIN_NDIS			
			pAd->IndicateMediaState = NdisMediaStateDisconnected;
			NdisMIndicateStatus(pAd->AdapterHandle, NDIS_STATUS_MEDIA_DISCONNECT, (PVOID)NULL, 0);
			NdisMIndicateStatusComplete(pAd->AdapterHandle);
#endif	 /* WIN_NDIS */
			DBGPRINT(RT_DEBUG_TRACE, ("NDIS_STATUS_MEDIA_DISCONNECT Event AA!\n"));
			break;
		}

		//
		// On WPA mode, Remove All Keys if not connect to the last BSSID
		// Key will be set after 4-way handshake.
		//
		if ((pAd->CommonCfg.AuthMode >= Ndis802_11AuthModeWPA) &&
			(!RTMPEqualMemory(pAd->CommonCfg.LastBssid, pAd->CommonCfg.Bssid, MAC_ADDR_LEN)))
		{
			// Remove all WPA keys 
			RTMPWPARemoveAllKeys(pAd);			
			pAd->StaCfg.PortSecured = WPA_802_1X_PORT_NOT_SECURED;			
		}
		// NOTE:
		// the decision of using "short slot time" or not may change dynamically due to
		// new STA association to the AP. so we have to decide that upon parsing BEACON, not here

		// NOTE:
		// the decision to use "RTC/CTS" or "CTS-to-self" protection or not may change dynamically
		// due to new STA association to the AP. so we have to decide that upon parsing BEACON, not here

		ComposePsPoll(pAd);
		ComposeNullFrame(pAd);
		AsicEnableBssSync(pAd);

		// only INFRASTRUCTURE mode need to indicate connectivity immediately; ADHOC mode
		// should wait until at least 2 active nodes in this BSSID.
		OPSTATUS_SET_FLAG(pAd, fOP_STATUS_MEDIA_STATE_CONNECTED); 

		/*
		//
		// Patch some AP on WPAPSK & WPA2PSK mode that they send first 4Way EAPOL frame before station indicate connect event to OS.
		// In this case, we are on disconnect state so that 802.1x protocol driver will dropt this packet.
		// But if AP didn't retransmit first 4way packet, we will not connect to this AP anymore.
		// For example: Linksys model: BEFW11S4 Ver.4 it send first 4way packet very fast within 2 ms.
		//
		pAd->bQueueEAPOL = FALSE;
		if (pAd->RxEAPOLLen != 0)
		{
			pAd->pRxData = pAd->pRxEAPOL + LENGTH_802_3;
			NdisMEthIndicateReceive(pAd->AdapterHandle, 
									(NDIS_HANDLE)pAd,
									(PVOID)pAd->pRxEAPOL,
									LENGTH_802_3, 
									(PVOID)(pAd->pRxEAPOL + LENGTH_802_3),
									pAd->RxEAPOLLen,
									pAd->RxEAPOLLen);
			NdisMEthIndicateReceiveComplete(pAd->AdapterHandle);
			pAd->RxEAPOLLen = 0;
			pAd->Counters8023.GoodReceives++;
			DBGPRINT(RT_DEBUG_TRACE, ("Indicate previous queued EAPOL frame\n"));
		}*/

		// Add BSSID in my MAC Table.
		MacTableInsertEntry(pAd, pAd->CommonCfg.Bssid, FALSE);
		// Update MAC Table with BSSID_WCID
		NdisAcquireSpinLock(&pAd->MacTabLock, IrqFlags);
		RTMPMoveMemory(pAd->MacTab.Content[BSSID_WCID].Addr, pAd->CommonCfg.Bssid, MAC_ADDR_LEN);
		pAd->MacTab.Content[BSSID_WCID].Aid = BSSID_WCID;
		pAd->MacTab.Content[BSSID_WCID].pAd = pAd;
		pAd->MacTab.Content[BSSID_WCID].ValidAsCLI = TRUE;	//Although this is bssid..still set ValidAsCl
		pAd->MacTab.Content[BSSID_WCID].Sst = SST_ASSOC;
		pAd->MacTab.Content[BSSID_WCID].AuthState = SST_ASSOC;
		pAd->MacTab.Content[BSSID_WCID].BaSizeInUse = (UCHAR)pAd->CommonCfg.BACapability.field.TxBAWinLimit;
		NdisReleaseSpinLock(&pAd->MacTabLock, IrqFlags);

		// For emulation, add BA session.
		if ((pAd->CommonCfg.BACapability.field.AutoBA == TRUE) && (pAd->StaActive.SupportedHtPhy.bHtEnable == TRUE))
		{
			for (idx = 0; idx <NUM_OF_TID; idx++)
			{
				// If add myself as one Recipient of peer (pAd->CommonCfg.Bssid), the sequence 0xffff indicates the BA
				// session not started yet. 
				BATableInsertEntry(pAd, BSSID_WCID,  0, 0x1, idx, pAd->MacTab.Content[BSSID_WCID].BaSizeInUse,  Originator_SetAutoAdd, FALSE);
				pAd->MacTab.Content[BSSID_WCID].TXAutoBAbitmap |= (1<<idx);
			}
		}
		DBGPRINT(RT_DEBUG_TRACE, ("ClientStatusFlags = %lx!\n", pAd->MacTab.Content[BSSID_WCID].ClientStatusFlags));
#ifdef CCX_SUPPORT
		//
		// Report Adjacent AP report.
		//
		CCXAdjacentAPReport(pAd);
#endif
		if ((pAd->MlmeAux.APRalinkIe & 0x00000002) == 2)
		{
			CLIENT_STATUS_SET_FLAG(&pAd->MacTab.Content[BSSID_WCID], fCLIENT_STATUS_PIGGYBACK_CAPABLE);			
			AsicDisablePiggyB(pAd);
			DBGPRINT(RT_DEBUG_TRACE, ("Turn on Piggy-Back\n"));
		}
		if (pAd->MlmeAux.APRalinkIe & 0x00000001)
		{
			CLIENT_STATUS_SET_FLAG(&pAd->MacTab.Content[BSSID_WCID], fOP_STATUS_AGGREGATION_INUSED);
		}
	}

	MlmeUpdateTxRates(pAd, TRUE);
	MlmeUpdateHtTxRates(pAd, BSSID_WCID);
	RTMPUpdateMlmeRate(pAd);

	// To gain high TX throughput, need to set as following,
	// 1. Set txop in register-EDCA_AC0_CFG as 0x60
	// 2. PBF_MAX_PCNT as 0x1F3FBF9F
	// 
	// Txop can only be modified when RDG is off, WMM is disable and TxBurst is enable
	if (pAd->CommonCfg.bEnableTxBurst)
	{
		// Add burst for HT mode.
		RTUSBReadMACRegister(pAd, EDCA_AC0_CFG, &MACValue);
		MACValue  &= 0xFFFFFF00;
		MACValue  |= 0x60;
		RTUSBWriteMACRegister(pAd, EDCA_AC0_CFG, MACValue);
	}
	if ((pAd->StaActive.SupportedHtPhy.bHtEnable == TRUE))
	{

		if (pAd->MacTab.Content[BSSID_WCID].MaxRAmpduFactor == 0)
		{
			// If HT AP doesn't support MaxRAmpduFactor = 1, we need to set max PSDU to 0.
			// Because our Init value is 1 at MACRegTable.
			RTUSBWriteMACRegister(pAd, MAX_LEN_CFG, 0x0fff);
			DBGPRINT(RT_DEBUG_TRACE, ("!!!AP MaxRAmpduFactor= %d \n", pAd->MacTab.Content[BSSID_WCID].MaxRAmpduFactor));
		}
		
		if (CLIENT_STATUS_TEST_FLAG(&pAd->MacTab.Content[BSSID_WCID], fCLIENT_STATUS_RDG_CAPABLE))
		{
			AsicEnableRDG(pAd);
			DBGPRINT(RT_DEBUG_TRACE, ("--->AsicEnableRDG \n"));
		}
		if (pAd->MlmeAux.APRalinkIe != 0x0)
		{
			CLIENT_STATUS_SET_FLAG(&pAd->MacTab.Content[BSSID_WCID], fCLIENT_STATUS_RALINK_CHIPSET);
			DBGPRINT(RT_DEBUG_TRACE, ("--->Assoc with Ralink Chipset \n"));
		}

		if (pAd->MlmeAux.AddHtInfo.AddHtInfo2.NonGfPresent == 1)
		{
			AsicUpdateProtect(pAd, pAd->MlmeAux.AddHtInfo.AddHtInfo2.OperaionMode,  ALLN_SETPROTECT, FALSE, TRUE);
		}
		else
			AsicUpdateProtect(pAd, pAd->MlmeAux.AddHtInfo.AddHtInfo2.OperaionMode,  ALLN_SETPROTECT, FALSE, FALSE);
		DBGPRINT(RT_DEBUG_TRACE, ("AP set OperaionMode = %d,  NonGfPresent = %d\n", pAd->MlmeAux.AddHtInfo.AddHtInfo2.OperaionMode, pAd->MlmeAux.AddHtInfo.AddHtInfo2.NonGfPresent));
	}
	
	DBGPRINT(RT_DEBUG_INFO, ("CCX: CWMax CWMin %d %d\n", pAd->StaCfg.CCXQosECWMax, pAd->StaCfg.CCXQosECWMin));

	// Set LED
	RTMPSetLED(pAd, LED_LINK_UP);

	//
	// Enable OFDM TX rate auto fallback to CCK, if need.
	//
	/*RTUSBReadMACRegister(pAd, TXRX_CSR4, &CurTxRxCsr4.word);
	NewTxRxCsr4.word = CurTxRxCsr4.word;
	if ((pAd->CommonCfg.Channel <= 14) && 
		((pAd->CommonCfg.PhyMode == PHY_11B) ||
		 (pAd->CommonCfg.PhyMode == PHY_11BG_MIXED) ||
		 (pAd->CommonCfg.PhyMode == PHY_11ABG_MIXED)))
	{
		NewTxRxCsr4.field.OfdmTxFallbacktoCCK = 1;   //Enable OFDM TX rate auto fallback to CCK 1M, 2M
	}
	else
	{
		NewTxRxCsr4.field.OfdmTxFallbacktoCCK = 0;   //Disable OFDM TX rate auto fallback to CCK 1M, 2M	
	}
*/
	
	// Set initial tx rate
	if (pAd->CommonCfg.bAutoTxRateSwitch == TRUE)
	{
		PUCHAR					pTable;
		UCHAR					TableSize = 0;
		PRTMP_TX_RATE_SWITCH	pTxRate;
		
		MlmeSelectTxRateTable(pAd, &pTable, &TableSize, &pAd->CommonCfg.TxRateIndex);
		pTxRate = (PRTMP_TX_RATE_SWITCH) &pTable[(pAd->CommonCfg.TxRateIndex+1)*5];

		AsicUpdateAutoFallBackTable(pAd, pTable);
	}
	if (pAd->CommonCfg.bAutoTxRateSwitch == FALSE)
	{
		pEntry = &pAd->MacTab.Content[BSSID_WCID];
		
		pEntry->HTPhyMode.field.MODE	= pAd->CommonCfg.HTPhyMode.field.MODE;
		pEntry->HTPhyMode.field.MCS		= pAd->CommonCfg.HTPhyMode.field.MCS;
		pEntry->HTPhyMode.field.BW		= pAd->CommonCfg.HTPhyMode.field.BW;
		pEntry->HTPhyMode.field.STBC	= pAd->CommonCfg.HTPhyMode.field.STBC;
		pEntry->HTPhyMode.field.ShortGI	= pAd->CommonCfg.HTPhyMode.field.ShortGI;
		if (pEntry->HTPhyMode.field.MCS == 32)
			pEntry->HTPhyMode.field.ShortGI = GI_800;

		if ((pEntry->HTPhyMode.field.MCS > MCS_7) || (pEntry->HTPhyMode.field.MCS == 32))
			pEntry->HTPhyMode.field.STBC = STBC_NONE;
	}
	//  Let Link Status Page display first initial rate.
	pAd->LastTxRate = (USHORT)(pAd->MacTab.Content[BSSID_WCID].HTPhyMode.word);
	pAd->Mlme.PeriodicRound = 0;        // re-schedule MlmePeriodicExec()
	pAd->Mlme.OneSecPeriodicRound = 0;
	pAd->bConfigChanged = FALSE;        // Reset config flag
	pAd->ExtraInfo = GENERAL_LINK_UP;   // Update extra information to link is up

	// Select DAC according to HT or Legacy
	if (pAd->StaActive.SupportedHtPhy.MCSSet[0] != 0x00)
	{
		RTUSBReadBBPRegister(pAd, BBP_R1, &BBPValue);
		BBPValue &= (~0x18);
		BBPValue |= 0x10;
		RTUSBWriteBBPRegister(pAd, BBP_R1, BBPValue);
	}
	else
	{
		RTUSBReadBBPRegister(pAd, BBP_R1, &BBPValue);
		BBPValue &= (~0x18);
		RTUSBWriteBBPRegister(pAd, BBP_R1, BBPValue);
	}
	if ((pAd->CommonCfg.IOTestParm.bLastAtheros == TRUE) && ((WEP_ON(pAd))||(TKIP_ON(pAd))))
	{
		pAd->CommonCfg.IOTestParm.bNextDisableRxBA = TRUE;
	}
	else
	{
		pAd->CommonCfg.IOTestParm.bNextDisableRxBA = FALSE;
	}
	
	pAd->CommonCfg.NdisRadioStateOff = FALSE;
	pAd->CommonCfg.IOTestParm.bLastAtheros = FALSE;
//	pAd->StaCfg.bDisallowWZC = FALSE;
	COPY_MAC_ADDR(pAd->CommonCfg.LastBssid, pAd->CommonCfg.Bssid);
	DBGPRINT(RT_DEBUG_TRACE, ("!!!pAd->bNextDisableRxBA= %d \n", pAd->CommonCfg.IOTestParm.bNextDisableRxBA));
}

/*
	==========================================================================

	Routine	Description:
		Disconnect current BSSID

	Arguments:
		pAd				- Pointer to our adapter
		IsReqFromAP		- Request from AP
		
	Return Value:		
		None
		
	IRQL = DISPATCH_LEVEL

	Note:
		We need more information to know it's this requst from AP.
		If yes! we need to do extra handling, for example, remove the WPA key.
		Otherwise on 4-way handshaking will faied, since the WPA key didn't be
		remove while auto reconnect.
		Disconnect request from AP, it means we will start afresh 4-way handshaking 
		on WPA mode.

	==========================================================================
*/
VOID LinkDown(
	IN PRTMP_ADAPTER pAd,
	IN  BOOLEAN      IsReqFromAP)
{
	ULONG			SlotTime;
	UCHAR			i, BBPValue;

	DBGPRINT(RT_DEBUG_TRACE, ("!!! LINK DOWN !!!\n"));

	OPSTATUS_CLEAR_FLAG(pAd, fOP_STATUS_AGGREGATION_INUSED);
	if (ADHOC_ON(pAd))		// Adhoc mode link down
	{
		OPSTATUS_CLEAR_FLAG(pAd, fOP_STATUS_ADHOC_ON);

#ifdef	SINGLE_ADHOC_LINKUP
#ifdef WIN_NDIS
		pAd->IndicateMediaState = NdisMediaStateDisconnected;
		NdisMIndicateStatus(pAd->AdapterHandle, NDIS_STATUS_MEDIA_DISCONNECT, (PVOID)NULL, 0);
		NdisMIndicateStatusComplete(pAd->AdapterHandle);
#endif	 /* WIN_NDIS */
		// clean up previous SCAN result, add current BSS back to table if any
		BssTableDeleteEntry(&pAd->ScanTab, pAd->CommonCfg.Bssid, pAd->CommonCfg.Channel);
#else
		if (RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_RADIO_OFF))
		{
			OPSTATUS_CLEAR_FLAG(pAd, fOP_STATUS_MEDIA_STATE_CONNECTED);
#ifdef WIN_NDIS			
			pAd->IndicateMediaState = NdisMediaStateDisconnected;
			NdisMIndicateStatus(pAd->AdapterHandle, NDIS_STATUS_MEDIA_DISCONNECT, (PVOID)NULL, 0);
			NdisMIndicateStatusComplete(pAd->AdapterHandle);
#endif	 /* WIN_NDIS */				
			BssTableDeleteEntry(&pAd->ScanTab, pAd->CommonCfg.Bssid, pAd->CommonCfg.Channel);
		}
#endif
		// ad-hoc linkdown Reset MAC Table. Start from 1 or 0 ?
		for (i=1; i<MAX_LEN_OF_MAC_TABLE; i++)
		{
			if (pAd->MacTab.Size == 0)
				break;
			
			if (pAd->MacTab.Content[i].ValidAsCLI == TRUE)
			{
				MacTableDeleteEntry(pAd, (USHORT)i, pAd->MacTab.Content[i].Addr);
				//BATableTearRECEntry(pAd, 0, i,TRUE);
				//BATableTearORIEntry(pAd, 0, i,TRUE);
				AsicDelWcidTab(pAd, i);
			}
		}
	}
	else					// Infra structure mode
	{

		DBGPRINT(RT_DEBUG_TRACE, ("!!! LINK DOWN 2!!!\n"));

		OPSTATUS_CLEAR_FLAG(pAd, fOP_STATUS_INFRA_ON); 
		OPSTATUS_CLEAR_FLAG(pAd, fOP_STATUS_MEDIA_STATE_CONNECTED); 
		// Saved last SSID for linkup comparison
		pAd->CommonCfg.LastSsidLen = pAd->CommonCfg.SsidLen;
		NdisMoveMemory(pAd->CommonCfg.LastSsid, pAd->CommonCfg.Ssid, pAd->CommonCfg.LastSsidLen);
		COPY_MAC_ADDR(pAd->CommonCfg.LastBssid, pAd->CommonCfg.Bssid);
		if (pAd->MlmeAux.CurrReqIsFromNdis == TRUE)
		{
#ifdef WIN_NDIS		
			pAd->IndicateMediaState = NdisMediaStateDisconnected;
			NdisMIndicateStatus(pAd->AdapterHandle, NDIS_STATUS_MEDIA_DISCONNECT, (PVOID)NULL, 0);
			NdisMIndicateStatusComplete(pAd->AdapterHandle);
#endif	 /* WIN_NDIS */
			DBGPRINT(RT_DEBUG_TRACE, ("NDIS_STATUS_MEDIA_DISCONNECT Event A!\n"));
			pAd->MlmeAux.CurrReqIsFromNdis = FALSE;
		}
		else
		{
			// Set linkdown timer
			RTMPSetTimer(pAd, &pAd->Mlme.LinkDownTimer, 10000);
		
			//
			// If disassociation request is from NDIS, then we don't need to delete BSSID from entry.
			// Otherwise lost beacon or receive De-Authentication from AP, 
			// then we should delete BSSID from BssTable.
			// If we don't delete from entry, roaming will fail.
			//
			BssTableDeleteEntry(&pAd->ScanTab, pAd->CommonCfg.Bssid, pAd->CommonCfg.Channel);
		}
		
		// restore back to - 
		//      1. long slot (20 us) or short slot (9 us) time
		//      2. turn on/off RTS/CTS and/or CTS-to-self protection
		//      3. short preamble
		OPSTATUS_CLEAR_FLAG(pAd, fOP_STATUS_BG_PROTECTION_INUSED);

		if (pAd->StaCfg.CCXAdjacentAPReportFlag == TRUE)
		{
			//
			// Record current AP's information.
			// for later used reporting Adjacent AP report.
			//
			pAd->StaCfg.CCXAdjacentAPChannel = pAd->CommonCfg.Channel;
			pAd->StaCfg.CCXAdjacentAPSsidLen = pAd->CommonCfg.SsidLen;
			NdisMoveMemory(pAd->StaCfg.CCXAdjacentAPSsid, pAd->CommonCfg.Ssid, pAd->StaCfg.CCXAdjacentAPSsidLen);
			COPY_MAC_ADDR(pAd->StaCfg.CCXAdjacentAPBssid, pAd->CommonCfg.Bssid);			
		}		
		if ( !MAC_ADDR_EQUAL(pAd->CommonCfg.Bssid,ZERO_MAC_ADDR ))
			MacTableDeleteEntry(pAd,BSSID_WCID, pAd->CommonCfg.Bssid);
	}

	//
	// Reset CWMin & CWMax to default value
	// Since we reset the slot time to 0x14(long slot time), so we also need to  
	// Reset the flag fOP_STATUS_SHORT_SLOT_INUSED at the same time.
	// 
	SlotTime = 0x14;
	//rt2860c
	//RTUSBWriteMACRegister(pAd, BKOFF_SLOT_CFG, SlotTime);
	OPSTATUS_CLEAR_FLAG(pAd, fOP_STATUS_SHORT_SLOT_INUSED);
	
	pAd->StaCfg.CCXQosECWMin	= 4;
	pAd->StaCfg.CCXQosECWMax	= 10;
	
	AsicSetSlotTime(pAd, TRUE); //FALSE);
	AsicSetEdcaParm(pAd, NULL);

	// Set LED
	RTMPSetLED(pAd, LED_LINK_DOWN);
	pAd->LedIndicatorStregth = 0xF0;
	RTMPSetSignalLED(pAd, -100);	// Force signal strength Led to be turned off, firmware is not done it.

	AsicDisableSync(pAd);
	pAd->Mlme.PeriodicRound = 0;
	pAd->Mlme.OneSecPeriodicRound = 0;

	{
		RTUSBReadBBPRegister(pAd, BBP_R4, &BBPValue);
		BBPValue&= (~0x18);
		RTUSBWriteBBPRegister(pAd, BBP_R4, BBPValue);
		pAd->CommonCfg.BBPCurrentBW = BW_20;
		DBGPRINT(RT_DEBUG_TRACE, ("!!!LINK DOWN set back to 20MHz !!! \n" ));
	}
	// Remove StaCfg Information after link down
	NdisZeroMemory(pAd->CommonCfg.Bssid, MAC_ADDR_LEN);
	NdisZeroMemory(pAd->CommonCfg.Ssid, MAX_LEN_OF_SSID);
	NdisZeroMemory(&pAd->MlmeAux.HtCapability, sizeof(HT_CAPABILITY_IE));
	NdisZeroMemory(&pAd->MlmeAux.AddHtInfo, sizeof(ADD_HT_INFO_IE));
	NdisZeroMemory(&pAd->StaActive, sizeof(STA_ACTIVE_CONFIG));
	pAd->MlmeAux.HtCapabilityLen = 0;
	pAd->MlmeAux.NewExtChannelOffset = 0xff;
	pAd->CommonCfg.SsidLen = 0;
	
	// Reset WPA-PSK state. Only reset when supplicant enabled
	if (pAd->StaCfg.WpaState != SS_NOTUSE)
	{
		pAd->StaCfg.WpaState = SS_START;
		// Clear Replay counter
		NdisZeroMemory(pAd->StaCfg.ReplayCounter, 8);
	}
	
	//
	// if link down come from AP, we need to remove all WPA keys on WPA mode.
	// otherwise will cause 4-way handshaking failed, since the WPA key not empty.
	//
	if ((IsReqFromAP) && (pAd->CommonCfg.AuthMode >= Ndis802_11AuthModeWPA))
	{
		// Remove all WPA keys 
		RTMPWPARemoveAllKeys(pAd);
	}
	
	// 802.1x port control
	pAd->StaCfg.PortSecured = WPA_802_1X_PORT_NOT_SECURED;
	pAd->StaCfg.MicErrCnt = 0;

	// Turn off Ckip and Cmic control flag
	pAd->StaCfg.bCkipCmicOn = FALSE;
	pAd->StaCfg.CCX2Enable = FALSE;

	// Update extra information to link is up
	pAd->ExtraInfo = GENERAL_LINK_DOWN;

	// Reset the Current AP's IP address
	NdisZeroMemory(pAd->StaCfg.AironetIPAddress, 4);
	pAd->bUsbTxBulkAggre = FALSE;

	// Clean association information
	NdisZeroMemory(&pAd->StaCfg.AssocInfo, sizeof(NDIS_802_11_ASSOCIATION_INFORMATION));
	pAd->StaCfg.AssocInfo.Length = sizeof(NDIS_802_11_ASSOCIATION_INFORMATION);
	pAd->StaCfg.ReqVarIELen = 0;
	pAd->StaCfg.ResVarIELen = 0;	
	{
		RTUSBReadBBPRegister(pAd, BBP_R1, &BBPValue);
		BBPValue &= (~0x18);
		BBPValue |= 0x10;
		RTUSBWriteBBPRegister(pAd, BBP_R1, BBPValue);
	}
	RTUSBWriteMACRegister(pAd, MAX_LEN_CFG, 0x1fff);
	//
	// Reset RSSI value after link down
	//
	pAd->StaCfg.AvgRssi = 0;
	pAd->StaCfg.AvgRssiX8 = 0;
	pAd->StaCfg.AvgRssi2 = 0;
	pAd->StaCfg.AvgRssi2X8 = 0;
	AsicUpdateProtect(pAd, 0, (ALLN_SETPROTECT|CCKSETPROTECT|OFDMSETPROTECT), TRUE, FALSE);
	AsicDisableRDG(pAd);
	AsicDisablePiggyB(pAd);
	// Restore MlmeRate
	pAd->CommonCfg.MlmeRate = pAd->CommonCfg.BasicMlmeRate;
	//pAd->CommonCfg.RtsRate = pAd->CommonCfg.BasicMlmeRate;
//	pAd->StaCfg.bDisallowWZC = FALSE;
	DBGPRINT(RT_DEBUG_TRACE, ("!!! LINK DOWN <==!!!\n"));

	OPSTATUS_CLEAR_FLAG(pAd, fOP_STATUS_RTS_PROTECTION_ENABLE);	
}

/*
	==========================================================================
	Description:

	IRQL = PASSIVE_LEVEL

	==========================================================================
*/
VOID MlmeCntlConfirm(
	IN PRTMP_ADAPTER pAd, 
	IN ULONG MsgType, 
	IN USHORT Msg) 
{
	MlmeEnqueue(pAd, MLME_CNTL_STATE_MACHINE, MsgType, sizeof(USHORT), &Msg);
}

/*
	==========================================================================
	Description:

	IRQL = DISPATCH_LEVEL
	
	==========================================================================
*/
VOID IterateOnBssTab(
	IN PRTMP_ADAPTER pAd) 
{
	MLME_START_REQ_STRUCT   StartReq;
	MLME_JOIN_REQ_STRUCT    JoinReq;
	ULONG                   BssIdx;
	
#if 0
	// Change the wepstatus to original wepstatus
	pAd->CommonCfg.WepStatus   = pAd->CommonCfg.OrigWepStatus;
	pAd->CommonCfg.PairCipher  = pAd->CommonCfg.OrigWepStatus;
	pAd->CommonCfg.GroupCipher = pAd->CommonCfg.OrigWepStatus;
#endif	
	pAd->CommonCfg.MixedModeGroupCipher = Cipher_Type_NONE;

	BssIdx = pAd->MlmeAux.BssIdx;
	if (BssIdx < pAd->MlmeAux.SsidBssTab.BssNr) 
	{
		// Check cipher suite, AP must have more secured cipher than station setting
		// Set the Pairwise and Group cipher to match the intended AP setting
		// We can only connect to AP with less secured cipher setting
		if ((pAd->CommonCfg.AuthMode == Ndis802_11AuthModeWPA) || (pAd->CommonCfg.AuthMode == Ndis802_11AuthModeWPAPSK))
		{
			pAd->CommonCfg.GroupCipher = pAd->MlmeAux.SsidBssTab.BssEntry[BssIdx].WPA.GroupCipher;
			
			if (pAd->CommonCfg.WepStatus == pAd->MlmeAux.SsidBssTab.BssEntry[BssIdx].WPA.PairCipher)
				pAd->CommonCfg.PairCipher = pAd->MlmeAux.SsidBssTab.BssEntry[BssIdx].WPA.PairCipher;
			else if (pAd->MlmeAux.SsidBssTab.BssEntry[BssIdx].WPA.PairCipherAux != Ndis802_11WEPDisabled)
				pAd->CommonCfg.PairCipher = pAd->MlmeAux.SsidBssTab.BssEntry[BssIdx].WPA.PairCipherAux;
			else	// There is no PairCipher Aux, downgrade our capability to TKIP
				pAd->CommonCfg.PairCipher = Ndis802_11Encryption2Enabled;			

			// Set the mixed mode group cipher suite, may be Cipher_Type_NONE, Cipher_Type_WEP40 or Cipher_Type_WEP104
			pAd->CommonCfg.MixedModeGroupCipher = pAd->MlmeAux.SsidBssTab.BssEntry[BssIdx].MixedModeGroupCipher;
		}
		else if ((pAd->CommonCfg.AuthMode == Ndis802_11AuthModeWPA2) || (pAd->CommonCfg.AuthMode == Ndis802_11AuthModeWPA2PSK))
		{
			pAd->CommonCfg.GroupCipher = pAd->MlmeAux.SsidBssTab.BssEntry[BssIdx].WPA2.GroupCipher;
			
			if (pAd->CommonCfg.WepStatus == pAd->MlmeAux.SsidBssTab.BssEntry[BssIdx].WPA2.PairCipher)
				pAd->CommonCfg.PairCipher = pAd->MlmeAux.SsidBssTab.BssEntry[BssIdx].WPA2.PairCipher;
			else if (pAd->MlmeAux.SsidBssTab.BssEntry[BssIdx].WPA2.PairCipherAux != Ndis802_11WEPDisabled)
				pAd->CommonCfg.PairCipher = pAd->MlmeAux.SsidBssTab.BssEntry[BssIdx].WPA2.PairCipherAux;
			else	// There is no PairCipher Aux, downgrade our capability to TKIP
				pAd->CommonCfg.PairCipher = Ndis802_11Encryption2Enabled;			

			// RSN capability
			pAd->CommonCfg.RsnCapability = pAd->MlmeAux.SsidBssTab.BssEntry[BssIdx].WPA2.RsnCapability;
		}
		// Set Mix cipher flag
		if (pAd->CommonCfg.PairCipher != pAd->CommonCfg.GroupCipher)
			pAd->CommonCfg.bMixCipher = TRUE;		

		DBGPRINT(RT_DEBUG_TRACE, ("CNTL - iterate BSS %ld of %d\n", BssIdx, pAd->MlmeAux.SsidBssTab.BssNr));
		JoinParmFill(pAd, &JoinReq, BssIdx);
		MlmeEnqueue(pAd, SYNC_STATE_MACHINE, MT2_MLME_JOIN_REQ, sizeof(MLME_JOIN_REQ_STRUCT), &JoinReq);
		pAd->Mlme.CntlMachine.CurrState = CNTL_WAIT_JOIN;
	}
	else if (pAd->StaCfg.BssType == BSS_ADHOC)
	{
		DBGPRINT(RT_DEBUG_TRACE, ("CNTL - All BSS fail; start a new ADHOC (Ssid=%s)...\n",pAd->MlmeAux.Ssid));
		StartParmFill(pAd, &StartReq, pAd->MlmeAux.Ssid, pAd->MlmeAux.SsidLen);
		MlmeEnqueue(pAd, SYNC_STATE_MACHINE, MT2_MLME_START_REQ, sizeof(MLME_START_REQ_STRUCT), &StartReq);
		pAd->Mlme.CntlMachine.CurrState = CNTL_WAIT_START;
	}
	else // no more BSS
	{
		DBGPRINT(RT_DEBUG_TRACE, ("CNTL - All roaming failed, stay @ ch #%d\n", pAd->CommonCfg.Channel));
		AsicSwitchChannel(pAd, pAd->CommonCfg.Channel,FALSE);
		AsicLockChannel(pAd, pAd->CommonCfg.Channel);
		pAd->Mlme.CntlMachine.CurrState = CNTL_IDLE;
	} 
}

// for re-association only
// IRQL = DISPATCH_LEVEL
VOID IterateOnBssTab2(
	IN PRTMP_ADAPTER pAd) 
{
	MLME_REASSOC_REQ_STRUCT ReassocReq;
	ULONG                   BssIdx;
	BSS_ENTRY               *pBss;

	BssIdx = pAd->MlmeAux.RoamIdx;
	pBss = &pAd->MlmeAux.RoamTab.BssEntry[BssIdx];

	if (BssIdx < pAd->MlmeAux.RoamTab.BssNr)
	{
		DBGPRINT(RT_DEBUG_TRACE, ("CNTL - iterate BSS %ld of %d\n", BssIdx, pAd->MlmeAux.RoamTab.BssNr));

		AsicSwitchChannel(pAd, pBss->Channel,FALSE);
		AsicLockChannel(pAd, pBss->Channel);

		// reassociate message has the same structure as associate message
		AssocParmFill(pAd, &ReassocReq, pBss->Bssid, pBss->CapabilityInfo, 
					  ASSOC_TIMEOUT, pAd->StaCfg.DefaultListenCount);
		MlmeEnqueue(pAd, ASSOC_STATE_MACHINE, MT2_MLME_REASSOC_REQ, 
					sizeof(MLME_REASSOC_REQ_STRUCT), &ReassocReq);

		pAd->Mlme.CntlMachine.CurrState = CNTL_WAIT_REASSOC;
	}
	else // no more BSS
	{
		DBGPRINT(RT_DEBUG_TRACE, ("CNTL - All fast roaming failed, back to ch #%d\n",pAd->CommonCfg.Channel));
		AsicSwitchChannel(pAd, pAd->CommonCfg.Channel,FALSE);
		AsicLockChannel(pAd, pAd->CommonCfg.Channel);
		pAd->Mlme.CntlMachine.CurrState = CNTL_IDLE;
	} 
}

/*
	==========================================================================
	Description:

	IRQL = DISPATCH_LEVEL
	
	==========================================================================
*/
VOID JoinParmFill(
	IN PRTMP_ADAPTER pAd, 
	IN OUT MLME_JOIN_REQ_STRUCT *JoinReq, 
	IN ULONG BssIdx) 
{
	JoinReq->BssIdx = BssIdx;
}

/*
	==========================================================================
	Description:

	IRQL = DISPATCH_LEVEL
	
	==========================================================================
*/
VOID AssocParmFill(
	IN PRTMP_ADAPTER pAd, 
	IN OUT MLME_ASSOC_REQ_STRUCT *AssocReq, 
	IN PUCHAR                     pAddr, 
	IN USHORT                     CapabilityInfo, 
	IN ULONG                      Timeout, 
	IN USHORT                     ListenIntv) 
{
	COPY_MAC_ADDR(AssocReq->Addr, pAddr);
	// Add mask to support 802.11b mode only
	AssocReq->CapabilityInfo = CapabilityInfo & SUPPORTED_CAPABILITY_INFO; // not cf-pollable, not cf-poll-request
	AssocReq->Timeout = Timeout;
	AssocReq->ListenIntv = ListenIntv;
}

/*
	==========================================================================
	Description:

	IRQL = DISPATCH_LEVEL
	
	==========================================================================
*/
VOID ScanParmFill(
	IN PRTMP_ADAPTER pAd, 
	IN OUT MLME_SCAN_REQ_STRUCT *ScanReq, 
	IN CHAR Ssid[], 
	IN UCHAR SsidLen, 
	IN UCHAR BssType, 
	IN UCHAR ScanType) 
{
	ScanReq->SsidLen = SsidLen;
	NdisMoveMemory(ScanReq->Ssid, Ssid, SsidLen);
	ScanReq->BssType = BssType;
	ScanReq->ScanType = ScanType;
}

/*
	==========================================================================
	Description:

	IRQL = DISPATCH_LEVEL
	
	==========================================================================
*/
VOID DisassocParmFill(
	IN PRTMP_ADAPTER pAd, 
	IN OUT MLME_DISASSOC_REQ_STRUCT *DisassocReq, 
	IN PUCHAR pAddr, 
	IN USHORT Reason) 
{
	COPY_MAC_ADDR(DisassocReq->Addr, pAddr);
	DisassocReq->Reason = Reason;
}

/*
	==========================================================================
	Description:

	IRQL = DISPATCH_LEVEL
	
	==========================================================================
*/
VOID StartParmFill(
	IN PRTMP_ADAPTER pAd, 
	IN OUT MLME_START_REQ_STRUCT *StartReq, 
	IN CHAR Ssid[], 
	IN UCHAR SsidLen) 
{
	if (SsidLen <= MAX_LEN_OF_SSID)
	{
		NdisMoveMemory(StartReq->Ssid, Ssid, SsidLen); 
		StartReq->SsidLen = SsidLen;
	}
	else
	{
		NdisMoveMemory(StartReq->Ssid, Ssid, MAX_LEN_OF_SSID); 
		StartReq->SsidLen = MAX_LEN_OF_SSID;
	}
}

/*
	==========================================================================
	Description:

	IRQL = DISPATCH_LEVEL
	
	==========================================================================
*/
VOID AuthParmFill(
	IN PRTMP_ADAPTER pAd, 
	IN OUT MLME_AUTH_REQ_STRUCT *AuthReq, 
	IN PUCHAR pAddr, 
	IN USHORT Alg) 
{
	COPY_MAC_ADDR(AuthReq->Addr, pAddr);
	AuthReq->Alg = Alg;
	AuthReq->Timeout = AUTH_TIMEOUT;
}

/*
	==========================================================================
	Description:

	IRQL = DISPATCH_LEVEL
	
	==========================================================================
 */
VOID ComposePsPoll(
	IN PRTMP_ADAPTER pAd)
{
	PTXINFO_STRUC		pTxInfo;
	PTXWI_STRUC		pTxWI;

	DBGPRINT(RT_DEBUG_TRACE, ("ComposePsPoll\n"));
	NdisZeroMemory(&pAd->PsPollFrame, sizeof(PSPOLL_FRAME));
	//pAd->PsPollFrame.FC.ToDs = 1;
	pAd->PsPollFrame.FC.PwrMgmt = 0;
	pAd->PsPollFrame.FC.Type = BTYPE_CNTL;
	pAd->PsPollFrame.FC.SubType = SUBTYPE_PS_POLL;
	pAd->PsPollFrame.Aid = pAd->StaActive.Aid | 0xC000;
	COPY_MAC_ADDR(pAd->PsPollFrame.Bssid, pAd->CommonCfg.Bssid);
	COPY_MAC_ADDR(pAd->PsPollFrame.Ta, pAd->CurrentAddress);

	RTMPZeroMemory(&pAd->PsPollContext.TransferBuffer->WirelessPacket[0], 100);
	pTxInfo = (PTXINFO_STRUC)&pAd->PsPollContext.TransferBuffer->WirelessPacket[0];
	RTMPWriteTxInfo(pAd, pTxInfo, (USHORT)(sizeof(PSPOLL_FRAME)+TXWI_SIZE), TRUE, EpToQueue[MGMTPIPEIDX], FALSE,  FALSE);
	pTxWI = (PTXWI_STRUC)&pAd->PsPollContext.TransferBuffer->WirelessPacket[TXINFO_SIZE];
	RTMPWriteTxWI(pAd, pTxWI, FALSE, FALSE, FALSE, TRUE, FALSE, 0, BSSID_WCID, (sizeof(PSPOLL_FRAME)),
		0, 0,  IFS_HTTXOP, FALSE ,pAd->CommonCfg.MlmeTransmit);

	RTMPMoveMemory(&pAd->PsPollContext.TransferBuffer->WirelessPacket[TXWI_SIZE+TXINFO_SIZE], &pAd->PsPollFrame, sizeof(PSPOLL_FRAME));
	// Append 4 extra zero bytes.
	pAd->PsPollContext.BulkOutSize =  TXINFO_SIZE + TXWI_SIZE + sizeof(PSPOLL_FRAME) + 4;
}

// IRQL = DISPATCH_LEVEL
VOID ComposeNullFrame(
	IN PRTMP_ADAPTER pAd)
{
	PTXINFO_STRUC		pTxInfo;
	PTXWI_STRUC		pTxWI;

	NdisZeroMemory(&pAd->NullFrame, sizeof(HEADER_802_11));
	pAd->NullFrame.FC.Type = BTYPE_DATA;
	pAd->NullFrame.FC.SubType = SUBTYPE_NULL_FUNC;
	pAd->NullFrame.FC.ToDs = 1;
	COPY_MAC_ADDR(pAd->NullFrame.Addr1, pAd->CommonCfg.Bssid);
	COPY_MAC_ADDR(pAd->NullFrame.Addr2, pAd->CurrentAddress);
	COPY_MAC_ADDR(pAd->NullFrame.Addr3, pAd->CommonCfg.Bssid);
	RTMPZeroMemory(&pAd->NullContext.TransferBuffer->WirelessPacket[0], 100);
	pTxInfo = (PTXINFO_STRUC)&pAd->NullContext.TransferBuffer->WirelessPacket[0];
	RTMPWriteTxInfo(pAd, pTxInfo, (USHORT)(sizeof(HEADER_802_11)+TXWI_SIZE), TRUE, EpToQueue[MGMTPIPEIDX], FALSE,  FALSE);
	pTxWI = (PTXWI_STRUC)&pAd->NullContext.TransferBuffer->WirelessPacket[TXINFO_SIZE];
	RTMPWriteTxWI(pAd, pTxWI, FALSE, FALSE, FALSE, TRUE, FALSE, 0, BSSID_WCID, (sizeof(HEADER_802_11)),
		0, 0,  IFS_HTTXOP, FALSE ,pAd->CommonCfg.MlmeTransmit);

	RTMPMoveMemory(&pAd->NullContext.TransferBuffer->WirelessPacket[TXWI_SIZE+TXINFO_SIZE], &pAd->NullFrame, sizeof(HEADER_802_11));
	pAd->NullContext.BulkOutSize =  TXINFO_SIZE + TXWI_SIZE + sizeof(pAd->NullFrame) + 4;
}

/*
	==========================================================================
	Description:
		Pre-build a BEACON frame in the shared memory

	IRQL = PASSIVE_LEVEL
	IRQL = DISPATCH_LEVEL
	
	==========================================================================
*/
ULONG MakeIbssBeacon(
	IN PRTMP_ADAPTER pAd) 
{
	UCHAR         DsLen = 1, IbssLen = 2;
//	UCHAR         SupRateLen, ExtRateLen;
	UCHAR         LocalErpIe[3] = {IE_ERP, 1, 0x04};//, ZERO[4] = {0,0,0,0};
	HEADER_802_11 BcnHdr;
	USHORT        CapabilityInfo;
	LARGE_INTEGER FakeTimestamp;
	ULONG         FrameLen = 0;
	PTXWI_STRUC	  pTxWI = &pAd->BeaconTxWI;
	CHAR         *pBeaconFrame = pAd->BeaconBuf;
	BOOLEAN       Privacy;
	UCHAR         SupRate[MAX_LEN_OF_SUPPORTED_RATES];
	UCHAR         SupRateLen = 0;
	UCHAR         ExtRate[MAX_LEN_OF_SUPPORTED_RATES];
	UCHAR         ExtRateLen = 0;
//	INT           i;
	ULONG	tmp;


	// 2003-12-10 802.11g WIFI spec disallow OFDM rates in 802.11g ADHOC mode
	//            make sure 1,2,5.5,11 are the firt 4 rates in CommonCfg.SupportedRates[] array
	if (((pAd->CommonCfg.PhyMode == PHY_11BG_MIXED) || 
		(pAd->CommonCfg.PhyMode == PHY_11ABG_MIXED)) &&
		(pAd->StaCfg.AdhocMode == ADHOC_11B))
	{
		SupRate[0] = 0x82; // 1 mbps
		SupRate[1] = 0x84; // 2 mbps
		SupRate[2] = 0x8b; // 5.5 mbps
		SupRate[3] = 0x96; // 11 mbps
		SupRateLen = 4;
		ExtRateLen = 0;
	}
	else if ((pAd->StaCfg.AdhocMode == ADHOC_11BG_MIXED))  //Adhoc Mode 1: B/G mixed.
	{
		SupRate[0] = 0x82; // 1 mbps
		SupRate[1] = 0x84; // 2 mbps
		SupRate[2] = 0x8b; // 5.5 mbps
		SupRate[3] = 0x96; // 11 mbps
		SupRateLen = 4;

		ExtRate[0]  = 0x0C;    // 6 mbps, in units of 0.5 Mbps
		ExtRate[1]  = 0x12;    // 9 mbps, in units of 0.5 Mbps
		ExtRate[2]  = 0x18;    // 12 mbps, in units of 0.5 Mbps
		ExtRate[3]  = 0x24;    // 18 mbps, in units of 0.5 Mbps
		ExtRate[4]  = 0x30;    // 24 mbps, in units of 0.5 Mbps
		ExtRate[5]  = 0x48;    // 36 mbps, in units of 0.5 Mbps
		ExtRate[6]  = 0x60;    // 48 mbps, in units of 0.5 Mbps
		ExtRate[7]  = 0x6c;    // 54 mbps, in units of 0.5 Mbps		
		ExtRateLen  = 8;
	}
	else if ((pAd->StaCfg.AdhocMode == ADHOC_11G) || (pAd->StaCfg.AdhocMode == ADHOC_11A) ||  //Adhoc Mode 2: 11g only 3: 11a only
			((pAd->CommonCfg.PhyMode == PHY_11ABG_MIXED) && (pAd->CommonCfg.Channel > 14)))
	{
		SupRate[0]  = 0x8C;    // 6 mbps, in units of 0.5 Mbps, basic rate
		SupRate[1]  = 0x12;    // 9 mbps, in units of 0.5 Mbps
		SupRate[2]  = 0x98;    // 12 mbps, in units of 0.5 Mbps, basic rate
		SupRate[3]  = 0x24;    // 18 mbps, in units of 0.5 Mbps
		SupRate[4]  = 0xb0;    // 24 mbps, in units of 0.5 Mbps, basic rate
		SupRate[5]  = 0x48;    // 36 mbps, in units of 0.5 Mbps
		SupRate[6]  = 0x60;    // 48 mbps, in units of 0.5 Mbps
		SupRate[7]  = 0x6c;    // 54 mbps, in units of 0.5 Mbps
		SupRateLen  = 8;
		ExtRateLen  = 0;

		//
		// Also Update MlmeRate & RtsRate for G only & A only
		//
		pAd->CommonCfg.MlmeRate = RATE_6;
		pAd->CommonCfg.RtsRate = RATE_6;
		pAd->CommonCfg.MlmeTransmit.field.MODE = MODE_OFDM;
		pAd->CommonCfg.MlmeTransmit.field.MCS = OfdmRateToRxwiMCS[pAd->CommonCfg.MlmeRate];
		pAd->MacTab.Content[BSS0Mcast_WCID].HTPhyMode.field.MODE = MODE_OFDM;
		pAd->MacTab.Content[BSS0Mcast_WCID].HTPhyMode.field.MCS = OfdmRateToRxwiMCS[pAd->CommonCfg.MlmeRate];	
	}
	else
	{
		SupRateLen = pAd->CommonCfg.SupRateLen;
		NdisMoveMemory(SupRate, pAd->CommonCfg.SupRate, SupRateLen);
		ExtRateLen = pAd->CommonCfg.ExtRateLen;
		NdisMoveMemory(ExtRate, pAd->CommonCfg.ExtRate, ExtRateLen);
		if (pAd->CommonCfg.PhyMode == PHY_11N)
		{
			pAd->CommonCfg.MlmeRate = RATE_1;
			pAd->CommonCfg.RtsRate = RATE_1;
			pAd->CommonCfg.MlmeTransmit.field.MODE = MODE_CCK;
			pAd->CommonCfg.MlmeTransmit.field.MCS = RATE_1;
			pAd->MacTab.Content[BSS0Mcast_WCID].HTPhyMode.field.MODE = MODE_CCK;
			pAd->MacTab.Content[BSS0Mcast_WCID].HTPhyMode.field.MCS = RATE_1;
		}
	}

	pAd->StaActive.SupRateLen = SupRateLen;
	NdisMoveMemory(pAd->StaActive.SupRate, SupRate, SupRateLen);
	pAd->StaActive.ExtRateLen = ExtRateLen;
	NdisMoveMemory(pAd->StaActive.ExtRate, ExtRate, ExtRateLen);

	// compose IBSS beacon frame
	MgtMacHeaderInit(pAd, &BcnHdr, SUBTYPE_BEACON, 0, BROADCAST_ADDR, pAd->CommonCfg.Bssid);
	Privacy = (pAd->CommonCfg.WepStatus == Ndis802_11Encryption1Enabled) || 
			  (pAd->CommonCfg.WepStatus == Ndis802_11Encryption2Enabled) || 
			  (pAd->CommonCfg.WepStatus == Ndis802_11Encryption3Enabled);
	CapabilityInfo = CAP_GENERATE(0, 1, Privacy, (pAd->CommonCfg.TxPreamble == Rt802_11PreambleShort), 0);

	MakeOutgoingFrame(pBeaconFrame,                &FrameLen,
					sizeof(HEADER_802_11),           &BcnHdr, 
					TIMESTAMP_LEN,                   &FakeTimestamp,
					2,                               &pAd->CommonCfg.BeaconPeriod,
					2,                               &CapabilityInfo,
					1,                               &SsidIe, 
					1,                               &pAd->CommonCfg.SsidLen, 
					pAd->CommonCfg.SsidLen,          pAd->CommonCfg.Ssid,
					1,                               &SupRateIe, 
					1,                               &SupRateLen,
					SupRateLen,                      SupRate,
					1,                               &DsIe, 
					1,                               &DsLen, 
					1,                               &pAd->CommonCfg.Channel,
					1,                               &IbssIe, 
					1,                               &IbssLen, 
					2,                               &pAd->StaActive.AtimWin,
					END_OF_ARGS);

	// add ERP_IE and EXT_RAE IE of in 802.11g
	if (ExtRateLen)
	{
		ULONG	tmp2;

		MakeOutgoingFrame(pBeaconFrame + FrameLen,         &tmp2,
						3,                               LocalErpIe,
						1,                               &ExtRateIe,
						1,                               &ExtRateLen,
						ExtRateLen,                      ExtRate,
						END_OF_ARGS);
		FrameLen += tmp2;
	}

	// If adhoc secruity is set for WPA-None, append the cipher suite IE
	if (pAd->CommonCfg.AuthMode == Ndis802_11AuthModeWPANone)
	{
		
		if (pAd->CommonCfg.WepStatus == Ndis802_11Encryption2Enabled)		// Tkip
		{
			MakeOutgoingFrame(pBeaconFrame + FrameLen,      &tmp,
							1,						    &WpaIe,
							1,						    &CipherSuiteWpaNoneTkipLen,
							CipherSuiteWpaNoneTkipLen,	&CipherSuiteWpaNoneTkip[0],
							END_OF_ARGS);
			FrameLen += tmp;
		}
		else if (pAd->CommonCfg.WepStatus == Ndis802_11Encryption3Enabled)	// Aes
		{
			MakeOutgoingFrame(pBeaconFrame + FrameLen,    &tmp,
							1,						  &WpaIe,
							1,						  &CipherSuiteWpaNoneAesLen,
							CipherSuiteWpaNoneAesLen,   &CipherSuiteWpaNoneAes[0],
							END_OF_ARGS);
			FrameLen += tmp;
		}
	}

#if 0
	if ((pAd->CommonCfg.PhyMode >= PHY_11ABGN_MIXED))
	{
		ULONG TmpLen, HtLen, HtLen1;
		// add HT Capability IE 
		HtLen = sizeof(pAd->CommonCfg.HtCapability);
		HtLen1 = sizeof(pAd->CommonCfg.AddHTInfo);
		MakeOutgoingFrame(pBeaconFrame+FrameLen,         &TmpLen,
								  1,                                &HtCapIe,
								  1,                                &HtLen,
								 HtLen,          &pAd->CommonCfg.HtCapability, 
								  1,                                &AddHtInfoIe,
								  1,                                &HtLen1,
								 HtLen1,          &pAd->CommonCfg.AddHTInfo, 
						  END_OF_ARGS);
		FrameLen += TmpLen;
	}
#endif
	RTMPWriteTxWI(pAd, pTxWI,  FALSE, TRUE, FALSE, FALSE, TRUE, 0, 0xff, FrameLen, 
		0, 0, IFS_HTTXOP, FALSE, pAd->CommonCfg.MlmeTransmit);

	//
	// For WiFi four stations beacon fair generation issue.
	// Modify Beacon's TxD cwmin. Recommend by Jerry.
	// 1.) Modify MAC register TXRX_CSR10 Bit 7:0
	// or 
	// 2.) Modify cwmin.
	//

	DBGPRINT(RT_DEBUG_INFO, ("MakeIbssBeacon (len=%ld)\n", FrameLen));

	return FrameLen;
}


