/*
 ***************************************************************************
 * Ralink Tech Inc.
 * 4F, No. 2 Technology	5th	Rd.
 * Science-based Industrial	Park
 * Hsin-chu, Taiwan, R.O.C.
 *
 * (c) Copyright 2002-2004, Ralink Technology, Inc.
 *
 * All rights reserved.	Ralink's source	code is	an unpublished work	and	the
 * use of a	copyright notice does not imply	otherwise. This	source code
 * contains	confidential trade secret material of Ralink Tech. Any attemp
 * or participation	in deciphering,	decoding, reverse engineering or in	any
 * way altering	the	source code	is stricitly prohibited, unless	the	prior
 * written consent of Ralink Technology, Inc. is obtained.
 ***************************************************************************

	Module Name:
	mlme.c

	Abstract:

	Revision History:
	Who			When			What
	--------	----------		----------------------------------------------
	John Chang	2004-08-25		Modify from RT2500 code base
	John Chang  2004-09-06      modified for RT2600
*/

#include "rt_config.h"
#include <stdarg.h>

UCHAR RateSwitchTable[] = {
// Item No.   Mode   Curr-MCS   TrainUp   TrainDown		// Mode- Bit0: STBC, Bit1: Short GI, Bit4,5: Mode(0:CCK, 1:OFDM, 2:HT Mix, 3:HT GF)
    0x11, 0x00,  0,  0,  0,						// Initial used item after association
    0x00, 0x00,  0, 40, 45,
    0x01, 0x00,  1, 40, 45,
    0x02, 0x00,  2, 35, 50,
    0x03, 0x00,  3, 20, 50,
    0x04, 0x21,  0, 20, 50,
    0x05, 0x21,  1, 20, 80,
    0x06, 0x21,  2, 20, 80,
    0x07, 0x21,  3, 15, 50,
    0x08, 0x21,  4, 15, 30,
    0x09, 0x21,  5, 10, 25,
    0x0a, 0x21,  6,  8, 25,
    0x0b, 0x21,  7,  8, 25,
    0x0c, 0x20, 12,  8, 20,
    0x0d, 0x20, 13,  8, 20,
    0x0e, 0x20, 14,  8, 20,
    0x0f, 0x20, 15,  8, 25,
    0x10, 0x22, 15,  8, 25,
    0x11, 0x00,  0,  0,  0,
    0x12, 0x00,  0,  0,  0,
    0x13, 0x00,  0,  0,  0,
    0x14, 0x00,  0,  0,  0,
    0x15, 0x00,  0,  0,  0,
    0x16, 0x00,  0,  0,  0,
    0x17, 0x00,  0,  0,  0,
    0x18, 0x00,  0,  0,  0,
    0x19, 0x00,  0,  0,  0,
    0x1a, 0x00,  0,  0,  0,
    0x1b, 0x00,  0,  0,  0,
    0x1c, 0x00,  0,  0,  0,
    0x1d, 0x00,  0,  0,  0,
    0x1e, 0x00,  0,  0,  0,
    0x1f, 0x00,  0,  0,  0,
};


UCHAR RateSwitchTable11B[] = {
// Item No.   Mode   Curr-MCS   TrainUp   TrainDown		// Mode- Bit0: STBC, Bit1: Short GI, Bit4,5: Mode(0:CCK, 1:OFDM, 2:HT Mix, 3:HT GF)
    0x04, 0x03,  0,  0,  0,						// Initial used item after association
    0x00, 0x00,  0, 40, 50,
    0x01, 0x00,  1, 40, 50,
    0x02, 0x00,  2, 35, 45,
    0x03, 0x00,  3, 20, 45,
};

UCHAR RateSwitchTable11BG[] = {
// Item No.   Mode   Curr-MCS   TrainUp   TrainDown		// Mode- Bit0: STBC, Bit1: Short GI, Bit4,5: Mode(0:CCK, 1:OFDM, 2:HT Mix, 3:HT GF)
    0x0a, 0x00,  0,  0,  0,						// Initial used item after association
    0x00, 0x00,  0, 40, 50,
    0x01, 0x00,  1, 40, 50,
    0x02, 0x00,  2, 35, 45,
    0x03, 0x00,  3, 20, 45,
    0x04, 0x10,  2, 20, 35,
    0x05, 0x10,  3, 16, 35,
    0x06, 0x10,  4, 10, 25,
    0x07, 0x10,  5, 16, 25,
    0x08, 0x10,  6, 10, 25,
    0x09, 0x10,  7, 10, 13,
};

UCHAR RateSwitchTable11G[] = {
// Item No.   Mode   Curr-MCS   TrainUp   TrainDown		// Mode- Bit0: STBC, Bit1: Short GI, Bit4,5: Mode(0:CCK, 1:OFDM, 2:HT Mix, 3:HT GF)
    0x08, 0x00,  0,  0,  0,						// Initial used item after association
    0x00, 0x10,  0, 20, 35,
    0x01, 0x10,  1, 20, 35,
    0x02, 0x10,  2, 20, 35,
    0x03, 0x10,  3, 16, 35,
    0x04, 0x10,  4, 10, 25,
    0x05, 0x10,  5, 16, 25,
    0x06, 0x10,  6, 10, 25,
    0x07, 0x10,  7, 10, 13,
};

UCHAR RateSwitchTable11N1S[] = {
// Item No.   Mode   Curr-MCS   TrainUp   TrainDown		// Mode- Bit0: STBC, Bit1: Short GI, Bit4,5: Mode(0:CCK, 1:OFDM, 2:HT Mix, 3:HT GF)
    0x09, 0x00,  0,  0,  0,						// Initial used item after association
    0x00, 0x21,  0, 20, 50,
    0x01, 0x21,  1, 20, 80,
    0x02, 0x21,  2, 20, 80,
    0x03, 0x21,  3, 15, 50,
    0x04, 0x21,  4, 15, 30,
    0x05, 0x21,  5, 10, 25,
    0x06, 0x21,  6,  8, 25,
    0x07, 0x21,  7,  8, 25,
    0x08, 0x23,  7,  8, 25,
};

UCHAR RateSwitchTable11N2S[] = {
// Item No.   Mode   Curr-MCS   TrainUp   TrainDown		// Mode- Bit0: STBC, Bit1: Short GI, Bit4,5: Mode(0:CCK, 1:OFDM, 2:HT Mix, 3:HT GF)
    0x0b, 0x00,  0,  0,  0,						// Initial used item after association
    0x00, 0x21,  0, 20, 50,
    0x01, 0x21,  1, 20, 80,
    0x02, 0x21,  2, 20, 80,
    0x03, 0x21,  3, 15, 50,
    0x04, 0x21,  4, 15, 30,
//    0x05, 0x21,  5, 10, 25,
//    0x06, 0x21,  6,  8, 25,
//    0x07, 0x21,  7,  8, 25,
    0x05, 0x20, 11,  8, 25,
    0x06, 0x20, 12,  8, 20,
    0x07, 0x20, 13,  8, 20,
    0x08, 0x20, 14,  8, 20,
    0x09, 0x20, 15,  8, 25,
    0x0a, 0x22, 15,  8, 25,
};

UCHAR RateSwitchTable11BGN1S[] = {
// Item No.   Mode   Curr-MCS   TrainUp   TrainDown		// Mode- Bit0: STBC, Bit1: Short GI, Bit4,5: Mode(0:CCK, 1:OFDM, 2:HT Mix, 3:HT GF)
    0x0c, 0x00,  0,  0,  0,						// Initial used item after association
    0x00, 0x00,  0, 40, 45,
    0x01, 0x00,  1, 40, 45,
    0x02, 0x00,  2, 35, 50,
    0x03, 0x00,  3, 20, 50,
    0x04, 0x21,  0, 20,101,	//50
    0x05, 0x21,  1, 20, 80,
    0x06, 0x21,  2, 20, 80,
    0x07, 0x21,  3, 15, 50,
    0x08, 0x21,  4, 15, 30,
    0x09, 0x21,  5, 10, 25,
    0x0a, 0x21,  6,  8, 25,
    0x0b, 0x21,  7,  8, 25,
};

UCHAR RateSwitchTable11BGN2S[] = {
// Item No.   Mode   Curr-MCS   TrainUp   TrainDown		// Mode- Bit0: STBC, Bit1: Short GI, Bit4,5: Mode(0:CCK, 1:OFDM, 2:HT Mix, 3:HT GF)
    0x0e, 0x00,  0,  0,  0,						// Initial used item after association
    0x00, 0x00,  0, 40, 45,
    0x01, 0x00,  1, 40, 45,
    0x02, 0x00,  2, 35, 50,
    0x03, 0x00,  3, 20, 50,
    0x04, 0x21,  0, 20,101,	//50
    0x05, 0x21,  1, 20, 80,
    0x06, 0x21,  2, 20, 80,
    0x07, 0x21,  3, 15, 50,
    0x08, 0x21,  4, 15, 30,
//    0x09, 0x21,  5, 10, 25,
//    0x0a, 0x21,  6,  8, 25,
//    0x0b, 0x21,  7,  8, 25,
    0x09, 0x20, 12, 15, 20,
    0x0a, 0x20, 13,  8, 20,
    0x0b, 0x20, 14,  8, 20,
    0x0c, 0x20, 15,  8, 25,
    0x0d, 0x22, 15,  8, 25,
};
PUCHAR ReasonString[] = {
		/* 0  */     "Reserved",
		/* 1  */     "Unspecified Reason",
		/* 2  */     "Previous Auth no longer valid",
		/* 3  */     "STA is leaving / has left",
		/* 4  */     "DIS-ASSOC due to inactivity",
		/* 5  */     "AP unable to hanle all associations",
		/* 6  */     "class 2 error",
		/* 7  */     "class 3 error",
		/* 8  */     "STA is leaving / has left",
		/* 9  */     "require auth before assoc/re-assoc",
		/* 10 */     "Reserved",
		/* 11 */     "Reserved",
		/* 12 */     "Reserved",
		/* 13 */     "invalid IE",
		/* 14 */     "MIC error",
		/* 15 */     "4-way handshake timeout",
		/* 16 */     "2-way (group key) handshake timeout",
		/* 17 */     "4-way handshake IE diff among AssosReq/Rsp/Beacon",
		/* 18 */
};

extern UCHAR	 OfdmRateToRxwiMCS[];
// since RT61 has better RX sensibility, we have to limit TX ACK rate not to exceed our normal data TX rate.
// otherwise the WLAN peer may not be able to receive the ACK thus downgrade its data TX rate
ULONG BasicRateMask[12]            = {0xfffff001 /* 1-Mbps */, 0xfffff003 /* 2 Mbps */, 0xfffff007 /* 5.5 */, 0xfffff00f /* 11 */,
									  0xfffff01f /* 6 */     , 0xfffff03f /* 9 */     , 0xfffff07f /* 12 */ , 0xfffff0ff /* 18 */,
									  0xfffff1ff /* 24 */    , 0xfffff3ff /* 36 */    , 0xfffff7ff /* 48 */ , 0xffffffff /* 54 */};

UCHAR MULTICAST_ADDR[MAC_ADDR_LEN] = {0x1,  0x00, 0x00, 0x00, 0x00, 0x00};
UCHAR BROADCAST_ADDR[MAC_ADDR_LEN] = {0xff, 0xff, 0xff, 0xff, 0xff, 0xff};
UCHAR ZERO_MAC_ADDR[MAC_ADDR_LEN]  = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

// e.g. RssiSafeLevelForTxRate[RATE_36]" means if the current RSSI is greater than 
//      this value, then it's quaranteed capable of operating in 36 mbps TX rate in 
//      clean environment.
//                                TxRate: 1   2   5.5   11   6    9    12   18   24   36   48   54   72  100
CHAR RssiSafeLevelForTxRate[] ={  -92, -91, -90, -87, -88, -86, -85, -83, -81, -78, -72, -71, -40, -40 };

								  //  1      2       5.5      11  
UCHAR Phy11BNextRateDownward[] = {RATE_1, RATE_1,   RATE_2,  RATE_5_5};
UCHAR Phy11BNextRateUpward[]   = {RATE_2, RATE_5_5, RATE_11, RATE_11};

								  //  1      2       5.5      11        6        9        12      18       24       36       48       54
UCHAR Phy11BGNextRateDownward[]= {RATE_1, RATE_1,   RATE_2,  RATE_5_5,RATE_11,  RATE_11, RATE_11, RATE_12, RATE_18, RATE_24, RATE_36, RATE_48};
UCHAR Phy11BGNextRateUpward[]  = {RATE_2, RATE_5_5, RATE_11, RATE_12, RATE_11,  RATE_12, RATE_18, RATE_24, RATE_36, RATE_48, RATE_54, RATE_54};

								  //  1      2       5.5      11        6        9        12      18       24       36       48       54
UCHAR Phy11ANextRateDownward[] = {RATE_6, RATE_6,   RATE_6,  RATE_6,  RATE_6,   RATE_6,  RATE_9,  RATE_12, RATE_18, RATE_24, RATE_36, RATE_48};
UCHAR Phy11ANextRateUpward[]   = {RATE_9, RATE_9,   RATE_9,  RATE_9,  RATE_9,   RATE_12, RATE_18, RATE_24, RATE_36, RATE_48, RATE_54, RATE_54};

//                       RATE_1,  2, 5.5, 11,  6,  9, 12, 18, 24, 36, 48, 54
USHORT RateUpPER[]   = {  40,  40,  35, 20, 20, 20, 20, 16, 10, 16, 10,  6 }; // in percentage
USHORT RateDownPER[] = {  50,  50,  45, 45, 35, 35, 35, 35, 25, 25, 25, 13 }; // in percentage

UCHAR  RateIdToMbps[]    = { 1, 2, 5, 11, 6, 9, 12, 18, 24, 36, 48, 54, 72, 100};
USHORT RateIdTo500Kbps[] = { 2, 4, 11, 22, 12, 18, 24, 36, 48, 72, 96, 108, 144, 200};

UCHAR  SsidIe    = IE_SSID;
UCHAR  SupRateIe = IE_SUPP_RATES;
UCHAR  ExtRateIe = IE_EXT_SUPP_RATES;
UCHAR  HtCapIe = IE_HT_CAP;
UCHAR  AddHtInfoIe = IE_ADD_HT;
UCHAR  NewExtChanIe = IE_NEW_EXT_CHA_OFFSET;
UCHAR  ErpIe     = IE_ERP;
UCHAR  DsIe      = IE_DS_PARM;
UCHAR  TimIe     = IE_TIM;
UCHAR  WpaIe     = IE_WPA;
UCHAR  Wpa2Ie    = IE_WPA2;
UCHAR  IbssIe    = IE_IBSS_PARM;
UCHAR  Ccx2Ie    = IE_CCX_V2;
    
extern UCHAR	WPA_OUI[];

UCHAR   SES_OUI[] = {0x00, 0x90, 0x4c};

UCHAR	ZeroSsid[32] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};

RTMP_RF_REGS RF2850RegTable[] = {
//		ch	 R1 		 R2 		 R3(TX0~4=0) R4
		{1,  0x98402ecc, 0x984c0786, 0x9816b455, 0x9800510b},
		{2,  0x98402ecc, 0x984c0786, 0x98168a55, 0x9800519f},
		{3,  0x98402ecc, 0x984c078a, 0x98168a55, 0x9800518b},
		{4,  0x98402ecc, 0x984c078a, 0x98168a55, 0x9800519f},
		{5,  0x98402ecc, 0x984c078e, 0x98168a55, 0x9800518b},
		{6,  0x98402ecc, 0x984c078e, 0x98168a55, 0x9800519f},
		{7,  0x98402ecc, 0x984c0792, 0x98168a55, 0x9800518b},
		{8,  0x98402ecc, 0x984c0792, 0x98168a55, 0x9800519f},
		{9,  0x98402ecc, 0x984c0796, 0x98168a55, 0x9800518b},
		{10, 0x98402ecc, 0x984c0796, 0x98168a55, 0x9800519f},
		{11, 0x98402ecc, 0x984c079a, 0x98168a55, 0x9800518b},
		{12, 0x98402ecc, 0x984c079a, 0x98168a55, 0x9800519f},
		{13, 0x98402ecc, 0x984c079e, 0x98168a55, 0x9800518b},
		{14, 0x98402ecc, 0x984c07a2, 0x98168a55, 0x98005193},

		// 802.11 UNI / HyperLan 2
		{36, 0x98402ecc, 0x984c099a, 0x98158a55, 0x980ed1a3},
		{38, 0x98402ecc, 0x984c099e, 0x98158a55, 0x980ed193},
		{40, 0x98402ec8, 0x984c0682, 0x98158a55, 0x980ed183},
		{44, 0x98402ec8, 0x984c0682, 0x98158a55, 0x980ed1a3},
		{46, 0x98402ec8, 0x984c0686, 0x98158a55, 0x980ed18b},
		{48, 0x98402ec8, 0x984c0686, 0x98158a55, 0x980ed19b},
		{52, 0x98402ec8, 0x984c068a, 0x98158a55, 0x980ed193},
		{54, 0x98402ec8, 0x984c068a, 0x98158a55, 0x980ed1a3},
		{56, 0x98402ec8, 0x984c068e, 0x98158a55, 0x980ed18b},
		{60, 0x98402ec8, 0x984c0692, 0x98158a55, 0x980ed183},
		{62, 0x98402ec8, 0x984c0692, 0x98158a55, 0x980ed193},
		{64, 0x98402ec8, 0x984c0692, 0x98158a55, 0x980ed1a3}, // Plugfest#4, Day4, change RFR3 left4th 9->5.
		
		// 802.11 HyperLan 2
		{100, 0x98402ec8, 0x984c06b2, 0x98178a55, 0x980ed783},
		{102, 0x98402ec8, 0x984c06b2, 0x98178a55, 0x980ed793},
		{104, 0x98402ec8, 0x984c06b2, 0x98178a55, 0x980ed1a3},
		{108, 0x98402ecc, 0x984c0a32, 0x98178a55, 0x980ed193},
		{110, 0x98402ecc, 0x984c0a36, 0x98178a55, 0x980ed183},
		{112, 0x98402ecc, 0x984c0a36, 0x98178a55, 0x980ed19b},
		{116, 0x98402ecc, 0x984c0a3a, 0x98178a55, 0x980ed1a3},
		{118, 0x98402ecc, 0x984c0a3e, 0x98178a55, 0x980ed193},
		{120, 0x98402ec4, 0x984c0382, 0x98178a55, 0x980ed183},
		{124, 0x98402ec4, 0x984c0382, 0x98178a55, 0x980ed193},
		{126, 0x98402ec4, 0x984c0382, 0x98178a55, 0x980ed1bb},
		{128, 0x98402ec4, 0x984c0382, 0x98178a55, 0x980ed1a3},
		{132, 0x98402ec4, 0x984c0386, 0x98178a55, 0x980ed18b},
		{134, 0x98402ec4, 0x984c0386, 0x98178a55, 0x980ed193},
		{136, 0x98402ec4, 0x984c0386, 0x98178a55, 0x980ed19b},
		{140, 0x98402ec4, 0x984c038a, 0x98178a55, 0x980ed183},
		
		// 802.11 UNII
		{149, 0x98402ec4, 0x984c038a, 0x98178a55, 0x980ed1a7},
		{151, 0x98402ec4, 0x984c038e, 0x98178a55, 0x980ed187},
		{153, 0x98402ec4, 0x984c038e, 0x98178a55, 0x980ed18f},
		{157, 0x98402ec4, 0x984c038e, 0x98178a55, 0x980ed19f},
		{159, 0x98402ec4, 0x984c038e, 0x98178a55, 0x980ed1a7},
		{161, 0x98402ec4, 0x984c0392, 0x98178a55, 0x980ed187},
		{165, 0x98402ec4, 0x984c0392, 0x98178a55, 0x980ed197},
		
		// Japan
		{184, 0x95002ccc, 0x9500491e, 0x9509be55, 0x950c0a0b},
		{188, 0x95002ccc, 0x95004922, 0x9509be55, 0x950c0a13},
		{192, 0x95002ccc, 0x95004926, 0x9509be55, 0x950c0a1b},
		{196, 0x95002ccc, 0x9500492a, 0x9509be55, 0x950c0a23},
		{208, 0x95002ccc, 0x9500493a, 0x9509be55, 0x950c0a13},
		{212, 0x95002ccc, 0x9500493e, 0x9509be55, 0x950c0a1b},
		{216, 0x95002ccc, 0x95004982, 0x9509be55, 0x950c0a23},
		// still lack of MMAC(Japan) ch 34,38,42,46
};
#define	NUM_OF_2860_CHNL	(sizeof(RF2850RegTable) / sizeof(RTMP_RF_REGS))


/*
	==========================================================================
	Description:
		initialize the MLME task and its data structure (queue, spinlock, 
		timer, state machines).

	IRQL = PASSIVE_LEVEL

	Return:
		always return NDIS_STATUS_SUCCESS

	==========================================================================
*/
NDIS_STATUS MlmeInit(
	IN PRTMP_ADAPTER pAd) 
{
	NDIS_STATUS Status = NDIS_STATUS_SUCCESS;

	DBGPRINT(RT_DEBUG_TRACE, ("--> MLME Initialize\n"));

	do 
	{
		Status = MlmeQueueInit(&pAd->Mlme.Queue);
		if(Status != NDIS_STATUS_SUCCESS) 
			break;

		// Initialize Mlme Memory Handler
		// Allocate 20 nonpaged memory pool which size are MAX_LEN_OF_MLME_BUFFER for use
		Status = MlmeInitMemoryHandler(pAd, 20, MAX_LEN_OF_MLME_BUFFER);
		if(Status != NDIS_STATUS_SUCCESS)
		{
			MlmeQueueDestroy(&pAd->Mlme.Queue);
			break;
		}

		pAd->Mlme.bRunning = FALSE;
		NdisAllocateSpinLock(&pAd->Mlme.TaskLock);

		BssTableInit(&pAd->ScanTab);

		// init STA state machines
		AssocStateMachineInit(pAd, &pAd->Mlme.AssocMachine, pAd->Mlme.AssocFunc);
		AuthStateMachineInit(pAd, &pAd->Mlme.AuthMachine, pAd->Mlme.AuthFunc);
		AuthRspStateMachineInit(pAd, &pAd->Mlme.AuthRspMachine, pAd->Mlme.AuthRspFunc);
		SyncStateMachineInit(pAd, &pAd->Mlme.SyncMachine, pAd->Mlme.SyncFunc);
		WpaPskStateMachineInit(pAd, &pAd->Mlme.WpaPskMachine, pAd->Mlme.WpaPskFunc);
#ifdef CCX_SUPPORT		
		AironetStateMachineInit(pAd, &pAd->Mlme.AironetMachine, pAd->Mlme.AironetFunc);
#endif		
		ActionStateMachineInit(pAd, &pAd->Mlme.ActMachine, pAd->Mlme.ActFunc);
		
		// Since we are using switch/case to implement it, the init is different from the above 
		// state machine init
		MlmeCntlInit(pAd, &pAd->Mlme.CntlMachine, NULL);

		// Init mlme periodic timer
		RTMPInitTimer(pAd, &pAd->Mlme.PeriodicTimer, GET_TIMER_FUNCTION(MlmePeriodicExec), pAd, TRUE);

		// Set mlme periodic timer
		RTMPSetTimer(pAd, &pAd->Mlme.PeriodicTimer, MLME_TASK_EXEC_INTV);

		// software-based RX Antenna diversity
		RTMPInitTimer(pAd, &pAd->Mlme.RxAntEvalTimer, GET_TIMER_FUNCTION(AsicRxAntEvalTimeout), pAd, FALSE);

		// Init timer to report link down event
		RTMPInitTimer(pAd, &pAd->Mlme.LinkDownTimer, GET_TIMER_FUNCTION(LinkDownExec), pAd, FALSE);		

	} while (FALSE);

	DBGPRINT(RT_DEBUG_TRACE, ("<-- MLME Initialize\n"));

	return Status;
}


/*
	==========================================================================
	Description:
		main loop of the MLME
	Pre:
		Mlme has to be initialized, and there are something inside the queue
	Note:
		This function is invoked from MPSetInformation and MPReceive;
		This task guarantee only one MlmeHandler will run. 

	IRQL = DISPATCH_LEVEL
	
	==========================================================================
 */
VOID MlmeHandler(
	IN PRTMP_ADAPTER pAd) 
{
	MLME_QUEUE_ELEM		*Elem = NULL;
	unsigned long		IrqFlags;
	
	// Only accept MLME and Frame from peer side, no other (control/data) frame should
	// get into this state machine

	NdisAcquireSpinLock(&pAd->Mlme.TaskLock, IrqFlags);
	if(pAd->Mlme.bRunning) 
	{
		NdisReleaseSpinLock(&pAd->Mlme.TaskLock, IrqFlags);
		return;
	} 
	else 
	{
		pAd->Mlme.bRunning = TRUE;
	}
	NdisReleaseSpinLock(&pAd->Mlme.TaskLock, IrqFlags);

	while (!MlmeQueueEmpty(&pAd->Mlme.Queue)) 
	{
		
		if (RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_MLME_RESET_IN_PROGRESS) ||
			RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_HALT_IN_PROGRESS) ||
			RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_NIC_NOT_EXIST))
		{
			DBGPRINT(RT_DEBUG_TRACE, ("Device Halted or Removed or MlmeRest, exit MlmeHandler! (queue num = %ld)\n", pAd->Mlme.Queue.Num));
			break;
		}

		//From message type, determine which state machine I should drive
		if (MlmeDequeue(&pAd->Mlme.Queue, &Elem)) 
		{
			if (Elem->MsgType == RT_CMD_RESET_MLME)
			{
				DBGPRINT_RAW(RT_DEBUG_TRACE, ("!!! reset MLME state machine !!!\n"));
				MlmeRestartStateMachine(pAd);
				MlmePostRestartStateMachine(pAd);
				Elem->Occupied = FALSE;
				Elem->MsgLen = 0;
				continue;
			}
		
			// if dequeue success
			switch (Elem->Machine) 
			{
				// STA state machines

				case ASSOC_STATE_MACHINE:
					StateMachinePerformAction(pAd, &pAd->Mlme.AssocMachine, Elem);
					break;
				case AUTH_STATE_MACHINE:
					StateMachinePerformAction(pAd, &pAd->Mlme.AuthMachine, Elem);
					break;
				case AUTH_RSP_STATE_MACHINE:
					StateMachinePerformAction(pAd, &pAd->Mlme.AuthRspMachine, Elem);
					break;
				case SYNC_STATE_MACHINE:
					StateMachinePerformAction(pAd, &pAd->Mlme.SyncMachine, Elem);
					break;
				case MLME_CNTL_STATE_MACHINE:
					MlmeCntlMachinePerformAction(pAd, &pAd->Mlme.CntlMachine, Elem);
					break;
				case WPA_PSK_STATE_MACHINE:
					StateMachinePerformAction(pAd, &pAd->Mlme.WpaPskMachine, Elem);
					break;
#ifdef CCX_SUPPORT					
				case LEAP_STATE_MACHINE:
					LeapMachinePerformAction(pAd, &pAd->Mlme.LeapMachine, Elem);
					break;
				case AIRONET_STATE_MACHINE:
					StateMachinePerformAction(pAd, &pAd->Mlme.AironetMachine, Elem);
					break;	
#endif
				case ACTION_STATE_MACHINE:
					StateMachinePerformAction(pAd, &pAd->Mlme.ActMachine, Elem);
					break;	
				// AP state amchines

				case AP_ASSOC_STATE_MACHINE:
					StateMachinePerformAction(pAd, &pAd->Mlme.ApAssocMachine, Elem);
					break;
				case AP_AUTH_STATE_MACHINE:
					StateMachinePerformAction(pAd, &pAd->Mlme.ApAuthMachine, Elem);
					break;
				case AP_AUTH_RSP_STATE_MACHINE:
					StateMachinePerformAction(pAd, &pAd->Mlme.ApAuthRspMachine, Elem);
					break;
				case AP_SYNC_STATE_MACHINE:
					StateMachinePerformAction(pAd, &pAd->Mlme.ApSyncMachine, Elem);
					break;
				case AP_WPA_STATE_MACHINE:
					StateMachinePerformAction(pAd, &pAd->Mlme.ApWpaMachine, Elem);
					break;

				default:
					DBGPRINT(RT_DEBUG_TRACE, ("ERROR: Illegal machine in MlmeHandler()\n"));
					break;
			} // end of switch

			// free MLME element
			Elem->Occupied = FALSE;
			Elem->MsgLen = 0;

		}
		else {
			DBGPRINT_ERR(("MlmeHandler: MlmeQueue empty\n"));
		}
	}

	NdisAcquireSpinLock(&pAd->Mlme.TaskLock, IrqFlags);
	pAd->Mlme.bRunning = FALSE;
	NdisReleaseSpinLock(&pAd->Mlme.TaskLock, IrqFlags);
}

/*
	==========================================================================
	Description:
		Destructor of MLME (Destroy queue, state machine, spin lock and timer)
	Parameters:
		Adapter - NIC Adapter pointer
	Post:
		The MLME task will no longer work properly

	IRQL = PASSIVE_LEVEL

	==========================================================================
 */
VOID MlmeHalt(
	IN PRTMP_ADAPTER pAd) 
{
	BOOLEAN       Cancelled;

	DBGPRINT(RT_DEBUG_TRACE, ("==> MlmeHalt\n"));

	// Cancel pending timers
	RTMPCancelTimer(&pAd->MlmeAux.AssocTimer,		&Cancelled);
	RTMPCancelTimer(&pAd->MlmeAux.ReassocTimer,		&Cancelled);
	RTMPCancelTimer(&pAd->MlmeAux.DisassocTimer,	&Cancelled);
	RTMPCancelTimer(&pAd->MlmeAux.AuthTimer,		&Cancelled);
	RTMPCancelTimer(&pAd->MlmeAux.BeaconTimer,		&Cancelled);
	RTMPCancelTimer(&pAd->MlmeAux.ScanTimer,		&Cancelled);
	RTMPCancelTimer(&pAd->Mlme.PeriodicTimer,		&Cancelled);
	RTMPCancelTimer(&pAd->Mlme.LinkDownTimer,       &Cancelled);
	RTMPCancelTimer(&pAd->Mlme.RxAntEvalTimer,		&Cancelled);
	
	NdisMSleep(500000);    // 0.5 sec to gurantee Ant Diversity timer canceled

	MlmeQueueDestroy(&pAd->Mlme.Queue);
	NdisFreeSpinLock(&pAd->Mlme.TaskLock);
	MlmeFreeMemoryHandler(pAd);
	DBGPRINT(RT_DEBUG_TRACE, ("<== MlmeHalt\n"));
}

VOID MlmeSuspend(
	IN PRTMP_ADAPTER pAd,
	IN BOOLEAN linkdown) 
{
	BOOLEAN       Cancelled;
	MLME_QUEUE_ELEM		*Elem = NULL;
	unsigned long   IrqFlags;

	DBGPRINT(RT_DEBUG_TRACE, ("==>MlmeSuspend\n"));

	// Cancel pending timers
	RTMPCancelTimer(&pAd->MlmeAux.AssocTimer,     &Cancelled);
	RTMPCancelTimer(&pAd->MlmeAux.ReassocTimer,   &Cancelled);
	RTMPCancelTimer(&pAd->MlmeAux.DisassocTimer,   &Cancelled);
	RTMPCancelTimer(&pAd->MlmeAux.AuthTimer,       &Cancelled);
	RTMPCancelTimer(&pAd->MlmeAux.BeaconTimer,     &Cancelled);
	RTMPCancelTimer(&pAd->MlmeAux.ScanTimer,       &Cancelled);

	while (TRUE)
	{
		NdisAcquireSpinLock(&pAd->Mlme.TaskLock, IrqFlags);
		if(pAd->Mlme.bRunning) 
		{
			NdisReleaseSpinLock(&pAd->Mlme.TaskLock, IrqFlags);
			if (RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_HALT_IN_PROGRESS))
				return;

			NdisMSleep(100);
		}
		else
		{
			pAd->Mlme.bRunning = TRUE;
			NdisReleaseSpinLock(&pAd->Mlme.TaskLock, IrqFlags);
			break;
		}
	}

	// Remove all Mlme queues elements
	while (!MlmeQueueEmpty(&pAd->Mlme.Queue)) 
	{
		//From message type, determine which state machine I should drive
		if (MlmeDequeue(&pAd->Mlme.Queue, &Elem)) 
		{
			// free MLME element
			Elem->Occupied = FALSE;
			Elem->MsgLen = 0;

		}
		else {
			DBGPRINT(RT_DEBUG_ERROR, ("ERROR: empty Elem in MlmeQueue\n"));
		}
	}
	
	// Remove running state
	NdisAcquireSpinLock(&pAd->Mlme.TaskLock, IrqFlags);
	pAd->Mlme.bRunning = FALSE;
	NdisReleaseSpinLock(&pAd->Mlme.TaskLock, IrqFlags);

	RTUSBCleanUpMLMEWaitQueue(pAd);
	RTUSBCleanUpMLMEBulkOutQueue(pAd);

	// Set all state machines back IDLE
	pAd->Mlme.CntlMachine.CurrState    = CNTL_IDLE;
	pAd->Mlme.AssocMachine.CurrState   = ASSOC_IDLE;
	pAd->Mlme.AuthMachine.CurrState    = AUTH_REQ_IDLE;
	pAd->Mlme.AuthRspMachine.CurrState = AUTH_RSP_IDLE;
	pAd->Mlme.SyncMachine.CurrState    = SYNC_IDLE;
	if (RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_BSS_JOIN_IN_PROGRESS))
		RTMP_CLEAR_FLAG(pAd, fRTMP_ADAPTER_BSS_JOIN_IN_PROGRESS);//steven:for test
	if (RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_REASSOC_IN_PROGRESS))
		RTMP_CLEAR_FLAG(pAd, fRTMP_ADAPTER_REASSOC_IN_PROGRESS);//steven:for test
	if (RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_BSS_SCAN_IN_PROGRESS))
		RTMP_CLEAR_FLAG(pAd, fRTMP_ADAPTER_BSS_SCAN_IN_PROGRESS);//steven:for test

	DBGPRINT(RT_DEBUG_TRACE, ("<==MlmeSuspend\n"));
}

VOID	MlmeResume(
	IN	PRTMP_ADAPTER	pAd)
{
	DBGPRINT(RT_DEBUG_TRACE, ("==>MlmeResume\n"));

	if (RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_BSS_JOIN_IN_PROGRESS))
		RTMP_CLEAR_FLAG(pAd, fRTMP_ADAPTER_BSS_JOIN_IN_PROGRESS);//steven:for test
	if (RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_REASSOC_IN_PROGRESS))
		RTMP_CLEAR_FLAG(pAd, fRTMP_ADAPTER_REASSOC_IN_PROGRESS);//steven:for test
	if (RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_BSS_SCAN_IN_PROGRESS))
		RTMP_CLEAR_FLAG(pAd, fRTMP_ADAPTER_BSS_SCAN_IN_PROGRESS);//steven:for test
	// Set all state machines back IDLE
	pAd->Mlme.CntlMachine.CurrState    = CNTL_IDLE;
	pAd->Mlme.AssocMachine.CurrState   = ASSOC_IDLE;
	pAd->Mlme.AuthMachine.CurrState    = AUTH_REQ_IDLE;
	pAd->Mlme.AuthRspMachine.CurrState = AUTH_RSP_IDLE;
	pAd->Mlme.SyncMachine.CurrState    = SYNC_IDLE;


	DBGPRINT(RT_DEBUG_TRACE, ("<==MlmeResume\n"));
}
 
/*
	==========================================================================
	Description:
		This routine is executed periodically to -
		1. Decide if it's a right time to turn on PwrMgmt bit of all 
		   outgoiing frames
		2. Calculate ChannelQuality based on statistics of the last
		   period, so that TX rate won't toggling very frequently between a 
		   successful TX and a failed TX.
		3. If the calculated ChannelQuality indicated current connection not 
		   healthy, then a ROAMing attempt is tried here.

	IRQL = DISPATCH_LEVEL

	==========================================================================
 */
#define ADHOC_BEACON_LOST_TIME      10000  // 10 sec
VOID MlmePeriodicExec(
	IN PVOID SystemSpecific1, 
	IN PVOID FunctionContext, 
	IN PVOID SystemSpecific2, 
	IN PVOID SystemSpecific3) 
{
	RTMP_ADAPTER *pAd = (RTMP_ADAPTER *)FunctionContext;


	// Do nothing if monitor mode is on
	if (pAd->bPromiscuous == TRUE)
		return;
		
	if ((pAd->StaCfg.bHardwareRadio == TRUE) && 
		(!RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_NIC_NOT_EXIST)) &&
		(!RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_HALT_IN_PROGRESS)))
	{
		RTUSBEnqueueInternalCmd(pAd, RT_OID_CHECK_GPIO, NULL, 0);
	}

	// Do nothing if the driver is starting halt state.
	// This might happen when timer already been fired before cancel timer with mlmehalt
	if ((RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_HALT_IN_PROGRESS)) || 
		(RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_RADIO_OFF)) ||
		(RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_RADIO_MEASUREMENT)) ||
		(RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_RESET_IN_PROGRESS)))
		return;

	pAd->Mlme.PeriodicRound ++;

	if (pAd->Mlme.PeriodicRound % RECBA_EXEC_MULTIPLE == 0)
	{
		if (RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_MEDIA_STATE_PENDING))
		{
			RTMP_CLEAR_FLAG(pAd, fRTMP_ADAPTER_MEDIA_STATE_PENDING);
#ifdef WIN_NDIS		
			pAd->IndicateMediaState = NdisMediaStateDisconnected;
			NdisMIndicateStatus(pAd->AdapterHandle, NDIS_STATUS_MEDIA_DISCONNECT, (PVOID)NULL, 0);
			NdisMIndicateStatusComplete(pAd->AdapterHandle);
#endif	 /* WIN_NDIS */		
			DBGPRINT(RT_DEBUG_TRACE, ("NDIS_STATUS_MEDIA_DISCONNECT Event B!\n"));
		}
	
		//
		// hardware failure?
		//
		if (RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_NIC_NOT_EXIST))
		{
			RTUSBRejectPendingPackets(pAd);
		}
	

		RECBATimerTimeout(SystemSpecific1,FunctionContext,SystemSpecific2,SystemSpecific3);
	}

	if (pAd->Mlme.PeriodicRound % MLME_TASK_EXEC_MULTIPLE == 0)
	{
		pAd->Mlme.OneSecPeriodicRound ++;
		NdisGetSystemUpTime(&pAd->Mlme.Now32);
		// if MGMT RING is full more than twice within 1 second, we consider there's
		// a hardware problem stucking the TX path. In this case, try a hardware reset
		// to recover the system
		if (pAd->RalinkCounters.MgmtRingFullCount >= 2)
			RTMP_SET_FLAG(pAd, fRTMP_ADAPTER_HARDWARE_ERROR);
		else
			pAd->RalinkCounters.MgmtRingFullCount = 0;


		RTUSBEnqueueInternalCmd(pAd, RT_OID_PERIODIC_EXECUT, NULL, 0); //STAMlmePeriodicExec(pAd);

		DBGPRINT(RT_DEBUG_INFO, ("OneSecAggCnt=%ld,OneSecNoAggCnt=%ld\n", pAd->RalinkCounters.OneSecAggCnt, pAd->RalinkCounters.OneSecNoAggCnt));
		pAd->RalinkCounters.OneSecAggCnt = 0;
		pAd->RalinkCounters.OneSecNoAggCnt = 0;

		RTUSBMlmeUp(pAd);
	}

	if ((pAd->StaCfg.StaQuickResponeForRateUpTimerRunning) && (pAd->Mlme.PeriodicRound % MLME_TASK_EXEC_MULTIPLE == 1))
	{
		RTUSBEnqueueInternalCmd(pAd, RT_OID_QKERIODIC_EXECUT, NULL, 0); //STAMlmePeriodicExec(pAd);
		RTUSBMlmeUp(pAd);
	}
}

VOID STAMlmePeriodicExec(
	IN PRTMP_ADAPTER pAd)
{
	ULONG		TxTotalCnt=0;
#if WPA_SUPPLICANT_SUPPORT
    union iwreq_data wrqu;
#endif


	{
		UINT32		MACValue;
		ULONG		Count = 0;
		RTUSBReadMACRegister(pAd, TXRXQ_PCNT, &MACValue);
		if ((MACValue & 0xff) !=0 )
		{
			DBGPRINT(RT_DEBUG_TRACE, ("TX QUEUE 0 Not EMPTY. !!!!!!!!!!!!!!!\n"));
			RTUSBWriteMACRegister(pAd, PBF_CFG, 0xf40012);
			while((MACValue &0xff) != 0 && (Count++ < 10))
			{
				RTUSBReadMACRegister(pAd, TXRXQ_PCNT, &MACValue);
				NdisMSleep(1);  
			}
			RTUSBWriteMACRegister(pAd, PBF_CFG, 0xf40006);
		}
		Count = 0;
		if ((MACValue & 0xff00) !=0 )
		{
			DBGPRINT(RT_DEBUG_TRACE, ("TX QUEUE 1 Not EMPTY. !!!!!!!!!!!!!!!\n"));
			RTUSBWriteMACRegister(pAd, PBF_CFG, 0xf4000a);
			while((MACValue &0xff00) != 0 && (Count++ < 10))
			{
				RTUSBReadMACRegister(pAd, TXRXQ_PCNT, &MACValue);
				NdisMSleep(1);  
			}
			RTUSBWriteMACRegister(pAd, PBF_CFG, 0xf40006);
		}
	}

	// WPA MIC error should block association attempt for 60 seconds
	if (pAd->StaCfg.bBlockAssoc && (pAd->StaCfg.LastMicErrorTime + (60 * OS_HZ) < pAd->Mlme.Now32))
		pAd->StaCfg.bBlockAssoc = FALSE;

	DBGPRINT(RT_DEBUG_INFO,("MMCHK - CommonCfg.Ssid[%d]=%c%c%c%c... MlmeAux.Ssid[%d]=%c%c%c%c...\n",
			pAd->CommonCfg.SsidLen, pAd->CommonCfg.Ssid[0], pAd->CommonCfg.Ssid[1], pAd->CommonCfg.Ssid[2], pAd->CommonCfg.Ssid[3],
			pAd->MlmeAux.SsidLen, pAd->MlmeAux.Ssid[0], pAd->MlmeAux.Ssid[1], pAd->MlmeAux.Ssid[2], pAd->MlmeAux.Ssid[3]));

	// add the most up-to-date h/w raw counters into software variable, so that
	// the dynamic tuning mechanism below are based on most up-to-date information
	NICUpdateRawCounters(pAd);
	
	// only apply to STA, SoftAP needs not to tune
	// dynamic tune BBP R66 to find a balance between sensibility and noise isolation
	AsicBbpTuning(pAd);

	ORIBATimerTimeout(pAd);

	// The time period for checking antenna is according to traffic
	if (pAd->Mlme.bEnableAutoAntennaCheck)
	{
		TxTotalCnt = pAd->RalinkCounters.OneSecTxNoRetryOkCount + 
						 pAd->RalinkCounters.OneSecTxRetryOkCount + 
						 pAd->RalinkCounters.OneSecTxFailCount;

		if (TxTotalCnt > 50)
		{
			if (pAd->Mlme.OneSecPeriodicRound % 10 == 0)
			{
				AsicEvaluateRxAnt(pAd);
			}
		}
		else
		{
			if (pAd->Mlme.OneSecPeriodicRound % 3 == 0)
			{
				AsicEvaluateRxAnt(pAd);
			}
		}
	}

	if (OPSTATUS_TEST_FLAG(pAd, fOP_STATUS_MEDIA_STATE_CONNECTED)) 
	{
		// update channel quality for Roaming and UI LinkQuality display
		MlmeCalculateChannelQuality(pAd, pAd->Mlme.Now32);

		// perform dynamic tx rate switching based on past TX history
		MlmeDynamicTxRateSwitching(pAd);
	}

	AsicAdjustTxPower(pAd);

	if (INFRA_ON(pAd))
	{
		// Is PSM bit consistent with user power management policy?
		// This is the only place that will set PSM bit ON.
		MlmeCheckPsmChange(pAd, pAd->Mlme.Now32);

#if 0
		// patch Gemtek Prism2.5 AP bug, which stop sending BEACON for no reason
		if (INFRA_ON(pAd) &&
			(pAd->StaCfg.LastBeaconRxTime + 2500 < pAd->Mlme.Now32))  // BEACON almost starving?
		{
			DBGPRINT(RT_DEBUG_TRACE, ("!!! BEACON lost > 2.5 sec !!! Send ProbeRequest\n")); 
			EnqueueProbeRequest(pAd);
		}
#endif


//
//		Move the flowing code to RTUSBHardTransmit, after prepare EAPOL frame that indicated MIC error
//		To meet the WiFi Test Plan "The STAUT must deauthenticate itself from the AP".
//		Also need to bloc association frame.
//
//		The flowing code on here can't send disassociation frame to the AP, since AP may send deauthentication
//      	frame, on the meanwhile, station will call link down and then this code can't be performed.
//
//		// Check for EAPOL frame sent after MIC countermeasures
//		if (pAd->StaCfg.MicErrCnt >= 3)
//		{
//	
//			MLME_DISASSOC_REQ_STRUCT    DisassocReq;
//
//			// disassoc from current AP first
//			DBGPRINT(RT_DEBUG_TRACE, ("MLME - disassociate with current AP after sending second continuous EAPOL frame\n"));
//			DisassocParmFill(pAd, &DisassocReq, pAd->CommonCfg.Bssid, REASON_MIC_FAILURE);
//			MlmeEnqueue(pAd, ASSOC_STATE_MACHINE, MT2_MLME_DISASSOC_REQ, 
//						sizeof(MLME_DISASSOC_REQ_STRUCT), &DisassocReq);
//
//			pAd->Mlme.CntlMachine.CurrState = CNTL_WAIT_DISASSOC;
//			pAd->StaCfg.bBlockAssoc = TRUE;
//		}
//

		// Add auto seamless roaming
		if (pAd->StaCfg.bFastRoaming)
		{
			// Check the RSSI value, we should begin the roaming attempt
			INT RxSignal = RTMPMaxRssi(pAd, pAd->StaCfg.LastRssi, pAd->StaCfg.LastRssi2, pAd->StaCfg.LastRssi3) ;
			SHORT dBmToRoam = (SHORT)pAd->StaCfg.dBmToRoam;

			DBGPRINT(RT_DEBUG_TRACE, ("RxSignal %d\n,dBmToRoam = %d", RxSignal,dBmToRoam)); 
			// Only perform action when signal is less than or equal to setting from the UI or registry
			if ( RTMPMaxRssi(pAd, pAd->StaCfg.LastRssi, pAd->StaCfg.LastRssi2, pAd->StaCfg.LastRssi3) <=  dBmToRoam )
			{
				MlmeCheckForFastRoaming(pAd, pAd->Mlme.Now32);
			}
		}

		// send out a NULL frame every 10 sec. for what??? inform "PwrMgmt" bit?
		if ((pAd->Mlme.OneSecPeriodicRound % 10) == 8)
			RTMPSendNullFrame(pAd, pAd->CommonCfg.TxRate);

		if (CQI_IS_DEAD(pAd->Mlme.ChannelQuality))
		{
			DBGPRINT(RT_DEBUG_TRACE, ("MMCHK - No BEACON. Dead CQI. Auto Recovery attempt #%ld\n", pAd->RalinkCounters.BadCQIAutoRecoveryCount));
			pAd->StaCfg.CCXAdjacentAPReportFlag = TRUE;
			pAd->StaCfg.CCXAdjacentAPLinkDownTime = pAd->StaCfg.LastBeaconRxTime;

#if WPA_SUPPLICANT_SUPPORT
			if (pAd->StaCfg.WPA_Supplicant == TRUE) 
			{
				// send disassoc event to wpa_supplicant 
				memset(&wrqu, 0, sizeof(wrqu));
				wrqu.data.flags = RT_DISASSOC_EVENT_FLAG;
				wireless_send_event(pAd->net_dev, IWEVCUSTOM, &wrqu, NULL);
			}
#endif
			// Lost AP, send disconnect & link down event
			LinkDown(pAd, FALSE);

			// RTMPPatchMacBbpBug(pAd);
			MlmeAutoReconnectLastSSID(pAd);
		}
		else if (CQI_IS_BAD(pAd->Mlme.ChannelQuality))
		{
			pAd->RalinkCounters.BadCQIAutoRecoveryCount ++;
			DBGPRINT(RT_DEBUG_TRACE, ("MMCHK - Bad CQI. Auto Recovery attempt #%ld\n", pAd->RalinkCounters.BadCQIAutoRecoveryCount));
			MlmeAutoReconnectLastSSID(pAd);
		}
// TODO: temp removed
#if 0
		else if (CQI_IS_POOR(pAd->Mlme.ChannelQuality))
		{
			// perform aggresive roaming only when SECURITY OFF or WEP64/128;
			// WPA and WPA-PSK has no aggresive roaming because re-negotiation 
			// between 802.1x supplicant and authenticator/AAA server is required
			// but can't be guaranteed.
			if (pAd->CommonCfg.AuthMode < Ndis802_11AuthModeWPA)
				MlmeCheckForRoaming(pAd, pAd->Mlme.Now32);
		}
#endif
	}
	else if (ADHOC_ON(pAd))
	{
		// 2003-04-17 john. this is a patch that driver forces a BEACON out if ASIC fails
		// the "TX BEACON competition" for the entire past 1 sec.
		// So that even when ASIC's BEACONgen engine been blocked
		// by peer's BEACON due to slower system clock, this STA still can send out
		// minimum BEACON to tell the peer I'm alive.
		// drawback is that this BEACON won't be well aligned at TBTT boundary.
		EnqueueBeaconFrame(pAd);              // software send BEACON

		// if all 11b peers leave this BSS more than 5 seconds, update Tx rate,
		// restore outgoing BEACON to support B/G-mixed mode
		if ((pAd->CommonCfg.Channel <= 14)             &&
			(pAd->CommonCfg.MaxTxRate <= RATE_11)      &&
			(pAd->CommonCfg.MaxDesiredRate > RATE_11)  &&
			((pAd->StaCfg.Last11bBeaconRxTime + 5000) < pAd->Mlme.Now32))
		{
			DBGPRINT(RT_DEBUG_TRACE, ("MMCHK - last 11B peer left, update Tx rates\n")); 
			NdisMoveMemory(pAd->StaActive.SupRate, pAd->CommonCfg.SupRate, MAX_LEN_OF_SUPPORTED_RATES);
			pAd->StaActive.SupRateLen = pAd->CommonCfg.SupRateLen;
			MlmeUpdateTxRates(pAd, FALSE);
			MakeIbssBeacon(pAd);        // re-build BEACON frame
			AsicEnableIbssSync(pAd);    // copy to on-chip memory
		}

		//radar detect
		if (((pAd->CommonCfg.PhyMode == PHY_11A) || (pAd->CommonCfg.PhyMode == PHY_11ABG_MIXED)) && (pAd->CommonCfg.bIEEE80211H == 1) && RadarChannelCheck(pAd, pAd->CommonCfg.Channel))
		{
			// need to check channel availability, after switch channel
			if (pAd->CommonCfg.RadarDetect.RDMode == RD_SILENCE_MODE)
			{
				pAd->CommonCfg.RadarDetect.RDCount++;
				
				// channel availability check time is 60sec
				if (pAd->CommonCfg.RadarDetect.RDCount > 65)
				{
					if (RadarDetectionStop(pAd))
					{
						pAd->ExtraInfo = DETECT_RADAR_SIGNAL;
						pAd->CommonCfg.RadarDetect.RDCount = 0;		// stat at silence mode and detect radar signal
						DBGPRINT(RT_DEBUG_TRACE, ("Found radar signal!!!\n\n"));
					}
					else
					{
						DBGPRINT(RT_DEBUG_TRACE, ("Not found radar signal, start send beacon\n"));
						AsicEnableIbssSync(pAd);
						pAd->CommonCfg.RadarDetect.RDMode = RD_NORMAL_MODE;
					}
				}
			}
		}

#ifndef SINGLE_ADHOC_LINKUP
		// If all peers leave, and this STA becomes the last one in this IBSS, then change MediaState
		// to DISCONNECTED. But still holding this IBSS (i.e. sending BEACON) so that other STAs can
		// join later.
		if ((pAd->StaCfg.LastBeaconRxTime + ADHOC_BEACON_LOST_TIME < pAd->Mlme.Now32) &&
			OPSTATUS_TEST_FLAG(pAd, fOP_STATUS_MEDIA_STATE_CONNECTED))
		{
			DBGPRINT(RT_DEBUG_TRACE, ("MMCHK - excessive BEACON lost, last STA in this IBSS, MediaState=Disconnected\n")); 

			OPSTATUS_CLEAR_FLAG(pAd, fOP_STATUS_MEDIA_STATE_CONNECTED); 
#ifdef WIN_NDIS			
			pAd->IndicateMediaState = NdisMediaStateDisconnected;
			NdisMIndicateStatus(pAd->AdapterHandle, NDIS_STATUS_MEDIA_DISCONNECT, (PVOID)NULL, 0);
			NdisMIndicateStatusComplete(pAd->AdapterHandle);
#endif	 /* WIN_NDIS */			
			// clean up previous SCAN result, add current BSS back to table if any
			BssTableDeleteEntry(&pAd->ScanTab, pAd->CommonCfg.Bssid, pAd->CommonCfg.Channel);

			pAd->StaCfg.LastScanTime = pAd->Mlme.Now32;
		}
#endif
	}
	else // no INFRA nor ADHOC connection
	{
		DBGPRINT(RT_DEBUG_INFO, ("MLME periodic exec, no association so far\n"));
		if ((pAd->StaCfg.bAutoReconnect == TRUE) && 
			(MlmeValidateSSID(pAd->MlmeAux.AutoReconnectSsid, pAd->MlmeAux.AutoReconnectSsidLen) == TRUE))
		{
			if ((pAd->ScanTab.BssNr==0) && (pAd->Mlme.CntlMachine.CurrState == CNTL_IDLE))
			{
				MLME_SCAN_REQ_STRUCT       ScanReq;

				if ((pAd->StaCfg.LastScanTime + 10 * OS_HZ) < pAd->Mlme.Now32)
				{
					DBGPRINT(RT_DEBUG_TRACE, ("CNTL - No matching BSS, start a new ACTIVE scan SSID[%s]\n", pAd->MlmeAux.AutoReconnectSsid));
					ScanParmFill(pAd, &ScanReq, pAd->MlmeAux.AutoReconnectSsid, pAd->MlmeAux.AutoReconnectSsidLen, BSS_ANY, SCAN_ACTIVE);
					MlmeEnqueue(pAd, SYNC_STATE_MACHINE, MT2_MLME_SCAN_REQ, sizeof(MLME_SCAN_REQ_STRUCT), &ScanReq);
					pAd->Mlme.CntlMachine.CurrState = CNTL_WAIT_OID_LIST_SCAN;
					// Reset Missed scan number
					pAd->StaCfg.LastScanTime = pAd->Mlme.Now32;
				}
				else if (pAd->StaCfg.BssType == BSS_ADHOC)  // Quit the forever scan when in a very clean room
					MlmeAutoReconnectLastSSID(pAd);
			}
			else if (pAd->Mlme.CntlMachine.CurrState == CNTL_IDLE)
			{
				if ((pAd->Mlme.OneSecPeriodicRound % 10) == 7)
				{
					if ((pAd->StaCfg.LastScanTime + 10 * OS_HZ) < pAd->Mlme.Now32)
					{
						MlmeAutoScan(pAd);
						pAd->StaCfg.LastScanTime = pAd->Mlme.Now32;
					}
				}
				else
					MlmeAutoReconnectLastSSID(pAd);
		
				DBGPRINT(RT_DEBUG_INFO, ("pAd->StaCfg.bAutoReconnect is TRUE\n"));
			}
		}
	}

	if (((pAd->Mlme.OneSecPeriodicRound % 2) == 0) &&
		(INFRA_ON(pAd) || ADHOC_ON(pAd)))
	{
		RTMPSetSignalLED(pAd, RTMPMaxRssi(pAd, (CHAR)pAd->StaCfg.AvgRssi, (CHAR)pAd->StaCfg.AvgRssi2, (CHAR)pAd->StaCfg.AvgRssi3));
	}	
	
	//
	// Clear Tx/Rx Traffic one second count.
	//
	pAd->BulkLastOneSecCount = pAd->BulkOutDataOneSecCount + pAd->BulkInDataOneSecCount;
	pAd->BulkOutDataOneSecCount = 0;
	pAd->BulkInDataOneSecCount = 0;	

	//pAd->RalinkCounters.LastOneSecRxOkDataCnt = pAd->RalinkCounters.OneSecRxOkDataCnt;
	// clear all OneSecxxx counters.
	pAd->RalinkCounters.OneSecBeaconSentCnt = 0;
	pAd->RalinkCounters.OneSecFalseCCACnt = 0;
	pAd->RalinkCounters.OneSecRxFcsErrCnt = 0;
	pAd->RalinkCounters.OneSecRxOkCnt = 0;
	pAd->RalinkCounters.OneSecTxFailCount = 0;
	pAd->RalinkCounters.OneSecTxNoRetryOkCount = 0;
	pAd->RalinkCounters.OneSecTxRetryOkCount = 0;
	pAd->RalinkCounters.OneSecRxOkDataCnt = 0;

	// TODO: for debug only. to be removed
	pAd->RalinkCounters.OneSecOsTxCount[QID_AC_BE] = 0;
	pAd->RalinkCounters.OneSecOsTxCount[QID_AC_BK] = 0;
	pAd->RalinkCounters.OneSecOsTxCount[QID_AC_VI] = 0;
	pAd->RalinkCounters.OneSecOsTxCount[QID_AC_VO] = 0;
	pAd->RalinkCounters.OneSecDmaDoneCount[QID_AC_BE] = 0;
	pAd->RalinkCounters.OneSecDmaDoneCount[QID_AC_BK] = 0;
	pAd->RalinkCounters.OneSecDmaDoneCount[QID_AC_VI] = 0;
	pAd->RalinkCounters.OneSecDmaDoneCount[QID_AC_VO] = 0;
	pAd->RalinkCounters.OneSecTxDoneCount = 0;
	pAd->RalinkCounters.OneSecTxAggregationCount = 0;
	pAd->RalinkCounters.OneSecRxAggregationCount = 0;	

}

// Link down report
VOID LinkDownExec(
	IN PVOID SystemSpecific1, 
	IN PVOID FunctionContext, 
	IN PVOID SystemSpecific2, 
	IN PVOID SystemSpecific3) 
{
	RTMP_ADAPTER *pAd = (RTMP_ADAPTER *)FunctionContext;
	pAd->IndicateMediaState = NdisMediaStateDisconnected;
#ifdef WIN_NDIS	
	NdisMIndicateStatus(pAd->AdapterHandle, NDIS_STATUS_MEDIA_DISCONNECT, (PVOID)NULL, 0);
	NdisMIndicateStatusComplete(pAd->AdapterHandle);		
#endif	 /* WIN_NDIS */
}

// IRQL = DISPATCH_LEVEL
VOID MlmeAutoScan(
	IN PRTMP_ADAPTER pAd)
{
	// check CntlMachine.CurrState to avoid collision with NDIS SetOID request
	if (pAd->Mlme.CntlMachine.CurrState == CNTL_IDLE)
	{
		DBGPRINT(RT_DEBUG_TRACE, ("MMCHK - Driver auto scan\n"));
		MlmeEnqueue(pAd, 
					MLME_CNTL_STATE_MACHINE, 
					OID_802_11_BSSID_LIST_SCAN, 
					0, 
					NULL);
		RTUSBMlmeUp(pAd);	
	}
}

// IRQL = DISPATCH_LEVEL
VOID MlmeAutoReconnectLastSSID(
	IN PRTMP_ADAPTER pAd)
{
	// check CntlMachine.CurrState to avoid collision with NDIS SetOID request
	if ((pAd->Mlme.CntlMachine.CurrState == CNTL_IDLE) &&  
		(MlmeValidateSSID(pAd->MlmeAux.AutoReconnectSsid, pAd->MlmeAux.AutoReconnectSsidLen) == TRUE))
	{
		NDIS_802_11_SSID OidSsid;
		OidSsid.SsidLength = pAd->MlmeAux.AutoReconnectSsidLen;
		NdisMoveMemory(OidSsid.Ssid, pAd->MlmeAux.AutoReconnectSsid, pAd->MlmeAux.AutoReconnectSsidLen);

		DBGPRINT(RT_DEBUG_TRACE, ("Driver auto reconnect to last OID_802_11_SSID setting - %s, len - %d\n", pAd->MlmeAux.AutoReconnectSsid, pAd->MlmeAux.AutoReconnectSsidLen));
		MlmeEnqueue(pAd, 
					MLME_CNTL_STATE_MACHINE, 
					OID_802_11_SSID, 
					sizeof(NDIS_802_11_SSID), 
					&OidSsid);
		RTUSBMlmeUp(pAd);	
	}
}

/*
	==========================================================================
	Validate SSID for connection try and rescan purpose
	Valid SSID will have visible chars only.
	The valid length is from 0 to 32.
	IRQL = DISPATCH_LEVEL
	==========================================================================
 */
BOOLEAN	MlmeValidateSSID(
	IN PUCHAR   pSsid,
	IN UCHAR    SsidLen)
{
	int	index;

	if (SsidLen > MAX_LEN_OF_SSID)
		return (FALSE);

	// Check each character value
	for (index = 0; index < SsidLen; index++)
	{
		if (pSsid[index] < 0x20)
			return (FALSE);
	}

	// All checked
	return (TRUE);
}


//
// TRUE: Visible SSID
// FALSE: None Visible SSID
//
BOOLEAN	MlmeIsVisibleSSID(
	IN PUCHAR   pSsid,
	IN UCHAR    SsidLen)
{
	int	index;

	if (SsidLen > MAX_LEN_OF_SSID)
		return (FALSE);

	// Check each character value
	for (index = 0; index < SsidLen; index++)
	{
		if ((pSsid[index] < 0x20) || (pSsid[index] > 0x7e))
			return (FALSE);
	}

	// All checked
	return (TRUE);
}

BOOLEAN	MlmeValidateSetSSID(
	IN PNDIS_802_11_SSID pOidSsid)
{
	ULONG	index;
	
	// First check the zero length "ANY" SSID
	if (pOidSsid->SsidLength == 0)
		return (TRUE);
	else if (pOidSsid->SsidLength > MAX_LEN_OF_SSID)
		return (FALSE);

	// Check each character value
	for (index = 0; index < pOidSsid->SsidLength; index++)
	{
		if (pOidSsid->Ssid[index] < 0x20)
			return (FALSE);
	}

	// All checked
	return (TRUE);
}

/*
	==========================================================================
	Description:
		This routine checks if there're other APs out there capable for
		roaming. Caller should call this routine only when Link up in INFRA mode
		and channel quality is below CQI_GOOD_THRESHOLD.

	IRQL = DISPATCH_LEVEL

	Output:
	==========================================================================
 */
VOID MlmeCheckForRoaming(
	IN PRTMP_ADAPTER pAd,
	IN ULONG    Now32)
{
#if 0
	USHORT     i;
	BSS_TABLE  *pRoamTab = &pAd->MlmeAux.RoamTab;
	BSS_ENTRY  *pBss;

	DBGPRINT(RT_DEBUG_TRACE, ("==> MlmeCheckForRoaming\n"));
	// put all roaming candidates into RoamTab, and sort in RSSI order
	BssTableInit(pRoamTab);
	for (i = 0; i < pAd->ScanTab.BssNr; i++)
	{
		pBss = &pAd->ScanTab.BssEntry[i];

		if ((pBss->LastBeaconRxTime + BEACON_LOST_TIME) < Now32) 
			continue;    // AP disappear
		if (pBss->Rssi <= RSSI_THRESHOLD_FOR_ROAMING)
			continue;    // RSSI too weak. forget it.
		if (MAC_ADDR_EQUAL(pBss->Bssid, pAd->CommonCfg.Bssid))
			continue;    // skip current AP
		if (pBss->Rssi < (pAd->StaCfg.LastRssi + RSSI_DELTA))
			continue;    // only AP with stronger RSSI is eligible for roaming

		// AP passing all above rules is put into roaming candidate table        
		NdisMoveMemory(&pRoamTab->BssEntry[pRoamTab->BssNr], pBss, sizeof(BSS_ENTRY));
		pRoamTab->BssNr += 1;
	}

	if (pRoamTab->BssNr > 0)
	{
		// check CntlMachine.CurrState to avoid collision with NDIS SetOID request
		if (pAd->Mlme.CntlMachine.CurrState == CNTL_IDLE)
		{
			pAd->RalinkCounters.PoorCQIRoamingCount ++;
			DBGPRINT(RT_DEBUG_TRACE, ("MMCHK - Roaming attempt #%ld\n", pAd->RalinkCounters.PoorCQIRoamingCount));
			MlmeEnqueue(pAd, MLME_CNTL_STATE_MACHINE, MT2_MLME_ROAMING_REQ, 0, NULL);
			RTUSBMlmeUp(pAd);
		}
	}
	DBGPRINT(RT_DEBUG_TRACE, ("<== MlmeCheckForRoaming(# of candidate= %ld)\n",pRoamTab->BssNr));   
#endif
}

/*
	==========================================================================
	Description:
		This routine checks if there're other APs out there capable for
		roaming. Caller should call this routine only when link up in INFRA mode
		and channel quality is below CQI_GOOD_THRESHOLD.

	IRQL = DISPATCH_LEVEL

	Output:
	==========================================================================
 */
VOID MlmeCheckForFastRoaming(
	IN	PRTMP_ADAPTER	pAd,
	IN	ULONG			Now)
{

	USHORT     i;
	BSS_TABLE  *pRoamTab = &pAd->MlmeAux.RoamTab;
	BSS_ENTRY  *pBss;

	DBGPRINT(RT_DEBUG_TRACE, ("==> MlmeCheckForFastRoaming\n"));
	// put all roaming candidates into RoamTab, and sort in RSSI order
	BssTableInit(pRoamTab);
	for (i = 0; i < pAd->ScanTab.BssNr; i++)
	{
		pBss = &pAd->ScanTab.BssEntry[i];		
		if ((pBss->Rssi <= -50) && (pBss->Channel == pAd->CommonCfg.Channel))			
			continue;    // RSSI too weak. forget it.
		if (MAC_ADDR_EQUAL(pBss->Bssid, pAd->CommonCfg.Bssid))
			continue;    // skip current AP
		if (!SSID_EQUAL(pBss->Ssid, pBss->SsidLen, pAd->CommonCfg.Ssid, pAd->CommonCfg.SsidLen))
			continue;    // skip different SSID
		if (pBss->Rssi < (RTMPMaxRssi(pAd, pAd->StaCfg.LastRssi, pAd->StaCfg.LastRssi2, pAd->StaCfg.LastRssi3) + RSSI_DELTA)) 		
			continue;    // skip AP without better RSSI
		
		DBGPRINT(RT_DEBUG_TRACE, ("LastRssi = %d, pBss->Rssi = %d\n", pAd->StaCfg.LastRssi, pBss->Rssi));
		// AP passing all above rules is put into roaming candidate table        
		NdisMoveMemory(&pRoamTab->BssEntry[pRoamTab->BssNr], pBss, sizeof(BSS_ENTRY));
		pRoamTab->BssNr += 1;
	}

	if (pRoamTab->BssNr > 0)
	{
		// check CntlMachine.CurrState to avoid collision with NDIS SetOID request
		if (pAd->Mlme.CntlMachine.CurrState == CNTL_IDLE)
		{
			pAd->RalinkCounters.PoorCQIRoamingCount ++;
			DBGPRINT(RT_DEBUG_TRACE, ("MMCHK - Roaming attempt #%ld\n", pAd->RalinkCounters.PoorCQIRoamingCount));
			MlmeEnqueue(pAd, MLME_CNTL_STATE_MACHINE, MT2_MLME_ROAMING_REQ, 0, NULL);
			RTUSBMlmeUp(pAd);
		}
	}
	// Maybe site survey required
	else
	{
		if ((pAd->StaCfg.LastScanTime + 10 * OS_HZ) < Now)
		{
			// check CntlMachine.CurrState to avoid collision with NDIS SetOID request
			DBGPRINT(RT_DEBUG_TRACE, ("MMCHK - Roaming, No eligable entry, try new scan!\n"));
			pAd->StaCfg.ScanCnt = 2;
			pAd->StaCfg.LastScanTime = Now;
			MlmeAutoScan(pAd);
		}
	}

	DBGPRINT(RT_DEBUG_TRACE, ("<== MlmeCheckForFastRoaming\n"));	

}

/*
	==========================================================================
	Description:
		This routine calculates TxPER, RxPER of the past N-sec period. And 
		according to the calculation result, ChannelQuality is calculated here 
		to decide if current AP is still doing the job. 

		If ChannelQuality is not good, a ROAMing attempt may be tried later.
	Output:
		StaCfg.ChannelQuality - 0..100

	IRQL = DISPATCH_LEVEL

	NOTE: This routine decide channle quality based on RX CRC error ratio.
		Caller should make sure a function call to NICUpdateRawCounters(pAd)
		is performed right before this routine, so that this routine can decide
		channel quality based on the most up-to-date information
	==========================================================================
 */
VOID MlmeCalculateChannelQuality(
	IN PRTMP_ADAPTER pAd,
	IN ULONG Now32)
{
	ULONG TxOkCnt, TxCnt, TxPER, TxPRR;
	ULONG RxCnt, RxPER;
	UCHAR NorRssi;

	//
	// calculate TX packet error ratio and TX retry ratio - if too few TX samples, skip TX related statistics
	//
	TxOkCnt = pAd->RalinkCounters.OneSecTxNoRetryOkCount + pAd->RalinkCounters.OneSecTxRetryOkCount;
	TxCnt = TxOkCnt + (pAd->RalinkCounters.OneSecTxFailCount>>2);
	if (TxCnt < 5) 
	{
		TxPER = 0;
		TxPRR = 0;
	}
	else 
	{
		TxPER = (pAd->RalinkCounters.OneSecTxFailCount * 100) / TxCnt; 
		TxPRR = ((TxCnt - pAd->RalinkCounters.OneSecTxNoRetryOkCount) * 100) / TxCnt;
	}

	//
	// calculate RX PER - don't take RxPER into consideration if too few sample
	//
	RxCnt = pAd->RalinkCounters.OneSecRxOkCnt + pAd->RalinkCounters.OneSecRxFcsErrCnt;
	if (RxCnt < 5)
		RxPER = 0;  
	else
		RxPER = (pAd->RalinkCounters.OneSecRxFcsErrCnt * 100) / RxCnt;


	//
	// decide ChannelQuality based on: 1)last BEACON received time, 2)last RSSI, 3)TxPER, and 4)RxPER
	//
	if (INFRA_ON(pAd) &&
		( pAd->RalinkCounters.OneSecTxNoRetryOkCount  < 2) && // no heavy traffic
		(pAd->StaCfg.LastBeaconRxTime + BEACON_LOST_TIME < Now32))
	{
		DBGPRINT(RT_DEBUG_TRACE, ("BEACON lost > %d msec with TxOkCnt=%ld -> CQI=0\n", BEACON_LOST_TIME, TxOkCnt)); 
		pAd->Mlme.ChannelQuality = 0;
	}
	else
	{
		// Normalize Rssi
		if (pAd->StaCfg.LastRssi < 0x20)
			NorRssi = 100;
		else if (pAd->StaCfg.LastRssi > 0x52)
			NorRssi = 0;
		else
			NorRssi = 100- (pAd->StaCfg.LastRssi - 0x20) * 2;
		
		// ChannelQuality = W1*RSSI + W2*TxPRR + W3*RxPER    (RSSI 0..100), (TxPER 100..0), (RxPER 100..0)
		pAd->Mlme.ChannelQuality = (RSSI_WEIGHTING * NorRssi + 
								   TX_WEIGHTING * (100 - TxPRR) + 
								   RX_WEIGHTING* (100 - RxPER)) / 100;
		if (pAd->Mlme.ChannelQuality >= 100)
			pAd->Mlme.ChannelQuality = 100;
	}
	DBGPRINT(RT_DEBUG_INFO, ("MMCHK - CQI= %ld (Tx Fail=%ld/Retry=%ld/Total=%ld, Rx Fail=%ld/Total=%ld, RSSI=%d dbm)\n", 
		pAd->Mlme.ChannelQuality, 
		pAd->RalinkCounters.OneSecTxFailCount, 
		pAd->RalinkCounters.OneSecTxRetryOkCount, 
		TxCnt, 
		pAd->RalinkCounters.OneSecRxFcsErrCnt, 
		RxCnt, pAd->StaCfg.LastRssi));

}

VOID MlmeSetTxRate(
	IN PRTMP_ADAPTER		pAd,
	IN PMAC_TABLE_ENTRY		pEntry,
	IN PRTMP_TX_RATE_SWITCH	pTxRate)
{
	if (pTxRate->STBC && (pAd->CommonCfg.MaxHTPhyMode.field.STBC))
		pAd->CommonCfg.HTPhyMode.field.STBC = STBC_USE;
	else
		pAd->CommonCfg.HTPhyMode.field.STBC = STBC_NONE;

	if (pTxRate->ShortGI && (pAd->CommonCfg.MaxHTPhyMode.field.ShortGI))
		pAd->CommonCfg.HTPhyMode.field.ShortGI = GI_400;
	else
		pAd->CommonCfg.HTPhyMode.field.ShortGI = GI_800;

	if (pTxRate->CurrMCS < MCS_AUTO)
		pAd->CommonCfg.HTPhyMode.field.MCS = pTxRate->CurrMCS;

	if (pTxRate->Mode <= MODE_HTGREENFIELD)
		pAd->CommonCfg.HTPhyMode.field.MODE = pTxRate->Mode;

	// Double confirm STBC not use if (MCS >7). Although we already make correct rate table.
	if (pAd->CommonCfg.HTPhyMode.field.MCS > 7)
		pAd->CommonCfg.HTPhyMode.field.STBC = STBC_NONE;
	
	pEntry->HTPhyMode.field.STBC	= pAd->CommonCfg.HTPhyMode.field.STBC;
	pEntry->HTPhyMode.field.ShortGI	= pAd->CommonCfg.HTPhyMode.field.ShortGI;
	pEntry->HTPhyMode.field.MCS		= pAd->CommonCfg.HTPhyMode.field.MCS;
	pEntry->HTPhyMode.field.MODE	= pAd->CommonCfg.HTPhyMode.field.MODE;

	DBGPRINT_RAW(RT_DEBUG_TRACE,("DRS: MlmeSetTxRate - CurrTxRateIdx=%d, MCS=%d, STBC=%d, ShortGI=%d, Mode=%d, BW=%d \n", pAd->CommonCfg.TxRateIndex,
		pAd->CommonCfg.HTPhyMode.field.MCS,	pAd->CommonCfg.HTPhyMode.field.STBC, pAd->CommonCfg.HTPhyMode.field.ShortGI,
		pAd->CommonCfg.HTPhyMode.field.MODE, pAd->CommonCfg.HTPhyMode.field.BW));
}

VOID MlmeSelectTxRateTable(
	IN PRTMP_ADAPTER		pAd,
	IN PUCHAR				*ppTable,
	IN PUCHAR				pTableSize,
	IN PUCHAR				pInitTxRateIdx)
{
	if (pAd->CommonCfg.TxRateTableSize > 0)
	{
		*ppTable = RateSwitchTable;
		*pTableSize = RateSwitchTable[0];
		*pInitTxRateIdx = RateSwitchTable[1];

		DBGPRINT_RAW(RT_DEBUG_TRACE,("DRS: rate table is from rate.bin \n"));
	}
	else if (ADHOC_ON(pAd))
	{
		if (pAd->CommonCfg.PhyMode == PHY_11B)
		{
			*ppTable = RateSwitchTable11B;
			*pTableSize = RateSwitchTable11B[0];
			*pInitTxRateIdx = RateSwitchTable11B[1];
			DBGPRINT_RAW(RT_DEBUG_INFO,("DRS: B only Adhoc \n"));
		}
		else if (pAd->LatchRfRegs.Channel <= 14)
		{
			*ppTable = RateSwitchTable11BG;
			*pTableSize = RateSwitchTable11BG[0];
			*pInitTxRateIdx = RateSwitchTable11BG[1];
			DBGPRINT_RAW(RT_DEBUG_INFO,("DRS: B/G mixed Adhoc \n"));
		}
		else
		{
			*ppTable = RateSwitchTable11G;
			*pTableSize = RateSwitchTable11G[0];
			*pInitTxRateIdx = RateSwitchTable11G[1];
			DBGPRINT_RAW(RT_DEBUG_INFO,("DRS: A/G Adhoc \n"));
		}
	}
	else
	{
		if ((pAd->StaActive.SupRateLen + pAd->StaActive.ExtRateLen == 12) && (pAd->StaActive.SupportedHtPhy.MCSSet[0] == 0xff) &&
			((pAd->StaActive.SupportedHtPhy.MCSSet[1] == 0x00) || (pAd->Antenna.field.TxPath == 1)))
		{// 11BGN 1S AP
			*ppTable = RateSwitchTable11BGN1S;
			*pTableSize = RateSwitchTable11BGN1S[0];
			*pInitTxRateIdx = RateSwitchTable11BGN1S[1];
			DBGPRINT_RAW(RT_DEBUG_INFO,("DRS: 11BGN 1S AP \n"));
		}
		else if ((pAd->StaActive.SupRateLen + pAd->StaActive.ExtRateLen == 12) && (pAd->StaActive.SupportedHtPhy.MCSSet[0] == 0xff) &&
			(pAd->StaActive.SupportedHtPhy.MCSSet[1] == 0xff) && (pAd->Antenna.field.TxPath == 2))
		{// 11BGN 2S AP
			*ppTable = RateSwitchTable11BGN2S;
			*pTableSize = RateSwitchTable11BGN2S[0];
			*pInitTxRateIdx = RateSwitchTable11BGN2S[1];
			DBGPRINT_RAW(RT_DEBUG_INFO,("DRS: 11BGN 2S AP \n"));
		}
		else if ((pAd->StaActive.SupportedHtPhy.MCSSet[0] == 0xff) && ((pAd->StaActive.SupportedHtPhy.MCSSet[1] == 0x00) || (pAd->Antenna.field.TxPath == 1)))
		{// 11N 1S AP
			*ppTable = RateSwitchTable11N1S;
			*pTableSize = RateSwitchTable11N1S[0];
			*pInitTxRateIdx = RateSwitchTable11N1S[1];
			DBGPRINT_RAW(RT_DEBUG_INFO,("DRS: 11N 1S AP \n"));
		}
		else if ((pAd->StaActive.SupportedHtPhy.MCSSet[0] == 0xff) && (pAd->StaActive.SupportedHtPhy.MCSSet[1] == 0xff) && (pAd->Antenna.field.TxPath == 2))
		{// 11N 2S AP
			*ppTable = RateSwitchTable11N2S;
			*pTableSize = RateSwitchTable11N2S[0];
			*pInitTxRateIdx = RateSwitchTable11N2S[1];
			DBGPRINT_RAW(RT_DEBUG_INFO,("DRS: 11N 2S AP \n"));
		}
		else if ((pAd->StaActive.SupRateLen == 4) && (pAd->StaActive.ExtRateLen == 0) && (pAd->StaActive.SupportedHtPhy.MCSSet[0] == 0) && (pAd->StaActive.SupportedHtPhy.MCSSet[1] == 0))
		{// B only AP
			*ppTable = RateSwitchTable11B;
			*pTableSize = RateSwitchTable11B[0];
			*pInitTxRateIdx = RateSwitchTable11B[1];
			DBGPRINT_RAW(RT_DEBUG_INFO,("DRS: B only AP \n"));
		}
		else if ((pAd->StaActive.SupRateLen + pAd->StaActive.ExtRateLen > 8) && (pAd->StaActive.SupportedHtPhy.MCSSet[0] == 0) && (pAd->StaActive.SupportedHtPhy.MCSSet[1] == 0))
		{// B/G  mixed AP
			*ppTable = RateSwitchTable11BG;
			*pTableSize = RateSwitchTable11BG[0];
			*pInitTxRateIdx = RateSwitchTable11BG[1];
			DBGPRINT_RAW(RT_DEBUG_INFO,("DRS: B/G mixed AP \n"));
		}
		else if ((pAd->StaActive.SupRateLen + pAd->StaActive.ExtRateLen == 8) && (pAd->StaActive.SupportedHtPhy.MCSSet[0] == 0) && (pAd->StaActive.SupportedHtPhy.MCSSet[1] == 0))
		{// G only AP
			*ppTable = RateSwitchTable11G;
			*pTableSize = RateSwitchTable11G[0];
			*pInitTxRateIdx = RateSwitchTable11G[1];
			DBGPRINT_RAW(RT_DEBUG_INFO,("DRS: A/G AP \n"));
		}
		else
		{
			*ppTable = RateSwitchTable11N2S;
			*pTableSize = RateSwitchTable11N2S[0];
			*pInitTxRateIdx = RateSwitchTable11N2S[1];
			DBGPRINT_RAW(RT_DEBUG_ERROR,("DRS: unkown mode \n"));
		}
	}
}

/*
	==========================================================================
	Description:
		This routine calculates the acumulated TxPER of eaxh TxRate. And 
		according to the calculation result, change CommonCfg.TxRate which 
		is the stable TX Rate we expect the Radio situation could sustained. 

		CommonCfg.TxRate will change dynamically within {RATE_1/RATE_6, MaxTxRate} 
	Output:
		CommonCfg.TxRate - 

	IRQL = DISPATCH_LEVEL

	NOTE:
		call this routine every second
	==========================================================================
 */
VOID MlmeDynamicTxRateSwitching(
	IN PRTMP_ADAPTER pAd)
{
	UCHAR					UpRateIdx = 1, DownRateIdx = 0, CurrRateIdx;
	ULONG					TxTotalCnt;
	ULONG					TxErrorRatio = 0;
	BOOLEAN					bTxRateChanged = TRUE, bUpgradeQuality = FALSE;
	PRTMP_TX_RATE_SWITCH	pCurrTxRate, pNextTxRate = NULL;
	PUCHAR					pTable;
	UCHAR					TableSize = 0;
	UCHAR					InitTxRateIdx = 0, TrainUp, TrainDown;
	CHAR					Rssi;

	CurrRateIdx = pAd->CommonCfg.TxRateIndex;

	Rssi = RTMPMaxRssi(pAd, (CHAR)pAd->StaCfg.AvgRssi, (CHAR)pAd->StaCfg.AvgRssi2, (CHAR)pAd->StaCfg.AvgRssi3);
	MlmeSelectTxRateTable(pAd, &pTable, &TableSize, &InitTxRateIdx);

	// decide the next upgrade rate and downgrade rate, if any
	if ((CurrRateIdx > 0) && (CurrRateIdx < (TableSize - 1)))
	{
		UpRateIdx = CurrRateIdx + 1;
		DownRateIdx = CurrRateIdx -1;
	}
	else if (CurrRateIdx == 0)
	{
		UpRateIdx = CurrRateIdx + 1;
		DownRateIdx = CurrRateIdx;
	}
	else if (CurrRateIdx == (TableSize - 1))
	{
		UpRateIdx = CurrRateIdx;
		DownRateIdx = CurrRateIdx - 1;
	}
	
	pCurrTxRate = (PRTMP_TX_RATE_SWITCH) &pTable[(CurrRateIdx+1)*5];
	if ((Rssi > -65) && (pCurrTxRate->Mode >= MODE_HTMIX))
	{
		TrainUp		= (pCurrTxRate->TrainUp + (pCurrTxRate->TrainUp >> 1));
		TrainDown	= (pCurrTxRate->TrainDown + (pCurrTxRate->TrainDown >> 1));
	}
	else
	{
		TrainUp		= pCurrTxRate->TrainUp;
		TrainDown	= pCurrTxRate->TrainDown;
	}

	// if no traffic in the past 1-sec period, don't change TX rate,
	// but clear all bad history. because the bad history may affect the next 
	// Chariot throughput test
	TxTotalCnt = pAd->RalinkCounters.OneSecTxNoRetryOkCount + 
				 pAd->RalinkCounters.OneSecTxRetryOkCount + 
				 pAd->RalinkCounters.OneSecTxFailCount;
	
	if (TxTotalCnt)
		TxErrorRatio = ((pAd->RalinkCounters.OneSecTxRetryOkCount + pAd->RalinkCounters.OneSecTxFailCount) * 100) / TxTotalCnt;

	if (pAd->CommonCfg.bAutoTxRateSwitch == FALSE)
	{
		DBGPRINT_RAW(RT_DEBUG_TRACE,("DRS: Fixed - CurrTxRateIdx=%d, MCS=%d, STBC=%d, ShortGI=%d, Mode=%d, BW=%d, PER=%ld%% \n\n",
			pAd->CommonCfg.TxRateIndex,	pAd->CommonCfg.HTPhyMode.field.MCS,	pAd->CommonCfg.HTPhyMode.field.STBC,
			pAd->CommonCfg.HTPhyMode.field.ShortGI,	pAd->CommonCfg.HTPhyMode.field.MODE, pAd->CommonCfg.HTPhyMode.field.BW, TxErrorRatio));
		return;
	}
	else
	{
		DBGPRINT_RAW(RT_DEBUG_TRACE,("DRS: Before- CurrTxRateIdx=%d, MCS=%d, STBC=%d, ShortGI=%d, Mode=%d, TrainUp=%d, TrainDown=%d, NextUp=%d, NextDown=%d, CurrMCS=%d, PER=%ld%%\n",
			CurrRateIdx,
			pCurrTxRate->CurrMCS,
			pCurrTxRate->STBC,
			pCurrTxRate->ShortGI,
			pCurrTxRate->Mode,
			TrainUp,
			TrainDown,
			UpRateIdx,
			DownRateIdx,
			pAd->CommonCfg.HTPhyMode.field.MCS,
			TxErrorRatio));
	}

	if (! OPSTATUS_TEST_FLAG(pAd, fOP_STATUS_TX_RATE_SWITCH_ENABLED))
		return;

	//
	// CASE 1. when TX samples are fewer than 15, then decide TX rate solely on RSSI
	//         (criteria copied from RT2500 for Netopia case)
	//
	if (TxTotalCnt <= 15)
	{
		CHAR	idx = 0;
		UCHAR	TxRateIdx;
		UCHAR	MCS0 = 0, MCS4 = 0, MCS7 = 0, MCS12 = 0, MCS15 = 0;

		Rssi = RTMPMaxRssi(pAd, (CHAR)pAd->StaCfg.AvgRssi, (CHAR)pAd->StaCfg.AvgRssi2, (CHAR)pAd->StaCfg.AvgRssi3);

		// check the existence and index of each needed MCS
		while (idx < pTable[0])
		{
			pCurrTxRate = (PRTMP_TX_RATE_SWITCH) &pTable[(idx+1)*5];

			if (pCurrTxRate->CurrMCS == MCS_0)
			{
				MCS0 = idx;
			}
			else if (pCurrTxRate->CurrMCS == MCS_4)
			{
				MCS4 = idx;
			}
			else if (pCurrTxRate->CurrMCS == MCS_7)
			{
				MCS7 = idx;
			}
			else if (pCurrTxRate->CurrMCS == MCS_12)
			{
				MCS12 = idx;
			}
			else if ((pCurrTxRate->CurrMCS == MCS_15) && (pCurrTxRate->ShortGI == GI_800))
			{
				MCS15 = idx;
			}

			idx ++;
		}

		if (MCS15 && (Rssi > -65))
			TxRateIdx = MCS15;
		else if (MCS12 && (Rssi > -75))
			TxRateIdx = MCS12;
		else if (MCS7 && (Rssi > -75))
			TxRateIdx = MCS7;
		else if (MCS4 && (Rssi > -84))
			TxRateIdx = MCS4;
		else if (!MCS4 )	// for B-only mode
			TxRateIdx = MCS_3;
		else
			TxRateIdx = MCS0;

		if (TxRateIdx != pAd->CommonCfg.TxRateIndex)
		{
			pAd->CommonCfg.TxRateIndex = TxRateIdx;
			pNextTxRate = (PRTMP_TX_RATE_SWITCH) &pTable[(pAd->CommonCfg.TxRateIndex+1)*5];
			MlmeSetTxRate(pAd, &pAd->MacTab.Content[BSSID_WCID], pNextTxRate);
		}

		NdisZeroMemory(pAd->DrsCounters.TxQuality, sizeof(USHORT)*MAX_STEP_OF_TX_RATE_SWITCH);
		NdisZeroMemory(pAd->DrsCounters.PER, sizeof(UCHAR)*MAX_STEP_OF_TX_RATE_SWITCH);
		pAd->DrsCounters.fLastSecAccordingRSSI = TRUE;

		DBGPRINT_RAW(RT_DEBUG_TRACE,("DRS: TxTotalCnt <= 15, switch MCS according to RSSI (%d)\n", Rssi));
		return;
	}

	if ((pAd->DrsCounters.fLastSecAccordingRSSI == TRUE) || (pAd->DrsCounters.LastSecTxRateChangeAction != 0))
	{
		pAd->DrsCounters.fLastSecAccordingRSSI = FALSE;
		pAd->DrsCounters.LastSecTxRateChangeAction = 0;
		DBGPRINT_RAW(RT_DEBUG_TRACE,("DRS: MCS is according to RSSI or rate changed last sec, and ignore tuning this sec\n"));
		return;
	}

	do
	{
		pAd->DrsCounters.CurrTxRateStableTime ++;
		DBGPRINT(RT_DEBUG_INFO, ("DRS:TxErrorRatio = %ld, TxNoRetryOkCount=%ld, TxRetryOkCount=%ld, TxFailCount=%ld \n",
			TxErrorRatio, pAd->RalinkCounters.OneSecTxNoRetryOkCount, pAd->RalinkCounters.OneSecTxRetryOkCount, pAd->RalinkCounters.OneSecTxFailCount));

		// downgrade TX quality if PER >= Rate-Down threshold
		if (TxErrorRatio >= TrainDown)
		{
			pAd->DrsCounters.TxQuality[CurrRateIdx] = DRS_TX_QUALITY_WORST_BOUND;
		}
		// upgrade TX quality if PER <= Rate-Up threshold
		else if (TxErrorRatio <= TrainUp)
		{
			bUpgradeQuality = TRUE;
			if (pAd->DrsCounters.TxQuality[CurrRateIdx])
				pAd->DrsCounters.TxQuality[CurrRateIdx] --;  // quality very good in CurrRate

			if (pAd->DrsCounters.TxRateUpPenalty)
				pAd->DrsCounters.TxRateUpPenalty --;
			else if (pAd->DrsCounters.TxQuality[UpRateIdx])
				pAd->DrsCounters.TxQuality[UpRateIdx] --;    // may improve next UP rate's quality
		}

		pAd->DrsCounters.PER[CurrRateIdx] = (UCHAR)TxErrorRatio;

		// perform DRS - consider TxRate Down first, then rate up.
		if ((CurrRateIdx != DownRateIdx) && (pAd->DrsCounters.TxQuality[CurrRateIdx] >= DRS_TX_QUALITY_WORST_BOUND))
		{
			pAd->CommonCfg.TxRateIndex = DownRateIdx;
		}
		else if ((CurrRateIdx != UpRateIdx) && (pAd->DrsCounters.TxQuality[UpRateIdx] <= 0))
		{
			pAd->CommonCfg.TxRateIndex = UpRateIdx;
		}
	}while (FALSE);

	// if rate-up happen, clear all bad history of all TX rates
	if (pAd->CommonCfg.TxRateIndex > CurrRateIdx)
	{
		DBGPRINT_RAW(RT_DEBUG_TRACE,("DRS: ++TX rate from %d to %d \n", CurrRateIdx, pAd->CommonCfg.TxRateIndex));
		
		pAd->DrsCounters.CurrTxRateStableTime = 0;
		pAd->DrsCounters.TxRateUpPenalty = 0;
		pAd->DrsCounters.LastSecTxRateChangeAction = 1; // rate UP
		NdisZeroMemory(pAd->DrsCounters.TxQuality, sizeof(USHORT)*MAX_STEP_OF_TX_RATE_SWITCH);
		NdisZeroMemory(pAd->DrsCounters.PER, sizeof(UCHAR)*MAX_STEP_OF_TX_RATE_SWITCH);

		//
		// For TxRate fast train up, issued by David 2005/05/12
		// 
		if (!pAd->StaCfg.StaQuickResponeForRateUpTimerRunning)
		{
			//RTMPSetTimer(pAd, &pAd->StaCfg.StaQuickResponeForRateUpTimer, pAd->QuickTimerP);

			pAd->StaCfg.StaQuickResponeForRateUpTimerRunning = TRUE;
		}
	}
	// if rate-down happen, only clear DownRate's bad history
	else if (pAd->CommonCfg.TxRateIndex < CurrRateIdx)
	{
		DBGPRINT_RAW(RT_DEBUG_TRACE,("DRS: --TX rate from %d to %d \n", CurrRateIdx, pAd->CommonCfg.TxRateIndex));
		
		pAd->DrsCounters.CurrTxRateStableTime = 0;
		pAd->DrsCounters.TxRateUpPenalty = 0;           // no penalty
		pAd->DrsCounters.LastSecTxRateChangeAction = 2; // rate DOWN
		pAd->DrsCounters.TxQuality[pAd->CommonCfg.TxRate] = 0;
		pAd->DrsCounters.PER[pAd->CommonCfg.TxRate] = 0;

		//
		// For TxRate fast train down
		// 
		if (!pAd->StaCfg.StaQuickResponeForRateUpTimerRunning)
		{
			//RTMPSetTimer(&pAd->StaCfg.StaQuickResponeForRateUpTimer, 100);

			pAd->StaCfg.StaQuickResponeForRateUpTimerRunning = TRUE;
		}
	}
	else
	{
		pAd->DrsCounters.LastSecTxRateChangeAction = 0; // rate no change
		bTxRateChanged = FALSE;
	}

	pAd->DrsCounters.LastTxOkCount = pAd->RalinkCounters.OneSecTxNoRetryOkCount;

	pNextTxRate = (PRTMP_TX_RATE_SWITCH) &pTable[(pAd->CommonCfg.TxRateIndex+1)*5];
	if (bTxRateChanged && pNextTxRate)
	{
		MlmeSetTxRate(pAd, &pAd->MacTab.Content[BSSID_WCID], pNextTxRate);
	}
}

/*
	========================================================================
	Routine Description:
		Station side, Auto TxRate faster train up timer call back function.

	Arguments:
		SystemSpecific1			- Not used.
		FunctionContext			- Pointer to our Adapter context.
		SystemSpecific2			- Not used.
		SystemSpecific3			- Not used.

	Return Value:
		None

	========================================================================
*/
VOID StaQuickResponeForRateUpExec(
	IN PVOID SystemSpecific1, 
	IN PVOID FunctionContext, 
	IN PVOID SystemSpecific2, 
	IN PVOID SystemSpecific3) 
{
	PRTMP_ADAPTER			pAd = (PRTMP_ADAPTER)FunctionContext;
	UCHAR					UpRateIdx = 1, DownRateIdx = 0, CurrRateIdx;
	ULONG					TxTotalCnt;
	ULONG					TxErrorRatio = 0;
	BOOLEAN					bTxRateChanged = TRUE;//, bUpgradeQuality = FALSE;
	PRTMP_TX_RATE_SWITCH	pCurrTxRate, pNextTxRate = NULL;
	PUCHAR					pTable;
	UCHAR					TableSize = 0;
	UCHAR					InitTxRateIdx = 0, TrainUp, TrainDown;
	TX_STA_CNT1_STRUC		StaTx1;
	TX_STA_CNT0_STRUC		TxStaCnt0;
	CHAR					Rssi, ratio;

	pAd->StaCfg.StaQuickResponeForRateUpTimerRunning = FALSE;
	Rssi = RTMPMaxRssi(pAd, (CHAR)pAd->StaCfg.AvgRssi, (CHAR)pAd->StaCfg.AvgRssi2, (CHAR)pAd->StaCfg.AvgRssi3);
	CurrRateIdx = pAd->CommonCfg.TxRateIndex;

	MlmeSelectTxRateTable(pAd, &pTable, &TableSize, &InitTxRateIdx);

	// decide the next upgrade rate and downgrade rate, if any
	if ((CurrRateIdx > 0) && (CurrRateIdx < (TableSize - 1)))
	{
		UpRateIdx = CurrRateIdx + 1;
		DownRateIdx = CurrRateIdx -1;
	}
	else if (CurrRateIdx == 0)
	{
		UpRateIdx = CurrRateIdx + 1;
		DownRateIdx = CurrRateIdx;
	}
	else if (CurrRateIdx == (TableSize - 1))
	{
		UpRateIdx = CurrRateIdx;
		DownRateIdx = CurrRateIdx - 1;
	}

	pCurrTxRate = (PRTMP_TX_RATE_SWITCH) &pTable[(CurrRateIdx+1)*5];
	if ((Rssi > -65) && (pCurrTxRate->Mode >= MODE_HTMIX))
	{
		TrainUp		= (pCurrTxRate->TrainUp + (pCurrTxRate->TrainUp >> 1));
		TrainDown	= (pCurrTxRate->TrainDown + (pCurrTxRate->TrainDown >> 1));
	}
	else
	{
		TrainUp		= pCurrTxRate->TrainUp;
		TrainDown	= pCurrTxRate->TrainDown;
	}

	pAd->RalinkCounters.QKTxRetryOkCount = 0;
	// Update statistic counter
	RTUSBReadMACRegister(pAd, TX_STA_CNT0, &TxStaCnt0.word);
	RTUSBReadMACRegister(pAd, TX_STA_CNT1, &StaTx1.word);
	pAd->WlanCounters.FailedCount.LowPart += TxStaCnt0.field.TxFailCount;
	pAd->RalinkCounters.OneSecTxRetryOkCount += StaTx1.field.TxRetransmit;
	pAd->RalinkCounters.OneSecTxNoRetryOkCount += StaTx1.field.TxSuccess;
	pAd->RalinkCounters.OneSecTxFailCount += TxStaCnt0.field.TxFailCount;
	// read counters in 100ms
	pAd->RalinkCounters.QKTxRetryOkCount = StaTx1.field.TxRetransmit;
	pAd->RalinkCounters.QKTxNoRetryOkCount = StaTx1.field.TxSuccess;
	pAd->RalinkCounters.QKTxFailCount = TxStaCnt0.field.TxFailCount;
	// if no traffic in the past 1-sec period, don't change TX rate,
	// but clear all bad history. because the bad history may affect the next 
	// Chariot throughput test
	TxTotalCnt = pAd->RalinkCounters.QKTxNoRetryOkCount + 
				 pAd->RalinkCounters.QKTxRetryOkCount + 
				 pAd->RalinkCounters.QKTxFailCount;


	if (TxTotalCnt)
		TxErrorRatio = ((pAd->RalinkCounters.QKTxRetryOkCount + pAd->RalinkCounters.QKTxFailCount) * 100) / TxTotalCnt;

	DBGPRINT(RT_DEBUG_TRACE, ("QuickDRS:TxErrorRatio = %ld, TxNoRetryOkCount=%ld, TxRetryOkCount=%ld, TxFailCount=%ld \n",
		TxErrorRatio, pAd->RalinkCounters.QKTxNoRetryOkCount, pAd->RalinkCounters.QKTxRetryOkCount, pAd->RalinkCounters.QKTxFailCount));
	//
	// CASE 1. when TX samples are fewer than 15, then decide TX rate solely on RSSI
	//         (criteria copied from RT2500 for Netopia case)
	//
	if (TxTotalCnt <= 12)
	{
		NdisZeroMemory(pAd->DrsCounters.TxQuality, sizeof(pAd->DrsCounters.TxQuality));
		NdisZeroMemory(pAd->DrsCounters.PER, sizeof(pAd->DrsCounters.PER));

		DBGPRINT_RAW(RT_DEBUG_TRACE,("QuickDRS: TxTotalCnt <= 15, ignore switching \n"));
		return;
	}

	do
	{
		ratio = 9;

		// downgrade TX quality if PER >= Rate-Down threshold
		if (TxErrorRatio >= TrainDown)
		{
			pAd->DrsCounters.TxQuality[CurrRateIdx] = DRS_TX_QUALITY_WORST_BOUND;
		}

		pAd->DrsCounters.PER[CurrRateIdx] = (UCHAR)TxErrorRatio;

		// perform DRS - consider TxRate Down first, then rate up.
		if ((pAd->DrsCounters.LastSecTxRateChangeAction == 1) && (CurrRateIdx != DownRateIdx))
		{
			if ((pAd->DrsCounters.LastTxOkCount + 2) >= (pAd->RalinkCounters.QKTxNoRetryOkCount * ratio + (pAd->RalinkCounters.QKTxNoRetryOkCount >> 1)))
			{
				pAd->CommonCfg.TxRateIndex = DownRateIdx;
				pAd->DrsCounters.TxQuality[CurrRateIdx] = DRS_TX_QUALITY_WORST_BOUND;
				DBGPRINT_RAW(RT_DEBUG_TRACE,("QuickDRS: (Up) bad tx ok count (L:%ld, C:%ld)\n", pAd->DrsCounters.LastTxOkCount, (pAd->RalinkCounters.QKTxNoRetryOkCount * ratio)));
			}
			else
			{
				DBGPRINT_RAW(RT_DEBUG_TRACE,("QuickDRS: (Up) keep rate-up (L:%ld, C:%ld)\n", pAd->DrsCounters.LastTxOkCount, (pAd->RalinkCounters.QKTxNoRetryOkCount * ratio)));
			}
		}
		else if ((pAd->DrsCounters.LastSecTxRateChangeAction == 2) && (CurrRateIdx != UpRateIdx))
		{
			if ((pAd->DrsCounters.LastTxOkCount + 2) >= (pAd->RalinkCounters.QKTxNoRetryOkCount * ratio + (pAd->RalinkCounters.QKTxNoRetryOkCount >> 1)))
			{
				pAd->CommonCfg.TxRateIndex = UpRateIdx;
				DBGPRINT_RAW(RT_DEBUG_TRACE,("QuickDRS: (Down) bad tx ok count (L:%ld, C:%ld)\n", pAd->DrsCounters.LastTxOkCount, (pAd->RalinkCounters.QKTxNoRetryOkCount * ratio)));
			}
			else
			{
				DBGPRINT_RAW(RT_DEBUG_TRACE,("QuickDRS: (Down) keep rate-down (L:%ld, C:%ld)\n", pAd->DrsCounters.LastTxOkCount, (pAd->RalinkCounters.QKTxNoRetryOkCount * ratio)));
			}
		}
	}while (FALSE);

	// if rate-up happen, clear all bad history of all TX rates
	if (pAd->CommonCfg.TxRateIndex > CurrRateIdx)
	{
		DBGPRINT_RAW(RT_DEBUG_TRACE,("QuickDRS: ++TX rate from %d to %d \n", CurrRateIdx, pAd->CommonCfg.TxRateIndex));
		
		pAd->DrsCounters.TxRateUpPenalty = 0;
		NdisZeroMemory(pAd->DrsCounters.TxQuality, sizeof(pAd->DrsCounters.TxQuality));
		NdisZeroMemory(pAd->DrsCounters.PER, sizeof(pAd->DrsCounters.PER));
	}
	// if rate-down happen, only clear DownRate's bad history
	else if (pAd->CommonCfg.TxRateIndex < CurrRateIdx)
	{
		DBGPRINT_RAW(RT_DEBUG_TRACE,("QuickDRS: --TX rate from %d to %d \n", CurrRateIdx, pAd->CommonCfg.TxRateIndex));
		
		pAd->DrsCounters.TxRateUpPenalty = 0;           // no penalty
		pAd->DrsCounters.TxQuality[pAd->CommonCfg.TxRate] = 0;
		pAd->DrsCounters.PER[pAd->CommonCfg.TxRate] = 0;
	}
	else
	{
		bTxRateChanged = FALSE;
		DBGPRINT_RAW(RT_DEBUG_TRACE,("QuickDRS: rate is not changed \n"));
	}

	pNextTxRate = (PRTMP_TX_RATE_SWITCH) &pTable[(pAd->CommonCfg.TxRateIndex+1)*5];
	if (bTxRateChanged && pNextTxRate)
	{
		MlmeSetTxRate(pAd, &pAd->MacTab.Content[BSSID_WCID], pNextTxRate);
	}
}

/*
	==========================================================================
	Description:
		This routine is executed periodically inside MlmePeriodicExec() after 
		association with an AP.
		It checks if StaCfg.Psm is consistent with user policy (recorded in
		StaCfg.WindowsPowerMode). If not, enforce user policy. However, 
		there're some conditions to consider:
		1. we don't support power-saving in ADHOC mode, so Psm=PWR_ACTIVE all
		   the time when Mibss==TRUE
		2. When link up in INFRA mode, Psm should not be switch to PWR_SAVE
		   if outgoing traffic available in TxRing or MgmtRing.
	Output:
		1. change pAd->StaCfg.Psm to PWR_SAVE or leave it untouched

	IRQL <= PASSIVE_LEVEL

	==========================================================================
 */
VOID MlmeCheckPsmChange(
	IN PRTMP_ADAPTER pAd,
	IN ULONG    Now32)
{
	ULONG	PowerMode;
	// condition -
	// 1. Psm maybe ON only happen in INFRASTRUCTURE mode
	// 2. user wants either MAX_PSP or FAST_PSP
	// 3. but current psm is not in PWR_SAVE
	// 4. CNTL state machine is not doing SCANning
	// 5. no TX SUCCESS event for the past 1-sec period
	PowerMode = pAd->StaCfg.WindowsPowerMode;

	//  rt2860 Firmware auto wake up for every bulk out frame. So we need to sed sleep command to firmware if we are using psm policy.
	if (INFRA_ON(pAd) &&
		(PowerMode != Ndis802_11PowerModeCAM) &&
		(pAd->StaCfg.Psm == PWR_ACTIVE) &&
		(pAd->Mlme.CntlMachine.CurrState == CNTL_IDLE) &&
		(pAd->RalinkCounters.OneSecTxNoRetryOkCount == 0) &&
		(pAd->RalinkCounters.OneSecTxRetryOkCount == 0))
	{
		MlmeSetPsm(pAd, PWR_SAVE);
		RTMPSendNullFrame(pAd, pAd->CommonCfg.TxRate);
	}

}

// IRQL <= PASSIVE_LEVEL
VOID MlmeSetPsm(
	IN PRTMP_ADAPTER pAd, 
	IN USHORT psm)
{
	AUTO_RSP_CFG_STRUC csr4;

	pAd->StaCfg.Psm = psm;	  
	RTUSBReadMACRegister(pAd, AUTO_RSP_CFG, &csr4.word);
	csr4.field.AckCtsPsmBit = (psm == PWR_SAVE)? 1:0;
	RTUSBWriteMACRegister(pAd, AUTO_RSP_CFG, csr4.word);
	DBGPRINT(RT_DEBUG_TRACE, ("MlmeSetPsm = %d\n", psm));
}

// IRQL = DISPATCH_LEVEL
VOID MlmeSetTxPreamble(
	IN PRTMP_ADAPTER pAd, 
	IN USHORT TxPreamble)
{
	AUTO_RSP_CFG_STRUC csr4;

	//
	// Always use Long preamble before verifiation short preamble functionality works well.
	// Todo: remove the following line if short preamble functionality works
	//
	//TxPreamble = Rt802_11PreambleLong;
	
	RTUSBReadMACRegister(pAd, AUTO_RSP_CFG, &csr4.word);
	if (TxPreamble == Rt802_11PreambleLong)
	{
		DBGPRINT(RT_DEBUG_TRACE, ("MlmeSetTxPreamble (= LONG PREAMBLE)\n"));
		OPSTATUS_CLEAR_FLAG(pAd, fOP_STATUS_SHORT_PREAMBLE_INUSED); 
		csr4.field.AutoResponderPreamble = 0;
	}
	else
	{
		// NOTE: 1Mbps should always use long preamble
		DBGPRINT(RT_DEBUG_TRACE, ("MlmeSetTxPreamble (= SHORT PREAMBLE)\n"));
		OPSTATUS_SET_FLAG(pAd, fOP_STATUS_SHORT_PREAMBLE_INUSED);
		csr4.field.AutoResponderPreamble = 1;
	}

	RTUSBWriteMACRegister(pAd, AUTO_RSP_CFG, csr4.word);
}

// IRQL = PASSIVE_LEVEL
// IRQL = DISPATCH_LEVEL
// bLinkUp is to identify the inital link speed.
// TRUE indicates the rate update at linkup, we should not try to set the rate at 54Mbps.
VOID MlmeUpdateTxRates(
	IN PRTMP_ADAPTER pAd,
	IN BOOLEAN		 bLinkUp)
{
	int i, num;
	UCHAR Rate = RATE_6, MaxDesire = RATE_1, MaxSupport = RATE_1;
	UCHAR MinSupport = RATE_54;
	ULONG BasicRateBitmap = 0x0000013f;
	UCHAR CurrBasicRate = RATE_1;
	UCHAR *pSupRate, SupRateLen, *pExtRate, ExtRateLen;

	// find max desired rate
	num = 0;
	for (i=0; i<MAX_LEN_OF_SUPPORTED_RATES; i++)
	{
		switch (pAd->CommonCfg.DesireRate[i] & 0x7f)
		{
			case 2:  Rate = RATE_1;   num++;   break;
			case 4:  Rate = RATE_2;   num++;   break;
			case 11: Rate = RATE_5_5; num++;   break;
			case 22: Rate = RATE_11;  num++;   break;
			case 12: Rate = RATE_6;   num++;   break;
			case 18: Rate = RATE_9;   num++;   break;
			case 24: Rate = RATE_12;  num++;   break;
			case 36: Rate = RATE_18;  num++;   break;
			case 48: Rate = RATE_24;  num++;   break;
			case 72: Rate = RATE_36;  num++;   break;
			case 96: Rate = RATE_48;  num++;   break;
			case 108: Rate = RATE_54; num++;   break;
			//default: Rate = RATE_1;   break; 
		}
		if (MaxDesire < Rate)  MaxDesire = Rate;
	}

	pAd->CommonCfg.BasicRateBitmap = BasicRateBitmap;

//===========================================================================
//===========================================================================

	// calculate the exptected ACK rate for each TX rate. This info is used to caculate
	// the DURATION field of outgoing uniicast DATA/MGMT frame
	for (i=0; i<MAX_LEN_OF_SUPPORTED_RATES; i++)
	{
		if (BasicRateBitmap & (0x01 << i))
			CurrBasicRate = (UCHAR)i;
		pAd->CommonCfg.ExpectedACKRate[i] = CurrBasicRate;
		DBGPRINT(RT_DEBUG_INFO,("E ACK  [%d] = %d Mbps", RateIdToMbps[i], RateIdToMbps[CurrBasicRate]));
	}
//===========================================================================
//===========================================================================

	// 2003-12-10 802.11g WIFI spec disallow OFDM rates in 802.11g ADHOC mode
	if ((pAd->StaCfg.BssType == BSS_ADHOC)		  &&
		((pAd->CommonCfg.PhyMode == PHY_11BG_MIXED))
		&& 
		(pAd->StaCfg.AdhocMode == 0) &&
		(MaxDesire > RATE_11) && (pAd->OpMode == OPMODE_STA))
	{
		MaxDesire = RATE_11;
		DBGPRINT(RT_DEBUG_INFO,("MlmeUpdateTxRates. 2 MaxDesire = %d. OpMode=%d\n", MaxDesire, pAd->OpMode));

	}

	pAd->CommonCfg.MaxDesiredRate = MaxDesire;
	pAd->CommonCfg.MinHTPhyMode.word = 0;
	pAd->CommonCfg.MaxHTPhyMode.word = 0;
	pAd->CommonCfg.HTPhyMode.word = 0;

	// Auto rate switching is enabled only if more than one DESIRED RATES are 
	// specified; otherwise disabled
	if (num <= 1)
	{
		OPSTATUS_CLEAR_FLAG(pAd, fOP_STATUS_TX_RATE_SWITCH_ENABLED);
		pAd->CommonCfg.bAutoTxRateSwitch	= FALSE;
	}
	else
	{
		OPSTATUS_SET_FLAG(pAd, fOP_STATUS_TX_RATE_SWITCH_ENABLED); 
		pAd->CommonCfg.bAutoTxRateSwitch	= TRUE;
	}

	if (ADHOC_ON(pAd) || INFRA_ON(pAd))
	{
		pSupRate = &pAd->StaActive.SupRate[0];
		pExtRate = &pAd->StaActive.ExtRate[0];
		SupRateLen = pAd->StaActive.SupRateLen;
		ExtRateLen = pAd->StaActive.ExtRateLen;
	}
	else
	{
		pSupRate = &pAd->CommonCfg.SupRate[0];
		pExtRate = &pAd->CommonCfg.ExtRate[0];
		SupRateLen = pAd->CommonCfg.SupRateLen;
		ExtRateLen = pAd->CommonCfg.ExtRateLen;
	}

	// find max supported rate
	for (i=0; i<SupRateLen; i++)
	{
		switch (pSupRate[i] & 0x7f)
		{
			case 2:   Rate = RATE_1;	if (pSupRate[i] & 0x80) BasicRateBitmap |= 0x0001;	 break;
			case 4:   Rate = RATE_2;	if (pSupRate[i] & 0x80) BasicRateBitmap |= 0x0002;	 break;
			case 11:  Rate = RATE_5_5;	if (pSupRate[i] & 0x80) BasicRateBitmap |= 0x0004;	 break;
			case 22:  Rate = RATE_11;	if (pSupRate[i] & 0x80) BasicRateBitmap |= 0x0008;	 break;
			case 12:  Rate = RATE_6;	/*if (pSupRate[i] & 0x80)*/  BasicRateBitmap |= 0x0010;  break;
			case 18:  Rate = RATE_9;	if (pSupRate[i] & 0x80) BasicRateBitmap |= 0x0020;	 break;
			case 24:  Rate = RATE_12;	/*if (pSupRate[i] & 0x80)*/  BasicRateBitmap |= 0x0040;  break;
			case 36:  Rate = RATE_18;	if (pSupRate[i] & 0x80) BasicRateBitmap |= 0x0080;	 break;
			case 48:  Rate = RATE_24;	/*if (pSupRate[i] & 0x80)*/  BasicRateBitmap |= 0x0100;  break;
			case 72:  Rate = RATE_36;	if (pSupRate[i] & 0x80) BasicRateBitmap |= 0x0200;	 break;
			case 96:  Rate = RATE_48;	if (pSupRate[i] & 0x80) BasicRateBitmap |= 0x0400;	 break;
			case 108: Rate = RATE_54;	if (pSupRate[i] & 0x80) BasicRateBitmap |= 0x0800;	 break;
			default:  Rate = RATE_1;	break;
		}
		if (MaxSupport < Rate)	MaxSupport = Rate;

		if (MinSupport > Rate) MinSupport = Rate;		
	}
	for (i=0; i<ExtRateLen; i++)
	{
		switch (pExtRate[i] & 0x7f)
		{
			case 2:   Rate = RATE_1;	if (pExtRate[i] & 0x80) BasicRateBitmap |= 0x0001;	 break;
			case 4:   Rate = RATE_2;	if (pExtRate[i] & 0x80) BasicRateBitmap |= 0x0002;	 break;
			case 11:  Rate = RATE_5_5;	if (pExtRate[i] & 0x80) BasicRateBitmap |= 0x0004;	 break;
			case 22:  Rate = RATE_11;	if (pExtRate[i] & 0x80) BasicRateBitmap |= 0x0008;	 break;
			case 12:  Rate = RATE_6;	/*if (pExtRate[i] & 0x80)*/  BasicRateBitmap |= 0x0010;  break;
			case 18:  Rate = RATE_9;	if (pExtRate[i] & 0x80) BasicRateBitmap |= 0x0020;	 break;
			case 24:  Rate = RATE_12;	/*if (pExtRate[i] & 0x80)*/  BasicRateBitmap |= 0x0040;  break;
			case 36:  Rate = RATE_18;	if (pExtRate[i] & 0x80) BasicRateBitmap |= 0x0080;	 break;
			case 48:  Rate = RATE_24;	/*if (pExtRate[i] & 0x80)*/  BasicRateBitmap |= 0x0100;  break;
			case 72:  Rate = RATE_36;	if (pExtRate[i] & 0x80) BasicRateBitmap |= 0x0200;	 break;
			case 96:  Rate = RATE_48;	if (pExtRate[i] & 0x80) BasicRateBitmap |= 0x0400;	 break;
			case 108: Rate = RATE_54;	if (pExtRate[i] & 0x80) BasicRateBitmap |= 0x0800;	 break;
			default:  Rate = RATE_1;	break;
		}
		if (MaxSupport < Rate)	MaxSupport = Rate;

		if (MinSupport > Rate) MinSupport = Rate;		
	}
	RTUSBWriteMACRegister(pAd, LEGACY_BASIC_RATE, BasicRateBitmap);
	pAd->CommonCfg.BasicRateBitmap = BasicRateBitmap;

	// calculate the exptected ACK rate for each TX rate. This info is used to caculate
	// the DURATION field of outgoing uniicast DATA/MGMT frame
	for (i=0; i<MAX_LEN_OF_SUPPORTED_RATES; i++)
	{
		if (BasicRateBitmap & (0x01 << i))
			CurrBasicRate = (UCHAR)i;
		pAd->CommonCfg.ExpectedACKRate[i] = CurrBasicRate;
		DBGPRINT(RT_DEBUG_INFO,("Exptected ACK rate[%d] = %d Mbps\n", RateIdToMbps[i], RateIdToMbps[CurrBasicRate]));
	}

	DBGPRINT(RT_DEBUG_INFO,("MlmeUpdateTxRates[MaxSupport = %d] = MaxDesire %d Mbps\n", MaxSupport, MaxDesire));
	// max tx rate = min {max desire rate, max supported rate}
	if (MaxSupport < MaxDesire)
		pAd->CommonCfg.MaxTxRate = MaxSupport;
	else
		pAd->CommonCfg.MaxTxRate = MaxDesire;

	// 2003-07-31 john - 2500 doesn't have good sensitivity at high OFDM rates. to increase the success
	// ratio of initial DHCP packet exchange, TX rate starts from a lower rate depending
	// on average RSSI
	//	 1. RSSI >= -70db, start at 54 Mbps (short distance)
	//	 2. -70 > RSSI >= -75, start at 24 Mbps (mid distance)
	//	 3. -75 > RSSI, start at 11 Mbps (long distance)
	pAd->CommonCfg.MinTxRate = MinSupport;

	// 2003-07-31 john - 2500 doesn't have good sensitivity at high OFDM rates. to increase the success
	// ratio of initial DHCP packet exchange, TX rate starts from a lower rate depending
	// on average RSSI
	//	 1. RSSI >= -70db, start at 54 Mbps (short distance)
	//	 2. -70 > RSSI >= -75, start at 24 Mbps (mid distance)
	//	 3. -75 > RSSI, start at 11 Mbps (long distance)
	if (OPSTATUS_TEST_FLAG(pAd, fOP_STATUS_TX_RATE_SWITCH_ENABLED)/* &&
		OPSTATUS_TEST_FLAG(pAd, fOP_STATUS_MEDIA_STATE_CONNECTED)*/)
	{
		short dbm = pAd->StaCfg.AvgRssi;
		/*if (bLinkUp == TRUE)
			pAd->CommonCfg.TxRate = RATE_24;
		else */
			pAd->CommonCfg.TxRate = pAd->CommonCfg.MaxTxRate; 

		if (dbm < -75)
			pAd->CommonCfg.TxRate = RATE_11;
		else if (dbm < -70)
			pAd->CommonCfg.TxRate = RATE_24;

		// should never exceed MaxTxRate (consider 11B-only mode)
		if (pAd->CommonCfg.TxRate > pAd->CommonCfg.MaxTxRate)
			pAd->CommonCfg.TxRate = pAd->CommonCfg.MaxTxRate; 

		pAd->CommonCfg.TxRateIndex			= 0;
		DBGPRINT(RT_DEBUG_INFO, (" MlmeUpdateTxRates (Rssi=%d, init TX rate = %d Mbps)\n", dbm, RateIdToMbps[pAd->CommonCfg.TxRate]));
	}
	else
	{
		pAd->CommonCfg.TxRate = pAd->CommonCfg.MaxTxRate;
		pAd->CommonCfg.HTPhyMode.field.MCS	= (pAd->CommonCfg.MaxTxRate > 3) ? (pAd->CommonCfg.MaxTxRate - 3) : pAd->CommonCfg.MaxTxRate;
		pAd->CommonCfg.HTPhyMode.field.MODE	= (pAd->CommonCfg.MaxTxRate > 3) ? MODE_OFDM : MODE_CCK;
		
		pAd->MacTab.Content[BSSID_WCID].HTPhyMode.field.STBC	= pAd->CommonCfg.HTPhyMode.field.STBC;
		pAd->MacTab.Content[BSSID_WCID].HTPhyMode.field.ShortGI	= pAd->CommonCfg.HTPhyMode.field.ShortGI;
		pAd->MacTab.Content[BSSID_WCID].HTPhyMode.field.MCS		= pAd->CommonCfg.HTPhyMode.field.MCS;
		pAd->MacTab.Content[BSSID_WCID].HTPhyMode.field.MODE	= pAd->CommonCfg.HTPhyMode.field.MODE;
	}

	if (pAd->CommonCfg.TxRate <= RATE_11)
	{
		pAd->CommonCfg.MaxHTPhyMode.field.MODE = MODE_CCK;
		pAd->CommonCfg.MaxHTPhyMode.field.MCS = pAd->CommonCfg.TxRate;
		pAd->CommonCfg.MinHTPhyMode.field.MCS = pAd->CommonCfg.MinTxRate;
	}
	else
	{
		pAd->CommonCfg.MaxHTPhyMode.field.MODE = MODE_OFDM;
		pAd->CommonCfg.MaxHTPhyMode.field.MCS = OfdmRateToRxwiMCS[pAd->CommonCfg.TxRate];
		
		if (pAd->CommonCfg.MinTxRate >= RATE_6 && (pAd->CommonCfg.MinTxRate <= RATE_54))
			{pAd->CommonCfg.MinHTPhyMode.field.MCS = OfdmRateToRxwiMCS[pAd->CommonCfg.MinTxRate];}
		else
			{pAd->CommonCfg.MinHTPhyMode.field.MCS = pAd->CommonCfg.MinTxRate;}
	}

	pAd->CommonCfg.HTPhyMode.word = (pAd->CommonCfg.MaxHTPhyMode.word);
	if (bLinkUp && (pAd->OpMode == OPMODE_STA))
	{
		pAd->MacTab.Content[BSSID_WCID].HTPhyMode.word = pAd->CommonCfg.HTPhyMode.word;
		pAd->MacTab.Content[BSSID_WCID].MaxHTPhyMode.word = pAd->CommonCfg.MaxHTPhyMode.word;
		pAd->MacTab.Content[BSSID_WCID].MinHTPhyMode.word = pAd->CommonCfg.MinHTPhyMode.word;
	}
	else
	{
		switch (pAd->CommonCfg.PhyMode) 
		{
			case PHY_11BG_MIXED:
			case PHY_11B:
			case PHY_11BGN_MIXED:
				pAd->CommonCfg.MlmeRate = RATE_1;
				pAd->CommonCfg.MlmeTransmit.field.MODE = MODE_CCK;
				pAd->CommonCfg.MlmeTransmit.field.MCS = RATE_1;
				
#ifdef	WIFI_TEST			
				pAd->CommonCfg.RtsRate = RATE_11;
#else
				pAd->CommonCfg.RtsRate = RATE_11;
#endif
				break;
			case PHY_11AGN_MIXED:
			case PHY_11GN_MIXED:
			case PHY_11N:
			case PHY_11G:
			case PHY_11A:
			case PHY_11AN_MIXED:
				pAd->CommonCfg.MlmeRate = RATE_6;
				pAd->CommonCfg.RtsRate = RATE_6;
				pAd->CommonCfg.MlmeTransmit.field.MODE = MODE_OFDM;
				pAd->CommonCfg.MlmeTransmit.field.MCS = OfdmRateToRxwiMCS[pAd->CommonCfg.MlmeRate];
				break;
			case PHY_11ABG_MIXED:
			case PHY_11ABGN_MIXED:
				if (pAd->CommonCfg.Channel <= 14)
				{
					pAd->CommonCfg.MlmeRate = RATE_1;
					pAd->CommonCfg.RtsRate = RATE_11;
					pAd->CommonCfg.MlmeTransmit.field.MODE = MODE_CCK;
					pAd->CommonCfg.MlmeTransmit.field.MCS = RATE_1;
				}
				else
				{
					pAd->CommonCfg.MlmeRate = RATE_6;
					pAd->CommonCfg.RtsRate = RATE_6;
					pAd->CommonCfg.MlmeTransmit.field.MODE = MODE_OFDM;
					pAd->CommonCfg.MlmeTransmit.field.MCS = OfdmRateToRxwiMCS[pAd->CommonCfg.MlmeRate];
				}
				break;
			default: // error
				pAd->CommonCfg.MlmeRate = RATE_6;
				pAd->CommonCfg.MlmeTransmit.field.MODE = MODE_OFDM;
				pAd->CommonCfg.MlmeTransmit.field.MCS = OfdmRateToRxwiMCS[pAd->CommonCfg.MlmeRate];
				pAd->CommonCfg.RtsRate = RATE_11;
				break;
		}
		//
		// Keep Basic Mlme Rate.
		//
		pAd->MacTab.Content[MCAST_WCID].HTPhyMode.word = pAd->CommonCfg.MlmeTransmit.word;
		if (pAd->CommonCfg.MlmeTransmit.field.MODE == MODE_OFDM)
			pAd->MacTab.Content[MCAST_WCID].HTPhyMode.field.MCS = OfdmRateToRxwiMCS[RATE_24];
		else
			pAd->MacTab.Content[MCAST_WCID].HTPhyMode.field.MCS = RATE_1;
		pAd->CommonCfg.BasicMlmeRate = pAd->CommonCfg.MlmeRate;
	}

	DBGPRINT(RT_DEBUG_TRACE, (" MlmeUpdateTxRates (MaxDesire=%d, MaxSupport=%d, MaxTxRate=%d, MinRate=%d, Rate Switching =%d)\n", 
			 RateIdToMbps[MaxDesire], RateIdToMbps[MaxSupport], RateIdToMbps[pAd->CommonCfg.MaxTxRate], RateIdToMbps[pAd->CommonCfg.MinTxRate], 
			 OPSTATUS_TEST_FLAG(pAd, fOP_STATUS_TX_RATE_SWITCH_ENABLED)));
	DBGPRINT(RT_DEBUG_TRACE, (" MlmeUpdateTxRates (TxRate=%d, RtsRate=%d, BasicRateBitmap=0x%04lx)\n", 
			 RateIdToMbps[pAd->CommonCfg.TxRate], RateIdToMbps[pAd->CommonCfg.RtsRate], BasicRateBitmap));
	DBGPRINT(RT_DEBUG_TRACE, ("MlmeUpdateTxRates (MlmeTransmit=0x%x, MinHTPhyMode=%x, MaxHTPhyMode=0x%x, HTPhyMode=0x%x)\n", 
			 pAd->CommonCfg.MlmeTransmit.word, pAd->MacTab.Content[BSSID_WCID].MinHTPhyMode.word ,pAd->MacTab.Content[BSSID_WCID].MaxHTPhyMode.word ,pAd->MacTab.Content[BSSID_WCID].HTPhyMode.word ));
}

/*
	==========================================================================
	Description:
		This function update HT Rate setting.
		Input Wcid value is valid for 2 case :
		1. it's used for Station in infra mode that copy AP rate to Mactable.
		2. OR Station 	in adhoc mode to copy peer's HT rate to Mactable. 

	IRQL = DISPATCH_LEVEL

	==========================================================================
 */
VOID MlmeUpdateHtTxRates(
	IN PRTMP_ADAPTER pAd,
	IN UCHAR		 Wcid)
{
	UCHAR	j, StbcMcs, bitmask;
	RT_HT_CAPABILITY *pRtHtCap;
	ULONG		BasicMCS;
	CHAR	i;
	
	DBGPRINT(RT_DEBUG_INFO,("MlmeUpdateHtTxRates===> \n"));
	
	if (ADHOC_ON(pAd) || INFRA_ON(pAd))
	{
		if (pAd->StaActive.SupportedHtPhy.bHtEnable == FALSE)
			return;
		pRtHtCap = &pAd->StaActive.SupportedHtPhy;
		StbcMcs = (UCHAR)pAd->MlmeAux.AddHtInfo.AddHtInfo3.StbcMcs;
		BasicMCS =pAd->MlmeAux.AddHtInfo.MCSSet[0]+(pAd->MlmeAux.AddHtInfo.MCSSet[1]<<8)+(StbcMcs<<16);
		if ((pAd->CommonCfg.DesiredHtPhy.TxSTBC)&&(pRtHtCap->RxSTBC))
			pAd->CommonCfg.MaxHTPhyMode.field.STBC = STBC_USE;
		else
			pAd->CommonCfg.MaxHTPhyMode.field.STBC = STBC_NONE;
	}
	else
	{
		if (pAd->CommonCfg.DesiredHtPhy.bHtEnable == FALSE)
			return;

		pRtHtCap = &pAd->CommonCfg.DesiredHtPhy;
		StbcMcs = (UCHAR)pAd->CommonCfg.AddHTInfo.AddHtInfo3.StbcMcs;
		BasicMCS = pAd->CommonCfg.AddHTInfo.MCSSet[0]+(pAd->CommonCfg.AddHTInfo.MCSSet[1]<<8)+(StbcMcs<<16);
		if ((pAd->CommonCfg.DesiredHtPhy.TxSTBC)&&(pRtHtCap->RxSTBC))
			pAd->CommonCfg.MaxHTPhyMode.field.STBC = STBC_USE;
		else
			pAd->CommonCfg.MaxHTPhyMode.field.STBC = STBC_NONE;
	}
	// Decide MAX ht rate.
	if ((pRtHtCap->GF) && (pAd->CommonCfg.DesiredHtPhy.GF))
		pAd->CommonCfg.MaxHTPhyMode.field.MODE = MODE_HTGREENFIELD;
	else
		pAd->CommonCfg.MaxHTPhyMode.field.MODE = MODE_HTMIX;
	
	if (pRtHtCap->ChannelWidth)
		pAd->CommonCfg.MaxHTPhyMode.field.BW = BW_40;
	else
		pAd->CommonCfg.MaxHTPhyMode.field.BW = BW_20;

	if (pAd->CommonCfg.MaxHTPhyMode.field.BW == BW_20)
		pAd->CommonCfg.MaxHTPhyMode.field.ShortGI = (pAd->CommonCfg.DesiredHtPhy.ShortGIfor20&pRtHtCap->ShortGIfor20);
	else
		pAd->CommonCfg.MaxHTPhyMode.field.ShortGI = (pAd->CommonCfg.DesiredHtPhy.ShortGIfor40&pRtHtCap->ShortGIfor40);

	for  (i=0;i<8;i++)		
	{
		if ((pRtHtCap->MCSSet[1]&(0x80>>i)) && (pAd->CommonCfg.DesiredHtPhy.MCSSet[1]&(0x80>>i)))
		{
			pAd->CommonCfg.MaxHTPhyMode.field.MCS = 15-i;
			break;
		}
	}
	if (i == 8)
	{
		for  (i=0;i<8;i++)		
		{
			if ((pRtHtCap->MCSSet[0]&(0x80>>i))&& (pAd->CommonCfg.DesiredHtPhy.MCSSet[0]&(0x80>>i)))
			{
				pAd->CommonCfg.MaxHTPhyMode.field.MCS = 7-i;
				break;
			}
		}
	}

	// Copy MIN ht rate.  rt2860???
	pAd->CommonCfg.MinHTPhyMode.field.BW = BW_20;
	pAd->CommonCfg.MinHTPhyMode.field.MCS = 0;
	pAd->CommonCfg.MinHTPhyMode.field.STBC = 0;
	pAd->CommonCfg.MinHTPhyMode.field.ShortGI = 0;
	//If STA assigns fixed rate. update to fixed here.
	if ( (pAd->OpMode == OPMODE_STA) && (pAd->CommonCfg.DesiredHtPhy.MCSSet[0] != 0xff))
	{
		if ((pAd->CommonCfg.DesiredHtPhy.MCSSet[4] != 0))
		{
			pAd->CommonCfg.MaxHTPhyMode.field.MCS = 32;
			pAd->CommonCfg.MinHTPhyMode.field.MCS = 32;
			DBGPRINT(RT_DEBUG_TRACE,("MlmeUpdateHtTxRates<=== Use Fixed MCS = %d\n",pAd->CommonCfg.MinHTPhyMode.field.MCS));
		}
		for (i = 15 ;i >= 0;i--)
		{	
			j = i/8;	
			bitmask = (1<<(i-(j*8)));
			if ( (pAd->CommonCfg.DesiredHtPhy.MCSSet[j]&bitmask) && (pRtHtCap->MCSSet[j]&bitmask))
			{
				pAd->CommonCfg.MaxHTPhyMode.field.MCS = i;
				pAd->CommonCfg.MinHTPhyMode.field.MCS = i;
				DBGPRINT(RT_DEBUG_INFO,("MlmeUpdateHtTxRates<=== Use Fixed MCS = %d\n", i));
				break;
			}
			if (i==0)
				break;
		}
	}
	
	// Decide ht rate
	pAd->CommonCfg.HTPhyMode.word = (pAd->CommonCfg.MaxHTPhyMode.word);

	if ((Wcid < MAX_LEN_OF_MAC_TABLE) && (INFRA_ON(pAd)))
	{     // 1. 802.11n rate, 2.Mpdudensity, 3.Amsdu size, 4. MimoPowerSave, 5. Max Rx Factor
		pAd->MacTab.Content[Wcid].HTPhyMode.word = pAd->CommonCfg.MaxHTPhyMode.word;
		pAd->MacTab.Content[Wcid].MaxHTPhyMode.word = pAd->CommonCfg.MaxHTPhyMode.word;
		pAd->MacTab.Content[Wcid].MinHTPhyMode.word = pAd->CommonCfg.MinHTPhyMode.word;
		if (pAd->MacTab.Content[Wcid].HTPhyMode.field.MCS < MCS_15)
			pAd->MacTab.Content[Wcid].HTPhyMode.field.ShortGI = GI_800;
		if ((pAd->MacTab.Content[Wcid].HTPhyMode.field.MCS > MCS_7) || (pAd->MacTab.Content[Wcid].HTPhyMode.field.MCS == 32))
			pAd->MacTab.Content[Wcid].HTPhyMode.field.STBC = STBC_NONE;
		DBGPRINT(RT_DEBUG_TRACE,("TX: HTPhyMode.word = %x    \n", pAd->MacTab.Content[Wcid].HTPhyMode.word));	
	}
	
	// use default now. rt2860
	//RTMP_IO_WRITE32(pAd, HT_BASIC_RATE, BasicMCS);
	if (pAd->CommonCfg.DesiredHtPhy.MCSSet[0] != 0xff)
		pAd->CommonCfg.bAutoTxRateSwitch = FALSE;
	else
		pAd->CommonCfg.bAutoTxRateSwitch = TRUE;

	DBGPRINT(RT_DEBUG_INFO,("MlmeUpdateHtTxRates<=== \n"));
}

VOID AsicUpdateAutoFallBackTable(
	IN	PRTMP_ADAPTER	pAd,
	IN	PUCHAR			pRateTable)
{
	UCHAR					i;
	HT_FBK_CFG0_STRUC		HtCfg0;
	HT_FBK_CFG1_STRUC		HtCfg1;
	LG_FBK_CFG0_STRUC		LgCfg0;
	LG_FBK_CFG1_STRUC		LgCfg1;
	PRTMP_TX_RATE_SWITCH	pCurrTxRate, pNextTxRate;

	// set to initial value
	HtCfg0.word = 0x65432100;
	HtCfg1.word = 0xedcba988;
	LgCfg0.word = 0xedcba988;
	LgCfg1.word = 0x00002100;

	pNextTxRate = (PRTMP_TX_RATE_SWITCH)pRateTable+1;
	for (i = 1; i < *((PUCHAR) pRateTable); i++)
	{
		pCurrTxRate = (PRTMP_TX_RATE_SWITCH)pRateTable+1+i;
		switch (pCurrTxRate->Mode)
		{
			case 0:		//CCK
				break;
			case 1:		//OFDM
				{
					switch(pCurrTxRate->CurrMCS)
					{
						case 0:
							LgCfg0.field.OFDMMCS0FBK = (pNextTxRate->Mode == MODE_OFDM) ? (pNextTxRate->CurrMCS+8): pNextTxRate->CurrMCS;
							break;
						case 1:
							LgCfg0.field.OFDMMCS1FBK = (pNextTxRate->Mode == MODE_OFDM) ? (pNextTxRate->CurrMCS+8): pNextTxRate->CurrMCS;
							break;
						case 2:
							LgCfg0.field.OFDMMCS2FBK = (pNextTxRate->Mode == MODE_OFDM) ? (pNextTxRate->CurrMCS+8): pNextTxRate->CurrMCS;
							break;
						case 3:
							LgCfg0.field.OFDMMCS3FBK = (pNextTxRate->Mode == MODE_OFDM) ? (pNextTxRate->CurrMCS+8): pNextTxRate->CurrMCS;
							break;
						case 4:
							LgCfg0.field.OFDMMCS4FBK = (pNextTxRate->Mode == MODE_OFDM) ? (pNextTxRate->CurrMCS+8): pNextTxRate->CurrMCS;
							break;
						case 5:
							LgCfg0.field.OFDMMCS5FBK = (pNextTxRate->Mode == MODE_OFDM) ? (pNextTxRate->CurrMCS+8): pNextTxRate->CurrMCS;
							break;
						case 6:
							LgCfg0.field.OFDMMCS6FBK = (pNextTxRate->Mode == MODE_OFDM) ? (pNextTxRate->CurrMCS+8): pNextTxRate->CurrMCS;
							break;
						case 7:
							LgCfg0.field.OFDMMCS7FBK = (pNextTxRate->Mode == MODE_OFDM) ? (pNextTxRate->CurrMCS+8): pNextTxRate->CurrMCS;
							break;
					}
				}
				break;
			case 2:		//HT-MIX
			case 3:		//HT-GF
				{
					if ((pNextTxRate->Mode >= MODE_HTMIX) && (pCurrTxRate->CurrMCS != pNextTxRate->CurrMCS))
					{
						switch(pCurrTxRate->CurrMCS)
						{
							case 0:
								HtCfg0.field.HTMCS0FBK = pNextTxRate->CurrMCS;
								break;
							case 1:
								HtCfg0.field.HTMCS1FBK = pNextTxRate->CurrMCS;
								break;
							case 2:
								HtCfg0.field.HTMCS2FBK = pNextTxRate->CurrMCS;
								break;
							case 3:
								HtCfg0.field.HTMCS3FBK = pNextTxRate->CurrMCS;
								break;
							case 4:
								HtCfg0.field.HTMCS4FBK = pNextTxRate->CurrMCS;
								break;
							case 5:
								HtCfg0.field.HTMCS5FBK = pNextTxRate->CurrMCS;
								break;
							case 6:
								HtCfg0.field.HTMCS6FBK = pNextTxRate->CurrMCS;
								break;
							case 7:
								HtCfg0.field.HTMCS7FBK = pNextTxRate->CurrMCS;
								break;
							case 8:
								HtCfg1.field.HTMCS8FBK = pNextTxRate->CurrMCS;
								break;
							case 9:
								HtCfg1.field.HTMCS9FBK = pNextTxRate->CurrMCS;
								break;
							case 10:
								HtCfg1.field.HTMCS10FBK = pNextTxRate->CurrMCS;
								break;
							case 11:
								HtCfg1.field.HTMCS11FBK = pNextTxRate->CurrMCS;
								break;
							case 12:
								HtCfg1.field.HTMCS12FBK = pNextTxRate->CurrMCS;
								break;
							case 13:
								HtCfg1.field.HTMCS13FBK = pNextTxRate->CurrMCS;
								break;
							case 14:
								HtCfg1.field.HTMCS14FBK = pNextTxRate->CurrMCS;
								break;
							case 15:
								HtCfg1.field.HTMCS15FBK = pNextTxRate->CurrMCS;
								break;
							default:
								DBGPRINT(RT_DEBUG_ERROR, ("AsicUpdateAutoFallBackTable: not support"));
						}
					}
				}
				break;
		}

		pNextTxRate = pCurrTxRate;
	}

	RTUSBWriteMACRegister(pAd, HT_FBK_CFG0, HtCfg0.word);
	RTUSBWriteMACRegister(pAd, HT_FBK_CFG1, HtCfg1.word);
	RTUSBWriteMACRegister(pAd, LG_FBK_CFG0, LgCfg0.word);
	RTUSBWriteMACRegister(pAd, LG_FBK_CFG1, LgCfg1.word);

	DBGPRINT(RT_DEBUG_TRACE, ("AsicUpdateAutoFallBackTable: HtCfg0=0x%x, HtCfg1=0x%x, LgCfg0=0x%x, LgCfg1=0x%x \n", HtCfg0.word, HtCfg1.word, LgCfg0.word, LgCfg1.word));
}

/*
	========================================================================

	Routine Description:
		Called when receiving my bssid beacon or beaconAtJoin to update protection mode.
		40MHz or 20MHz protection mode in HT 40/20 capabale BSS.
		As STA, this obeys the operation mode in ADDHT IE.
		As AP, update protection when setting ADDHT IE.
		
		Operation mode meaning:
		== 0x10: Transmission in 40M is protected.
		== 0x11: Transmission in both 40M and 20M shall be protected

	========================================================================
*/
VOID 	AsicUpdateProtect(
	IN		PRTMP_ADAPTER	pAd,
	IN 		USHORT			OperationMode,
	IN 		ULONG			SetMask,
	IN		BOOLEAN			bDisableBGProtect,
	IN		BOOLEAN			bNonGFExist)	
{
	PROT_CFG_STRUC ProtCfg, ProtCfg4;
	UINT32		Protect[6];
	PCMDHandler_TLV pTLV = (PCMDHandler_TLV)&Protect[0];

	RTMPZeroMemory(Protect, sizeof(Protect));

	ProtCfg4.word = 0;
	ProtCfg.word = 0;
	ProtCfg.field.TxopAllowGF40 = 1;
	ProtCfg.field.TxopAllowGF20 = 1;
	ProtCfg.field.TxopAllowMM40 = 1;
	ProtCfg.field.TxopAllowMM20 = 1;
	ProtCfg.field.TxopAllowOfdm = 1;
	ProtCfg.field.TxopAllowCck = 1;
	ProtCfg.field.RTSThEn = 1;
	ProtCfg.field.ProtectNav = ASIC_SHORTNAV;

	// Handle legacy(B/G) protection
	if (bDisableBGProtect)
	{
		ProtCfg.field.ProtectRate = pAd->CommonCfg.RtsRate;
		ProtCfg.field.ProtectCtrl = 0;
		Protect[1] = ProtCfg.word;		
		Protect[2] = ProtCfg.word;		
	}
	else
	{
		ProtCfg.field.ProtectRate = pAd->CommonCfg.RtsRate;
		ProtCfg.field.ProtectCtrl = 0;			// CCK do not need to be protected
		Protect[1] = ProtCfg.word;
		ProtCfg.field.ProtectCtrl = ASIC_CTS;	// OFDM needs using CCK to protect
		Protect[2] = ProtCfg.word;
	}

	pTLV->Offset = CCK_PROT_CFG;
	pTLV->Length = 8;
	RTUSBEnqueueInternalCmd(pAd, RT_OID_MULTI_WRITE_MAC,  &Protect[0], 12);

	// Decide HT frame protection.
	if ((SetMask & ALLN_SETPROTECT) != 0)
	{
		pAd->CommonCfg.BACapability.field.RxBAWinLimit = pAd->CommonCfg.REGBACapability.field.RxBAWinLimit;
		switch(OperationMode)
		{
			case HT_NO_PROTECT:
				// NO PROTECT 
				// 1.All STAs in the BSS are 20/40 MHz HT
				// 2. in ai 20/40MHz BSS
				// 3. all STAs are 20MHz in a 20MHz BSS
				// Pure HT. no protection.
				Protect[2] = 0x1744004;
				Protect[3] = 0x3f44084;
				Protect[4] = 0x1744004;
				Protect[5] = 0x3f44084;
				if (bNonGFExist)
				{
					Protect[4] = 0x1754004;
					Protect[5] = 0x3f54084;
				}

				pAd->CommonCfg.IOTestParm.bRTSLongProtOn = FALSE;
				break;

			case HT_LEGACY_PROTECT:
				// This is "HT non-member protection mode."
				// If there may be non-HT STAs my BSS
				ProtCfg.word = 0x1744004;	//duplicaet legacy 24M. BW set 1.
				ProtCfg4.word = 0x3f44084;
				if (OPSTATUS_TEST_FLAG(pAd, fOP_STATUS_BG_PROTECTION_INUSED))
				{
					ProtCfg.word = 0x1740003;	//ERP use Protection bit is set, use protection rate at Clause 18..
					ProtCfg4.word = 0x3f40003;
				}
				//Assign Protection method for 20&40 MHz packets
				ProtCfg.field.ProtectCtrl = ASIC_RTS;
				ProtCfg.field.ProtectNav = ASIC_SHORTNAV;
				ProtCfg4.field.ProtectCtrl = ASIC_RTS;
				ProtCfg4.field.ProtectNav = ASIC_SHORTNAV;
				Protect[2] = ProtCfg.word;
				Protect[3] = ProtCfg4.word;
				Protect[4] = ProtCfg.word;
				Protect[5] = ProtCfg4.word;
				pAd->CommonCfg.IOTestParm.bRTSLongProtOn = TRUE;

				break;
			case HT_40_PROTECT:
				// If only HT STAs are in BSS. at least one is 20MHz. Only protect 40MHz packets
				ProtCfg.word = 0x1744004;	//duplicaet legacy 24M. BW set 1.
				ProtCfg4.word = 0x3f44084;
				//Assign Protection method for 40MHz packets
				ProtCfg4.field.ProtectCtrl = ASIC_RTS;
				ProtCfg4.field.ProtectNav = ASIC_SHORTNAV;
				Protect[2] = ProtCfg.word;
				Protect[3] = ProtCfg4.word;
				Protect[4] = ProtCfg.word;
				Protect[5] = ProtCfg4.word;
				pAd->CommonCfg.IOTestParm.bRTSLongProtOn = FALSE;
				break;
			case HT_2040_PROTECT:
				// HT mixed mode.	 PROTECT ALL!
				//Assign Rate
				ProtCfg.word = 0x1744004;	//duplicaet legacy 24M. BW set 1.
				ProtCfg4.word = 0x3f44084;
				// both 20MHz and 40MHz are protected. Whether use RTS or CTS-to-self depends on the
				if (OPSTATUS_TEST_FLAG(pAd, fOP_STATUS_BG_PROTECTION_INUSED))
				{
					ProtCfg.word = 0x1740003;	//ERP use Protection bit is set, use protection rate at Clause 18..
					ProtCfg4.word = 0x3f40003;
				}
				//Assign Protection method for 20&40 MHz packets
				ProtCfg.field.ProtectCtrl = ASIC_RTS;
				ProtCfg.field.ProtectNav = ASIC_SHORTNAV;
				ProtCfg4.field.ProtectCtrl = ASIC_RTS;
				ProtCfg4.field.ProtectNav = ASIC_SHORTNAV;
				Protect[2] = ProtCfg.word;
				Protect[3] = ProtCfg4.word;
				Protect[4] = ProtCfg.word;
				Protect[5] = ProtCfg4.word;
				pAd->CommonCfg.IOTestParm.bRTSLongProtOn = TRUE;
				break;		
			case HT_ATHEROS:
				// Special on for Atheros problem n chip.
				Protect[2] = 0x1754004;
				Protect[3] = 0x3f54084;
				Protect[4] = 0x1754004;
				Protect[5] = 0x3f54084;
				pAd->CommonCfg.IOTestParm.bRTSLongProtOn = TRUE;
				DBGPRINT(RT_DEBUG_TRACE, ("AsicUpdateProtect===>OperationMode = %d. \n", OperationMode));
				break;
		}
		pTLV = (PCMDHandler_TLV)&Protect[1];
		pTLV->Offset = MM20_PROT_CFG;
		pTLV->Length = 16;
		RTUSBEnqueueInternalCmd(pAd, RT_OID_MULTI_WRITE_MAC,  &Protect[1], 20);	
	}
}
// IRQL = DISPATCH_LEVEL
VOID MlmeRadioOff(
	IN PRTMP_ADAPTER pAd)
{
	WPDMA_GLO_CFG_STRUC	GloCfg;
	UINT32				Value, i;
	
	DBGPRINT(RT_DEBUG_TRACE,("MlmeRadioOff()\n"));

	// Set Radio off flag
	RTMP_SET_FLAG(pAd, fRTMP_ADAPTER_RADIO_OFF);

	// Link down first if any association exists
	if (INFRA_ON(pAd) || ADHOC_ON(pAd))
		LinkDown(pAd, FALSE);
	
	RTMPusecDelay(10000);

	// Set LED
	RTMPSetLED(pAd, LED_RADIO_OFF);

	//==========================================
	// Clean up old bss table
	BssTableInit(&pAd->ScanTab);

	// Disable Tx/Rx DMA
	RTUSBReadMACRegister(pAd, WPDMA_GLO_CFG, &GloCfg.word);	   // disable DMA 
	GloCfg.field.EnableTxDMA = 0;
	GloCfg.field.EnableRxDMA = 0;
	RTUSBWriteMACRegister(pAd, WPDMA_GLO_CFG, GloCfg.word);	   // abort all TX rings

	// Waiting for DMA idle
	i = 0;
	do
	{
		RTUSBReadMACRegister(pAd, WPDMA_GLO_CFG, &GloCfg.word);
		if ((GloCfg.field.TxDMABusy == 0) && (GloCfg.field.RxDMABusy == 0))
			break;
		
		RTMPusecDelay(1000);
	}while (i++ < 100);

	// Disable MAC Tx/Rx
	RTUSBReadMACRegister(pAd, MAC_SYS_CTRL, &Value);
	Value &= (0xfffffff3);
	RTUSBWriteMACRegister(pAd, MAC_SYS_CTRL, Value);

	AsicSendCommandToMcu(pAd, 0x30, 0xff, 0xff, 0x02);

//	RTUSBWriteMACRegister(pAd, PWR_PIN_CFG, 0x0C);		  // Turn off BBP, RF

//	RTUSBWriteMACRegister(pAd, WPDMA_RST_IDX, 0x01003f);		  // reset DMA

}

// IRQL = DISPATCH_LEVEL
VOID MlmeRadioOn(
	IN PRTMP_ADAPTER pAd)
{		
	DBGPRINT(RT_DEBUG_TRACE,("MlmeRadioOn()\n"));

//	RTMP_IO_WRITE32(pAd, PWR_PIN_CFG, 0x03);		  // Turn on BBP, RF
	AsicSendCommandToMcu(pAd, 0x31, 0xff, 0x00, 0x02);
	RTMPusecDelay(10000);
	NICResetFromError(pAd);

	// Enable Tx/Rx
	RTMPEnableRxTx(pAd);
	
	// Clear Radio off flag
	RTMP_CLEAR_FLAG(pAd, fRTMP_ADAPTER_RADIO_OFF);
	RTUSBBulkReceive(pAd);

	// Set LED
	RTMPSetLED(pAd, LED_RADIO_ON);
}


// ===========================================================================================
// bss_table.c
// ===========================================================================================


/*! \brief initialize BSS table
 *  \param p_tab pointer to the table
 *  \return none
 *  \pre
 *  \post

 IRQL = PASSIVE_LEVEL
 IRQL = DISPATCH_LEVEL
  
 */
VOID BssTableInit(
	IN BSS_TABLE *Tab) 
{
	int i;

	Tab->BssNr = 0;
	for (i = 0; i < MAX_LEN_OF_BSS_TABLE; i++) 
	{
		NdisZeroMemory(&Tab->BssEntry[i], sizeof(BSS_ENTRY));
	}
}

VOID BATableInit(
    IN BA_TABLE *Tab) 
{
	int i;

	Tab->numAsOriginator = 0;
	Tab->numAsRecipient = 0;
	for (i = 0; i < MAX_LEN_OF_BA_REC_TABLE; i++) 
	{
		Tab->BARecEntry[i].REC_BA_Status = Recipient_NONE;
	}
	for (i = 0; i < MAX_LEN_OF_BA_ORI_TABLE; i++) 
	{
		Tab->BAOriEntry[i].ORI_BA_Status = Originator_NONE;
	}
}
/*! \brief search the BSS table by SSID
 *  \param p_tab pointer to the bss table
 *  \param ssid SSID string 
 *  \return index of the table, BSS_NOT_FOUND if not in the table
 *  \pre
 *  \post
 *  \note search by sequential search

 IRQL = DISPATCH_LEVEL
 
 */
ULONG BssTableSearch(
	IN BSS_TABLE *Tab, 
	IN PUCHAR    pBssid,
	IN UCHAR     Channel) 
{
	UCHAR i;

	for (i = 0; i < Tab->BssNr; i++) 
	{
		//
		// Some AP that support A/B/G mode that may used the same BSSID on 11A and 11B/G.
		// We should distinguish this case.
		//    	
		if ((((Tab->BssEntry[i].Channel <= 14) && (Channel <= 14)) ||
			 ((Tab->BssEntry[i].Channel > 14) && (Channel > 14))) &&
			MAC_ADDR_EQUAL(Tab->BssEntry[i].Bssid, pBssid)) 
		{ 
			return i;
		}
	}
	return (ULONG)BSS_NOT_FOUND;
}

ULONG BssSsidTableSearch(
	IN BSS_TABLE *Tab, 
	IN PUCHAR    pBssid,
	IN PUCHAR    pSsid,
	IN UCHAR     SsidLen,
	IN UCHAR     Channel) 
{
	UCHAR i;

	for (i = 0; i < Tab->BssNr; i++) 
	{
		//
		// Some AP that support A/B/G mode that may used the same BSSID on 11A and 11B/G.
		// We should distinguish this case.
		//
		if ((((Tab->BssEntry[i].Channel <= 14) && (Channel <= 14)) ||
			 ((Tab->BssEntry[i].Channel > 14) && (Channel > 14))) &&
			MAC_ADDR_EQUAL(Tab->BssEntry[i].Bssid, pBssid) &&
			SSID_EQUAL(pSsid, SsidLen, Tab->BssEntry[i].Ssid, Tab->BssEntry[i].SsidLen)) 
		{ 
			return i;
		}
	}
	return (ULONG)BSS_NOT_FOUND;
}

ULONG BssTableSearchWithSSID(
	IN BSS_TABLE *Tab, 
	IN PUCHAR    Bssid,
	IN PUCHAR    pSsid,
	IN UCHAR     SsidLen,
	IN UCHAR     Channel)
{
	UCHAR i;

	for (i = 0; i < Tab->BssNr; i++) 
	{
		if ((((Tab->BssEntry[i].Channel <= 14) && (Channel <= 14)) ||
			((Tab->BssEntry[i].Channel > 14) && (Channel > 14))) &&
			MAC_ADDR_EQUAL(&(Tab->BssEntry[i].Bssid), Bssid) &&
			(SSID_EQUAL(pSsid, SsidLen, Tab->BssEntry[i].Ssid, Tab->BssEntry[i].SsidLen) ||
			(NdisEqualMemory(pSsid, ZeroSsid, SsidLen)) || 
			(NdisEqualMemory(Tab->BssEntry[i].Ssid, ZeroSsid, Tab->BssEntry[i].SsidLen))))
		{ 
			return i;
		}
	}
	return (ULONG)BSS_NOT_FOUND;
}

// IRQL = DISPATCH_LEVEL
VOID BssTableDeleteEntry(
	IN OUT	BSS_TABLE *Tab, 
	IN		PUCHAR    pBssid,
	IN      UCHAR     Channel)
{
	UCHAR i, j;

	for (i = 0; i < Tab->BssNr; i++) 
	{
		//printf("comparing %s and %s\n", p_tab->bss[i].ssid, ssid);
		if ((Tab->BssEntry[i].Channel == Channel) && 
			(MAC_ADDR_EQUAL(Tab->BssEntry[i].Bssid, pBssid)))
		{
			for (j = i; j < Tab->BssNr - 1; j++)
			{
				NdisMoveMemory(&(Tab->BssEntry[j]), &(Tab->BssEntry[j + 1]), sizeof(BSS_ENTRY));
			}
			Tab->BssNr -= 1;
			return;
		}
	}
}

/*
	========================================================================
	Routine Description:
		Delete the Originator Entry in BAtable. Or decrease numAs Originator by 1 if needed.
		
	Arguments:
	// IRQL = DISPATCH_LEVEL
	========================================================================
*/
VOID BATableDeleteORIEntry(
	IN OUT	PRTMP_ADAPTER pAd, 
	IN		BA_ORI_ENTRY	*pBAORIEntry)
{
	unsigned long   IrqFlags;

	NdisAcquireSpinLock(&pAd->BATabLock, IrqFlags);
	if (pBAORIEntry->ORI_BA_Status != Originator_NONE)
	{
		if (pBAORIEntry->ORI_BA_Status == Originator_Done)
		{
			pAd->BATable.numAsOriginator -= 1;
			DBGPRINT(RT_DEBUG_TRACE, ("BATableDeleteORIEntry numAsOriginator= %ld\n", pAd->BATable.numAsRecipient));
			// Erase Bitmap flag.
		}
		// Not clear Sequence here.
	}
	
	pAd->MacTab.Content[pBAORIEntry->Wcid].TXBAbitmap &= (~(1<<(pBAORIEntry->TID) ));	// If STA mode,  erase flag here
	pAd->MacTab.Content[pBAORIEntry->Wcid].TXAutoBAbitmap &= (~(1<<(pBAORIEntry->TID) ));	// If STA mode,  erase flag here
	pAd->MacTab.Content[pBAORIEntry->Wcid].BAOriWcidArray[pBAORIEntry->TID] = 0;	// If STA mode,  erase flag here
	pBAORIEntry->ORI_BA_Status = Originator_NONE;
	pBAORIEntry->Token = 1;
	NdisReleaseSpinLock(&pAd->BATabLock, IrqFlags);
}

// IRQL = DISPATCH_LEVEL
VOID BATableDeleteRECEntry(
	IN OUT	PRTMP_ADAPTER pAd, 
	IN		BA_REC_ENTRY	*pBARECEntry)
{
	UCHAR i, k;
	PRTMP_REORDERBUF	pBuf;
	UCHAR	Curindidx;
//	USHORT 	offset;	
//	ULONG	MCAValue;
	unsigned long   IrqFlags, IrqFlags2;
	
	if (pBARECEntry->REC_BA_Status == Recipient_Accept)
	{
		
		NdisAcquireSpinLock(&pAd->BATabLock, IrqFlags);
		Curindidx = pBARECEntry->Curindidx;
		NdisAcquireSpinLock(&pBARECEntry->RxReRingLock, IrqFlags2);
		pBARECEntry->REC_BA_Status = Recipient_NONE;
		// 1. indicaterx all frames in reordering buffer
		for ( i = 0, k = 0; k < pBARECEntry->BAWinSize; k++)
		{
			pBuf = &pAd->LocalRxReorderBuf[pBARECEntry->RxBufIdxUsed].MAP_RXBuf[Curindidx];
			if (pBuf->IsFull)
			{
				i++;
				REPORT_ETHERNET_FRAME_TO_LLC(pAd, pBuf->Header802_3,
					(PUCHAR)((pBuf->pBuffer) + pBuf->DataOffset), pBuf->Datasize);
			}
			INC_RING_INDEX(Curindidx, MAX_RX_REORDERBUF);
		}
		NdisReleaseSpinLock(&pBARECEntry->RxReRingLock, IrqFlags2);
		pAd->LocalRxReorderBuf[pBARECEntry->RxBufIdxUsed].InUse = FALSE;
		pBARECEntry->RxBufIdxUsed = 0;
		//reset this BARECEn try content
		// Erase Bitmap flag.
		pBARECEntry->LastIndSeq = 0xffff;
		pBARECEntry->LastIndSeqAtTimer= 0xffff;
		pBARECEntry->BAWinSize = 0;
		// Erase Bitmap flag at software mactable
		pAd->MacTab.Content[pBARECEntry->Wcid].RXBAbitmap &= (~(1<<(pBARECEntry->TID)));
		pAd->MacTab.Content[pBARECEntry->Wcid].BARecWcidArray[pBARECEntry->TID] = 0;	// If STA mode,  erase flag here
		pAd->BATable.numAsRecipient -= 1;


		//if (KeGetCurrentIrql() != PASSIVE_LEVEL)
		{
			RT_SET_ASIC_WCID	SetAsicWcid;
			// Another adhoc joining, add to our MAC table. 
			SetAsicWcid.WCID = pBARECEntry->Wcid;
			SetAsicWcid.SetTid = (0xffffffff);
			SetAsicWcid.DeleteTid = (0x10000<<(pBARECEntry->TID) );
			RTUSBEnqueueInternalCmd(pAd, RT_CMD_SET_ASIC_WCID, &SetAsicWcid, sizeof(RT_SET_ASIC_WCID));
			DBGPRINT(RT_DEBUG_TRACE,("Aid= 0x%x.DeleteTid= 0x%lx. \n", pBARECEntry->Wcid, SetAsicWcid.DeleteTid));
		}
		/*else
		{

			offset = MAC_WCID_BASE + (pBARECEntry->Wcid) * HW_WCID_ENTRY_SIZE + 4;
			RTUSBReadMACRegister(pAd, offset, &MCAValue);
			// bitmap field starts at 0x10000 in ASIC WCID table
			MCAValue &= (~(0x10000<<(pBARECEntry->TID) ));
			RTUSBWriteMACRegister(pAd, offset, MCAValue);
		}*/
		NdisReleaseSpinLock(&pAd->BATabLock, IrqFlags);
	}
}

/*
	========================================================================
	Routine Description:
		Invoke DELBA Action frame to tear down current BA session.
	Arguments:
		PUCHAR	  pAddr,  MAC Address
		UCHAR TID,	TID <=16
				pAddr and TID together are used to find exact one BARECEntry.
		BOOLEAN ALL  
			if ALL == TRUE. Ignore TID. Delete All BARECEntries with the same pAddr. 
				Used when delete this MAC Client's association.
				if ALL == FALSE, pAddr and TID together are used to find exact one BARECEntry.
					when DELBA sent or DELBA received.
	========================================================================
*/
VOID BATableTearRECEntry(
	IN OUT	PRTMP_ADAPTER pAd, 
	IN		UCHAR TID, 
	IN		UCHAR Wcid, 
	IN		BOOLEAN ALL) 
{
	ULONG	Idx;
	BA_REC_ENTRY	*pBARECEntry;
	UCHAR	TIDStart, TIDEnd, CurTID;
	
	DBGPRINT(RT_DEBUG_TRACE,("BATableTearRECEntry===> Wcid=%d.TID=%d \n", Wcid, TID));

	if (Wcid >= MAX_LEN_OF_MAC_TABLE)
	{
		return;
	}

	//
	// 0 . If to delete all TID with the same pAddr, loop for all TID.
	//
	if (ALL == TRUE)
	{
		TIDStart = 0;
		TIDEnd = 8;
	}
	else
	{
		TIDStart = TID;
		TIDEnd = TID+1;
	}
	

	for (CurTID = TIDStart; CurTID < TIDEnd; CurTID++)
	{
		pBARECEntry = NULL;
		//
		// 2. Find corresponding BA Recipient Entry in BATable using Aid we obtained above.
		//

		// if this receiving packet is from SA that is in our OriEntry. Since WCID <9 has direct mapping. no need search.
		Idx = pAd->MacTab.Content[Wcid].BARecWcidArray[CurTID];

		pBARECEntry = &pAd->BATable.BARecEntry[Idx];
		//
		// 2.1  Always send DELBA. 
		//
		{
			if ((ALL == FALSE) || ((ALL == TRUE) && (pBARECEntry->REC_BA_Status == Recipient_Accept)))
			{
				MLME_DELBA_REQ_STRUCT	DelbaReq;	

				NdisZeroMemory(&DelbaReq, sizeof(DelbaReq));
				COPY_MAC_ADDR(DelbaReq.Addr, pAd->MacTab.Content[pBARECEntry->Wcid].Addr);
				DelbaReq.Wcid = Wcid;
				DelbaReq.TID = CurTID;
				DelbaReq.Initiator = RECIPIENT;
				MlmeEnqueue(pAd, ACTION_STATE_MACHINE, MT2_MLME_ORI_DELBA_CATE, sizeof(MLME_DELBA_REQ_STRUCT), (PVOID)&DelbaReq);
				RTUSBMlmeUp(pAd);
			}
			
			if (pBARECEntry->TID == CurTID)
				BATableDeleteRECEntry(pAd, pBARECEntry);
		}

	}
}
/*
	========================================================================
	Routine Description:
		Invoke DELBA Action frame to tear down current BA session.

	Arguments:
		PUCHAR	  pAddr,  MAC Address
		UCHAR TID,	TID <=16
				pAddr and TID together are used to find exact one BARECEntry.
		BOOLEAN ALL  
			if ALL == TRUE. Ignore TID. Delete All BAORIEntries with the same pAddr. 
				Used when delete this MAC Client's association.
				if ALL == FALSE, pAddr and TID together are used to find exact one BAORIEntry.
					when DELBA sent or DELBA received.
	========================================================================
*/
VOID BATableTearORIEntry(
	IN OUT	PRTMP_ADAPTER pAd, 
	IN		UCHAR TID, 
	IN		UCHAR Wcid, 
	IN		BOOLEAN bForceDelete, 
	IN		BOOLEAN ALL) 
{
	ULONG	Idx = 0;
	BA_ORI_ENTRY	*pBAORIEntry;
	UCHAR	TIDStart, TIDEnd, CurTID;

	DBGPRINT(RT_DEBUG_TRACE,("BATableTearORIEntry===> Wcid=%d.TID=%d, numAsOriginator= %ld \n", Wcid, TID,pAd->BATable.numAsOriginator));
	if (Wcid >= MAX_LEN_OF_MAC_TABLE)
	{
		return;
	}
	//
	// 0 . If wish to delete all TID with the same pAddr, loop for all TID.
	//
	if (ALL == TRUE)
	{
		TIDStart = 0;
		TIDEnd = 8;
	}
	else
	{
		TIDStart = TID;
		TIDEnd = TID+1;
	}
	
	for (CurTID = TIDStart; CurTID < TIDEnd; CurTID++)
	{
		//
		// 2. Locate corresponding BA Originator Entry in BA Table with the (pAddr,TID).
		//
		Idx = pAd->MacTab.Content[Wcid].BAOriWcidArray[CurTID];
		pBAORIEntry = &pAd->BATable.BAOriEntry[Idx];
		//
		// 2.1  Always send DELBA. 
		//
		{
			MLME_DELBA_REQ_STRUCT	DelbaReq;	

			if ((ALL == FALSE) || ((ALL == TRUE) && (pBAORIEntry->ORI_BA_Status == Originator_Done)))
			{
				NdisZeroMemory(&DelbaReq, sizeof(DelbaReq));
				COPY_MAC_ADDR(DelbaReq.Addr, pAd->MacTab.Content[pBAORIEntry->Wcid].Addr);
				DelbaReq.Wcid = Wcid;
				DelbaReq.TID = CurTID;
				DelbaReq.Initiator = ORIGINATOR;
				MlmeEnqueue(pAd, ACTION_STATE_MACHINE, MT2_MLME_ORI_DELBA_CATE, sizeof(MLME_DELBA_REQ_STRUCT), (PVOID)&DelbaReq);
				RTUSBMlmeUp(pAd)	
			}

			if (pBAORIEntry->TID == CurTID)
				BATableDeleteORIEntry(pAd, pBAORIEntry);
				
			if ((pAd->CommonCfg.BACapability.field.AutoBA == 1) && (bForceDelete == FALSE))
			{
				BATableInsertEntry(pAd, Wcid,  0, 0x1, CurTID, pAd->MacTab.Content[Wcid].BaSizeInUse, Originator_SetAutoAdd,  FALSE);
				pAd->MacTab.Content[Wcid].TXAutoBAbitmap |= ((1<<(pBAORIEntry->TID) ));	// If STA mode,  erase flag here
			}
		}
	}
}

/*! \brief
 *  \param 
 *  \return
 *  \pre
 *  \post
	 
 IRQL = DISPATCH_LEVEL
 
 */
VOID BssEntrySet(
	IN	PRTMP_ADAPTER	pAd, 
	OUT BSS_ENTRY *pBss, 
	IN PUCHAR pBssid, 
	IN CHAR Ssid[], 
	IN UCHAR SsidLen, 
	IN UCHAR BssType, 
	IN USHORT BeaconPeriod, 
	IN PCF_PARM pCfParm, 
	IN USHORT AtimWin, 
	IN USHORT CapabilityInfo, 
	IN UCHAR SupRate[], 
	IN UCHAR SupRateLen,
	IN UCHAR ExtRate[], 
	IN UCHAR ExtRateLen,
	IN HT_CAPABILITY_IE *pHtCapability,
	IN ADD_HT_INFO_IE *pAddHtInfo,	// AP might use this additional ht info IE 
	IN UCHAR			HtCapabilityLen,
	IN UCHAR			AddHtInfoLen,
	IN UCHAR			NewExtChanOffset,
	IN UCHAR Channel,
	IN CHAR Rssi,
	IN LARGE_INTEGER TimeStamp,
	IN UCHAR CkipFlag,
	IN PEDCA_PARM pEdcaParm,
	IN PQOS_CAPABILITY_PARM pQosCapability,
	IN PQBSS_LOAD_PARM pQbssLoad,
	IN UCHAR LengthVIE,	
	IN PNDIS_802_11_VARIABLE_IEs pVIE,
	IN BOOLEAN bUpdateRssi) 
{
	COPY_MAC_ADDR(pBss->Bssid, pBssid);
	// Default Hidden SSID to be TRUE, it will be turned to FALSE after coping SSID
	pBss->Hidden = 1;	
	if (SsidLen > 0)
	{
		// For hidden SSID AP, it might send beacon with SSID len equal to 0
		// Or send beacon /probe response with SSID len matching real SSID length,
		// but SSID is all zero. such as "00-00-00-00" with length 4.
		// We have to prevent this case overwrite correct table
		if (NdisEqualMemory(Ssid, ZeroSsid, SsidLen) == 0)
		{
			NdisMoveMemory(pBss->Ssid, Ssid, SsidLen);
			pBss->SsidLen = SsidLen;
			pBss->Hidden = 0;
		}
	}
	pBss->BssType = BssType;
	pBss->BeaconPeriod = BeaconPeriod;
	if (BssType == BSS_INFRA) 
	{
		if (pCfParm->bValid) 
		{
			pBss->CfpCount = pCfParm->CfpCount;
			pBss->CfpPeriod = pCfParm->CfpPeriod;
			pBss->CfpMaxDuration = pCfParm->CfpMaxDuration;
			pBss->CfpDurRemaining = pCfParm->CfpDurRemaining;
		}
	} 
	else 
	{
		pBss->AtimWin = AtimWin;
	}

	pBss->CapabilityInfo = CapabilityInfo;
	// The privacy bit indicate security is ON, it maight be WEP, TKIP or AES
	// Combine with AuthMode, they will decide the connection methods.
	pBss->Privacy = CAP_IS_PRIVACY_ON(pBss->CapabilityInfo);
	NdisMoveMemory(pBss->SupRate, SupRate, (SupRateLen>MAX_LEN_OF_SUPPORTED_RATES)?MAX_LEN_OF_SUPPORTED_RATES:SupRateLen);
	pBss->SupRateLen = SupRateLen;
	NdisMoveMemory(pBss->ExtRate, ExtRate, (ExtRateLen>MAX_LEN_OF_SUPPORTED_RATES)?MAX_LEN_OF_SUPPORTED_RATES:ExtRateLen);
	NdisMoveMemory(&pBss->HtCapability, pHtCapability, HtCapabilityLen);
	NdisMoveMemory(&pBss->AddHtInfo, pAddHtInfo, AddHtInfoLen);
	pBss->NewExtChanOffset = NewExtChanOffset;
	pBss->ExtRateLen = ExtRateLen;
	pBss->Channel = Channel;
	pBss->CentralChannel = Channel;

	if (bUpdateRssi == TRUE)
	{
		pBss->Rssi = Rssi;
	}
	
	// Update CkipFlag. if not exists, the value is 0x0
	pBss->CkipFlag = CkipFlag;

	// New for microsoft Fixed IEs
	NdisMoveMemory(pBss->FixIEs.Timestamp, &TimeStamp, 8);
	pBss->FixIEs.BeaconInterval = BeaconPeriod;
	pBss->FixIEs.Capabilities = CapabilityInfo;

	// New for microsoft Variable IEs
	if (LengthVIE != 0)
	{
		pBss->VarIELen = LengthVIE;
		NdisMoveMemory(pBss->VarIEs, pVIE, pBss->VarIELen);
	}
	else
	{
		pBss->VarIELen = 0;
	}

	if (HtCapabilityLen> 0)
	{
		pBss->HtCapabilityLen = HtCapabilityLen;
		NdisMoveMemory(&pBss->HtCapability, pHtCapability, HtCapabilityLen);
 		if (AddHtInfoLen > 0)
 		{
 			pBss->AddHtInfoLen = AddHtInfoLen;
 			NdisMoveMemory(&pBss->AddHtInfo, pAddHtInfo, AddHtInfoLen);
 			
 			if ((pAddHtInfo->ControlChan > 2)&& (pAddHtInfo->AddHtInfo.ExtChanOffset == EXTCHA_BELOW) && (pHtCapability->HtCapInfo.ChannelWidth == BW_40))
 			{
 				pBss->CentralChannel = pAddHtInfo->ControlChan - 2;
 			}
 			else if ((pAddHtInfo->AddHtInfo.ExtChanOffset == EXTCHA_ABOVE) && (pHtCapability->HtCapInfo.ChannelWidth == BW_40))
 			{
 				pBss->CentralChannel = pAddHtInfo->ControlChan + 2;
 			}
 		}
 		else
 			pBss->AddHtInfoLen = 0;

	}
	else
		pBss->HtCapabilityLen = 0;
	
	BssCipherParse(pBss);

	// new for QOS
	if (pEdcaParm)
		NdisMoveMemory(&pBss->EdcaParm, pEdcaParm, sizeof(EDCA_PARM));
	else
		pBss->EdcaParm.bValid = FALSE;
	if (pQosCapability)
		NdisMoveMemory(&pBss->QosCapability, pQosCapability, sizeof(QOS_CAPABILITY_PARM));
	else
		pBss->QosCapability.bValid = FALSE;
	if (pQbssLoad)
		NdisMoveMemory(&pBss->QbssLoad, pQbssLoad, sizeof(QBSS_LOAD_PARM));
	else
		pBss->QbssLoad.bValid = FALSE;
}


/*! 
 *  \brief insert an entry into the bss table
 *  \param p_tab The BSS table
 *  \param Bssid BSSID
 *  \param ssid SSID
 *  \param ssid_len Length of SSID
 *  \param bss_type
 *  \param beacon_period
 *  \param timestamp
 *  \param p_cf
 *  \param atim_win
 *  \param cap
 *  \param rates
 *  \param rates_len
 *  \param channel_idx
 *  \return none
 *  \pre
 *  \post
 *  \note If SSID is identical, the old entry will be replaced by the new one
	 
 IRQL = DISPATCH_LEVEL
 
 */
ULONG BssTableSetEntry(
	IN	PRTMP_ADAPTER	pAd, 
	OUT BSS_TABLE *Tab, 
	IN PUCHAR pBssid, 
	IN CHAR Ssid[], 
	IN UCHAR SsidLen, 
	IN UCHAR BssType, 
	IN USHORT BeaconPeriod, 
	IN CF_PARM *CfParm, 
	IN USHORT AtimWin, 
	IN USHORT CapabilityInfo, 
	IN UCHAR SupRate[],
	IN UCHAR SupRateLen,
	IN UCHAR ExtRate[],
	IN UCHAR ExtRateLen,
	IN HT_CAPABILITY_IE *pHtCapability,
	IN ADD_HT_INFO_IE *pAddHtInfo,	// AP might use this additional ht info IE 
	IN UCHAR			HtCapabilityLen,
	IN UCHAR			AddHtInfoLen,
	IN UCHAR			NewExtChanOffset,
	IN UCHAR ChannelNo,
	IN CHAR Rssi,
	IN LARGE_INTEGER TimeStamp,
	IN UCHAR CkipFlag,
	IN PEDCA_PARM pEdcaParm,
	IN PQOS_CAPABILITY_PARM pQosCapability,
	IN PQBSS_LOAD_PARM pQbssLoad,
	IN UCHAR LengthVIE,	
	IN PNDIS_802_11_VARIABLE_IEs pVIE,
	IN BOOLEAN bUpdateRssi)
{
	ULONG   Idx;

	Idx = BssTableSearchWithSSID(Tab, pBssid,  Ssid, SsidLen, ChannelNo);
	if (Idx == BSS_NOT_FOUND) 
	{
		if (Tab->BssNr >= MAX_LEN_OF_BSS_TABLE)
			return BSS_NOT_FOUND;
		Idx = Tab->BssNr;
		BssEntrySet(pAd, &Tab->BssEntry[Idx], pBssid, Ssid, SsidLen, BssType, BeaconPeriod, CfParm, AtimWin, 
					CapabilityInfo, SupRate, SupRateLen, ExtRate, ExtRateLen,pHtCapability, pAddHtInfo,HtCapabilityLen, AddHtInfoLen,
					NewExtChanOffset, ChannelNo, Rssi, TimeStamp, CkipFlag, pEdcaParm, pQosCapability, pQbssLoad, LengthVIE, pVIE, bUpdateRssi);
		Tab->BssNr++;
	} 
	else
	{
		BssEntrySet(pAd, &Tab->BssEntry[Idx], pBssid, Ssid, SsidLen, BssType, BeaconPeriod,CfParm, AtimWin, 
					CapabilityInfo, SupRate, SupRateLen, ExtRate, ExtRateLen,pHtCapability, pAddHtInfo,HtCapabilityLen, AddHtInfoLen,
					NewExtChanOffset, ChannelNo, Rssi, TimeStamp, CkipFlag, pEdcaParm, pQosCapability, pQbssLoad, LengthVIE, pVIE, bUpdateRssi);
	}

	return Idx;
}

/*
============================================================
Description:  

If insert as recipient, it means accept the ADDBA request, and start receive A-MPDU right now.

If insert as Originator, the initial state is wait_for_response, if ADDBA Rsp not receive or feedback status code is not zero,
the baentry will be deleted, otherwise, change state to originaotr_done and start send A-MPDU.

============================================================
*/
VOID BATableInsertEntry(
	IN	PRTMP_ADAPTER	pAd, 
	IN USHORT Aid, 
	IN USHORT		TimeOutValue,
	IN USHORT		StartingSeq,
	IN UCHAR TID, 
	IN UCHAR BAWinSize, 
	IN UCHAR OriginatorStatus, 
	IN BOOLEAN Recipient) 
{
	UCHAR	Idx = 0xff;
	UCHAR 	index;
	UCHAR i;
	MAC_TABLE_ENTRY *pEntry;
	USHORT 	offset;	
//	ULONG	Value;
	unsigned long   IrqFlags;
	
	if (Aid >= MAX_LEN_OF_MAC_TABLE)
		return;	
	if (pAd->CommonCfg.BACapability.field.Policy == BA_NOTUSE)
		return;	
	pEntry = &pAd->MacTab.Content[Aid];
	if (Recipient == TRUE)
	{
		BA_REC_ENTRY	*pBAEntry = NULL;
		
		DBGPRINT(RT_DEBUG_TRACE, ("BATableInsert Recipient Entry ===>Aid = %d. StartingSeq = %x\n", Aid, StartingSeq));
		// concurrent Recipient # is limited by how many reordering buffer we allocate at initialization stage.
		if (pAd->BATable.numAsRecipient >= Max_BARECI_SESSION) 
		{
			return;
		}
		
		Idx = pAd->MacTab.Content[Aid].BARecWcidArray[TID];
		if ((pAd->MacTab.Content[Aid].BARecWcidArray[TID]) == 0)
		{
			for (i = 1; i < MAX_LEN_OF_BA_REC_TABLE;i++)
			{
				pBAEntry =& pAd->BATable.BARecEntry[i];
				if (pBAEntry->REC_BA_Status == Recipient_NONE)
				{
					// find vacant entry with Zero Addr,
					Idx = i;
					pAd->MacTab.Content[Aid].BARecWcidArray[TID] = i;
					pBAEntry =&pAd->BATable.BARecEntry[Idx];
					DBGPRINT(RT_DEBUG_TRACE, ("BATableInsert[%d] ===>Wcid = %d\n", Idx, Aid));
					break;
				}
				pBAEntry = NULL;
			}
		}
		else if ((pAd->BATable.BARecEntry[Idx].REC_BA_Status == Recipient_Accept))
		{
			if ((pAd->BATable.BARecEntry[Idx].BAWinSize != BAWinSize))
			{
				// Update existing entry's parameter. Need to tear down current BA session and set BA session again.
				// shoudle we handle here? why not ask GUI to tear duplicate entry then insert.
			}
			return;
		}
		// Start fill in parameters.
		if ((pBAEntry != NULL))
		{
			NdisAcquireSpinLock(&pAd->BATabLock, IrqFlags);
			if (pBAEntry->REC_BA_Status == Recipient_NONE)
			{
				pAd->BATable.numAsRecipient++;
				// Allocate reordering buffer to this Recipient Entry.
				for (index = 0; index < Max_BARECI_SESSION; index++)
				{
					if (pAd->LocalRxReorderBuf[index].InUse == FALSE)
					{
						pAd->LocalRxReorderBuf[index].InUse = TRUE;
						pAd->LocalRxReorderBuf[index].ByBaRecIndex = Idx;
						pBAEntry->RxBufIdxUsed = index;
						break;
					}
				}
			}
			pBAEntry->Wcid = (UCHAR)Aid;
			pBAEntry->BAWinSize = (UCHAR)BAWinSize;
			pBAEntry->Curindidx = 0;
			pBAEntry->NumOfRxPkt = 0;
			pBAEntry->pAdapter = pAd;
			pBAEntry->TID = TID;
			pBAEntry->TimeOutValue = TimeOutValue;
			pBAEntry->REC_BA_Status = Recipient_Accept;
			//
			pBAEntry->LastIndSeq = StartingSeq;
			pBAEntry->LastIndSeqAtTimer= StartingSeq;
			// Set Bitmap flag.
			pAd->MacTab.Content[Aid].RXBAbitmap |= (1<<TID );	
			
			offset = MAC_WCID_BASE + Aid * HW_WCID_ENTRY_SIZE + 4;
			// Set BA session mask in WCID table.
			//if (KeGetCurrentIrql() != PASSIVE_LEVEL)
			{
				RT_SET_ASIC_WCID	SetAsicWcid;
				// Another adhoc joining, add to our MAC table. 
				SetAsicWcid.WCID = Aid;
				SetAsicWcid.SetTid = (0x10000<<TID);
				SetAsicWcid.DeleteTid = 0xffffffff;
				RTUSBEnqueueInternalCmd(pAd, RT_CMD_SET_ASIC_WCID, &SetAsicWcid, sizeof(RT_SET_ASIC_WCID));
				DBGPRINT(RT_DEBUG_TRACE,("Aid= 0x%x.SetTid= 0x%lx. \n", Aid, SetAsicWcid.SetTid));
			}
			/*else		
			{

				RTUSBReadMACRegister(pAd, offset, &Value);
				Value |= (0x10000<<TID);
				RTUSBWriteMACRegister(pAd, offset, Value);
			}*/
			DBGPRINT(RT_DEBUG_TRACE,("Recipient : pAddr =%x, %x,  %x, %x, %x, %x. assign %dth reorder buf\n", 
				pAd->MacTab.Content[Aid].Addr[0], pAd->MacTab.Content[Aid].Addr[1], pAd->MacTab.Content[Aid].Addr[2], pAd->MacTab.Content[Aid].Addr[3], pAd->MacTab.Content[Aid].Addr[4], 
				pAd->MacTab.Content[Aid].Addr[5], pBAEntry->RxBufIdxUsed));
			DBGPRINT(RT_DEBUG_TRACE,("MACEntry[%d] Seq = %x, RXBAbitmap = 0x%x. BARecWcidArray=%d\n", 
				Aid, StartingSeq, pAd->MacTab.Content[Aid].RXBAbitmap, pAd->MacTab.Content[Aid].BARecWcidArray[TID]));

			NdisReleaseSpinLock(&pAd->BATabLock, IrqFlags);
		}
	}
	else
	{
		BA_ORI_ENTRY	*pBAEntry = NULL;
		// if FULL, return
		if (pAd->BATable.numAsOriginator >= MAX_LEN_OF_BA_ORI_TABLE) 
			return;

		Idx = pAd->MacTab.Content[Aid].BAOriWcidArray[TID];
		//Since we want to insert this Entry, 
		if ((pAd->MacTab.Content[Aid].BAOriWcidArray[TID]) == 0)
		{
			for (i = 1; i < MAX_LEN_OF_BA_ORI_TABLE;i++)
			{
				pBAEntry =&pAd->BATable.BAOriEntry[i];
				if ((pBAEntry->ORI_BA_Status == Originator_NONE))
				{
					// Find an empty pair. Use this.
					Idx = i;
					//Record this index. So at Hardtransmit, only need to search MAC Etnry wcid.
					//Doesn't need to search the corresponding BA Orient entry .
					pAd->MacTab.Content[Aid].BAOriWcidArray[TID] = i;
					NdisAcquireSpinLock(&pAd->BATabLock, IrqFlags);
					pBAEntry->ORI_BA_Status = OriginatorStatus;
					pBAEntry->BAWinSize = BAWinSize;
					pBAEntry->Token = 1;	// Start from non-zero value.
					NdisReleaseSpinLock(&pAd->BATabLock, IrqFlags);
					DBGPRINT(RT_DEBUG_TRACE, ("BATableInsert ===>Aid=%d, BAIdx = %d, OriginatorStatus = %d \n", Aid, Idx, OriginatorStatus));
					break;
				}
				else if ((pBAEntry->ORI_BA_Status == Originator_SetAutoAdd) && (OriginatorStatus == Originator_WaitRes))
				{
					// Set via OID. OID has higher priority of auto add originator. :)
					// Find an empty pair. Use this.
					Idx = i;
					//Record this index. So at Hardtransmit, only need to search MAC Etnry wcid.
					//Doesn't need to search the corresponding BA Orient entry .
					pAd->MacTab.Content[Aid].BAOriWcidArray[TID] = i;
					NdisAcquireSpinLock(&pAd->BATabLock, IrqFlags);
					pBAEntry->ORI_BA_Status = OriginatorStatus;
					pBAEntry->BAWinSize = BAWinSize;
					pBAEntry->Token = 1;	// Start from non-zero value.
					NdisReleaseSpinLock(&pAd->BATabLock, IrqFlags);
					DBGPRINT(RT_DEBUG_TRACE, ("BATableInsertEntry[%d]. BAWinSize= %d\n",i, BAWinSize));
					break;
				}
				pBAEntry = NULL;
			}
		}
		else if ((pAd->BATable.BAOriEntry[Idx].ORI_BA_Status == Originator_WaitRes))
		{
			// handshake in progress. return.
			DBGPRINT(RT_DEBUG_TRACE, ("BATableInsert handshake in progress\n"));
			return;
		}
		else if ((pAd->BATable.BAOriEntry[Idx].ORI_BA_Status == Originator_Done))
		{
			if ((pAd->BATable.BAOriEntry[Idx].BAWinSize != BAWinSize))
			{
				// Update existing entry's parameter. Need to tear down current BA session and set BA session again.
				// shoudle we handle here? why not ask GUI to tear duplicate entry then insert.
			}
			DBGPRINT(RT_DEBUG_TRACE, ("BATableInsert - already exists. Aid=%d, BAIdx=%d \n", Aid, Idx));
			return;
		}

		// Fill in parameters.
		if ((pBAEntry != NULL))
		{
			NdisAcquireSpinLock(&pAd->BATabLock, IrqFlags);
			pBAEntry->Wcid = (UCHAR)Aid;
			pBAEntry->BAWinSize = (UCHAR)BAWinSize;
			pBAEntry->pAdapter = pAd;
			pBAEntry->TID = TID;
			pBAEntry->Token = 0;
			// set Status to Done immediately. 

			DBGPRINT(RT_DEBUG_TRACE,("MACEntry[%d]TXBAbitmap = 0x%x. BAOriWcidArray=%d\n", 
				Aid, pAd->MacTab.Content[Aid].TXBAbitmap, pAd->MacTab.Content[Aid].BAOriWcidArray[TID]));
			NdisReleaseSpinLock(&pAd->BATabLock, IrqFlags);
		}
	}
	DBGPRINT(RT_DEBUG_TRACE, ("<===BATableInsertEntry \n"));
	
}

// IRQL = DISPATCH_LEVEL
VOID BssTableSsidSort(
	IN	PRTMP_ADAPTER	pAd, 
	OUT BSS_TABLE *OutTab, 
	IN  CHAR Ssid[], 
	IN  UCHAR SsidLen) 
{
	INT i;
	BssTableInit(OutTab);

	for (i = 0; i < pAd->ScanTab.BssNr; i++) 
	{
		BSS_ENTRY *pInBss = &pAd->ScanTab.BssEntry[i];

		if ((pInBss->BssType == pAd->StaCfg.BssType) && 
			SSID_EQUAL(Ssid, SsidLen, pInBss->Ssid, pInBss->SsidLen))
		{
			BSS_ENTRY *pOutBss = &OutTab->BssEntry[OutTab->BssNr];

			// New for WPA2
			// Check the Authmode first
			if (pAd->CommonCfg.AuthMode >= Ndis802_11AuthModeWPA)
			{
				// Check AuthMode and AuthModeAux for matching, in case AP support dual-mode
				if ((pAd->CommonCfg.AuthMode != pInBss->AuthMode) && (pAd->CommonCfg.AuthMode != pInBss->AuthModeAux))
					// None matched
					continue;
				
				// Check cipher suite, AP must have more secured cipher than station setting
				if ((pAd->CommonCfg.AuthMode == Ndis802_11AuthModeWPA) || (pAd->CommonCfg.AuthMode == Ndis802_11AuthModeWPAPSK))
				{
					// If it's not mixed mode, we should only let BSS pass with the same encryption
					if (pInBss->WPA.bMixMode == FALSE)
						if (pAd->CommonCfg.WepStatus != pInBss->WPA.GroupCipher)
							continue;
						
					// check group cipher, accept WPA+WEP mixed mode
					if ((pAd->CommonCfg.WepStatus < pInBss->WPA.GroupCipher) && (pInBss->MixedModeGroupCipher == Cipher_Type_NONE))
						continue;

					// check pairwise cipher, skip if none matched
					// If profile set to AES, let it pass without question.
					// If profile set to TKIP, we must find one mateched
					if ((pAd->CommonCfg.WepStatus == Ndis802_11Encryption2Enabled) && 
						(pAd->CommonCfg.WepStatus != pInBss->WPA.PairCipher) && 
						(pAd->CommonCfg.WepStatus != pInBss->WPA.PairCipherAux))
						continue;						
				}
				else if ((pAd->CommonCfg.AuthMode == Ndis802_11AuthModeWPA2) || (pAd->CommonCfg.AuthMode == Ndis802_11AuthModeWPA2PSK))
				{
					// If it's not mixed mode, we should only let BSS pass with the same encryption
					if (pInBss->WPA2.bMixMode == FALSE)
						if (pAd->CommonCfg.WepStatus != pInBss->WPA2.GroupCipher)
							continue;
						
					// check group cipher
					if (pAd->CommonCfg.WepStatus < pInBss->WPA2.GroupCipher)
						continue;

					// check pairwise cipher, skip if none matched
					// If profile set to AES, let it pass without question.
					// If profile set to TKIP, we must find one mateched
					if ((pAd->CommonCfg.WepStatus == Ndis802_11Encryption2Enabled) && 
						(pAd->CommonCfg.WepStatus != pInBss->WPA2.PairCipher) && 
						(pAd->CommonCfg.WepStatus != pInBss->WPA2.PairCipherAux))
						continue;						
				}
			}			
			// Bss Type matched, SSID matched. 
			// We will check wepstatus for qualification Bss
			else if (pAd->CommonCfg.WepStatus != pInBss->WepStatus)
			{
				DBGPRINT(RT_DEBUG_TRACE,("CommonCfg.WepStatus=%d, while pInBss->WepStatus=%d\n", pAd->CommonCfg.WepStatus, pInBss->WepStatus));
				//
				// For the SESv2 case, we will not qualify WepStatus.
				//
				if ((!pInBss->bSES) && (pInBss->MixedModeGroupCipher == Cipher_Type_NONE))
					continue;
			}

			// Since the AP is using hidden SSID, and we are trying to connect to ANY
			// It definitely will fail. So, skip it.
			// CCX also require not even try to connect it!!
			if (SsidLen == 0)
				continue;
			
			// copy matching BSS from InTab to OutTab
			NdisMoveMemory(pOutBss, pInBss, sizeof(BSS_ENTRY));

			OutTab->BssNr++;
		}
		else if ((pInBss->BssType == pAd->StaCfg.BssType) && (SsidLen == 0))
		{
			BSS_ENTRY *pOutBss = &OutTab->BssEntry[OutTab->BssNr];

			// New for WPA2
			// Check the Authmode first
			if (pAd->CommonCfg.AuthMode >= Ndis802_11AuthModeWPA)
			{
				// Check AuthMode and AuthModeAux for matching, in case AP support dual-mode
				if ((pAd->CommonCfg.AuthMode != pInBss->AuthMode) && (pAd->CommonCfg.AuthMode != pInBss->AuthModeAux))
					// None matched
					continue;
				
				// Check cipher suite, AP must have more secured cipher than station setting
				if ((pAd->CommonCfg.AuthMode == Ndis802_11AuthModeWPA) || (pAd->CommonCfg.AuthMode == Ndis802_11AuthModeWPAPSK))
				{
					// If it's not mixed mode, we should only let BSS pass with the same encryption
					if (pInBss->WPA.bMixMode == FALSE)
						if (pAd->CommonCfg.WepStatus != pInBss->WPA.GroupCipher)
							continue;

					// check group cipher
					if (pAd->CommonCfg.WepStatus < pInBss->WPA.GroupCipher)
						continue;

					// check pairwise cipher, skip if none matched
					// If profile set to AES, let it pass without question.
					// If profile set to TKIP, we must find one mateched
					if ((pAd->CommonCfg.WepStatus == Ndis802_11Encryption2Enabled) && 
						(pAd->CommonCfg.WepStatus != pInBss->WPA.PairCipher) && 
						(pAd->CommonCfg.WepStatus != pInBss->WPA.PairCipherAux))
						continue;						
				}
				else if ((pAd->CommonCfg.AuthMode == Ndis802_11AuthModeWPA2) || (pAd->CommonCfg.AuthMode == Ndis802_11AuthModeWPA2PSK))
				{
					// If it's not mixed mode, we should only let BSS pass with the same encryption
					if (pInBss->WPA2.bMixMode == FALSE)
						if (pAd->CommonCfg.WepStatus != pInBss->WPA2.GroupCipher)
							continue;
						
					// check group cipher
					if (pAd->CommonCfg.WepStatus < pInBss->WPA2.GroupCipher)
						continue;

					// check pairwise cipher, skip if none matched
					// If profile set to AES, let it pass without question.
					// If profile set to TKIP, we must find one mateched
					if ((pAd->CommonCfg.WepStatus == Ndis802_11Encryption2Enabled) && 
						(pAd->CommonCfg.WepStatus != pInBss->WPA2.PairCipher) && 
						(pAd->CommonCfg.WepStatus != pInBss->WPA2.PairCipherAux))
						continue;
				}
			}
			// Bss Type matched, SSID matched. 
			// We will check wepstatus for qualification Bss
			else if (pAd->CommonCfg.WepStatus != pInBss->WepStatus)
					continue;
			
			// copy matching BSS from InTab to OutTab
			NdisMoveMemory(pOutBss, pInBss, sizeof(BSS_ENTRY));

			OutTab->BssNr++;
		}

		if (OutTab->BssNr >= MAX_LEN_OF_BSS_TABLE)
			break;
		
	}

	BssTableSortByRssi(OutTab);

	// Update group-cipher within rsn_ie
	if (OutTab->BssNr > 0)
	{
		if (pAd->CommonCfg.AuthMode == Ndis802_11AuthModeWPA2PSK)
			RTMPMakeRSNIE(pAd, OutTab->BssEntry[0].WPA2.GroupCipher);
		else if (pAd->CommonCfg.AuthMode == Ndis802_11AuthModeWPAPSK)
			RTMPMakeRSNIE(pAd, OutTab->BssEntry[0].WPA.GroupCipher);
	}

}


// IRQL = DISPATCH_LEVEL
VOID BssTableSortByRssi(
	IN OUT BSS_TABLE *OutTab) 
{
	INT       i, j;
	BSS_ENTRY TmpBss;

	for (i = 0; i < OutTab->BssNr - 1; i++) 
	{
		for (j = i+1; j < OutTab->BssNr; j++) 
		{
			if (OutTab->BssEntry[j].Rssi > OutTab->BssEntry[i].Rssi) 
			{
				NdisMoveMemory(&TmpBss, &OutTab->BssEntry[j], sizeof(BSS_ENTRY));
				NdisMoveMemory(&OutTab->BssEntry[j], &OutTab->BssEntry[i], sizeof(BSS_ENTRY));
				NdisMoveMemory(&OutTab->BssEntry[i], &TmpBss, sizeof(BSS_ENTRY));
			}
		}
	}
}

extern	UCHAR	RSN_OUI[];		// in sanity.c

VOID BssCipherParse(
	IN OUT	PBSS_ENTRY	pBss)
{
	PEID_STRUCT						pEid;
	PUCHAR							pTmp;
	PRSN_IE_HEADER_STRUCT			pRsnHeader;
	PCIPHER_SUITE_STRUCT			pCipher;
	PAKM_SUITE_STRUCT				pAKM;
	USHORT							Count;
	INT								Length;
	NDIS_802_11_ENCRYPTION_STATUS	TmpCipher;
	//
	// WepStatus will be reset later, if AP announce TKIP or AES on the beacon frame.
	//
	if (pBss->Privacy)
	{
		pBss->WepStatus     = Ndis802_11WEPEnabled;
	}
	else
	{
		pBss->WepStatus     = Ndis802_11WEPDisabled;
	}
	// Set default to disable & open authentication before parsing variable IE
	pBss->AuthMode      = Ndis802_11AuthModeOpen;
	pBss->AuthModeAux   = Ndis802_11AuthModeOpen;

	// init the MixedMode group cipher
	pBss->MixedModeGroupCipher = Cipher_Type_NONE;

	// init MixedMode on auth and enc for the purpose of ioctl query
	pBss->AuthBitMode   	= Ndis802_11AuthModeOpen;
	pBss->PairCipherBitMode = Ndis802_11WEPDisabled;
    
	// Init WPA setting
	pBss->WPA.PairCipher    = Ndis802_11WEPDisabled;
	pBss->WPA.PairCipherAux = Ndis802_11WEPDisabled;
	pBss->WPA.GroupCipher   = Ndis802_11WEPDisabled;
	pBss->WPA.RsnCapability = 0;
	pBss->WPA.bMixMode      = FALSE;

	// Init WPA2 setting
	pBss->WPA2.PairCipher    = Ndis802_11WEPDisabled;
	pBss->WPA2.PairCipherAux = Ndis802_11WEPDisabled;
	pBss->WPA2.GroupCipher   = Ndis802_11WEPDisabled;
	pBss->WPA2.RsnCapability = 0;
	pBss->WPA2.bMixMode      = FALSE;
	Length = (INT) pBss->VarIELen;

	while (Length > 0)
	{
		// Parse cipher suite base on WPA1 & WPA2, they should be parsed differently
		pTmp = ((PUCHAR) pBss->VarIEs) + pBss->VarIELen - Length;
		pEid = (PEID_STRUCT) pTmp;
		switch (pEid->Eid)
		{
			case IE_WPA:			
				//Parse Cisco IE_WPA (LEAP, CCKM, etc.)
				if ( NdisEqualMemory((pTmp+8), CISCO_OUI, 3))
				{
#ifdef CCX_SUPPORT				
					pTmp   += 11;
					switch (*pTmp)
					{
						case 1:
						case 5:	// Although WEP is not allowed in WPA related auth mode, we parse it anyway
							pBss->WepStatus = Ndis802_11Encryption1Enabled;
							pBss->WPA.PairCipher = Ndis802_11Encryption1Enabled;
							pBss->WPA.GroupCipher = Ndis802_11Encryption1Enabled;
							break;
						case 2:
							pBss->WepStatus = Ndis802_11Encryption2Enabled;
							pBss->WPA.PairCipher = Ndis802_11Encryption1Enabled;
							pBss->WPA.GroupCipher = Ndis802_11Encryption1Enabled;
							break;
						case 4:
							pBss->WepStatus = Ndis802_11Encryption3Enabled;
							pBss->WPA.PairCipher = Ndis802_11Encryption1Enabled;
							pBss->WPA.GroupCipher = Ndis802_11Encryption1Enabled;
							break;
						default:
							break;
					}

					// if Cisco IE_WPA, break
					break;
#endif					
				}
				else if (NdisEqualMemory(pEid->Octet, SES_OUI, 3) && (pEid->Len == 7))				
				{
					pBss->bSES = TRUE;
					break;
				}				
				else if (NdisEqualMemory(pEid->Octet, WPA_OUI, 4) != 1)
				{
					// if unsupported vendor specific IE
					break;
				}
				// Skip OUI, version, and multicast suite
				// This part should be improved in the future when AP supported multiple cipher suite.
				// For now, it's OK since almost all APs have fixed cipher suite supported.
				// pTmp = (PUCHAR) pEid->Octet;
				pTmp   += 11;

				// Cipher Suite Selectors from Spec P802.11i/D3.2 P26.
				//  Value      Meaning
				//  0           None 
				//  1           WEP-40
				//  2           Tkip
				//  3           WRAP
				//  4           AES
				//  5           WEP-104
				// Parse group cipher
				switch (*pTmp)
				{
					case 1:
						pBss->WPA.GroupCipher = Ndis802_11Encryption1Enabled;
						pBss->MixedModeGroupCipher = Cipher_Type_WEP40;
						break;
					case 5:
						pBss->WPA.GroupCipher = Ndis802_11Encryption1Enabled;
						pBss->MixedModeGroupCipher = Cipher_Type_WEP104;
						break;
					case 2:
						pBss->WPA.GroupCipher = Ndis802_11Encryption2Enabled;
						break;
					case 4:
						pBss->WPA.GroupCipher = Ndis802_11Encryption3Enabled;
						break;
					default:
						break;
				}
				// number of unicast suite
				pTmp   += 1;

				// skip all unicast cipher suites
				Count = *(PUSHORT) pTmp;
				pTmp   += sizeof(USHORT);

				// Parsing all unicast cipher suite
				while (Count > 0)
				{
					// Skip OUI
					pTmp += 3;
					TmpCipher = Ndis802_11WEPDisabled;
					switch (*pTmp)
					{
						case 1:
						case 5: // Although WEP is not allowed in WPA related auth mode, we parse it anyway
							TmpCipher = Ndis802_11Encryption1Enabled;
							break;
						case 2:
							TmpCipher = Ndis802_11Encryption2Enabled;
							pBss->PairCipherBitMode |= TKIPBIT;
							break;
						case 4:
							TmpCipher = Ndis802_11Encryption3Enabled;
							pBss->PairCipherBitMode |= CCMPBIT;
							break;
						default:
							break;
					}
					if (TmpCipher > pBss->WPA.PairCipher)
					{
						// Move the lower cipher suite to PairCipherAux
						pBss->WPA.PairCipherAux = pBss->WPA.PairCipher;
						pBss->WPA.PairCipher    = TmpCipher;
					}
					else
					{
						pBss->WPA.PairCipherAux = TmpCipher;
					}
					pTmp++;
					Count--;
				}

				// 4. get AKM suite counts
				Count   = *(PUSHORT) pTmp;
				pTmp   += sizeof(USHORT);
				pTmp   += 3;

				switch (*pTmp)
				{
					case 1:
						// Set AP support WPA mode
						if (pBss->AuthMode == Ndis802_11AuthModeOpen)
							pBss->AuthMode = Ndis802_11AuthModeWPA;
						else
							pBss->AuthModeAux = Ndis802_11AuthModeWPA;
						pBss->AuthBitMode |= WPA1AKMBIT;
						break;
					case 2:
						// Set AP support WPA mode
						if (pBss->AuthMode == Ndis802_11AuthModeOpen)
							pBss->AuthMode = Ndis802_11AuthModeWPAPSK;
						else
							pBss->AuthModeAux = Ndis802_11AuthModeWPAPSK;
						pBss->AuthBitMode |= WPA1PSKAKMBIT;

						break;
					default:
						break;
				}
				pTmp   += 1;

				// Fixed for WPA-None
				if (pBss->BssType == BSS_ADHOC)
				{
					pBss->AuthMode    = Ndis802_11AuthModeWPANone;
					pBss->AuthModeAux = Ndis802_11AuthModeWPANone;
					pBss->WepStatus   = pBss->WPA.GroupCipher;
					// Patched bugs for old driver
					if (pBss->WPA.PairCipherAux == Ndis802_11WEPDisabled)
						pBss->WPA.PairCipherAux = pBss->WPA.GroupCipher;
				}
				else
					pBss->WepStatus   = pBss->WPA.PairCipher;

				// Check the Pair & Group, if different, turn on mixed mode flag
				if (pBss->WPA.GroupCipher != pBss->WPA.PairCipher)
					pBss->WPA.bMixMode = TRUE;

				break;

			case IE_RSN:
				pRsnHeader = (PRSN_IE_HEADER_STRUCT) pTmp;
				
				// 0. Version must be 1
				if (pRsnHeader->Version != 1)
					break;
				pTmp   += sizeof(RSN_IE_HEADER_STRUCT);

				// 1. Check group cipher
				pCipher = (PCIPHER_SUITE_STRUCT) pTmp;
				if (!RTMPEqualMemory(pTmp, RSN_OUI, 3))
					break;

				// Parse group cipher
				switch (pCipher->Type)
				{
					case 1:
					case 5:	// Although WEP is not allowed in WPA related auth mode, we parse it anyway
						pBss->WPA2.GroupCipher = Ndis802_11Encryption1Enabled;
						break;
					case 2:
						pBss->WPA2.GroupCipher = Ndis802_11Encryption2Enabled;
						break;
					case 4:
						pBss->WPA2.GroupCipher = Ndis802_11Encryption3Enabled;
						break;
					default:
						break;
				}
				// set to correct offset for next parsing
				pTmp   += sizeof(CIPHER_SUITE_STRUCT);

				// 2. Get pairwise cipher counts
				Count = *(PUSHORT) pTmp;
				pTmp   += sizeof(USHORT);
				
				// 3. Get pairwise cipher
				// Parsing all unicast cipher suite
				while (Count > 0)
				{
					// Skip OUI
					pCipher = (PCIPHER_SUITE_STRUCT) pTmp;
					TmpCipher = Ndis802_11WEPDisabled;
					switch (pCipher->Type)
					{
						case 1:
						case 5: // Although WEP is not allowed in WPA related auth mode, we parse it anyway
							TmpCipher = Ndis802_11Encryption1Enabled;
							break;
						case 2:
							TmpCipher = Ndis802_11Encryption2Enabled;
							pBss->PairCipherBitMode |= TKIPBIT;
							break;
						case 4:
							TmpCipher = Ndis802_11Encryption3Enabled;
							pBss->PairCipherBitMode |= CCMPBIT;
							break;
						default:
							break;
					}
					if (TmpCipher > pBss->WPA2.PairCipher)
					{
						// Move the lower cipher suite to PairCipherAux
						pBss->WPA2.PairCipherAux = pBss->WPA2.PairCipher;
						pBss->WPA2.PairCipher    = TmpCipher;
					}
					else
					{
						pBss->WPA2.PairCipherAux = TmpCipher;
					}
					pTmp += sizeof(CIPHER_SUITE_STRUCT);
					Count--;
				}
				
				// 4. get AKM suite counts
				Count   = *(PUSHORT) pTmp;
				pTmp   += sizeof(USHORT);

				// 5. Get AKM ciphers
				pAKM = (PAKM_SUITE_STRUCT) pTmp;
				if (!RTMPEqualMemory(pTmp, RSN_OUI, 3))
					break;

				switch (pAKM->Type)
				{
					case 1:
						// Set AP support WPA mode
						if (pBss->AuthMode == Ndis802_11AuthModeOpen)
							pBss->AuthMode = Ndis802_11AuthModeWPA2;
						else
							pBss->AuthModeAux = Ndis802_11AuthModeWPA2;
						pBss->AuthBitMode |= WPA2AKMBIT;
						break;
					case 2:
						// Set AP support WPA mode
						if (pBss->AuthMode == Ndis802_11AuthModeOpen)
							pBss->AuthMode = Ndis802_11AuthModeWPA2PSK;
						else
							pBss->AuthModeAux = Ndis802_11AuthModeWPA2PSK;
						pBss->AuthBitMode |= WPA2PSKAKMBIT;
						break;
					default:
						break;
				}
				pTmp   += (Count * sizeof(AKM_SUITE_STRUCT));

				// Fixed for WPA-None
				if (pBss->BssType == BSS_ADHOC)
				{
					pBss->AuthMode = Ndis802_11AuthModeWPANone;
					pBss->AuthModeAux = Ndis802_11AuthModeWPANone;
					pBss->WPA.PairCipherAux = pBss->WPA2.PairCipherAux;
					pBss->WPA.GroupCipher   = pBss->WPA2.GroupCipher;
					pBss->WepStatus         = pBss->WPA.GroupCipher;
					// Patched bugs for old driver
					if (pBss->WPA.PairCipherAux == Ndis802_11WEPDisabled)
						pBss->WPA.PairCipherAux = pBss->WPA.GroupCipher;
				}
				pBss->WepStatus   = pBss->WPA2.PairCipher;

				// 6. Get RSN capability
				pBss->WPA2.RsnCapability = *(PUSHORT) pTmp;
				pTmp += sizeof(USHORT);

				// Check the Pair & Group, if different, turn on mixed mode flag
				if (pBss->WPA2.GroupCipher != pBss->WPA2.PairCipher)
					pBss->WPA2.bMixMode = TRUE;

				break;

			default:
				break;
		}
		Length -= (pEid->Len + 2);
	}
}

// ===========================================================================================
// mac_table.c
// ===========================================================================================

/*! \brief generates a random mac address value for IBSS BSSID
 *  \param Addr the bssid location
 *  \return none
 *  \pre
 *  \post
 */
VOID MacAddrRandomBssid(
	IN PRTMP_ADAPTER pAd, 
	OUT PUCHAR pAddr) 
{
	INT i;

	for (i = 0; i < MAC_ADDR_LEN; i++) 
	{
		pAddr[i] = RandomByte(pAd);
	}

	pAddr[0] = (pAddr[0] & 0xfe) | 0x02;  // the first 2 bits must be 01xxxxxxxx
}

/*! \brief init the management mac frame header
 *  \param p_hdr mac header
 *  \param subtype subtype of the frame
 *  \param p_ds destination address, don't care if it is a broadcast address
 *  \return none
 *  \pre the station has the following information in the pAd->StaCfg
 *   - bssid
 *   - station address
 *  \post
 *  \note this function initializes the following field

 IRQL = PASSIVE_LEVEL
 IRQL = DISPATCH_LEVEL
  
 */
VOID MgtMacHeaderInit(
	IN	PRTMP_ADAPTER	pAd, 
	IN OUT PHEADER_802_11 pHdr80211, 
	IN UCHAR SubType, 
	IN UCHAR ToDs, 
	IN PUCHAR pDA, 
	IN PUCHAR pBssid) 
{
	NdisZeroMemory(pHdr80211, sizeof(HEADER_802_11));
	pHdr80211->FC.Type = BTYPE_MGMT;
	pHdr80211->FC.SubType = SubType;
	pHdr80211->FC.ToDs = ToDs;
	COPY_MAC_ADDR(pHdr80211->Addr1, pDA);
	COPY_MAC_ADDR(pHdr80211->Addr2, pAd->CurrentAddress);
	COPY_MAC_ADDR(pHdr80211->Addr3, pBssid);
}

// ===========================================================================================
// mem_mgmt.c
// ===========================================================================================

/*!***************************************************************************
 * This routine build an outgoing frame, and fill all information specified 
 * in argument list to the frame body. The actual frame size is the summation 
 * of all arguments.
 * input params:
 *      Buffer - pointer to a pre-allocated memory segment
 *      args - a list of <int arg_size, arg> pairs.
 *      NOTE NOTE NOTE!!!! the last argument must be NULL, otherwise this
 *                         function will FAIL!!!
 * return:
 *      Size of the buffer
 * usage:  
 *      MakeOutgoingFrame(Buffer, output_length, 2, &fc, 2, &dur, 6, p_addr1, 6,p_addr2, END_OF_ARGS);

 IRQL = PASSIVE_LEVEL
 IRQL = DISPATCH_LEVEL
  
 ****************************************************************************/
ULONG MakeOutgoingFrame(
	OUT CHAR *Buffer, 
	OUT ULONG *FrameLen, ...) 
{
	CHAR   *p;
	int     leng;
	ULONG   TotLeng;
	va_list Args;

	// calculates the total length
	TotLeng = 0;
	va_start(Args, FrameLen);
	do 
	{
		leng = va_arg(Args, int);
		if (leng == END_OF_ARGS) 
		{
			break;
		}
		p = va_arg(Args, PVOID);
		NdisMoveMemory(&Buffer[TotLeng], p, leng);
		TotLeng = TotLeng + leng;
	} while(TRUE);

	va_end(Args); /* clean up */
	*FrameLen = TotLeng;
	return TotLeng;
}

// ===========================================================================================
// mlme_queue.c
// ===========================================================================================

/*! \brief  Initialize The MLME Queue, used by MLME Functions
 *  \param  *Queue     The MLME Queue
 *  \return Always     Return NDIS_STATE_SUCCESS in this implementation
 *  \pre
 *  \post
 *  \note   Because this is done only once (at the init stage), no need to be locked

 IRQL = PASSIVE_LEVEL
 
 */
NDIS_STATUS MlmeQueueInit(
	IN MLME_QUEUE *Queue) 
{
	INT i;

	NdisAllocateSpinLock(&Queue->Lock);

	Queue->Num  = 0;
	Queue->Head = 0;
	Queue->Tail = 0;

	for (i = 0; i < MAX_LEN_OF_MLME_QUEUE; i++) 
	{
		Queue->Entry[i].Occupied = FALSE;
		Queue->Entry[i].MsgLen = 0;
		NdisZeroMemory(Queue->Entry[i].Msg, MGMT_DMA_BUFFER_SIZE);
	}

	return NDIS_STATUS_SUCCESS;
}


/*! \brief   Enqueue a message for other threads, if they want to send messages to MLME thread
 *  \param  *Queue    The MLME Queue
 *  \param   Machine  The State Machine Id
 *  \param   MsgType  The Message Type
 *  \param   MsgLen   The Message length
 *  \param  *Msg      The message pointer
 *  \return  TRUE if enqueue is successful, FALSE if the queue is full
 *  \pre
 *  \post
 *  \note    The message has to be initialized

 IRQL = PASSIVE_LEVEL
 IRQL = DISPATCH_LEVEL
  
 */
BOOLEAN MlmeEnqueue(
	IN	PRTMP_ADAPTER	pAd,
	IN ULONG Machine, 
	IN ULONG MsgType, 
	IN ULONG MsgLen, 
	IN VOID *Msg)
{
	INT Tail;
	MLME_QUEUE	*Queue = (MLME_QUEUE *)&pAd->Mlme.Queue;
	unsigned long   IrqFlags;
	
	// Do nothing if the driver is starting halt state.
	// This might happen when timer already been fired before cancel timer with mlmehalt
	if (RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_HALT_IN_PROGRESS))
		return FALSE;

	// First check the size, it MUST not exceed the mlme queue size
	if (MsgLen > MGMT_DMA_BUFFER_SIZE)
	{
		DBGPRINT_ERR(("MlmeEnqueue: msg too large, size = %ld \n", MsgLen));
		return FALSE;
	}
	
	if (MlmeQueueFull(Queue)) 
	{
		DBGPRINT_ERR(("MlmeEnqueue: full, msg dropped and may corrupt MLME\n"));
		return FALSE;
	}

	NdisAcquireSpinLock(&(Queue->Lock), IrqFlags);
	Tail = Queue->Tail;
	Queue->Tail++;
	Queue->Num++;
	if (Queue->Tail == MAX_LEN_OF_MLME_QUEUE) 
	{
		Queue->Tail = 0;
	}

	Queue->Entry[Tail].Occupied = TRUE;
	Queue->Entry[Tail].Machine = Machine;
	Queue->Entry[Tail].MsgType = MsgType;
	Queue->Entry[Tail].MsgLen  = MsgLen;
	NdisMoveMemory(Queue->Entry[Tail].Msg, Msg, MsgLen);
	NdisReleaseSpinLock(&(Queue->Lock), IrqFlags);
	DBGPRINT(RT_DEBUG_INFO, ("MlmeEnqueue, num=%ld\n",Queue->Num));
	return TRUE;
}

/*! \brief   This function is used when Recv gets a MLME message
 *  \param  *Queue           The MLME Queue
 *  \param   TimeStampHigh   The upper 32 bit of timestamp
 *  \param   TimeStampLow    The lower 32 bit of timestamp
 *  \param   Rssi            The receiving RSSI strength
 *  \param   MsgLen          The length of the message
 *  \param  *Msg             The message pointer
 *  \return  TRUE if everything ok, FALSE otherwise (like Queue Full)
 *  \pre
 *  \post
 
 IRQL = DISPATCH_LEVEL
 
 */
BOOLEAN MlmeEnqueueForRecv(
	IN	PRTMP_ADAPTER	pAd, 
	IN ULONG Wcid, 
	IN UCHAR Rssi0, 
	IN UCHAR Rssi1, 
	IN UCHAR Rssi2, 
	IN ULONG MsgLen, 
	IN VOID *Msg,
	IN UCHAR Signal) 
{
	INT          Tail, Machine;
	PFRAME_802_11 pFrame = (PFRAME_802_11)Msg;
	UINT         MsgType;
	MLME_QUEUE	*Queue = (MLME_QUEUE *)&pAd->Mlme.Queue;
	unsigned long   IrqFlags;
	
	// Do nothing if the driver is starting halt state.
	// This might happen when timer already been fired before cancel timer with mlmehalt
	if (RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_HALT_IN_PROGRESS))
		return FALSE;

	// First check the size, it MUST not exceed the mlme queue size
	if (MsgLen > MGMT_DMA_BUFFER_SIZE)
	{
		DBGPRINT_ERR(("MlmeEnqueueForRecv: frame too large, size = %ld \n", MsgLen));
		return FALSE;
	}

	if (MlmeQueueFull(Queue)) 
	{
		DBGPRINT_ERR(("MlmeEnqueueForRecv: full and dropped\n"));
		return FALSE;
	}

	if (!MsgTypeSubst(pAd, pFrame, &Machine, &MsgType)) 
	{
		DBGPRINT_ERR(("MlmeEnqueueForRecv: un-recongnized mgmt->subtype=%d\n",pFrame->Hdr.FC.SubType));
		return FALSE;
	}

	// OK, we got all the informations, it is time to put things into queue
	NdisAcquireSpinLock(&(Queue->Lock), IrqFlags);
	Tail = Queue->Tail;
	Queue->Tail++;
	Queue->Num++;
	if (Queue->Tail == MAX_LEN_OF_MLME_QUEUE) 
	{
		Queue->Tail = 0;
	}
	DBGPRINT(RT_DEBUG_INFO, ("MlmeEnqueueForRecv, num=%ld\n",Queue->Num));

	Queue->Entry[Tail].Occupied = TRUE;
	Queue->Entry[Tail].Machine = Machine;
	Queue->Entry[Tail].MsgType = MsgType;
	Queue->Entry[Tail].MsgLen  = MsgLen;
	Queue->Entry[Tail].Rssi = Rssi0;
	Queue->Entry[Tail].Rssi2 = Rssi1;
	Queue->Entry[Tail].Rssi3 = Rssi2;
	Queue->Entry[Tail].Signal = Signal;
	Queue->Entry[Tail].Channel = pAd->LatchRfRegs.Channel;
	Queue->Entry[Tail].Wcid = (UCHAR)Wcid;
	NdisMoveMemory(Queue->Entry[Tail].Msg, Msg, MsgLen);

	NdisReleaseSpinLock(&(Queue->Lock), IrqFlags);

	RTUSBMlmeUp(pAd);	

	return TRUE;
}

/*! \brief   Dequeue a message from the MLME Queue
 *  \param  *Queue    The MLME Queue
 *  \param  *Elem     The message dequeued from MLME Queue
 *  \return  TRUE if the Elem contains something, FALSE otherwise
 *  \pre
 *  \post

 IRQL = DISPATCH_LEVEL

 */
BOOLEAN MlmeDequeue(
	IN MLME_QUEUE *Queue, 
	OUT MLME_QUEUE_ELEM **Elem) 
{
	unsigned long   IrqFlags;
	
	NdisAcquireSpinLock(&(Queue->Lock), IrqFlags);
	*Elem = &(Queue->Entry[Queue->Head]);
	Queue->Num--;
	Queue->Head++;
	if (Queue->Head == MAX_LEN_OF_MLME_QUEUE) 
	{
		Queue->Head = 0;
	}
	NdisReleaseSpinLock(&(Queue->Lock), IrqFlags);
	DBGPRINT(RT_DEBUG_INFO, ("MlmeDequeue, num=%ld\n",Queue->Num));

	return TRUE;
}

// IRQL = DISPATCH_LEVEL
VOID	MlmeRestartStateMachine(
	IN	PRTMP_ADAPTER	pAd)
{
	BOOLEAN				Cancelled;

	DBGPRINT(RT_DEBUG_TRACE, ("==> MlmeRestartStateMachine\n"));

	RTMP_SET_FLAG(pAd, fRTMP_ADAPTER_MLME_RESET_IN_PROGRESS);

	// Cancel all timer events
	// Be careful to cancel new added timer
	RTMPCancelTimer(&pAd->MlmeAux.AssocTimer,     &Cancelled);
	RTMPCancelTimer(&pAd->MlmeAux.ReassocTimer,   &Cancelled);
	RTMPCancelTimer(&pAd->MlmeAux.DisassocTimer,  &Cancelled);
	RTMPCancelTimer(&pAd->MlmeAux.AuthTimer,       &Cancelled);
	RTMPCancelTimer(&pAd->MlmeAux.BeaconTimer,     &Cancelled);
	RTMPCancelTimer(&pAd->MlmeAux.ScanTimer,       &Cancelled);

	// Set all state machines back IDLE
	pAd->Mlme.CntlMachine.CurrState    = CNTL_IDLE;
	pAd->Mlme.AssocMachine.CurrState   = ASSOC_IDLE;
	pAd->Mlme.AuthMachine.CurrState    = AUTH_REQ_IDLE;
	pAd->Mlme.AuthRspMachine.CurrState = AUTH_RSP_IDLE;
	pAd->Mlme.SyncMachine.CurrState    = SYNC_IDLE;
	pAd->Mlme.ActMachine.CurrState    = ACT_IDLE;
	if (RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_BSS_JOIN_IN_PROGRESS))
		RTMP_CLEAR_FLAG(pAd, fRTMP_ADAPTER_BSS_JOIN_IN_PROGRESS);//steven:for test
	if (RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_REASSOC_IN_PROGRESS))
		RTMP_CLEAR_FLAG(pAd, fRTMP_ADAPTER_REASSOC_IN_PROGRESS);//steven:for test
	if (RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_BSS_SCAN_IN_PROGRESS))
		RTMP_CLEAR_FLAG(pAd, fRTMP_ADAPTER_BSS_SCAN_IN_PROGRESS);//steven:for test

	RTMP_CLEAR_FLAG(pAd, fRTMP_ADAPTER_MLME_RESET_IN_PROGRESS);
	
	DBGPRINT(RT_DEBUG_TRACE, ("<== MlmeRestartStateMachine\n"));
}

VOID	MlmePostRestartStateMachine(
	IN	PRTMP_ADAPTER	pAd)
{
	// Change back to original channel in case of doing scan
	AsicSwitchChannel(pAd, pAd->CommonCfg.Channel,FALSE);
	AsicLockChannel(pAd, pAd->CommonCfg.Channel);

	// Resume MSDU which is turned off durning scan
	RTUSBResumeMsduTransmission(pAd);
}

/*! \brief  test if the MLME Queue is empty
 *  \param  *Queue    The MLME Queue
 *  \return TRUE if the Queue is empty, FALSE otherwise
 *  \pre
 *  \post
 
 IRQL = DISPATCH_LEVEL
 
 */
BOOLEAN MlmeQueueEmpty(
	IN MLME_QUEUE *Queue) 
{
	BOOLEAN Ans;
	unsigned long   IrqFlags;
	
	NdisAcquireSpinLock(&(Queue->Lock), IrqFlags);
	Ans = (Queue->Num == 0);
	NdisReleaseSpinLock(&(Queue->Lock), IrqFlags);

	return Ans;
}

/*! \brief   test if the MLME Queue is full
 *  \param   *Queue      The MLME Queue
 *  \return  TRUE if the Queue is empty, FALSE otherwise
 *  \pre
 *  \post

 IRQL = PASSIVE_LEVEL
 IRQL = DISPATCH_LEVEL
  
 */
BOOLEAN MlmeQueueFull(
	IN MLME_QUEUE *Queue) 
{
	BOOLEAN Ans;
	unsigned long   IrqFlags;
	
	NdisAcquireSpinLock(&(Queue->Lock), IrqFlags);
	Ans = (Queue->Num == MAX_LEN_OF_MLME_QUEUE);
	NdisReleaseSpinLock(&(Queue->Lock), IrqFlags);

	return Ans;
}

/*! \brief   The destructor of MLME Queue
 *  \param 
 *  \return
 *  \pre
 *  \post
 *  \note   Clear Mlme Queue, Set Queue->Num to Zero.

 IRQL = PASSIVE_LEVEL
 
 */
VOID MlmeQueueDestroy(
	IN MLME_QUEUE *pQueue) 
{
	unsigned long   IrqFlags;
	
	NdisAcquireSpinLock(&(pQueue->Lock), IrqFlags);
	pQueue->Num  = 0;
	pQueue->Head = 0;
	pQueue->Tail = 0;	
	NdisReleaseSpinLock(&(pQueue->Lock), IrqFlags);
	NdisFreeSpinLock(&(pQueue->Lock));
}

/*! \brief   To substitute the message type if the message is coming from external
 *  \param  pFrame         The frame received
 *  \param  *Machine       The state machine
 *  \param  *MsgType       the message type for the state machine
 *  \return TRUE if the substitution is successful, FALSE otherwise
 *  \pre
 *  \post
 
 IRQL = DISPATCH_LEVEL
 
 */
BOOLEAN MsgTypeSubst(
	IN PRTMP_ADAPTER  pAd,
	IN PFRAME_802_11 pFrame, 
	OUT INT *Machine, 
	OUT INT *MsgType) 
{
	USHORT	Seq;
	UCHAR	EAPType;
	PUCHAR	pData;

	// Pointer to start of data frames including SNAP header
	pData = (PUCHAR) pFrame + LENGTH_802_11;

	// The only data type will pass to this function is EAPOL frame
	if (pFrame->Hdr.FC.Type == BTYPE_DATA) 
	{ 
#ifdef CCX_SUPPORT
		if (NdisEqualMemory(SNAP_AIRONET, pData, LENGTH_802_1_H))
		{
			// Cisco Aironet SNAP header
			*Machine = AIRONET_STATE_MACHINE;
			*MsgType = MT2_AIRONET_MSG;
			return (TRUE);			
		}
		
		if ( pAd->StaCfg.LeapAuthMode == CISCO_AuthModeLEAP ) //LEAP
		{
			// LEAP frames
			*Machine = LEAP_STATE_MACHINE;
			EAPType = *((UCHAR*)pFrame + LENGTH_802_11 + LENGTH_802_1_H + 1);
			return (LeapMsgTypeSubst(EAPType, MsgType));
		}
		else
#endif
		{
			*Machine = WPA_PSK_STATE_MACHINE;		
			EAPType = *((UCHAR*)pFrame + LENGTH_802_11 + LENGTH_802_1_H + 1);
			return(WpaMsgTypeSubst(EAPType, MsgType));
		}
	}

	switch (pFrame->Hdr.FC.SubType) 
	{
		case SUBTYPE_ASSOC_REQ:
			*Machine = ASSOC_STATE_MACHINE;
			*MsgType = MT2_PEER_ASSOC_REQ;
			break;
		case SUBTYPE_ASSOC_RSP:
			*Machine = ASSOC_STATE_MACHINE;
			*MsgType = MT2_PEER_ASSOC_RSP;
			break;
		case SUBTYPE_REASSOC_REQ:
			*Machine = ASSOC_STATE_MACHINE;
			*MsgType = MT2_PEER_REASSOC_REQ;
			break;
		case SUBTYPE_REASSOC_RSP:
			*Machine = ASSOC_STATE_MACHINE;
			*MsgType = MT2_PEER_REASSOC_RSP;
			break;
		case SUBTYPE_PROBE_REQ:
			*Machine = SYNC_STATE_MACHINE;
			*MsgType = MT2_PEER_PROBE_REQ;
			break;
		case SUBTYPE_PROBE_RSP:
			*Machine = SYNC_STATE_MACHINE;
			*MsgType = MT2_PEER_PROBE_RSP;
			break;
		case SUBTYPE_BEACON:
			*Machine = SYNC_STATE_MACHINE;
			*MsgType = MT2_PEER_BEACON;
			break;
		case SUBTYPE_ATIM:
			*Machine = SYNC_STATE_MACHINE;
			*MsgType = MT2_PEER_ATIM;
			break;
		case SUBTYPE_DISASSOC:
			*Machine = ASSOC_STATE_MACHINE;
			*MsgType = MT2_PEER_DISASSOC_REQ;
			break;
		case SUBTYPE_AUTH:
			// get the sequence number from payload 24 Mac Header + 2 bytes algorithm
			NdisMoveMemory(&Seq, &pFrame->Octet[2], sizeof(USHORT));
			if (Seq == 1 || Seq == 3) 
			{
				*Machine = AUTH_RSP_STATE_MACHINE;
				*MsgType = MT2_PEER_AUTH_ODD;
			} 
			else if (Seq == 2 || Seq == 4) 
			{
				*Machine = AUTH_STATE_MACHINE;
				*MsgType = MT2_PEER_AUTH_EVEN;
			} 
			else 
			{
				return FALSE;
			}
			break;
		case SUBTYPE_DEAUTH:
			*Machine = AUTH_RSP_STATE_MACHINE;
			*MsgType = MT2_PEER_DEAUTH;
			break;
		case SUBTYPE_ACTION:
			*Machine = ACTION_STATE_MACHINE;
			//  Sometimes Sta will return with category bytes with MSB = 1, if they receive catogory out of their support
			if ((pFrame->Octet[0]&0x7F) > MAX_PEER_CATE_MSG) 
			{
				*MsgType = MT2_ACT_INVALID;
			} 
			else
			{
				*MsgType = (pFrame->Octet[0]&0x7F);
			} 
			break;
		default:
			return FALSE;
			break;
	}

	return TRUE;
}

// ===========================================================================================
// state_machine.c
// ===========================================================================================

/*! \brief Initialize the state machine.
 *  \param *S           pointer to the state machine 
 *  \param  Trans       State machine transition function
 *  \param  StNr        number of states 
 *  \param  MsgNr       number of messages 
 *  \param  DefFunc     default function, when there is invalid state/message combination 
 *  \param  InitState   initial state of the state machine 
 *  \param  Base        StateMachine base, internal use only
 *  \pre p_sm should be a legal pointer
 *  \post

 IRQL = PASSIVE_LEVEL
 
 */

VOID StateMachineInit(
	IN STATE_MACHINE *S, 
	IN STATE_MACHINE_FUNC Trans[], 
	IN ULONG StNr, 
	IN ULONG MsgNr, 
	IN STATE_MACHINE_FUNC DefFunc, 
	IN ULONG InitState, 
	IN ULONG Base) 
{
	ULONG i, j;

	// set number of states and messages
	S->NrState = StNr;
	S->NrMsg   = MsgNr;
	S->Base    = Base;

	S->TransFunc  = Trans;

	// init all state transition to default function
	for (i = 0; i < StNr; i++) 
	{
		for (j = 0; j < MsgNr; j++) 
		{
			S->TransFunc[i * MsgNr + j] = DefFunc;
		}
	}

	// set the starting state
	S->CurrState = InitState;

}

/*! \brief This function fills in the function pointer into the cell in the state machine 
 *  \param *S   pointer to the state machine
 *  \param St   state
 *  \param Msg  incoming message
 *  \param f    the function to be executed when (state, message) combination occurs at the state machine
 *  \pre *S should be a legal pointer to the state machine, st, msg, should be all within the range, Base should be set in the initial state
 *  \post

 IRQL = PASSIVE_LEVEL
 
 */
VOID StateMachineSetAction(
	IN STATE_MACHINE *S, 
	IN ULONG St, 
	IN ULONG Msg, 
	IN STATE_MACHINE_FUNC Func) 
{
	ULONG MsgIdx;

	MsgIdx = Msg - S->Base;

	if (St < S->NrState && MsgIdx < S->NrMsg) 
	{
		// boundary checking before setting the action
		S->TransFunc[St * S->NrMsg + MsgIdx] = Func;
	} 
}

/*! \brief   This function does the state transition
 *  \param   *Adapter the NIC adapter pointer
 *  \param   *S       the state machine
 *  \param   *Elem    the message to be executed
 *  \return   None
 
 IRQL = DISPATCH_LEVEL
 
 */
VOID StateMachinePerformAction(
	IN	PRTMP_ADAPTER	pAd, 
	IN STATE_MACHINE *S, 
	IN MLME_QUEUE_ELEM *Elem) 
{
	(*(S->TransFunc[S->CurrState * S->NrMsg + Elem->MsgType - S->Base]))(pAd, Elem);
}

/*
	==========================================================================
	Description:
		The drop function, when machine executes this, the message is simply 
		ignored. This function does nothing, the message is freed in 
		StateMachinePerformAction()
	==========================================================================
 */
VOID Drop(
	IN PRTMP_ADAPTER pAd, 
	IN MLME_QUEUE_ELEM *Elem) 
{
}

// ===========================================================================================
// lfsr.c
// ===========================================================================================

/*
	==========================================================================
	Description:

	IRQL = PASSIVE_LEVEL

	==========================================================================
 */
VOID LfsrInit(
	IN PRTMP_ADAPTER pAd, 
	IN ULONG Seed) 
{
	if (Seed == 0) 
		pAd->Mlme.ShiftReg = 1;
	else 
		pAd->Mlme.ShiftReg = Seed;
}

/*
	==========================================================================
	Description:
	==========================================================================
 */
UCHAR RandomByte(
	IN PRTMP_ADAPTER pAd) 
{
	ULONG i;
	UCHAR R, Result;

	R = 0;

	for (i = 0; i < 8; i++) 
	{
		if (pAd->Mlme.ShiftReg & 0x00000001) 
		{
			pAd->Mlme.ShiftReg = ((pAd->Mlme.ShiftReg ^ LFSR_MASK) >> 1) | 0x80000000;
			Result = 1;
		} 
		else 
		{
			pAd->Mlme.ShiftReg = pAd->Mlme.ShiftReg >> 1;
			Result = 0;
		}
		R = (R << 1) | Result;
	}

	return R;
}

/*
	==========================================================================
	Description:

	IRQL = PASSIVE_LEVEL
	IRQL = DISPATCH_LEVEL
	
	==========================================================================
 */
VOID AsicSwitchChannel(
	IN PRTMP_ADAPTER pAd, 
	IN	UCHAR			Channel,
	IN	BOOLEAN			bScan) 
{
	UINT32 R3 = DEFAULT_RF_TX_POWER, R4=0, R2, Value;
	CHAR	TxPwer = 0, TxPwer2 = DEFAULT_RF_TX_POWER;//, Bbp94 = BBPR94_DEFAULT;
	UCHAR index;//, BbpReg;
	RTMP_RF_REGS *RFRegTable;

	// Search Tx power value
	for (index = 0; index < pAd->ChannelListNum; index++)
	{
		if (Channel == pAd->ChannelList[index].Channel)
		{
			TxPwer = pAd->ChannelList[index].Power;
			TxPwer2 = pAd->ChannelList[index].Power2;
			break;
		}
	}

	RFRegTable = RF2850RegTable;
	R3 = (ULONG) TxPwer;
	R3 = R3 << 9; // shift TX power control to correct RF R3 bit position


	switch (pAd->RfIcType)
	{
		case RFIC_2820:
		case RFIC_2850:
		case RFIC_2720:
		case RFIC_2750:

			for (index = 0; index < NUM_OF_2860_CHNL; index++)
			{
				if (Channel == RFRegTable[index].Channel)
				{
					R2 = RFRegTable[index].R2;
					if (pAd->Antenna.field.TxPath == 1)
					{
						R2 |= 0x4000;	// If TXpath is 1, bit 14 = 1;
					}
					
					if (pAd->Antenna.field.RxPath == 2)
					{
						R2 |= 0x40;	// write 1 to off Rxpath.
					}
					else if (pAd->Antenna.field.RxPath == 1)
					{
						R2 |= 0x20040;	// write 1 to off RxPath
					}
					
					R3 = R3 | (RFRegTable[index].R3 & 0xffffc1ff); // set TX power0
					R4 = (RFRegTable[index].R4 & (~0x001f87c0)) | (pAd->RfFreqOffset << 15) | (TxPwer2 <<6);// Set freq Offset & TxPwr1

					// Based on BBP current mode before changing RF channel.
					if (!bScan && (pAd->CommonCfg.BBPCurrentBW == BW_40))
					{
						R4 |=0x200000;
					}
					
					// Update variables
					pAd->LatchRfRegs.Channel = Channel;
					pAd->LatchRfRegs.R1 = RFRegTable[index].R1;
					pAd->LatchRfRegs.R2 = R2;
					pAd->LatchRfRegs.R3 = R3;
					pAd->LatchRfRegs.R4 = R4;
				}
			}
			break;


			
		default:
			break;
	}

	
	// Set RF value 1's set R3[bit2] = [0]
	RTUSBWriteRFRegister(pAd, pAd->LatchRfRegs.R1);
	RTUSBWriteRFRegister(pAd, pAd->LatchRfRegs.R2);
	RTUSBWriteRFRegister(pAd, (pAd->LatchRfRegs.R3 & (~0x04)));
	RTUSBWriteRFRegister(pAd, pAd->LatchRfRegs.R4);

	RTMPusecDelay(200);
	// Set RF value 2's set R3[bit2] = [1]
	RTUSBWriteRFRegister(pAd, pAd->LatchRfRegs.R1);
	RTUSBWriteRFRegister(pAd, pAd->LatchRfRegs.R2);
	RTUSBWriteRFRegister(pAd, (pAd->LatchRfRegs.R3 | 0x04));
	RTUSBWriteRFRegister(pAd, pAd->LatchRfRegs.R4);

	RTMPusecDelay(200);
	// Set RF value 3's set R3[bit2] = [0]
	RTUSBWriteRFRegister(pAd, pAd->LatchRfRegs.R1);
	RTUSBWriteRFRegister(pAd, pAd->LatchRfRegs.R2);
	RTUSBWriteRFRegister(pAd, (pAd->LatchRfRegs.R3 & (~0x04)));
	RTUSBWriteRFRegister(pAd, pAd->LatchRfRegs.R4);
	
	// Change BBP setting during siwtch from a->g, g->a
	if (Channel <= 14)
	{
		RTUSBWriteBBPRegister(pAd, BBP_R62, (0x37 - GET_LNA_GAIN(pAd)));
		RTUSBWriteBBPRegister(pAd, BBP_R63, (0x37 - GET_LNA_GAIN(pAd)));
		RTUSBWriteBBPRegister(pAd, BBP_R64, (0x37 - GET_LNA_GAIN(pAd)));
		RTUSBWriteBBPRegister(pAd, BBP_R86, (0x37 - GET_LNA_GAIN(pAd)));
		

		// 5G band selection PIN, bit1 and bit2 are complement
		RTUSBReadMACRegister(pAd, TX_BAND_CFG, &Value);
		Value &= (~0x6);
		Value |= (0x04);
		RTUSBWriteMACRegister(pAd, TX_BAND_CFG, Value);
	}
	else
	{
		RTUSBWriteBBPRegister(pAd, BBP_R62, (0x37 - GET_LNA_GAIN(pAd)));
		RTUSBWriteBBPRegister(pAd, BBP_R63, (0x37 - GET_LNA_GAIN(pAd)));
		RTUSBWriteBBPRegister(pAd, BBP_R64, (0x37 - GET_LNA_GAIN(pAd)));
		RTUSBWriteBBPRegister(pAd, BBP_R86, (0x37 - GET_LNA_GAIN(pAd)));
		RTUSBWriteBBPRegister(pAd, BBP_R82, 0xF2);

		// 5G band selection PIN, bit1 and bit2 are complement
		RTUSBReadMACRegister(pAd, TX_BAND_CFG, &Value);
		Value &= (~0x6);
		Value |= (0x02);
		RTUSBWriteMACRegister(pAd, TX_BAND_CFG, Value);
	}
	// R66 should be set according to Channel and use 20MHz when scanning
	RTUSBWriteBBPRegister(pAd, BBP_R66, (0x26 + GET_LNA_GAIN(pAd)));
	//
	// On 11A/11G, We should delay and wait RF/BBP to be stable
	// and the appropriate time should be 10 micro seconds 
	// It's not recommend to use NdisStallExecution on PASSIVE_LEVEL
	// use NdisMSleep to dealy 10 microsecond instead.
	//
	NdisMSleep(10);  

	DBGPRINT(RT_DEBUG_TRACE, ("SwitchChannel#%d(RF=%d, Pwr0=%d, Pwr1=%d, %dT) to , R1=0x%08lx, R2=0x%08lx, R3=0x%08lx, R4=0x%08lx\n",
		Channel, 
		pAd->RfIcType, 
		(R3 & 0x00003e00) >> 9,
		(R4 & 0x000007c0) >> 6,
		pAd->Antenna.field.TxPath,
		pAd->LatchRfRegs.R1, 
		pAd->LatchRfRegs.R2, 
		pAd->LatchRfRegs.R3, 
		pAd->LatchRfRegs.R4));
}


/*
	==========================================================================
	Description:
		This function is required for 2421 only, and should not be used during
		site survey. It's only required after NIC decided to stay at a channel
		for a longer period.
		When this function is called, it's always after AsicSwitchChannel().

	IRQL = PASSIVE_LEVEL
	IRQL = DISPATCH_LEVEL
	
	==========================================================================
 */
VOID AsicLockChannel(
	IN PRTMP_ADAPTER pAd, 
	IN UCHAR Channel) 
{
	//Not used.
}

/*
	==========================================================================
	Description:

	IRQL = PASSIVE_LEVEL
	IRQL = DISPATCH_LEVEL
	
	==========================================================================
 */
char *AntStr[4] = {"SW Diversity","Ant-A","Ant-B","HW Diversity"};

#define SOFTWARE_DIVERSITY  0
#define ANTENNA_A		    1
#define ANTENNA_B		    2
#define HARDWARE_DIVERSITY  3

VOID	AsicAntennaSelect(
	IN	PRTMP_ADAPTER	pAd,
	IN	UCHAR			Channel) 
{
}

VOID	AsicAntennaSetting(
	IN	PRTMP_ADAPTER	pAd,
	IN	ABGBAND_STATE	BandState)
{
					

}

/*
	==========================================================================
	Description:
		Gives CCK TX rate 2 more dB TX power.
		This routine works only in LINK UP in INFRASTRUCTURE mode.

		calculate desired Tx power in RF R3.Tx0~5,	should consider -
		0. if current radio is a noisy environment (pAd->DrsCounters.fNoisyEnvironment)
		1. TxPowerPercentage
		2. auto calibration based on TSSI feedback
		3. extra 2 db for CCK
		4. -10 db upon very-short distance (AvgRSSI >= -40db) to AP

	NOTE: Since this routine requires the value of (pAd->DrsCounters.fNoisyEnvironment),
		it should be called AFTER MlmeDynamicTxRatSwitching()
	==========================================================================
 */
VOID AsicAdjustTxPower(
	IN PRTMP_ADAPTER pAd) 
{
	INT			i, j;
	CHAR		DeltaPwr = 0;
	BOOLEAN		bAutoTxAgc = FALSE;
	UCHAR		TssiRef, *pTssiMinusBoundary, *pTssiPlusBoundary, TxAgcStep;
	UCHAR		BbpR1, idx;
	PCHAR		pTxAgcCompensate;
	ULONG		TxPwr[5];
	CHAR		Value;


	if (pAd->CommonCfg.BBPCurrentBW == BW_40)
	{
		if (pAd->CommonCfg.CentralChannel > 14)
		{
			TxPwr[0] = pAd->Tx40MPwrCfgABand[0];
			TxPwr[1] = pAd->Tx40MPwrCfgABand[1];
			TxPwr[2] = pAd->Tx40MPwrCfgABand[2];
			TxPwr[3] = pAd->Tx40MPwrCfgABand[3];
			TxPwr[4] = pAd->Tx40MPwrCfgABand[4];
		}
		else
		{
			TxPwr[0] = pAd->Tx40MPwrCfgGBand[0];
			TxPwr[1] = pAd->Tx40MPwrCfgGBand[1];
			TxPwr[2] = pAd->Tx40MPwrCfgGBand[2];
			TxPwr[3] = pAd->Tx40MPwrCfgGBand[3];
			TxPwr[4] = pAd->Tx40MPwrCfgGBand[4];
		}
	}
	else
	{
		TxPwr[0] = pAd->TxPwrCfg[0];
		TxPwr[1] = pAd->TxPwrCfg[1];
		TxPwr[2] = pAd->TxPwrCfg[2];
		TxPwr[3] = pAd->TxPwrCfg[3];
		TxPwr[4] = pAd->TxPwrCfg[4];
	}

	// TX power compensation for temperature variation based on TSSI. try every 4 second
	if (pAd->Mlme.OneSecPeriodicRound % 4 == 0)
	{
		if (pAd->CommonCfg.Channel <= 14)
		{
			bAutoTxAgc         = pAd->bAutoTxAgcG;
			TssiRef            = pAd->TssiRefG;
			pTssiMinusBoundary = &pAd->TssiMinusBoundaryG[0];
			pTssiPlusBoundary  = &pAd->TssiPlusBoundaryG[0];
			TxAgcStep          = pAd->TxAgcStepG;
			pTxAgcCompensate   = &pAd->TxAgcCompensateG;
		}
		else
		{
			bAutoTxAgc         = pAd->bAutoTxAgcA;
			TssiRef            = pAd->TssiRefA;
			pTssiMinusBoundary = &pAd->TssiMinusBoundaryA[0];
			pTssiPlusBoundary  = &pAd->TssiPlusBoundaryA[0];
			TxAgcStep          = pAd->TxAgcStepA;
			pTxAgcCompensate   = &pAd->TxAgcCompensateA;
		}

		if (bAutoTxAgc)
		{
			RTUSBReadBBPRegister(pAd, BBP_R49, &BbpR1);
			if (BbpR1 > pTssiMinusBoundary[1])
			{
				// Reading is larger than the reference value
				// check for how large we need to decrease the Tx power
				for (idx = 1; idx < 5; idx++)
				{
					if (BbpR1 <= pAd->TssiMinusBoundaryG[idx])  // Found the range
						break;
				}
				// The index is the step we should decrease, idx = 0 means there is nothing to compensate
//				if (R3 > (ULONG) (TxAgcStep * (idx-1)))
					*pTxAgcCompensate = -(TxAgcStep * (idx-1));
//				else
//					*pTxAgcCompensate = -((UCHAR)R3);
				
				DeltaPwr += (*pTxAgcCompensate);
				DBGPRINT(RT_DEBUG_TRACE, ("-- Tx Power, BBP R1=%x, TssiRef=%x, TxAgcStep=%x, step = -%d\n",
					BbpR1, TssiRef, TxAgcStep, idx-1));                    
			}
			else if (BbpR1 < pTssiPlusBoundary[1])
			{
				// Reading is smaller than the reference value
				// check for how large we need to increase the Tx power
				for (idx = 1; idx < 5; idx++)
				{
					if (BbpR1 >= pTssiPlusBoundary[idx])   // Found the range
						break;
				}
				// The index is the step we should increase, idx = 0 means there is nothing to compensate
				*pTxAgcCompensate = TxAgcStep * (idx-1);
				DeltaPwr += (*pTxAgcCompensate);
				DBGPRINT(RT_DEBUG_TRACE, ("++ Tx Power, BBP R1=%x, TssiRef=%x, TxAgcStep=%x, step = +%d\n",
					BbpR1, TssiRef, TxAgcStep, idx-1));
			}
			else
			{
				*pTxAgcCompensate = 0;
			}
		}
	}
	else
	{
		if (pAd->CommonCfg.Channel <= 14)
		{
			bAutoTxAgc         = pAd->bAutoTxAgcG;
			pTxAgcCompensate   = &pAd->TxAgcCompensateG;
		}
		else
		{
			bAutoTxAgc         = pAd->bAutoTxAgcA;
			pTxAgcCompensate   = &pAd->TxAgcCompensateA;
		}

		if (bAutoTxAgc)
			DeltaPwr += (*pTxAgcCompensate);
	}


	// E2PROM setting is calibrated for maximum TX power (i.e. 100%)
	// We lower TX power here according to the percentage specified from UI
	if (pAd->CommonCfg.TxPowerPercentage == 0xffffffff)       // AUTO TX POWER control
		;
	else if (pAd->CommonCfg.TxPowerPercentage > 90)  // 91 ~ 100% & AUTO, treat as 100% in terms of mW
		;
	else if (pAd->CommonCfg.TxPowerPercentage > 60)  // 61 ~ 90%, treat as 75% in terms of mW
	{
		DeltaPwr -= 1;
	}
	else if (pAd->CommonCfg.TxPowerPercentage > 30)  // 31 ~ 60%, treat as 50% in terms of mW
	{
		DeltaPwr -= 3;
	}
	else if (pAd->CommonCfg.TxPowerPercentage > 15)  // 16 ~ 30%, treat as 25% in terms of mW
	{
		DeltaPwr -= 6;
	}
	else if (pAd->CommonCfg.TxPowerPercentage > 9)   // 10 ~ 15%, treat as 12.5% in terms of mW
	{
		DeltaPwr -= 9;
	}
	else                                           // 0 ~ 9 %, treat as MIN(~3%) in terms of mW
	{
		DeltaPwr -= 12;
	}

	for (i=0; i<5; i++)
	{
		if (TxPwr[i] != 0xffffffff)
		{
			for (j=0; j<8; j++)
			{
				Value = (CHAR)((TxPwr[i] >> j*4) & 0x0F);

				if ((Value + DeltaPwr) < 0)
				{
					Value = 0;
				}
				else if ((Value + DeltaPwr) > 0xF)
				{
					Value = 0xF;
				}
				else
				{
					Value += DeltaPwr;
				}

				TxPwr[i] = (TxPwr[i] & ~(0x0000000F << j*4)) | (Value << j*4);
			}
			
			RTUSBWriteMACRegister(pAd, TX_PWR_CFG_0 + i*4, TxPwr[i]);
		}
	}

	DBGPRINT(RT_DEBUG_INFO, ("<-- AsicAdjustTxPower, DeltaPwr=%d\n", DeltaPwr));
}
/*
	==========================================================================
	Description:
		put PHY to sleep here, and set next wakeup timer. PHY doesn't not wakeup 
		automatically. Instead, MCU will issue a TwakeUpInterrupt to host after
		the wakeup timer timeout. Driver has to issue a separate command to wake
		PHY up.

	IRQL = DISPATCH_LEVEL

	==========================================================================
 */
VOID AsicSleepThenAutoWakeup(
	IN PRTMP_ADAPTER pAd, 
	IN BOOLEAN bEnable, 
	IN USHORT TbttNumToNextWakeUp) 
{
	AUTO_WAKEUP_STRUC	AutoWakeupCfg;

	// we have decided to SLEEP, so at least do it for a BEACON period.
	if (TbttNumToNextWakeUp == 0)
		TbttNumToNextWakeUp = 1;

	AutoWakeupCfg.word = 0;
	RTUSBWriteMACRegister(pAd, AUTO_WAKEUP_CFG, AutoWakeupCfg.word);

	AutoWakeupCfg.field.NumofSleepingTbtt = TbttNumToNextWakeUp - 1;
	AutoWakeupCfg.field.EnableAutoWakeup = 1;
	AutoWakeupCfg.field.AutoLeadTime = 5;
	RTUSBWriteMACRegister(pAd, AUTO_WAKEUP_CFG, AutoWakeupCfg.word);

	AsicSendCommandToMcu(pAd, 0x30, 0xff, 0xff, 0x02);   // send POWER-SAVE command to MCU. Timeout unit:40us.

	OPSTATUS_SET_FLAG(pAd, fOP_STATUS_DOZE);
	
	DBGPRINT(RT_DEBUG_TRACE, ("<-- AsicSleepThenAutoWakeup, TbttNumToNextWakeUp=%d \n", TbttNumToNextWakeUp));

}

/*
	==========================================================================
	Description:
		AsicForceWakeup() is used whenever manual wakeup is required
		AsicForceSleep() should only be used when not in INFRA BSS. When
		in INFRA BSS, we should use AsicSleepThenAutoWakeup() instead.
	==========================================================================
 */
VOID AsicForceSleep(
	IN PRTMP_ADAPTER pAd)
{
	ULONG		value;
	value = (SLEEPCID<<16)+(OWNERMCU<<24)+ (0x40<<8)+1;
	RTUSBWriteMACRegister(pAd, 0x7010, value);
	RTUSBWriteMACRegister(pAd, 0x404, 0x30);
	DBGPRINT_RAW(RT_DEBUG_ERROR, ("MlmeSet Sleep Mailbox  value=0x%lx\n",  value));

}

/*
	==========================================================================
	Description:
		AsicForceWakeup() is used whenever Twakeup timer (set via AsicSleepThenAutoWakeup)
		expired.

	IRQL = PASSIVE_LEVEL
	IRQL = DISPATCH_LEVEL
	==========================================================================
 */
VOID AsicForceWakeup(
	IN PRTMP_ADAPTER pAd)
{
	AUTO_WAKEUP_STRUC	AutoWakeupCfg;

	AutoWakeupCfg.word = 0;
	RTUSBWriteMACRegister(pAd, AUTO_WAKEUP_CFG, AutoWakeupCfg.word);

	AsicSendCommandToMcu(pAd, 0x31, 0xff, 0x00, 0x02);   

	OPSTATUS_CLEAR_FLAG(pAd, fOP_STATUS_DOZE);

	DBGPRINT(RT_DEBUG_TRACE, ("<-- AsicForceWakeup \n"));
}

/*
	==========================================================================
	Description:

	IRQL = DISPATCH_LEVEL

	==========================================================================
 */
VOID AsicSetBssid(
	IN PRTMP_ADAPTER pAd, 
	 IN  PUCHAR pBssid) 
{
	ULONG         Addr4;
	USHORT 		offset;

	
	DBGPRINT(RT_DEBUG_TRACE, ("==============AsicSetBssid %x:%x:%x:%x:%x:%x\n",
		pBssid[0],pBssid[1],pBssid[2],pBssid[3], pBssid[4],pBssid[5]));

	Addr4 = (ULONG)(pBssid[0])       | 
			(ULONG)(pBssid[1] << 8)  | 
			(ULONG)(pBssid[2] << 16) |
			(ULONG)(pBssid[3] << 24);
	RTUSBWriteMACRegister(pAd, MAC_BSSID_DW0, Addr4);
	if (INFRA_ON(pAd))
	{
		offset = MAC_WCID_BASE + BSSID_WCID * HW_WCID_ENTRY_SIZE;
		RTUSBWriteMACRegister(pAd, offset, Addr4);
	}
	
	// always one BSSID in STA mode
	Addr4 = (ULONG)(pBssid[4]) | (ULONG)(pBssid[5] << 8);
	RTUSBWriteMACRegister(pAd, MAC_BSSID_DW1, Addr4);
	if (INFRA_ON(pAd))
	{
		offset = (MAC_WCID_BASE + BSSID_WCID * HW_WCID_ENTRY_SIZE)+ 4;
		// always one BSSID in STA mode
		RTUSBWriteMACRegister(pAd, offset, Addr4);
	}

}
/*
	==========================================================================
	Description:  Bssid also is a Wireless Client . So add Bssid MAC.

	IRQL = DISPATCH_LEVEL

	==========================================================================
 */
VOID AsicSetBssidWC(
	IN PRTMP_ADAPTER pAd, 
	IN PUCHAR pBssid) 
{

}
/*
	==========================================================================
	Description:   

	IRQL = DISPATCH_LEVEL

	==========================================================================
 */
VOID AsicDelWcidTab(
	IN PRTMP_ADAPTER pAd,
	IN UCHAR	Wcid) 
{
	ULONG		  Addr0 = 0x0, Addr1 = 0x0;
	USHORT 		offset;

	DBGPRINT(RT_DEBUG_TRACE, ("AsicDelWcidTab==>Wcid = 0x%x\n",Wcid));
	offset = MAC_WCID_BASE + Wcid * HW_WCID_ENTRY_SIZE;
	RTUSBWriteMACRegister(pAd, offset, Addr0);
	offset += 4;
	RTUSBWriteMACRegister(pAd, offset, Addr1);
}
/*
	==========================================================================
	Description:

	IRQL = PASSIVE_LEVEL
	IRQL = DISPATCH_LEVEL
	
	==========================================================================
 */
VOID AsicDisableSync(
	IN PRTMP_ADAPTER pAd) 
{
	BCN_TIME_CFG_STRUC csr;
	DBGPRINT(RT_DEBUG_ERROR, ("--->Disable TSF synchronization\n"));

	// 2003-12-20 disable TSF and TBTT while NIC in power-saving have side effect
	//            that NIC will never wakes up because TSF stops and no more 
	//            TBTT interrupts
	RTUSBReadMACRegister(pAd, BCN_TIME_CFG, &csr.word);
	csr.field.bBeaconGen = 0;
	csr.field.bTBTTEnable = 0;
	csr.field.TsfSyncMode = 0;
	RTUSBWriteMACRegister(pAd, BCN_TIME_CFG, csr.word);
}

/*
	==========================================================================
	Description:

	IRQL = DISPATCH_LEVEL
	
	==========================================================================
 */
VOID AsicEnableRDG(
	IN PRTMP_ADAPTER pAd) 
{
	TX_LINK_CFG_STRUC	TxLinkCfg;
	UINT32				Data;

	DBGPRINT(RT_DEBUG_INFO, ("--->AsicEnableRDG \n"));

	RTUSBReadMACRegister(pAd, TX_LINK_CFG, &TxLinkCfg.word);
	TxLinkCfg.field.TxRDGEn = 1;
	RTUSBWriteMACRegister(pAd, TX_LINK_CFG, TxLinkCfg.word);

	RTUSBReadMACRegister(pAd, EDCA_AC0_CFG, &Data);
	Data  &= 0xFFFFFF00;
	Data  |= 0x80;
	RTUSBWriteMACRegister(pAd, EDCA_AC0_CFG, Data);
}

/*
	==========================================================================
	Description:

	IRQL = DISPATCH_LEVEL
	
	==========================================================================
 */
VOID AsicDisableRDG(
	IN PRTMP_ADAPTER pAd) 
{
	TX_LINK_CFG_STRUC	TxLinkCfg;
	UINT32				Data;

	DBGPRINT(RT_DEBUG_INFO, ("--->AsicDisableRDG \n"));

	RTUSBReadMACRegister(pAd, TX_LINK_CFG, &TxLinkCfg.word);
	TxLinkCfg.field.TxRDGEn = 0;
	RTUSBWriteMACRegister(pAd, TX_LINK_CFG, TxLinkCfg.word);

	RTUSBReadMACRegister(pAd, EDCA_AC0_CFG, &Data);
	Data  &= 0xFFFFFF00;
	RTUSBWriteMACRegister(pAd, EDCA_AC0_CFG, Data);
}


/*
	==========================================================================
	Description:

	IRQL = DISPATCH_LEVEL
	
	==========================================================================
 */
VOID AsicEnablePiggyB(
	IN PRTMP_ADAPTER pAd) 
{
	TX_LINK_CFG_STRUC	TxLinkCfg;

	DBGPRINT(RT_DEBUG_INFO, ("--->AsicEnableRDG \n"));

	RTUSBReadMACRegister(pAd, TX_LINK_CFG, &TxLinkCfg.word);
	TxLinkCfg.field.TxCFAckEn = 1;
	RTUSBWriteMACRegister(pAd, TX_LINK_CFG, TxLinkCfg.word);
}

/*
	==========================================================================
	Description:

	IRQL = DISPATCH_LEVEL
	
	==========================================================================
 */
VOID AsicDisablePiggyB(
	IN PRTMP_ADAPTER pAd) 
{
	TX_LINK_CFG_STRUC	TxLinkCfg;

	DBGPRINT(RT_DEBUG_INFO, ("--->AsicEnableRDG \n"));

	RTUSBReadMACRegister(pAd, TX_LINK_CFG, &TxLinkCfg.word);
	TxLinkCfg.field.TxCFAckEn = 0;
	RTUSBWriteMACRegister(pAd, TX_LINK_CFG, TxLinkCfg.word);
}
/*
	==========================================================================
	Description:

	IRQL = DISPATCH_LEVEL
	
	==========================================================================
 */
VOID AsicEnableBssSync(
	IN PRTMP_ADAPTER pAd) 
{
	BCN_TIME_CFG_STRUC csr;

	DBGPRINT(RT_DEBUG_TRACE, ("--->AsicEnableBssSync(INFRA mode)\n"));

	RTUSBReadMACRegister(pAd, BCN_TIME_CFG, &csr.word);

	if (pAd->OpMode == OPMODE_AP)
	{
		csr.field.BeaconInterval = pAd->CommonCfg.BeaconPeriod << 4; // ASIC register in units of 1/16 TU
		csr.field.bTsfTicking = 1;
		csr.field.TsfSyncMode = 3; // sync TSF similar as in ADHOC mode?
		csr.field.bBeaconGen  = 1; // AP should generate BEACON
		csr.field.bTBTTEnable = 1;
	}
	else
	{
		csr.field.BeaconInterval = pAd->CommonCfg.BeaconPeriod << 4; // ASIC register in units of 1/16 TU
		csr.field.bTsfTicking = 1;
		csr.field.TsfSyncMode = 1; // sync TSF in INFRASTRUCTURE mode
		csr.field.bBeaconGen  = 0; // do NOT generate BEACON
		csr.field.bTBTTEnable = 1;
	}
	RTUSBWriteMACRegister(pAd, BCN_TIME_CFG, csr.word);
}

/*
	==========================================================================
	Description:
	Note: 
		BEACON frame in shared memory should be built ok before this routine
		can be called. Otherwise, a garbage frame maybe transmitted out every
		Beacon period.

	IRQL = DISPATCH_LEVEL
	
	==========================================================================
 */
VOID AsicEnableIbssSync(
	IN PRTMP_ADAPTER pAd)
{
	BCN_TIME_CFG_STRUC csr9;
	PUCHAR          ptr;
	ULONG		longptr;
	USHORT i;

	DBGPRINT(RT_DEBUG_INFO, ("--->AsicEnableIbssSync(ADHOC mode. MPDUtotalByteCount = %d)\n", pAd->BeaconTxWI.MPDUtotalByteCount));

	RTUSBReadMACRegister(pAd, BCN_TIME_CFG, &csr9.word);
	csr9.field.bBeaconGen = 0;
	csr9.field.bTBTTEnable = 0;
	csr9.field.bTsfTicking = 0;
	RTUSBWriteMACRegister(pAd, BCN_TIME_CFG, csr9.word);

	// move BEACON TXD and frame content to on-chip memory
	ptr = (PUCHAR)&pAd->BeaconTxWI;
	for (i=0; i<TXWI_SIZE; )  // 24-byte TXINFO field
	{
		longptr =  *ptr + (*(ptr+1)<<8) + (*(ptr+2)<<16) + (*(ptr+3)<<24);
		RTUSBWriteMACRegister(pAd, HW_BEACON_BASE0 + i, longptr);
		ptr += 4;
		i+=4;
	}

	// start right after the 24-byte TXINFO field. last 4 bytes should be zero. request by MAX.
	ptr = pAd->BeaconBuf;
	for (i=0; i< (pAd->BeaconTxWI.MPDUtotalByteCount);)
	{
		longptr =  *ptr + (*(ptr+1)<<8) + (*(ptr+2)<<16) + (*(ptr+3)<<24);
		RTUSBWriteMACRegister(pAd, HW_BEACON_BASE0 + TXWI_SIZE + i, longptr);
		ptr += 4;
		i+=4;
	}
	
	RTUSBWriteMACRegister(pAd, TBTT_SYNC_CFG, 0x00422040);
	// start sending BEACON
	csr9.field.BeaconInterval = pAd->CommonCfg.BeaconPeriod << 4; // ASIC register in units of 1/16 TU
	csr9.field.bTsfTicking = 1;
	csr9.field.TsfSyncMode = 2; // sync TSF in IBSS mode
	csr9.field.bTBTTEnable = 1;
	csr9.field.bBeaconGen = 1;
	RTUSBWriteMACRegister(pAd, BCN_TIME_CFG, csr9.word);
 }

/*
	==========================================================================
	Description:

	IRQL = PASSIVE_LEVEL
	IRQL = DISPATCH_LEVEL
	
	==========================================================================
 */
VOID AsicSetEdcaParm(
	IN PRTMP_ADAPTER pAd,
	IN PEDCA_PARM    pEdcaParm)
{
	EDCA_AC_CFG_STRUC	Ac0Cfg, Ac1Cfg, Ac2Cfg, Ac3Cfg;
	AC_TXOP_CSR0_STRUC csr0;
	AC_TXOP_CSR1_STRUC csr1;
	AIFSN_CSR_STRUC    AifsnCsr;
	CWMIN_CSR_STRUC    CwminCsr;
	CWMAX_CSR_STRUC    CwmaxCsr;

	
	DBGPRINT(RT_DEBUG_INFO,("AsicSetEdcaParm==>\n"));
	Ac0Cfg.word = 0;
	Ac1Cfg.word = 0;
	Ac2Cfg.word = 0;
	Ac3Cfg.word = 0;
	if ((pEdcaParm == NULL) || (pEdcaParm->bValid == FALSE))
	{
		OPSTATUS_CLEAR_FLAG(pAd, fOP_STATUS_WMM_INUSED);
		//========================================================
		//      MAC Register has a copy .
		//========================================================
		Ac0Cfg.field.AcTxop = 0; 	// QID_AC_BE
		Ac0Cfg.field.Cwmin = CW_MIN_IN_BITS;
		Ac0Cfg.field.Cwmax = CW_MAX_IN_BITS;
		Ac0Cfg.field.Aifsn = 2;
		RTUSBWriteMACRegister(pAd, EDCA_AC0_CFG, Ac0Cfg.word);

		Ac1Cfg.field.AcTxop = 0; 	// QID_AC_BK
		Ac1Cfg.field.Cwmin = CW_MIN_IN_BITS;
		Ac1Cfg.field.Cwmax = CW_MAX_IN_BITS;
		Ac1Cfg.field.Aifsn = 2;
		RTUSBWriteMACRegister(pAd, EDCA_AC1_CFG, Ac1Cfg.word);
		
		if (pAd->CommonCfg.PhyMode == PHY_11B)
		{
			Ac2Cfg.field.AcTxop = cpu2le16(192); 	// AC_VI: 192*32us ~= 6ms
			Ac3Cfg.field.AcTxop = cpu2le16(96);		// AC_VO: 96*32us  ~= 3ms
		}
		else
		{
			Ac2Cfg.field.AcTxop = cpu2le16(96);		// AC_VI: 96*32us ~= 3ms
			Ac3Cfg.field.AcTxop = cpu2le16(48);		// AC_VO: 48*32us ~= 1.5ms
		}
		Ac2Cfg.field.Cwmin = CW_MIN_IN_BITS;
		Ac2Cfg.field.Cwmax = CW_MAX_IN_BITS;
		Ac2Cfg.field.Aifsn = 2;
		RTUSBWriteMACRegister(pAd, EDCA_AC2_CFG, Ac2Cfg.word);
		Ac3Cfg.field.Cwmin = CW_MIN_IN_BITS;
		Ac3Cfg.field.Cwmax = CW_MAX_IN_BITS;
		Ac3Cfg.field.Aifsn = 2;
		RTUSBWriteMACRegister(pAd, EDCA_AC3_CFG, Ac3Cfg.word);


		//========================================================
		//      DMA Register has a copy too.
		//========================================================
		csr0.field.Ac0Txop = 0;     // QID_AC_BE
		csr0.field.Ac1Txop = 0;     // QID_AC_BK
		RTUSBWriteMACRegister(pAd, WMM_TXOP0_CFG, csr0.word);
		if (pAd->CommonCfg.PhyMode == PHY_11B)
		{
			csr1.field.Ac2Txop = cpu2le16(192);     // AC_VI: 192*32us ~= 6ms
			csr1.field.Ac3Txop = cpu2le16(96);      // AC_VO: 96*32us  ~= 3ms
		}
		else
		{
			csr1.field.Ac2Txop = cpu2le16(96);      // AC_VI: 96*32us ~= 3ms
			csr1.field.Ac3Txop = cpu2le16(48);      // AC_VO: 48*32us ~= 1.5ms
		}
		RTUSBWriteMACRegister(pAd, WMM_TXOP1_CFG, csr1.word);

		CwminCsr.word = 0;
		CwminCsr.field.Cwmin0 = CW_MIN_IN_BITS;
		CwminCsr.field.Cwmin1 = CW_MIN_IN_BITS;
		CwminCsr.field.Cwmin2 = CW_MIN_IN_BITS;
		CwminCsr.field.Cwmin3 = CW_MIN_IN_BITS;
		RTUSBWriteMACRegister(pAd, WMM_CWMIN_CFG, CwminCsr.word);

		CwmaxCsr.word = 0;
		CwmaxCsr.field.Cwmax0 = CW_MAX_IN_BITS;
		CwmaxCsr.field.Cwmax1 = CW_MAX_IN_BITS;
		CwmaxCsr.field.Cwmax2 = CW_MAX_IN_BITS;
		CwmaxCsr.field.Cwmax3 = CW_MAX_IN_BITS;
		RTUSBWriteMACRegister(pAd, WMM_CWMAX_CFG, CwmaxCsr.word);

		RTUSBWriteMACRegister(pAd, WMM_AIFSN_CFG, 0x00002222);

		NdisZeroMemory(&pAd->CommonCfg.APEdcaParm, sizeof(EDCA_PARM));
	}
	else
	{
		OPSTATUS_SET_FLAG(pAd, fOP_STATUS_WMM_INUSED);
		//========================================================
		//      MAC Register has a copy.
		//========================================================
		//
		// Modify Cwmin/Cwmax/Txop on queue[QID_AC_VI], Recommend by Jerry 2005/07/27
		// To degrade our VIDO Queue's throughput for WiFi WMM S3T07 Issue.
		//
		//pEdcaParm->Txop[QID_AC_VI] = pEdcaParm->Txop[QID_AC_VI] * 7 / 10;
		
		Ac0Cfg.field.AcTxop = cpu2le16(pEdcaParm->Txop[QID_AC_BE]);
		Ac0Cfg.field.Cwmin= pEdcaParm->Cwmin[QID_AC_BE];
		Ac0Cfg.field.Cwmax = pEdcaParm->Cwmax[QID_AC_BE];
		Ac0Cfg.field.Aifsn = pEdcaParm->Aifsn[QID_AC_BE];
		RTUSBWriteMACRegister(pAd, EDCA_AC0_CFG, Ac0Cfg.word);

		Ac1Cfg.field.AcTxop = cpu2le16(pEdcaParm->Txop[QID_AC_BK]);
		Ac1Cfg.field.Cwmin = pEdcaParm->Cwmin[QID_AC_BK];
		Ac1Cfg.field.Cwmax = pEdcaParm->Cwmax[QID_AC_BK];
		Ac1Cfg.field.Aifsn = pEdcaParm->Aifsn[QID_AC_BK];
		RTUSBWriteMACRegister(pAd, EDCA_AC1_CFG, Ac1Cfg.word);

		Ac2Cfg.field.AcTxop = cpu2le16(pEdcaParm->Txop[QID_AC_VI]) * 6 / 10;
		Ac2Cfg.field.Cwmin = pEdcaParm->Cwmin[QID_AC_VI];
		Ac2Cfg.field.Cwmax = pEdcaParm->Cwmax[QID_AC_VI];
		Ac2Cfg.field.Aifsn = pEdcaParm->Aifsn[QID_AC_VI] + 3;
		RTUSBWriteMACRegister(pAd, EDCA_AC2_CFG, Ac2Cfg.word);

		Ac3Cfg.field.AcTxop = cpu2le16(pEdcaParm->Txop[QID_AC_VO]);
		Ac3Cfg.field.Cwmin = pEdcaParm->Cwmin[QID_AC_VO];
		Ac3Cfg.field.Cwmax = pEdcaParm->Cwmax[QID_AC_VO];
		Ac3Cfg.field.Aifsn = pEdcaParm->Aifsn[QID_AC_VO];
		RTUSBWriteMACRegister(pAd, EDCA_AC3_CFG, Ac3Cfg.word);

		//========================================================
		//      DMA Register has a copy too.
		//========================================================

		csr0.field.Ac0Txop = cpu2le16(pEdcaParm->Txop[QID_AC_BE]);
		csr0.field.Ac1Txop = cpu2le16(pEdcaParm->Txop[QID_AC_BK]);
		RTUSBWriteMACRegister(pAd, WMM_TXOP0_CFG, csr0.word);

		csr1.field.Ac2Txop = cpu2le16(pEdcaParm->Txop[QID_AC_VI]);
		csr1.field.Ac3Txop = cpu2le16(pEdcaParm->Txop[QID_AC_VO]);
		RTUSBWriteMACRegister(pAd, WMM_TXOP1_CFG, csr1.word);

		CwminCsr.word = 0;
		CwminCsr.field.Cwmin0 = pEdcaParm->Cwmin[QID_AC_BE];
		CwminCsr.field.Cwmin1 = pEdcaParm->Cwmin[QID_AC_BK];
		CwminCsr.field.Cwmin2 = pEdcaParm->Cwmin[QID_AC_VI];
		CwminCsr.field.Cwmin3 = pEdcaParm->Cwmin[QID_AC_VO] - 1;
		RTUSBWriteMACRegister(pAd, WMM_CWMIN_CFG, CwminCsr.word);

		CwmaxCsr.word = 0;
		CwmaxCsr.field.Cwmax0 = pEdcaParm->Cwmax[QID_AC_BE];
		CwmaxCsr.field.Cwmax1 = pEdcaParm->Cwmax[QID_AC_BK];
		CwmaxCsr.field.Cwmax2 = pEdcaParm->Cwmax[QID_AC_VI];
		CwmaxCsr.field.Cwmax3 = pEdcaParm->Cwmax[QID_AC_VO];
		RTUSBWriteMACRegister(pAd, WMM_CWMAX_CFG, CwmaxCsr.word);

		AifsnCsr.word = 0;
		AifsnCsr.field.Aifsn0 = pEdcaParm->Aifsn[QID_AC_BE];
		AifsnCsr.field.Aifsn1 = pEdcaParm->Aifsn[QID_AC_BK];
		AifsnCsr.field.Aifsn2 = pEdcaParm->Aifsn[QID_AC_VI];
		AifsnCsr.field.Aifsn3 = pEdcaParm->Aifsn[QID_AC_VO] - 1;
		RTUSBWriteMACRegister(pAd, WMM_AIFSN_CFG, AifsnCsr.word);

		NdisMoveMemory(&pAd->CommonCfg.APEdcaParm, pEdcaParm, sizeof(EDCA_PARM));
		if (!ADHOC_ON(pAd))
		{
			DBGPRINT(RT_DEBUG_TRACE,("EDCA [#%d]: AIFSN CWmin CWmax  TXOP(us)  ACM\n", pEdcaParm->EdcaUpdateCount));
			DBGPRINT(RT_DEBUG_TRACE,("	  AC_BE 	%d	   %d	  %d	 %4d	 %d\n",
				pEdcaParm->Aifsn[0],
				pEdcaParm->Cwmin[0],
				pEdcaParm->Cwmax[0],
				pEdcaParm->Txop[0]<<5,
				pEdcaParm->bACM[0]));
			DBGPRINT(RT_DEBUG_TRACE,("	  AC_BK 	%d	   %d	  %d	 %4d	 %d\n",
				pEdcaParm->Aifsn[1],
				pEdcaParm->Cwmin[1],
				pEdcaParm->Cwmax[1],
				pEdcaParm->Txop[1]<<5,
				pEdcaParm->bACM[1]));
			DBGPRINT(RT_DEBUG_TRACE,("	  AC_VI 	%d	   %d	  %d	 %4d	 %d\n",
				pEdcaParm->Aifsn[2],
				pEdcaParm->Cwmin[2],
				pEdcaParm->Cwmax[2],
				pEdcaParm->Txop[2]<<5,
				pEdcaParm->bACM[2]));
			DBGPRINT(RT_DEBUG_TRACE,("	  AC_VO 	%d	   %d	  %d	 %4d	 %d\n",
				pEdcaParm->Aifsn[3],
				pEdcaParm->Cwmin[3],
				pEdcaParm->Cwmax[3],
				pEdcaParm->Txop[3]<<5,
				pEdcaParm->bACM[3]));
		}
	}
}

/*
	==========================================================================
	Description:

	IRQL = PASSIVE_LEVEL
	IRQL = DISPATCH_LEVEL
	
	==========================================================================
 */
VOID AsicSetSlotTime(
	IN PRTMP_ADAPTER pAd,
	IN BOOLEAN bUseShortSlotTime) 
{
	UINT32	SlotTime, MACReg;

	RTUSBReadMACRegister(pAd, BKOFF_SLOT_CFG, &MACReg);

	MACReg &= 0xffffff00;
	if (pAd->CommonCfg.Channel > 14)
		bUseShortSlotTime = TRUE;

	if (bUseShortSlotTime && OPSTATUS_TEST_FLAG(pAd, fOP_STATUS_SHORT_SLOT_INUSED))
		return;
	else if ((!bUseShortSlotTime) && (!OPSTATUS_TEST_FLAG(pAd, fOP_STATUS_SHORT_SLOT_INUSED)))
		return;

	if (bUseShortSlotTime)
		OPSTATUS_SET_FLAG(pAd, fOP_STATUS_SHORT_SLOT_INUSED);
	else
		OPSTATUS_CLEAR_FLAG(pAd, fOP_STATUS_SHORT_SLOT_INUSED);

	SlotTime = (bUseShortSlotTime)? 9 : 20;

	// force using short SLOT time for FAE to demo performance when TxBurst is ON
	if (pAd->CommonCfg.bEnableTxBurst)
		SlotTime = 9;
	//
	// For some reasons, always set it to short slot time.
	// 
	// ToDo: Should consider capability with 11B
	//
	if (pAd->StaCfg.BssType == BSS_ADHOC)	
		SlotTime = 20;

	MACReg += SlotTime;
	RTUSBWriteMACRegister(pAd, BKOFF_SLOT_CFG, MACReg);

	DBGPRINT(RT_DEBUG_TRACE, ("AsicSetSlotTime(=%d us)\n", SlotTime));
}

/*
	==========================================================================
	Description:
		danamic tune BBP R66 to find a balance between sensibility and 
		noise isolation

	IRQL = DISPATCH_LEVEL

	==========================================================================
 */
VOID AsicBbpTuning(
	IN PRTMP_ADAPTER pAd)
{	
	UCHAR	R66, R66UpperBound = 0x30, R66LowerBound = 0x30;
	CHAR	Rssi;

	// 2860C did not support Fase CCA, therefore can't tune
	if (pAd->BbpTuning.bEnable == FALSE) 
		return;

	RTUSBReadBBPRegister(pAd, BBP_R66, &R66);

	//
	// work as a STA
	//
	if (pAd->Mlme.CntlMachine.CurrState != CNTL_IDLE)  // no R66 tuning when SCANNING
		return;  

	Rssi = RTMPMaxRssi(pAd, pAd->StaCfg.AvgRssi, pAd->StaCfg.AvgRssi2, pAd->StaCfg.AvgRssi3);

	if (OPSTATUS_TEST_FLAG(pAd, fOP_STATUS_MEDIA_STATE_CONNECTED))
	{
		if (pAd->CommonCfg.BBPCurrentBW == BW_20)
		{// BW=20MHz
			if (Rssi <= RSSI_FOR_MID_SENSIBILITY)
			{
				if (R66 != (0x26 + GET_LNA_GAIN(pAd)))
				{
					R66 = (0x26 + GET_LNA_GAIN(pAd));
					RTUSBWriteBBPRegister(pAd, BBP_R66, R66);
				}
				if (pAd->bForcePrintRX)
					DBGPRINT(RT_DEBUG_TRACE, ("weak RSSI=%d, CCA=%ld, BW=%d, fixed R66 at 0x%x\n", 
							Rssi, pAd->RalinkCounters.OneSecFalseCCACnt, pAd->CommonCfg.BBPCurrentBW, R66));
				return;
			}
			else if (Rssi >= RSSI_FOR_MID_LOW_SENSIBILITY)
			{
				R66UpperBound = (0x26 + GET_LNA_GAIN(pAd) + 0x18);
				R66LowerBound = (0x26 + GET_LNA_GAIN(pAd));
			}

			else
			{
				R66UpperBound = (0x26 + GET_LNA_GAIN(pAd) + 0x8);
				R66LowerBound = (0x26 + GET_LNA_GAIN(pAd));
			}
		}
		else
		{// BW=40MHz
			if (Rssi <= RSSI_FOR_MID_LOW_SENSIBILITY)
			{
				if (R66 != (0x2E + GET_LNA_GAIN(pAd)))
				{
					R66 = (0x2E + GET_LNA_GAIN(pAd));
					RTUSBWriteBBPRegister(pAd, BBP_R66, R66);
				}
				if (pAd->bForcePrintRX)
					DBGPRINT(RT_DEBUG_TRACE, ("weak RSSI=%d, CCA=%ld, BW=%d, fixed R66 at 0x%x\n", 
							Rssi, pAd->RalinkCounters.OneSecFalseCCACnt, pAd->CommonCfg.BBPCurrentBW, R66));
				return;
			}
			else
			{
				R66UpperBound = (0x2E + GET_LNA_GAIN(pAd) + 0x10);
				R66LowerBound = (0x2E + GET_LNA_GAIN(pAd));
			}
		}
	}

	if (pAd->MACVersion == 0x28600100)
	{
		RTUSBWriteBBPRegister(pAd, BBP_R66, R66UpperBound);
		DBGPRINT(RT_DEBUG_TRACE, ("RSSI=%d, CCA=%ld, BW=%d, R66= 0x%x, R66LowerBound=0x%x, R66UpperBound=0x%x (Ver.C)\n",
			Rssi, pAd->RalinkCounters.OneSecFalseCCACnt, pAd->CommonCfg.BBPCurrentBW, R66, R66LowerBound, R66UpperBound));
	}
	else
	{
		// R66 is currenly in dynamic tuning range, keep dynamic tuning based on False CCA counter
		if ((pAd->RalinkCounters.OneSecFalseCCACnt > pAd->BbpTuning.FalseCcaUpperThreshold) && (R66 < R66UpperBound))
		{
		    R66 += pAd->BbpTuning.R66Delta;
	    
		    if (R66 >= R66UpperBound)
			    R66 = R66UpperBound;
    
		    RTUSBWriteBBPRegister(pAd, BBP_R66, R66);
			if (pAd->bForcePrintRX)
				DBGPRINT(RT_DEBUG_TRACE, ("RSSI=%d, CCA=%ld, BW=%d, ++R66= 0x%x\n",
						Rssi, pAd->RalinkCounters.OneSecFalseCCACnt, pAd->CommonCfg.BBPCurrentBW, R66));
		}
		else if ((pAd->RalinkCounters.OneSecFalseCCACnt < pAd->BbpTuning.FalseCcaLowerThreshold) && (R66 > R66LowerBound))
		{
			R66 -= pAd->BbpTuning.R66Delta;

			if (R66 <= R66LowerBound)
				R66 = R66LowerBound;
		
			RTUSBWriteBBPRegister(pAd, BBP_R66, R66);
			if (pAd->bForcePrintRX)
				DBGPRINT(RT_DEBUG_TRACE, ("RSSI=%d, CCA=%ld, BW=%d, --R66= 0x%x\n",
						Rssi, pAd->RalinkCounters.OneSecFalseCCACnt, pAd->CommonCfg.BBPCurrentBW, R66));
		}
		else
		{
			if (R66 > R66UpperBound)
			{
				R66 = R66UpperBound;
				RTUSBWriteBBPRegister(pAd, BBP_R66, R66);
			}

			if (R66 < R66LowerBound)
			{
				R66 = R66LowerBound;
				RTUSBWriteBBPRegister(pAd, BBP_R66, R66);
			}

			if (pAd->bForcePrintRX)
				DBGPRINT(RT_DEBUG_TRACE, ("RSSI=%d, CCA=%ld, BW=%d, R66= 0x%x, R66LowerBound=0x%x, R66UpperBound=0x%x\n",
						Rssi, pAd->RalinkCounters.OneSecFalseCCACnt, pAd->CommonCfg.BBPCurrentBW, R66, R66LowerBound, R66UpperBound));
		}
	}
}

VOID AsicUpdateWCIDAttribute(
	IN PRTMP_ADAPTER pAd,
	IN USHORT		WCID,
	IN UCHAR		BssIndex,
	IN UCHAR        CipherAlg,
	IN BOOLEAN		bUsePairewiseKeyTable)
{
	ULONG   WCIDAttri = 0;
	USHORT	offset;

	//
	// Update WCID attribute.
	// Only TxKey could update WCID attribute.
	//
	offset = MAC_WCID_ATTRIBUTE_BASE + (WCID * HW_WCID_ATTRI_SIZE);
	WCIDAttri = (BssIndex << 4) | (CipherAlg << 1) | (bUsePairewiseKeyTable);
	RTUSBWriteMACRegister(pAd, offset, WCIDAttri);
}

VOID AsicUpdateWCIDIVEIV(
	IN PRTMP_ADAPTER pAd,
	IN USHORT		WCID,
	IN ULONG        uIV,
	IN ULONG        uEIV)
{
	USHORT	offset;

	offset = PAIRWISE_IVEIV_TABLE_BASE + (WCID * HW_IVEIV_ENTRY_SIZE);

	RTUSBWriteMACRegister(pAd, offset, uIV);
	RTUSBWriteMACRegister(pAd, offset + 4, uEIV);
}

VOID AsicUpdateRxWCIDTable(
	IN PRTMP_ADAPTER pAd,
	IN USHORT		WCID,
	IN PUCHAR        pAddr)
{
	USHORT offset;
	ULONG Addr;
	
	offset = MAC_WCID_BASE + (WCID * HW_WCID_ENTRY_SIZE);	
	Addr = pAddr[0] + (pAddr[1] << 8) +(pAddr[2] << 16) +(pAddr[3] << 24);
	RTUSBWriteMACRegister(pAd, offset, Addr);
	Addr = pAddr[4] + (pAddr[5] << 8);
	RTUSBWriteMACRegister(pAd, offset + 4, Addr);	
}

// BssIndex = 0 in windows driver. Call this when under WPA auth mode.
VOID AsicAddWcidCipherEntry(
	IN PRTMP_ADAPTER pAd,
	IN UCHAR		 WCID,
	IN UCHAR		 BssIndex,
	IN UCHAR		 KeyTable,
	IN UCHAR		 CipherAlg,
	IN PUCHAR		 pAddr,
	IN CIPHER_KEY		 *pCipherKey)
{
	ULONG 	WCIDAttri;
	USHORT 	offset;
	CIPHER_KEY	CipherKey;
	
	DBGPRINT(RT_DEBUG_TRACE, ("AsicAddWcidCipherEntry===>KeyTable=%d, CipherAlg = %d\n", KeyTable, CipherAlg));
	RTMPZeroMemory(&CipherKey, sizeof(CipherKey));
	
	// WCID Attribute UDF:3, BSSIdx:3, Alg:3, Keytable:1=PAIRWISE KEY, BSSIdx is 0
	offset = MAC_WCID_ATTRIBUTE_BASE + (WCID * HW_WCID_ATTRI_SIZE);

	WCIDAttri = (CipherAlg<<1)|KeyTable;
	RTUSBWriteMACRegister(pAd, offset, WCIDAttri);

	CipherKey.CipherAlg = CipherAlg;
	
	AsicAddPairwiseKeyEntry(pAd, pAddr, WCID, pCipherKey);
}

//	IRQL = DISPATCH_LEVEL
VOID AsicAddSharedKeyEntry(
	IN PRTMP_ADAPTER pAd,
	IN UCHAR         BssIndex,
	IN UCHAR         KeyIdx,
	IN UCHAR         CipherAlg,
	IN PUCHAR        pKey,
	IN PUCHAR        pTxMic,
	IN PUCHAR        pRxMic)
{
	INT   i;
	ULONG offset;
	SHAREDKEY_MODE_STRUC csr1;
	UCHAR		KeyBuffer[MAX_LEN_OF_SHARE_KEY + (MIC_KEY_LEN * 2)];
	USHORT		KeyLen = 0;
	ULONG		WCIDAttri;
	UINT32		Value;

	DBGPRINT(RT_DEBUG_ERROR,("AsicAddSharedKeyEntry: %s key #%d\n", CipherName[CipherAlg], BssIndex*4 + KeyIdx));
	DBGPRINT_RAW(RT_DEBUG_TRACE, ("     Key ="));
	for (i = 0; i < 16; i++)
	{
		DBGPRINT_RAW(RT_DEBUG_TRACE, ("%02x:", pKey[i]));
	}
	DBGPRINT_RAW(RT_DEBUG_TRACE, ("\n"));
	if (pRxMic)
	{
		DBGPRINT_RAW(RT_DEBUG_TRACE, ("     Rx MIC Key = "));
		for (i = 0; i < 8; i++)
		{
			DBGPRINT_RAW(RT_DEBUG_TRACE, ("%02x:", pRxMic[i]));
		}
		DBGPRINT_RAW(RT_DEBUG_TRACE, ("\n"));
	}
	if (pTxMic)
	{
		DBGPRINT_RAW(RT_DEBUG_TRACE, ("     Tx MIC Key = "));
		for (i = 0; i < 8; i++)
		{
			DBGPRINT_RAW(RT_DEBUG_TRACE, ("%02x:", pTxMic[i]));
		}
		DBGPRINT_RAW(RT_DEBUG_TRACE, ("\n"));
	}


	//
	// fill key material - key + TX MIC + RX MIC
	//
	offset = SHARED_KEY_TABLE_BASE + (4*BssIndex + KeyIdx)*HW_KEY_ENTRY_SIZE;

	NdisMoveMemory(KeyBuffer, pAd->SharedKey[BSS0][KeyIdx].Key, MAX_LEN_OF_SHARE_KEY);
	KeyLen = MAX_LEN_OF_SHARE_KEY;

	if (pTxMic)
	{
		NdisMoveMemory(KeyBuffer + KeyLen, pAd->SharedKey[BSS0][KeyIdx].TxMic, MIC_KEY_LEN);
		KeyLen += MIC_KEY_LEN;
	}

	if (pRxMic)
	{
		NdisMoveMemory(KeyBuffer + KeyLen, pAd->SharedKey[BSS0][KeyIdx].RxMic, MIC_KEY_LEN);
		KeyLen += MIC_KEY_LEN;
	}

	RTUSBMultiWrite(pAd, (USHORT) offset, KeyBuffer, KeyLen);


	// WCID Attribute UDF:3, BSSIdx:3, Alg:3, Keytable:1=PAIRWISE KEY, BSSIdx is 0
	if ((CipherAlg == CIPHER_TKIP) || (CipherAlg == CIPHER_TKIP_NO_MIC) || (CipherAlg == CIPHER_AES))
		WCIDAttri = (CipherAlg<<1)|SHAREDKEYTABLE;
	else
		WCIDAttri = (CipherAlg<<1)|SHAREDKEYTABLE;
	
	offset = MAC_WCID_ATTRIBUTE_BASE;
	RTUSBWriteMACRegister(pAd, (USHORT)offset, WCIDAttri);
	RTUSBReadMACRegister(pAd, (USHORT)offset, &Value);
	DBGPRINT(RT_DEBUG_TRACE, ("MCAST_WCID : offset = %lx, WCIDAttri = %lx\n", offset, WCIDAttri));

	//
	// Update cipher algorithm. WSTA always use BSS0
	//
	RTUSBReadMACRegister(pAd, SHARED_KEY_MODE_BASE+4*(BssIndex/2), &csr1.word);
	if ((BssIndex%2) == 0)
	{
		if (KeyIdx == 0)
			csr1.field.Bss0Key0CipherAlg = CipherAlg;
		else if (KeyIdx == 1)
			csr1.field.Bss0Key1CipherAlg = CipherAlg;
		else if (KeyIdx == 2)
			csr1.field.Bss0Key2CipherAlg = CipherAlg;
		else
			csr1.field.Bss0Key3CipherAlg = CipherAlg;
	}
	else
	{
		if (KeyIdx == 0)
			csr1.field.Bss1Key0CipherAlg = CipherAlg;
		else if (KeyIdx == 1)
			csr1.field.Bss1Key1CipherAlg = CipherAlg;
		else if (KeyIdx == 2)
			csr1.field.Bss1Key2CipherAlg = CipherAlg;
		else
			csr1.field.Bss1Key3CipherAlg = CipherAlg;
	}
	RTUSBWriteMACRegister(pAd, SHARED_KEY_MODE_BASE+4*(BssIndex/2), csr1.word);

}

//	IRQL = DISPATCH_LEVEL
VOID AsicRemoveSharedKeyEntry(
	IN PRTMP_ADAPTER pAd,
	IN UCHAR         BssIndex,
	IN UCHAR         KeyIdx)
{
	SHAREDKEY_MODE_STRUC csr1;

	DBGPRINT(RT_DEBUG_TRACE,("AsicRemoveSharedKeyEntry: #%d \n", BssIndex*4 + KeyIdx));

	RTUSBReadMACRegister(pAd, SHARED_KEY_MODE_BASE+4*(BssIndex/2), &csr1.word);
	if ((BssIndex%2) == 0)
	{
		if (KeyIdx == 0)
			csr1.field.Bss0Key0CipherAlg = 0;
		else if (KeyIdx == 1)
			csr1.field.Bss0Key1CipherAlg = 0;
		else if (KeyIdx == 2)
			csr1.field.Bss0Key2CipherAlg = 0;
		else
			csr1.field.Bss0Key3CipherAlg = 0;
	}
	else
	{
		if (KeyIdx == 0)
			csr1.field.Bss1Key0CipherAlg = 0;
		else if (KeyIdx == 1)
			csr1.field.Bss1Key1CipherAlg = 0;
		else if (KeyIdx == 2)
			csr1.field.Bss1Key2CipherAlg = 0;
		else
			csr1.field.Bss1Key3CipherAlg = 0;
	}
	DBGPRINT(RT_DEBUG_TRACE,("Write: SHARED_KEY_MODE_BASE at this Bss[%d] = 0x%x \n", BssIndex, csr1.word));
	RTUSBWriteMACRegister(pAd, SHARED_KEY_MODE_BASE+4*(BssIndex/2), csr1.word);
	ASSERT(BssIndex < 4);
	ASSERT(KeyIdx < 4);

}

//	IRQL = DISPATCH_LEVEL
VOID AsicAddPairwiseKeyEntry(
	IN PRTMP_ADAPTER pAd,
	IN PUCHAR        pAddr,
	IN UCHAR		WCID,
	IN CIPHER_KEY		 *pCipherKey)
{

//	RTUSBWriteMACRegister(pAd, SEC_CSR3, csr3);
}

//	IRQL = DISPATCH_LEVEL
VOID AsicRemovePairwiseKeyEntry(
	IN PRTMP_ADAPTER pAd,
	IN UCHAR         KeyIdx)
{


}
#if 0
BOOLEAN AsicSendCommandToMcu(
	IN PRTMP_ADAPTER pAd,
	IN UCHAR		 Command,
	IN UCHAR		 Token,
	IN UCHAR		 Arg0,
	IN UCHAR		 Arg1)
{
	HOST_CMD_CSR_STRUC H2MCmd;
	H2M_MAILBOX_STRUC  H2MMailbox;
//	ULONG		value;

	RTUSBReadMACRegister(pAd, H2M_MAILBOX_CSR, &H2MMailbox.word);
	if (H2MMailbox.field.Owner == 1)
	{
		DBGPRINT_ERR(("H2M_MAILBOX still hold by MCU. command fail\n"));
		return FALSE;
	}

	H2MMailbox.field.Owner	  = 1;	   // pass ownership to MCU
	H2MMailbox.field.CmdToken = Token;
	H2MMailbox.field.HighByte = Arg1;
	H2MMailbox.field.LowByte  = Arg0;
	RTUSBWriteMACRegister(pAd, H2M_MAILBOX_CSR, H2MMailbox.word);

	H2MCmd.word 			  = 0;
	H2MCmd.field.HostCommand  = Command;
	RTUSBWriteMACRegister(pAd, HOST_CMD_CSR, H2MCmd.word);
	DBGPRINT(RT_DEBUG_TRACE, ("SW interrupt MCU (cmd=0x%02x, token=0x%02x, arg1,arg0=0x%02x,0x%02x)\n", 
			H2MCmd.field.HostCommand, Token, Arg1, Arg0));
	return TRUE;
}
#else
BOOLEAN AsicSendCommandToMcu(
	IN PRTMP_ADAPTER pAd,
	IN UCHAR		 Command,
	IN UCHAR		 Token,
	IN UCHAR		 Arg0,
	IN UCHAR		 Arg1)
{
	HOST_CMD_CSR_STRUC	H2MCmd;
	H2M_MAILBOX_STRUC	H2MMailbox;
	ULONG				i = 0;

	do
	{
		RTUSBReadMACRegister(pAd, H2M_MAILBOX_CSR, &H2MMailbox.word);
		if (H2MMailbox.field.Owner == 0)
			break;

		RTMPusecDelay(2);
		DBGPRINT(RT_DEBUG_INFO, ("AsicSendCommanToMcu::Mail box is busy\n"));
	} while(i++ < 100);

	if (i >= 100)
	{
		DBGPRINT_ERR(("H2M_MAILBOX still hold by MCU. command fail\n"));
		return FALSE;
	}

	H2MMailbox.field.Owner	  = 1;	   // pass ownership to MCU
	H2MMailbox.field.CmdToken = Token;
	H2MMailbox.field.HighByte = Arg1;
	H2MMailbox.field.LowByte  = Arg0;
	RTUSBWriteMACRegister(pAd, H2M_MAILBOX_CSR, H2MMailbox.word);

	H2MCmd.word 			  = 0;
	H2MCmd.field.HostCommand  = Command;

	RTUSBWriteMACRegister(pAd, HOST_CMD_CSR, H2MCmd.word);

	if (Command != 0x80)
	{
		DBGPRINT(RT_DEBUG_TRACE, ("SW interrupt MCU (cmd=0x%02x, token=0x%02x, arg1,arg0=0x%02x,0x%02x)\n",
			H2MCmd.field.HostCommand, Token, Arg1, Arg0));
	}
	
	return TRUE;
}
#endif
/*
	========================================================================

	Routine Description:
		Verify the support rate for different PHY type

	Arguments:
		pAd                 Pointer to our adapter

	Return Value:
		None

	IRQL = PASSIVE_LEVEL

	========================================================================
*/
VOID	RTMPCheckRates(
	IN		PRTMP_ADAPTER	pAd,
	IN OUT	UCHAR			SupRate[],
	IN OUT	UCHAR			*SupRateLen)
{
	UCHAR	RateIdx, i, j;
	UCHAR	NewRate[12], NewRateLen;
	
	NewRateLen = 0;
	
	if (pAd->CommonCfg.PhyMode == PHY_11B)
		RateIdx = 4;
//	else if ((pAd->CommonCfg.PhyMode == PHY_11BG_MIXED) && 
//		(pAd->StaCfg.BssType == BSS_ADHOC)           &&
//		(pAd->StaCfg.AdhocMode == 0))
//		RateIdx = 4;
	else
		RateIdx = 12;

	// Check for support rates exclude basic rate bit	
	for (i = 0; i < *SupRateLen; i++)
		for (j = 0; j < RateIdx; j++)
			if ((SupRate[i] & 0x7f) == RateIdTo500Kbps[j])
				NewRate[NewRateLen++] = SupRate[i];
			
	*SupRateLen = NewRateLen;
	NdisMoveMemory(SupRate, NewRate, NewRateLen);
}

/*
	========================================================================

	Routine Description:
		Verify the support rate for HT phy type

	Arguments:
		pAd 				Pointer to our adapter

	Return Value:
		FALSE if pAd->CommonCfg.SupportedHtPhy doesn't accept the pHtCapability.  (AP Mode)

	IRQL = PASSIVE_LEVEL

	========================================================================
*/
BOOLEAN 	RTMPCheckHt(
	IN		PRTMP_ADAPTER	pAd,
	IN		UCHAR	Wcid,
	IN OUT	HT_CAPABILITY_IE			*pHtCapability,
	IN OUT	ADD_HT_INFO_IE			*pAddHtInfo)
{

	// If use AMSDU, set flag.
	if (Wcid < MAX_LEN_OF_MAC_TABLE)
	{
		if (pAd->CommonCfg.DesiredHtPhy.AmsduEnable)
			CLIENT_STATUS_SET_FLAG(&pAd->MacTab.Content[Wcid], fCLIENT_STATUS_AMSDU_INUSED);
		// Save Peer Capability
		if (pHtCapability->HtCapInfo.ShortGIfor20)
			CLIENT_STATUS_SET_FLAG(&pAd->MacTab.Content[Wcid], fCLIENT_STATUS_SGI20_CAPABLE);	
		if (pHtCapability->HtCapInfo.ShortGIfor40)
			CLIENT_STATUS_SET_FLAG(&pAd->MacTab.Content[Wcid], fCLIENT_STATUS_SGI40_CAPABLE);	
		if (pHtCapability->HtCapInfo.TxSTBC)
			CLIENT_STATUS_SET_FLAG(&pAd->MacTab.Content[Wcid], fCLIENT_STATUS_TxSTBC_CAPABLE);	
		if (pHtCapability->HtCapInfo.RxSTBC)
			CLIENT_STATUS_SET_FLAG(&pAd->MacTab.Content[Wcid], fCLIENT_STATUS_RxSTBC_CAPABLE);
		if (pAd->CommonCfg.DesiredHtPhy.RdgEnable && pHtCapability->ExtHtCapInfo.RDGSupport)
			CLIENT_STATUS_SET_FLAG(&pAd->MacTab.Content[Wcid], fCLIENT_STATUS_RDG_CAPABLE);
		
		pAd->MacTab.Content[Wcid].MpduDensity = pHtCapability->HtCapParm.MpduDensity;
	}
	if ((pAd->OpMode == OPMODE_STA) && (Wcid == BSSID_WCID))
	{
		if (BaSizeArray[pHtCapability->HtCapParm.MaxRAmpduFactor] > pAd->CommonCfg.BACapability.field.TxBAWinLimit)
			pAd->MacTab.Content[Wcid].BaSizeInUse = (UCHAR)pAd->CommonCfg.BACapability.field.TxBAWinLimit;
		else
			pAd->MacTab.Content[Wcid].BaSizeInUse = BaSizeArray[pHtCapability->HtCapParm.MaxRAmpduFactor];
	}
	pAd->MlmeAux.HtCapability.MCSSet[0] = 0xff;
	pAd->MlmeAux.HtCapability.MCSSet[4] = 0x1;
	if (pAd->Antenna.field.TxPath == 2)	
	{
		pAd->MlmeAux.HtCapability.MCSSet[1] = 0xff;
	}
	else
	{
		pAd->MlmeAux.HtCapability.MCSSet[1] = 0x00;
	}

	// choose smaller setting
	if (pAd->CommonCfg.PhyMode == PHY_11ABGN_MIXED)
	{
		if (pAd->CommonCfg.Channel > 14)
			pAd->MlmeAux.HtCapability.HtCapInfo.ChannelWidth = pAddHtInfo->AddHtInfo.RecomWidth & pAd->CommonCfg.DesiredHtPhy.ChannelWidth & !pAd->NicConfig2.field.BW40MAvailForA;
		else
			pAd->MlmeAux.HtCapability.HtCapInfo.ChannelWidth = pAddHtInfo->AddHtInfo.RecomWidth & pAd->CommonCfg.DesiredHtPhy.ChannelWidth & !pAd->NicConfig2.field.BW40MAvailForG;
	}
	else
	{
		pAd->MlmeAux.HtCapability.HtCapInfo.ChannelWidth = pAddHtInfo->AddHtInfo.RecomWidth&pAd->CommonCfg.DesiredHtPhy.ChannelWidth;
	}

	DBGPRINT(RT_DEBUG_TRACE, ("RTMPCheckHt:: HtCapInfo.ChannelWidth=%d, RecomWidth=%d, DesiredHtPhy.ChannelWidth=%d, BW40MAvailForA/G=%d/%d, PhyMode=%d \n",
		pAd->MlmeAux.HtCapability.HtCapInfo.ChannelWidth, pAddHtInfo->AddHtInfo.RecomWidth, pAd->CommonCfg.DesiredHtPhy.ChannelWidth,
		pAd->NicConfig2.field.BW40MAvailForA, pAd->NicConfig2.field.BW40MAvailForG, pAd->CommonCfg.PhyMode));
	
	pAd->MlmeAux.HtCapability.HtCapInfo.GF =  (pHtCapability->HtCapInfo.GF) & (pAd->CommonCfg.DesiredHtPhy.GF);

	// Send Assoc Req with my HT capability.
	pAd->MlmeAux.HtCapability.HtCapInfo.AMsduSize =  pAd->CommonCfg.DesiredHtPhy.AmsduSize;
	pAd->MlmeAux.HtCapability.HtCapInfo.MimoPs =  pAd->CommonCfg.DesiredHtPhy.MimoPs;
	pAd->MlmeAux.HtCapability.HtCapInfo.ShortGIfor20 =  (pAd->CommonCfg.DesiredHtPhy.ShortGIfor20) & (pHtCapability->HtCapInfo.ShortGIfor20);
	pAd->MlmeAux.HtCapability.HtCapInfo.ShortGIfor40 =  (pAd->CommonCfg.DesiredHtPhy.ShortGIfor40) & (pHtCapability->HtCapInfo.ShortGIfor40);
	pAd->MlmeAux.HtCapability.HtCapInfo.TxSTBC =  (pAd->CommonCfg.DesiredHtPhy.TxSTBC)&(pHtCapability->HtCapInfo.RxSTBC);
	pAd->MlmeAux.HtCapability.HtCapInfo.RxSTBC =  (pAd->CommonCfg.DesiredHtPhy.RxSTBC)&(pHtCapability->HtCapInfo.TxSTBC);
	pAd->MlmeAux.HtCapability.HtCapParm.MaxRAmpduFactor = pAd->CommonCfg.DesiredHtPhy.MaxRAmpduFactor;
	pAd->MlmeAux.HtCapability.HtCapParm.MpduDensity = pAd->CommonCfg.HtCapability.HtCapParm.MpduDensity;
	pAd->MlmeAux.HtCapability.ExtHtCapInfo.PlusHTC = pHtCapability->ExtHtCapInfo.PlusHTC;
	
	if (pAd->CommonCfg.bRdg)
	{
		pAd->MlmeAux.HtCapability.ExtHtCapInfo.RDGSupport = pHtCapability->ExtHtCapInfo.RDGSupport;
	}
	COPY_AP_HTSETTINGS_FROM_BEACON(pAd, pHtCapability);
	return TRUE;
}

BOOLEAN		RTMPCheckAddHtInfoIe(
	IN		PRTMP_ADAPTER	pAd,
	IN OUT	ADD_HT_INFO_IE	*pAddHTInfo)
{
	INT		i;
	ADD_HTINFO		TempAddHTInfo;

	RTMPMoveMemory(&TempAddHTInfo, pAddHTInfo, SIZE_ADD_HT_INFO_IE);
	RTMPZeroMemory(pAddHTInfo, SIZE_ADD_HT_INFO_IE);

	// basic MCS that should be supported for this BSSID.
	for ( i=0 ; i< 16 ; i++)
	{
		if ((pAddHTInfo->MCSSet[i] & pAd->CommonCfg.HtCapability.MCSSet[i]) != pAddHTInfo->MCSSet[i] )
		return	FALSE;
	}

	// Check Controlled access for PSMP only. rt2860 not suppor PSMP yet.
	if (pAddHTInfo->AddHtInfo.CntlAccOnly == 1)
		return	FALSE;
		
	return	TRUE;
	
}

/*
	========================================================================

	Routine Description:
        Periodic evaluate antenna link status

	Arguments:
        pAd         - Adapter pointer



	Return Value:
		None



	========================================================================
*/
VOID AsicEvaluateRxAnt(
	IN PRTMP_ADAPTER	pAd)


{
	UCHAR	BBPR3;

	if (RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_RESET_IN_PROGRESS)	||
		RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_HALT_IN_PROGRESS)		||
		RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_RADIO_OFF)			||
		RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_NIC_NOT_EXIST))
		return;

	if (pAd->StaCfg.Psm == PWR_SAVE)
		return;

	/*if (pAd->OpMode == OPMODE_AP)
	{
		APAsicEvaluateRxAnt(pAd);
		return;
	}*/

	DBGPRINT(RT_DEBUG_INFO, ("AsicEvaluateRxAnt : RealRxPath=%d \n", pAd->Mlme.RealRxPath));
	
	RTUSBReadBBPRegister(pAd, BBP_R3, &BBPR3);
	BBPR3 &= (~0x18);
	if(pAd->Antenna.field.RxPath == 3)
	{
		BBPR3 |= (0x10);
	}
	else if(pAd->Antenna.field.RxPath == 2)
	{
		BBPR3 |= (0x8);
	}
	else if(pAd->Antenna.field.RxPath == 1)
	{
		BBPR3 |= (0x0);
	}
	RTUSBWriteBBPRegister(pAd, BBP_R3, BBPR3);

	if (OPSTATUS_TEST_FLAG(pAd, fOP_STATUS_MEDIA_STATE_CONNECTED))
	{
		ULONG	TxTotalCnt = pAd->RalinkCounters.OneSecTxNoRetryOkCount + 
								pAd->RalinkCounters.OneSecTxRetryOkCount + 
								pAd->RalinkCounters.OneSecTxFailCount;

		if (TxTotalCnt > 50)
		{
			RTMPSetTimer(pAd,&pAd->Mlme.RxAntEvalTimer, 20);
			pAd->Mlme.bLowThroughput = FALSE;
		}
		else
		{
			RTMPSetTimer(pAd,&pAd->Mlme.RxAntEvalTimer, 300);
			pAd->Mlme.bLowThroughput = TRUE;
		}
	}
}

// this timeout routine collect AvgRssi[SecondaryRxAnt] and decide the best Ant
VOID AsicRxAntEvalTimeout(
	IN PVOID SystemSpecific1, 
	IN PVOID FunctionContext, 
	IN PVOID SystemSpecific2, 
	IN PVOID SystemSpecific3) 
{
	RTMP_ADAPTER *pAd = (RTMP_ADAPTER *)FunctionContext;
	RTUSBEnqueueInternalCmd(pAd, RT_PERFORM_SOFT_DIVERSITY, NULL, 0);
}

VOID AsicRxAntEvalAction(
	IN PRTMP_ADAPTER pAd)
{
	UCHAR			BBPR3;
	CHAR			larger = -127, rssi0, rssi1, rssi2;

	if (RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_RESET_IN_PROGRESS)	||
		RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_HALT_IN_PROGRESS)		||
		RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_RADIO_OFF)			||
		RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_NIC_NOT_EXIST))
		return;

	if (pAd->StaCfg.Psm == PWR_SAVE)
		return;	

	// if the traffic is low, use average rssi as the criteria
	if (pAd->Mlme.bLowThroughput == TRUE)
	{
		rssi0 = pAd->StaCfg.LastRssi;
		rssi1 = pAd->StaCfg.LastRssi2;
		rssi2 = pAd->StaCfg.LastRssi3;
	}
	else
	{
		rssi0 = pAd->StaCfg.AvgRssi;
		rssi1 = pAd->StaCfg.AvgRssi2;
		rssi2 = pAd->StaCfg.AvgRssi3;
	}

	if (pAd->Antenna.field.RxPath == 3)
	{
		larger = max(rssi0, rssi1);

		if (larger > (rssi2 + 20))
			pAd->Mlme.RealRxPath = 2;
		else
			pAd->Mlme.RealRxPath = 3;
	}
	else if (pAd->Antenna.field.RxPath == 2)
	{
		if (rssi0 > (rssi1 + 20))
			pAd->Mlme.RealRxPath = 1;
		else
			pAd->Mlme.RealRxPath = 2;
	}

	RTUSBReadBBPRegister(pAd, BBP_R3, &BBPR3);
	BBPR3 &= (~0x18);
	if (pAd->Mlme.RealRxPath == 3)
	{
		BBPR3 |= (0x10);
	}
	else if (pAd->Mlme.RealRxPath == 2)
	{
		BBPR3 |= (0x8);
	}
	else if (pAd->Mlme.RealRxPath == 1)
	{
		BBPR3 |= (0x0);
	}
	RTUSBWriteBBPRegister(pAd, BBP_R3, BBPR3);

	if (pAd->bForcePrintRX)
		DBGPRINT(RT_DEBUG_TRACE, ("AsicRxAntEvalAction : RealRxPath=%d, AvgRssi=%d, AvgRssi2=%d, AvgRssi3=%d \n",
				pAd->Mlme.RealRxPath, rssi0, rssi1, rssi2));

}

/*
	========================================================================

	Routine Description:
		Radar detection routine

	Arguments:
		pAd     Pointer to our adapter

	Return Value:

	========================================================================
*/
VOID RadarDetectionStart(
	IN PRTMP_ADAPTER	pAd)
{
		
}

/*
	========================================================================

	Routine Description:
		Radar detection routine

	Arguments:
		pAd     Pointer to our adapter

	Return Value:
		TRUE    Found radar signal
		FALSE   Not found radar signal

	========================================================================
*/
BOOLEAN RadarDetectionStop(
	IN PRTMP_ADAPTER	pAd)
{

	return TRUE;
}

/*
	========================================================================

	Routine Description:
		Radar channel check routine

	Arguments:
		pAd     Pointer to our adapter

	Return Value:
		TRUE    need to do radar detect
		FALSE   need not to do radar detect

	========================================================================
*/
BOOLEAN RadarChannelCheck(
	IN PRTMP_ADAPTER	pAd,
	IN UCHAR			Ch)
{
	INT		i;
	UCHAR	Channel[15]={52, 56, 60, 64, 100, 104, 108, 112, 116, 120, 124, 128, 132, 136, 140};

	for (i=0; i<15; i++)
	{
		if (Ch == Channel[i])
		{
			break;
		}
	}
	
	if (i != 15)
		return TRUE;
	else
		return FALSE;
}

/*
	========================================================================

	Routine Description:
		Mlme free the in-used nonpaged memory,
		move it to the unused memory link list

	Arguments:
		pAd                 Pointer to our adapter
		AllocVa             Pointer to the base virtual address for free

	Return Value:
		None

	IRQL = PASSIVE_LEVEL
	IRQL = DISPATCH_LEVEL
	
	Note:

	========================================================================
*/
VOID    MlmeFreeMemory(
	IN PRTMP_ADAPTER pAd,
	IN PVOID         AllocVa)
{
	PMLME_MEMORY_STRUCT             pPrevious = NULL;
	PMLME_MEMORY_STRUCT             pMlmeMemoryStruct = NULL;
	UINT                            Index = 0;
	BOOLEAN                         bIsFound = FALSE;
	unsigned long   IrqFlags;
	
	DBGPRINT(RT_DEBUG_INFO, ("==> MlmeFreeMemory\n"));
	NdisAcquireSpinLock(&pAd->MemLock, IrqFlags);
	if (pAd->Mlme.MemHandler.MemRunning)
	{ 
		//Mlme memory handler is busy.
		//Move it to the Pending array for later free
		pAd->Mlme.MemHandler.MemFreePending[pAd->Mlme.MemHandler.PendingCount++] = (PULONG) AllocVa;

		DBGPRINT(RT_DEBUG_INFO, ("Mlme memory Handler Busy!! move free memory to pending list [IN:%d][UN:%d][Pending:%d]\n",
					pAd->Mlme.MemHandler.InUseCount, pAd->Mlme.MemHandler.UnUseCount, pAd->Mlme.MemHandler.PendingCount));
		DBGPRINT(RT_DEBUG_INFO, ("<== MlmeFreeMemory\n"));
		NdisReleaseSpinLock(&pAd->MemLock, IrqFlags);
		return;
	}
	else
	{
		pAd->Mlme.MemHandler.MemRunning = TRUE;
		NdisReleaseSpinLock(&pAd->MemLock, IrqFlags);
	}

	//First check is there have to free memory in the  pAd->Mlme.MemHandler.MemFreePending.
	while (pAd->Mlme.MemHandler.PendingCount > 0)
	{
		pPrevious = NULL;
		pMlmeMemoryStruct = pAd->Mlme.MemHandler.pInUseHead;
		while (pMlmeMemoryStruct)
		{
			if (pMlmeMemoryStruct->AllocVa == (PVOID) pAd->Mlme.MemHandler.MemFreePending[Index])
			{ 
				//Found virtual address in the in-used link list
				//Remove it from the memory in-used link list, and move it to the unused link list
				if (pPrevious == NULL)
					pAd->Mlme.MemHandler.pInUseHead = pAd->Mlme.MemHandler.pInUseHead->Next;
				else
					pPrevious->Next = pMlmeMemoryStruct->Next;

				if ((pAd->Mlme.MemHandler.pUnUseHead == NULL))
				{ //No head, add it as head
					pMlmeMemoryStruct->Next = NULL;
					pAd->Mlme.MemHandler.pUnUseHead = pMlmeMemoryStruct;
					pAd->Mlme.MemHandler.pUnUseTail = pAd->Mlme.MemHandler.pUnUseHead;
				}
				else
				{
					//Append it to the tail in pAd->Mlme.MemHandler.pUnUseTail
					pMlmeMemoryStruct->Next = NULL;
					pAd->Mlme.MemHandler.pUnUseTail->Next = pMlmeMemoryStruct;
					pAd->Mlme.MemHandler.pUnUseTail = pAd->Mlme.MemHandler.pUnUseTail->Next;
				}
				pAd->Mlme.MemHandler.MemFreePending[Index++] = NULL;
				pAd->Mlme.MemHandler.PendingCount--;
				pAd->Mlme.MemHandler.UnUseCount++;
				pAd->Mlme.MemHandler.InUseCount--;
				bIsFound = TRUE;
				break;
			}
			else
			{
				pPrevious = pMlmeMemoryStruct;
				pMlmeMemoryStruct = pMlmeMemoryStruct->Next;
			}
		}

		if (!bIsFound)
		{
			//This shoult not be happened! Just in case!
			DBGPRINT(RT_DEBUG_INFO, ("<Warning>Free memory faild!! memory corruption on [Va:0x%lx] not found in In-Used link list [IN:%d][UN:%d][Pending:%d]\n",
				(ULONG)pAd->Mlme.MemHandler.MemFreePending[pAd->Mlme.MemHandler.PendingCount],
				pAd->Mlme.MemHandler.InUseCount, pAd->Mlme.MemHandler.UnUseCount, pAd->Mlme.MemHandler.PendingCount));
			//lost a memory
			pAd->Mlme.MemHandler.MemFreePending[Index++] = NULL;
			pAd->Mlme.MemHandler.PendingCount--;
		}
	}

	pPrevious = NULL;
	pMlmeMemoryStruct = pAd->Mlme.MemHandler.pInUseHead;
	while (pMlmeMemoryStruct)
	{
		if (pMlmeMemoryStruct->AllocVa == AllocVa)
		{
			//Found virtual address in the in-used link list
			//Remove it from the memory in-used link list, and move it to the unused link list
			if (pPrevious == NULL)
				pAd->Mlme.MemHandler.pInUseHead = pAd->Mlme.MemHandler.pInUseHead->Next;
			else
				pPrevious->Next = pMlmeMemoryStruct->Next;

			if (pAd->Mlme.MemHandler.pUnUseHead == NULL)
			{
				pMlmeMemoryStruct->Next = NULL;
				pAd->Mlme.MemHandler.pUnUseHead = pMlmeMemoryStruct;
				pAd->Mlme.MemHandler.pUnUseTail = pMlmeMemoryStruct;
			}
			else
			{
				pMlmeMemoryStruct->Next = NULL;
				pAd->Mlme.MemHandler.pUnUseTail->Next = pMlmeMemoryStruct;
				pAd->Mlme.MemHandler.pUnUseTail = pMlmeMemoryStruct;
			}

			pAd->Mlme.MemHandler.InUseCount--;
			pAd->Mlme.MemHandler.UnUseCount++;
			DBGPRINT(RT_DEBUG_INFO, ("MlmeFreeMemory Add it to the Unused memory link List[pMlmeMemoryStruct=0x%lx][VA=0x%lx]\n", (ULONG)pMlmeMemoryStruct, (ULONG)pMlmeMemoryStruct->AllocVa));
			break;
		}
		pPrevious = pMlmeMemoryStruct;
		pMlmeMemoryStruct = pMlmeMemoryStruct->Next;
	}

	NdisAcquireSpinLock(&pAd->MemLock, IrqFlags);
	pAd->Mlme.MemHandler.MemRunning = FALSE;
	NdisReleaseSpinLock(&pAd->MemLock, IrqFlags);

	DBGPRINT(RT_DEBUG_INFO, ("<== MlmeFreeMemory [IN:%d][UN:%d][Pending:%d]\n", 
				pAd->Mlme.MemHandler.InUseCount, pAd->Mlme.MemHandler.UnUseCount, pAd->Mlme.MemHandler.PendingCount));
}

/*
	========================================================================

	Routine Description:
		Get an unused nonpaged system-space memory for use

	Arguments:
		pAd                 Pointer to our adapter
		AllocVa             Pointer to the base virtual address for later use

	Return Value:
		NDIS_STATUS_SUCCESS
		NDIS_STATUS_FAILURE
		NDIS_STATUS_RESOURCES

	IRQL = PASSIVE_LEVEL
	IRQL = DISPATCH_LEVEL
	
	Note:

	========================================================================
*/
NDIS_STATUS MlmeAllocateMemory(
	IN PRTMP_ADAPTER pAd,
	OUT PVOID        *AllocVa)
{
	NDIS_STATUS                     Status = NDIS_STATUS_SUCCESS;
	PMLME_MEMORY_STRUCT             pMlmeMemoryStruct = NULL;
	unsigned long   IrqFlags;
	
	DBGPRINT(RT_DEBUG_INFO, ("==> MlmeAllocateMemory\n"));
	NdisAcquireSpinLock(&pAd->MemLock, IrqFlags);
	if (pAd->Mlme.MemHandler.MemRunning)
	{
		DBGPRINT(RT_DEBUG_INFO, ("Mlme memory Handler Busy!!, MlmeAllocateMemory failed!!\n"));
		Status = NDIS_STATUS_FAILURE;
		DBGPRINT(RT_DEBUG_INFO, ("<== MlmeAllocateMemory\n"));
		NdisReleaseSpinLock(&pAd->MemLock, IrqFlags);
		return (Status);
	}
	else
	{
		pAd->Mlme.MemHandler.MemRunning = TRUE;
		NdisReleaseSpinLock(&pAd->MemLock, IrqFlags);
	}

	if (pAd->Mlme.MemHandler.pUnUseHead == NULL)
	{ //There are no available memory for caller use 
		Status = NDIS_STATUS_RESOURCES;
		NdisAcquireSpinLock(&pAd->MemLock, IrqFlags);
		pAd->Mlme.MemHandler.MemRunning = FALSE;
		NdisReleaseSpinLock(&pAd->MemLock, IrqFlags);
		DBGPRINT(RT_DEBUG_INFO, ("MlmeAllocateMemory, failed!! (There are no available memory in list)\n"));
		DBGPRINT(RT_DEBUG_INFO, ("<== MlmeAllocateMemory\n"));
		return (Status);
	}

	pMlmeMemoryStruct = pAd->Mlme.MemHandler.pUnUseHead;
	*AllocVa = pMlmeMemoryStruct->AllocVa;          //Saved porint to Pointer the base virtual address of the nonpaged memory for caller use.
	//Unused memory point to next available
	pAd->Mlme.MemHandler.pUnUseHead = pAd->Mlme.MemHandler.pUnUseHead->Next;
	pAd->Mlme.MemHandler.UnUseCount--;

	//Append the unused memory link list to the in-used link list tail
	if (pAd->Mlme.MemHandler.pInUseHead == NULL)
	{//no head, so current Item assign to In-use Head.
		pAd->Mlme.MemHandler.pInUseHead = pMlmeMemoryStruct;
		pAd->Mlme.MemHandler.pInUseHead->Next = NULL;
		pAd->Mlme.MemHandler.pInUseTail = pAd->Mlme.MemHandler.pInUseHead;
	}
	else
	{
		pMlmeMemoryStruct->Next = NULL;
		pAd->Mlme.MemHandler.pInUseTail->Next = pMlmeMemoryStruct;
		pAd->Mlme.MemHandler.pInUseTail = pAd->Mlme.MemHandler.pInUseTail->Next;
	}
	pAd->Mlme.MemHandler.InUseCount++;
	NdisAcquireSpinLock(&pAd->MemLock, IrqFlags);
	pAd->Mlme.MemHandler.MemRunning = FALSE;
	NdisReleaseSpinLock(&pAd->MemLock, IrqFlags);
	DBGPRINT(RT_DEBUG_INFO, ("MlmeAllocateMemory [pMlmeMemoryStruct=0x%lx][VA=0x%lx]\n", (ULONG)pMlmeMemoryStruct, (ULONG)pMlmeMemoryStruct->AllocVa));
	DBGPRINT(RT_DEBUG_INFO, ("<== MlmeAllocateMemory[IN:%d][UN:%d][Pending:%d]\n",
				pAd->Mlme.MemHandler.InUseCount, pAd->Mlme.MemHandler.UnUseCount, pAd->Mlme.MemHandler.PendingCount));

	return (Status);
}

/*
	========================================================================

	Routine Description:
		Allocates resident (nonpaged) system-space memory for MLME send frames

	Arguments:
		pAd                 Pointer to our adapter
		Number              Total nonpaged memory for use
		Size                Each nonpaged memory size

	Return Value:
		NDIS_STATUS_SUCCESS
		NDIS_STATUS_RESOURCES

	IRQL = PASSIVE_LEVEL

	Note:

	========================================================================
*/
NDIS_STATUS MlmeInitMemoryHandler(
	IN PRTMP_ADAPTER pAd,
	IN UINT  Number,
	IN UINT  Size)
{
	PMLME_MEMORY_STRUCT         Current = NULL;
	NDIS_STATUS                 Status = NDIS_STATUS_SUCCESS;
	UINT                        i;

	DBGPRINT(RT_DEBUG_INFO, ("==> MlmeInitMemory\n"));
	pAd->Mlme.MemHandler.MemoryCount = 0;
	pAd->Mlme.MemHandler.pInUseHead = NULL;
	pAd->Mlme.MemHandler.pInUseTail = NULL;
	pAd->Mlme.MemHandler.pUnUseHead = NULL;
	pAd->Mlme.MemHandler.pUnUseTail = NULL;
	pAd->Mlme.MemHandler.MemRunning = FALSE;

	//initial the memory free-pending array all to NULL;
	for (i = 0; i < MAX_MLME_HANDLER_MEMORY; i++)
		pAd->Mlme.MemHandler.MemFreePending[i] = NULL;

	//
	// Available nonpaged memory counts MAX_MLME_HANDLER_MEMORY
	//
	if (Number > MAX_MLME_HANDLER_MEMORY)
		Number = MAX_MLME_HANDLER_MEMORY;

	for (i = 0; i < Number; i++)
	{
		//Allocate a nonpaged memory for link list use.
		Status = RTMPAllocateMemory((PVOID *)&Current, sizeof(MLME_MEMORY_STRUCT));
		if (Status != NDIS_STATUS_SUCCESS)
		{
			Status = NDIS_STATUS_RESOURCES;
			break;
		}

		//Allocate a nonpaged memory for mlme use, Current->AllocVa is VirtualAddress pointer
		Status = RTMPAllocateMemory((PVOID *)&Current->AllocVa, Size);
		if (Status != NDIS_STATUS_SUCCESS)
		{
			Status = NDIS_STATUS_RESOURCES;
			//Free the nonpaged memory of the current link list
			NdisFreeMemory((VOID *)Current, sizeof(MLME_MEMORY_STRUCT), NIC_TAG);
			break;
		}
		NdisZeroMemory(Current->AllocVa, Size);

		pAd->Mlme.MemHandler.MemoryCount++;

		//build up the link list
		if (pAd->Mlme.MemHandler.pUnUseHead != NULL)
		{
			Current->Next = pAd->Mlme.MemHandler.pUnUseHead;
			pAd->Mlme.MemHandler.pUnUseHead = Current;
		}
		else
		{
			Current->Next = NULL;
			pAd->Mlme.MemHandler.pUnUseHead = Current;
		}

		if (pAd->Mlme.MemHandler.pUnUseTail == NULL)
			pAd->Mlme.MemHandler.pUnUseTail = Current;

	}

	if (pAd->Mlme.MemHandler.MemoryCount < Number)
	{
		Status = NDIS_STATUS_RESOURCES;
		DBGPRINT(RT_DEBUG_TRACE, ("MlmeInitMemory Initial failed [Require=%d, available=%d]\n", Number, pAd->Mlme.MemHandler.MemoryCount));
	}

	pAd->Mlme.MemHandler.InUseCount = 0;
	pAd->Mlme.MemHandler.UnUseCount = Number;
	pAd->Mlme.MemHandler.PendingCount = 0;
	DBGPRINT(RT_DEBUG_INFO, ("<== MlmeInitMemory\n"));
	return (Status);
}

/*
	========================================================================

	Routine Description:
		Free Mlme memory handler (link list, nonpaged memory, spin lock)

	Arguments:
		pAd                 Pointer to our adapter

	Return Value:
		None

	IRQL = PASSIVE_LEVEL

	========================================================================
*/
VOID MlmeFreeMemoryHandler(
	IN PRTMP_ADAPTER pAd)
{
	PMLME_MEMORY_STRUCT      pMlmeMemoryStruct = NULL;
//	int     i=0; //For Debug

	//Free nonpaged memory, free it in the *In-used* link list.
	while (pAd->Mlme.MemHandler.pInUseHead != NULL)
	{
		pMlmeMemoryStruct = pAd->Mlme.MemHandler.pInUseHead;
		pAd->Mlme.MemHandler.pInUseHead = pAd->Mlme.MemHandler.pInUseHead->Next;
		//Free the virtual address in AllocVa which size is MAX_LEN_OF_MLME_BUFFER
		NdisFreeMemory(pMlmeMemoryStruct->AllocVa, MAX_LEN_OF_MLME_BUFFER, 0);
		//Free the link list item self
		NdisFreeMemory(pMlmeMemoryStruct, sizeof(MLME_MEMORY_STRUCT), 0);
	}

	//Free nonpaged memory, free it in the *Unused* link list.
	while (pAd->Mlme.MemHandler.pUnUseHead != NULL)
	{
		pMlmeMemoryStruct = pAd->Mlme.MemHandler.pUnUseHead;
		pAd->Mlme.MemHandler.pUnUseHead = pAd->Mlme.MemHandler.pUnUseHead->Next;
		//Free the virtual address in AllocVa which size is MAX_LEN_OF_MLME_BUFFER
		NdisFreeMemory(pMlmeMemoryStruct->AllocVa, MAX_LEN_OF_MLME_BUFFER, 0);
		//Free the link list item self
		NdisFreeMemory(pMlmeMemoryStruct, sizeof(MLME_MEMORY_STRUCT), 0);
	}
}
/*
	========================================================================

	Routine Description:
		Verify the support rate for different PHY type

	Arguments:
		pAd 				Pointer to our adapter

	Return Value:
		None

	IRQL = PASSIVE_LEVEL

	========================================================================
*/
VOID RTMPUpdateMlmeRate(
	IN PRTMP_ADAPTER	pAd)
{
	UCHAR	MinimumRate;
	UCHAR	ProperMlmeRate = RATE_54;
	UCHAR	i, j, RateIdx = 12; //1, 2, 5.5, 11, 6, 9, 12, 18, 24, 36, 48, 54

	switch (pAd->CommonCfg.PhyMode) 
	{
		case PHY_11BG_MIXED:
		case PHY_11B:
		case PHY_11BGN_MIXED:
			MinimumRate = RATE_1;
			break;
		case PHY_11A:
		case PHY_11N:	// rt2860 need to check mlmerate for 802.11n
		case PHY_11G:	// rt2860 need to check mlmerate for 802.11n
		case PHY_11GN_MIXED:
		case PHY_11AN_MIXED:
		case PHY_11AGN_MIXED:
			MinimumRate = RATE_6;
			break;
		case PHY_11ABGN_MIXED:
		case PHY_11ABG_MIXED:
			if (pAd->CommonCfg.Channel <= 14)
			{
			   MinimumRate = RATE_1;
			}
			else
			{
				MinimumRate = RATE_6;
			}
			break;
		default: // error
			MinimumRate = RATE_1;
			break;
	}

	for (i = 0; i < pAd->MlmeAux.SupRateLen; i++)
	{
		for (j = 0; j < RateIdx; j++)
		{
			if ((pAd->MlmeAux.SupRate[i] & 0x7f) == RateIdTo500Kbps[j])
			{
				if (j < ProperMlmeRate)
					ProperMlmeRate = j;  //Zero base.
				else if (j == MinimumRate)
					ProperMlmeRate = MinimumRate;
			}			
		}

		if (ProperMlmeRate == MinimumRate)
			break;
	}

	for (i = 0; i < pAd->MlmeAux.ExtRateLen; i++)
	{
		for (j = 0; j < RateIdx; j++)
		{
			if ((pAd->MlmeAux.ExtRate[i] & 0x7f) == RateIdTo500Kbps[j])
			{
				if (j < (ProperMlmeRate))
					ProperMlmeRate = j;  //Zero base.
				else if (j == MinimumRate)
					ProperMlmeRate = MinimumRate;
			}				
		}
		
		if (ProperMlmeRate == MinimumRate)
			break;		
	}

	pAd->CommonCfg.MlmeRate = ProperMlmeRate;
	//pAd->CommonCfg.RtsRate = ProperMlmeRate;
	if (pAd->CommonCfg.MlmeRate >= RATE_6)
	{
		pAd->CommonCfg.MlmeTransmit.field.MODE = MODE_OFDM;
		pAd->CommonCfg.MlmeTransmit.field.MCS = OfdmRateToRxwiMCS[pAd->CommonCfg.MlmeRate];
	}
	else
	{
		pAd->CommonCfg.MlmeTransmit.field.MODE = MODE_CCK;
		pAd->CommonCfg.MlmeTransmit.field.MCS = pAd->CommonCfg.MlmeRate;
	}
	pAd->MacTab.Content[MCAST_WCID].HTPhyMode.word = pAd->CommonCfg.MlmeTransmit.word;
	if (pAd->CommonCfg.MlmeTransmit.field.MODE == MODE_OFDM)
		pAd->MacTab.Content[MCAST_WCID].HTPhyMode.field.MCS = OfdmRateToRxwiMCS[RATE_6];
	else
		pAd->MacTab.Content[MCAST_WCID].HTPhyMode.field.MCS = 0;
}

CHAR RTMPMaxRssi(
	IN PRTMP_ADAPTER	pAd,
	IN CHAR				Rssi0,
	IN CHAR				Rssi1,
	IN CHAR				Rssi2)
{
	CHAR		larger = -127;
	
	if (pAd->Antenna.field.RxPath == 1)
	{
		larger = Rssi0;
	}

	if (pAd->Antenna.field.RxPath >= 2)
	{
		larger = max(Rssi0, Rssi1);
	}
	
	if (pAd->Antenna.field.RxPath == 3)
	{
		larger = max(larger, Rssi2);
	}
	return larger;
}

