/*
 ***************************************************************************
 * Ralink Tech Inc.
 * 4F, No. 2 Technology 5th Rd.
 * Science-based Industrial Park
 * Hsin-chu, Taiwan, R.O.C.
 *
 * (c) Copyright 2002-2006, Ralink Technology, Inc.
 *
 * All rights reserved.	Ralink's source	code is	an unpublished work	and	the
 * use of a	copyright notice does not imply	otherwise. This	source code
 * contains	confidential trade secret material of Ralink Tech. Any attemp
 * or participation	in deciphering,	decoding, reverse engineering or in	any
 * way altering	the	source code	is stricitly prohibited, unless	the	prior
 * written consent of Ralink Technology, Inc. is obtained.
 ***************************************************************************

    Module Name:
    sta_ioctl.c

    Abstract:
    IOCTL related subroutines

    Revision History:
    Who         When          What
    --------    ----------    ----------------------------------------------
    Rory Chen   01-03-2003    created
    Rory Chen   02-14-2005    modify to support RT61
*/

#include	"rt_config.h"
#include <net/iw_handler.h>

#if WIRELESS_EXT <= 11
#ifndef SIOCDEVPRIVATE
#define SIOCDEVPRIVATE                              0x8BE0
#endif
#define SIOCIWFIRSTPRIV								SIOCDEVPRIVATE
#endif

#define RT_PRIV_IOCTL								(SIOCIWFIRSTPRIV + 0x0E) // Sync. with RT61 (for wpa_supplicant), snowpin 20070201 
#define RTPRIV_IOCTL_SET							(SIOCIWFIRSTPRIV + 0x02)

#ifdef DBG
#define RTPRIV_IOCTL_BBP                            (SIOCIWFIRSTPRIV + 0x03)
#define RTPRIV_IOCTL_MAC                            (SIOCIWFIRSTPRIV + 0x05)
#define RTPRIV_IOCTL_E2P                            (SIOCIWFIRSTPRIV + 0x07)
#endif

#define RTPRIV_IOCTL_STATISTICS                     (SIOCIWFIRSTPRIV + 0x09)
#define RTPRIV_IOCTL_ADD_PMKID_CACHE                (SIOCIWFIRSTPRIV + 0x0A)
#define RTPRIV_IOCTL_RADIUS_DATA                    (SIOCIWFIRSTPRIV + 0x0C)
#define RTPRIV_IOCTL_GSITESURVEY					(SIOCIWFIRSTPRIV + 0x0D)
#define RTPRIV_IOCTL_GET_MAC_TABLE					(SIOCIWFIRSTPRIV + 0x0F)
#define RTPRIV_IOCTL_HTINFO							(SIOCIWFIRSTPRIV + 0x11)

#ifdef DBG
extern ULONG    RTDebugLevel;
#endif

#ifndef IW_ESSID_MAX_SIZE
/* Maximum size of the ESSID and NICKN strings */
#define IW_ESSID_MAX_SIZE   		32
#endif

#define NR_WEP_KEYS 				4
#define WEP_SMALL_KEY_LEN 			(40/8)
#define WEP_LARGE_KEY_LEN 			(104/8)

#define GROUP_KEY_NO                4

extern UCHAR    CipherWpa2Template[];
extern UCHAR    CipherWpaPskTkip[];
extern UCHAR    CipherWpaPskTkipLen;

typedef struct PACKED _RT_VERSION_INFO{
    UCHAR       DriverVersionW;
    UCHAR       DriverVersionX;
    UCHAR       DriverVersionY;
    UCHAR       DriverVersionZ;
    UINT        DriverBuildYear;
    UINT        DriverBuildMonth;
    UINT        DriverBuildDay;
} RT_VERSION_INFO, *PRT_VERSION_INFO;

struct iw_priv_args privtab[] = {
{ RTPRIV_IOCTL_SET, 
  IW_PRIV_TYPE_CHAR | 1024, 0,
  "set"},

#ifdef DBG	//TODO: not ready
{ RTPRIV_IOCTL_BBP,
  IW_PRIV_TYPE_CHAR | 1024, IW_PRIV_TYPE_CHAR | 1024,
  "bbp"},
{ RTPRIV_IOCTL_MAC,
  IW_PRIV_TYPE_CHAR | 1024, IW_PRIV_TYPE_CHAR | 1024,
  "mac"}, 
{ RTPRIV_IOCTL_E2P,
  IW_PRIV_TYPE_CHAR | 1024, IW_PRIV_TYPE_CHAR | 1024,
  "e2p"},
#endif

{ RTPRIV_IOCTL_STATISTICS,
  IW_PRIV_TYPE_CHAR | 1024, IW_PRIV_TYPE_CHAR | 1024,
  "stat"}, 
{ RTPRIV_IOCTL_GSITESURVEY,
  IW_PRIV_TYPE_CHAR | 1024, IW_PRIV_TYPE_CHAR | 1024 ,
  "get_site_survey"},

{ RTPRIV_IOCTL_HTINFO,
  IW_PRIV_TYPE_CHAR | 1024, IW_PRIV_TYPE_CHAR | 1024 ,
  "get_ht"},

};

// ************************
//	Prototype
// ************************
INT Set_DriverVersion_Proc(
	IN	PRTMP_ADAPTER	pAd, 
	IN	PUCHAR			arg);

INT Set_CountryRegion_Proc(
	IN	PRTMP_ADAPTER	pAd, 
	IN	PUCHAR			arg);

INT Set_CountryRegionABand_Proc(
	IN	PRTMP_ADAPTER	pAd, 
	IN	PUCHAR			arg);

INT Set_SSID_Proc(
    IN  PRTMP_ADAPTER   pAdapter, 
    IN  PUCHAR          arg);

INT Set_WirelessMode_Proc(
    IN  PRTMP_ADAPTER   pAdapter, 
    IN  PUCHAR          arg);

INT Set_TxRate_Proc(
    IN  PRTMP_ADAPTER   pAdapter, 
    IN  PUCHAR          arg);

INT Set_Channel_Proc(
    IN  PRTMP_ADAPTER   pAdapter, 
    IN  PUCHAR          arg);

#ifdef DBG
INT	Set_Debug_Proc(
	IN	PRTMP_ADAPTER	pAd, 
	IN	PUCHAR			arg);
#endif

INT Set_BGProtection_Proc(
    IN  PRTMP_ADAPTER   pAdapter, 
    IN  PUCHAR          arg);

INT Set_TxPreamble_Proc(
    IN  PRTMP_ADAPTER   pAdapter, 
    IN  PUCHAR          arg);

INT Set_RTSThreshold_Proc(
    IN  PRTMP_ADAPTER   pAdapter, 
    IN  PUCHAR          arg);

INT Set_FragThreshold_Proc(
    IN  PRTMP_ADAPTER   pAdapter, 
    IN  PUCHAR          arg);

INT Set_TxBurst_Proc(
    IN  PRTMP_ADAPTER   pAdapter, 
    IN  PUCHAR          arg);

INT Set_AdhocModeRate_Proc(
	IN	PRTMP_ADAPTER	pAdapter, 
	IN	PUCHAR			arg);
	
#ifdef AGGREGATION_SUPPORT
INT	Set_PktAggregate_Proc(
	IN	PRTMP_ADAPTER	pAd, 
	IN	PUCHAR			arg);
#endif

#ifdef WMM_SUPPORT
INT	Set_WmmCapable_Proc(
	IN	PRTMP_ADAPTER	pAd, 
	IN	PUCHAR			arg);

INT	Set_APSDPsm_Proc(
	IN	PRTMP_ADAPTER	pAd, 
	IN	PUCHAR			arg);
#endif
	
INT	Set_IEEE80211H_Proc(
	IN	PRTMP_ADAPTER	pAd, 
	IN	PUCHAR			arg);

INT Set_NetworkType_Proc(
    IN  PRTMP_ADAPTER   pAdapter, 
    IN  PUCHAR          arg);

INT Set_AuthMode_Proc(
    IN  PRTMP_ADAPTER   pAdapter, 
    IN  PUCHAR          arg);

INT Set_EncrypType_Proc(
    IN  PRTMP_ADAPTER   pAdapter, 
    IN  PUCHAR          arg);

INT Set_DefaultKeyID_Proc(
    IN  PRTMP_ADAPTER   pAdapter, 
    IN  PUCHAR          arg);

INT Set_Key1_Proc(
    IN  PRTMP_ADAPTER   pAdapter, 
    IN  PUCHAR          arg);

INT Set_Key2_Proc(
    IN  PRTMP_ADAPTER   pAdapter, 
    IN  PUCHAR          arg);

INT Set_Key3_Proc(
    IN  PRTMP_ADAPTER   pAdapter, 
    IN  PUCHAR          arg);

INT Set_Key4_Proc(
    IN  PRTMP_ADAPTER   pAdapter, 
    IN  PUCHAR          arg);

INT Set_WPAPSK_Proc(
    IN  PRTMP_ADAPTER   pAdapter, 
    IN  PUCHAR          arg);

INT	Set_ResetStatCounter_Proc(
	IN	PRTMP_ADAPTER	pAd, 
	IN	PUCHAR			arg);

INT Set_PSMode_Proc(
    IN  PRTMP_ADAPTER   pAdapter, 
    IN  PUCHAR          arg);

#ifdef DBG
VOID RTMPIoctlBBP(
	IN	PRTMP_ADAPTER	pAdapter,
	IN	struct iwreq	*wrq);
	
VOID RTMPIoctlMAC(
	IN	PRTMP_ADAPTER	pAdapter,
	IN	struct iwreq	*wrq);

VOID RTMPIoctlE2PROM(
	IN	PRTMP_ADAPTER	pAdapter,
	IN	struct iwreq	*wrq);
#endif

INT RTMPSetInformation(
    IN  PRTMP_ADAPTER pAdapter,
    IN  OUT struct ifreq    *rq,
    IN  INT                 cmd);

INT RTMPQueryInformation(
	IN	PRTMP_ADAPTER pAdapter,
	IN	OUT struct ifreq	*rq,
	IN	INT			cmd);

VOID RTMPIoctlGetSiteSurvey(
	IN	PRTMP_ADAPTER	pAdapter, 
	IN	struct iwreq	*wrq);

VOID RTMPIoctlStatistics(
	IN	PRTMP_ADAPTER	pAd, 
	IN	struct iwreq	*wrq);
	
VOID RTMPIoctlHtInfo(
	IN	PRTMP_ADAPTER	pAd, 
	IN	struct iwreq	*wrq);

INT	Set_HtBw_Proc(
	IN	PRTMP_ADAPTER	pAd, 
	IN	PUCHAR			arg);

INT	Set_HtMcs_Proc(
	IN	PRTMP_ADAPTER	pAd, 
	IN	PUCHAR			arg);

INT	Set_HtGi_Proc(
	IN	PRTMP_ADAPTER	pAd, 
	IN	PUCHAR			arg);

INT	Set_HtOpMode_Proc(
	IN	PRTMP_ADAPTER	pAd, 
	IN	PUCHAR			arg);

INT	Set_HtStbc_Proc(
	IN	PRTMP_ADAPTER	pAd, 
	IN	PUCHAR			arg);

INT	Set_HtMpduDensity_Proc(
	IN	PRTMP_ADAPTER	pAd, 
	IN	PUCHAR			arg);

INT	Set_HtRdg_Proc(
	IN	PRTMP_ADAPTER	pAd, 
	IN	PUCHAR			arg);
	
INT	Set_HtLinkAdapt_Proc(																																																																																																																																																																																																																																																																																																																			
	IN	PRTMP_ADAPTER	pAd, 
	IN	PUCHAR			arg);

INT	Set_HtAmsdu_Proc(																																																																																																																																																																																																																																																																																																																			
	IN	PRTMP_ADAPTER	pAd, 
	IN	PUCHAR			arg);

INT	Set_HtAutoBa_Proc(
	IN	PRTMP_ADAPTER	pAd, 
	IN	PUCHAR			arg);
	
INT	SetCommonHT(
	IN	PRTMP_ADAPTER	pAd);

INT	Set_BASetup_Proc(
	IN	PRTMP_ADAPTER	pAd, 
	IN	PUCHAR			arg);

INT	Set_BAOriTearDown_Proc(
	IN	PRTMP_ADAPTER	pAd, 
	IN	PUCHAR			arg);

INT	Set_BARecTearDown_Proc(
	IN	PRTMP_ADAPTER	pAd, 
	IN	PUCHAR			arg);

INT	Set_HtMimoPs_Proc(
	IN	PRTMP_ADAPTER	pAd, 
	IN	PUCHAR			arg);
	
// ************************
	
static struct {
	CHAR *name;
	INT (*set_proc)(PRTMP_ADAPTER pAdapter, PUCHAR arg);
} *PRTMP_PRIVATE_SET_PROC, RTMP_PRIVATE_SUPPORT_PROC[] = {
	{"DriverVersion",				Set_DriverVersion_Proc},
	{"CountryRegion",				Set_CountryRegion_Proc},	
	{"CountryRegionABand",			Set_CountryRegionABand_Proc},      
	{"SSID",						Set_SSID_Proc}, 
	{"WirelessMode",				Set_WirelessMode_Proc},       
	{"TxRate",						Set_TxRate_Proc},          
	{"Channel",						Set_Channel_Proc},            
	{"BGProtection",				Set_BGProtection_Proc},
	{"TxPreamble",					Set_TxPreamble_Proc},         
	{"RTSThreshold",				Set_RTSThreshold_Proc},       
	{"FragThreshold",				Set_FragThreshold_Proc},      
	{"TxBurst",						Set_TxBurst_Proc}, 
	{"BASetup",                     Set_BASetup_Proc},
	{"BAOriTearDown",				Set_BAOriTearDown_Proc},
	{"BARecTearDown",				Set_BARecTearDown_Proc},
	{"HtBw",		                Set_HtBw_Proc},
	{"HtMcs",		                Set_HtMcs_Proc},
	{"HtGi",		                Set_HtGi_Proc},
	{"HtOpMode",		            Set_HtOpMode_Proc},
	{"HtStbc",		            	Set_HtStbc_Proc},
	{"HtMpduDensity",		        Set_HtMpduDensity_Proc},
	{"HtRdg",		        		Set_HtRdg_Proc},
	{"HtLinkAdapt",		        	Set_HtLinkAdapt_Proc},
	{"HtAmsdu",		        		Set_HtAmsdu_Proc},
	{"HtAutoBa",		        	Set_HtAutoBa_Proc},
	{"HtMimoPs",					Set_HtMimoPs_Proc},
//	{"AdhocOfdm",					Set_AdhocModeRate_Proc},
#ifdef AGGREGATION_SUPPORT	
	{"PktAggregate",				Set_PktAggregate_Proc},
#endif
#if 0 // Snowpin: 2006.07.18
	{"TurboRate",					Set_TurboRate_Proc},
#endif // if 0, snowpin
#ifdef WMM_SUPPORT
	{"WmmCapable",					Set_WmmCapable_Proc},	
//	{"APSDPsm",						Set_APSDPsm_Proc},
#endif         
//	{"ShortSlot",					Set_ShortSlot_Proc},
	{"IEEE80211H",					Set_IEEE80211H_Proc},
	{"NetworkType",                 Set_NetworkType_Proc},        
	{"AuthMode",					Set_AuthMode_Proc},           
	{"EncrypType",					Set_EncrypType_Proc},         
	{"DefaultKeyID",				Set_DefaultKeyID_Proc},       
	{"Key1",						Set_Key1_Proc},               
	{"Key2",						Set_Key2_Proc},               
	{"Key3",						Set_Key3_Proc},               
	{"Key4",						Set_Key4_Proc},               
	{"WPAPSK",						Set_WPAPSK_Proc},
	{"ResetCounter",				Set_ResetStatCounter_Proc},
	{"PSMode",                      Set_PSMode_Proc},
#ifdef DBG
	{"Debug",						Set_Debug_Proc},             
#endif        
	{NULL,}
};

static USHORT RateMCSTable[] = {
// row 0. BW = 20, GI = 800
// row 1. BW = 20, GI = 400
// row 2. BW = 40, GI = 800
// row 3. BW = 40, GI = 400
// MCS:	0	1	2	3	4	5	6	7	8	9	10	11	12	13	14	15	32(Idx=16)	33(Idx=17)
	65,	 130, 195, 260, 390, 520,  585,  650,  130, 260, 390, 520,  780,  1040, 1170, 1300, 0,  0, 	
	72,  144, 217, 289, 433, 578,  650,  722,  144, 288, 433, 577,  866,  1155, 1300, 1444, 0,  0,
	135, 270, 405, 540, 810, 1080, 1215, 1350, 270, 540, 810, 1080, 1620, 2160, 2430, 2700, 60, 390,
	150, 300, 450, 600, 900, 1200, 1350, 1500, 300, 600, 900, 1200, 1800, 2400, 2700, 3000, 67, 433,
};

static UINT32 *GetTxRate( IN	PRTMP_ADAPTER pAd)
{
	UCHAR	PhyRateMode;
	UCHAR	McsIdx;
	ULONG	ret =0;
	
	PhyRateMode = pAd->MacTab.Content[BSSID_WCID].HTPhyMode.field.MODE;

	if (pAd->MacTab.Content[BSSID_WCID].HTPhyMode.field.MCS == MCS_32)
		McsIdx = 16;
	else if (pAd->MacTab.Content[BSSID_WCID].HTPhyMode.field.MCS == MCS_AUTO)
		McsIdx = 17;
	else
		McsIdx = pAd->MacTab.Content[BSSID_WCID].HTPhyMode.field.MCS;
		
	switch(PhyRateMode)
	{			
		case MODE_HTMIX:
		case MODE_HTGREENFIELD:
			if ((pAd->MacTab.Content[BSSID_WCID].HTPhyMode.field.BW == BW_40) &&
				(pAd->MacTab.Content[BSSID_WCID].HTPhyMode.field.ShortGI == GI_400))
			{
				ret = (RateMCSTable[3*18 + McsIdx] * 100000); 
			}
			else if ((pAd->MacTab.Content[BSSID_WCID].HTPhyMode.field.BW == BW_40) &&
					 (pAd->MacTab.Content[BSSID_WCID].HTPhyMode.field.ShortGI == GI_800))
			{
				ret = (RateMCSTable[2*18 + McsIdx] * 100000); 
			}
			else if	((pAd->MacTab.Content[BSSID_WCID].HTPhyMode.field.BW == BW_20) &&
					 (pAd->MacTab.Content[BSSID_WCID].HTPhyMode.field.ShortGI == GI_400))
			{
				ret = (RateMCSTable[1*18 + McsIdx] * 100000); 
			}
			else	// BW=20, GI=800			 
			{
				ret = (RateMCSTable[McsIdx] * 100000); 
			}

			break;

		case MODE_CCK:
		case MODE_OFDM:
		default:
			ret = (RateIdTo500Kbps[pAd->CommonCfg.TxRate] * 500000);
			break;
	}

	return (UINT32 *)ret;
}

char * rtstrchr(const char * s, int c)
{
    for(; *s != (char) c; ++s)
        if (*s == '\0')
            return NULL;
    return (char *) s;
}

#if 0	// move to sta_profile.c
/**
 * rstrtok - Split a string into tokens
 * @s: The string to be searched
 * @ct: The characters to search for
 * * WARNING: strtok is deprecated, use strsep instead. However strsep is not compatible with old architecture.
 */
char * __rstrtok;
char * rstrtok(char * s,const char * ct)
{
	char *sbegin, *send;

	sbegin  = s ? s : __rstrtok;
	if (!sbegin)
	{
		return NULL;
	}

	sbegin += strspn(sbegin,ct);
	if (*sbegin == '\0')
	{
		__rstrtok = NULL;
		return( NULL );
	}

	send = strpbrk( sbegin, ct);
	if (send && *send != '\0')
		*send++ = '\0';

	__rstrtok = send;

	return (sbegin);
}
#endif

/*
This is required for LinEX2004/kernel2.6.7 to provide iwlist scanning function
*/

int
rt_ioctl_giwname(struct net_device *dev,
		   struct iw_request_info *info,
		   char *name, char *extra)
{
	strncpy(name, "RT2870 WLAN", IFNAMSIZ);
	return 0;
}

int rt_ioctl_siwfreq(struct net_device *dev,
			struct iw_request_info *info,
			struct iw_freq *freq, char *extra)
{
	PRTMP_ADAPTER pAdapter = (PRTMP_ADAPTER) dev->priv;
	POS_COOKIE pObj = (POS_COOKIE) pAdapter->OS_Cookie;
	int 	chan = -1;

	//check if the interface is down
	if (pObj->RTUSBCmdThr_pid < 0)
		return -ENETDOWN;

	if (freq->e > 1)
		return -EINVAL;

	if((freq->e == 0) && (freq->m <= 1000))
		chan = freq->m;	// Setting by channel number 
	else
		MAP_KHZ_TO_CHANNEL_ID( (freq->m /100) , chan); // Setting by frequency - search the table , like 2.412G, 2.422G, 
	pAdapter->CommonCfg.Channel = chan;
	DBGPRINT(RT_DEBUG_TRACE, ("==>rt_ioctl_siwfreq::SIOCSIWFREQ[cmd=0x%x] (Channel=%d)\n", SIOCSIWFREQ, pAdapter->CommonCfg.Channel));


	return 0;
}
int rt_ioctl_giwfreq(struct net_device *dev,
		   struct iw_request_info *info,
		   struct iw_freq *freq, char *extra)
{
	PRTMP_ADAPTER pAdapter = (PRTMP_ADAPTER) dev->priv;
	POS_COOKIE pObj = (POS_COOKIE) pAdapter->OS_Cookie;
	ULONG	m;

	//check if the interface is down
	if (pObj->RTUSBCmdThr_pid < 0)
		return -ENETDOWN;

	DBGPRINT(RT_DEBUG_TRACE,("==>rt_ioctl_giwfreq  %d\n",pAdapter->CommonCfg.Channel));
	
	MAP_CHANNEL_ID_TO_KHZ(pAdapter->CommonCfg.Channel, m);
	freq->m = m * 100;
	freq->e = 1;

	return 0;
}

int rt_ioctl_siwmode(struct net_device *dev,
		   struct iw_request_info *info,
		   __u32 *mode, char *extra)
{
	PRTMP_ADAPTER pAdapter = (PRTMP_ADAPTER) dev->priv;
	POS_COOKIE pObj = (POS_COOKIE) pAdapter->OS_Cookie;
	
	//check if the interface is down
	if (pObj->RTUSBCmdThr_pid < 0)
		return -ENETDOWN;   

	switch (*mode)
	{
		case IW_MODE_ADHOC:
			if (pAdapter->StaCfg.BssType != BSS_ADHOC)
			{	
				// Config has changed
				if (INFRA_ON(pAdapter))
				{
					RTUSBEnqueueInternalCmd(pAdapter, RT_OID_LINK_DOWN, NULL, 0);
					// First cancel linkdown timer
					DBGPRINT(RT_DEBUG_TRACE, ("NDIS_STATUS_MEDIA_DISCONNECT Event BB!\n"));							
				}

			}
			pAdapter->StaCfg.BssType = BSS_ADHOC;
			DBGPRINT(RT_DEBUG_TRACE, ("===>rt_ioctl_siwmode::SIOCSIWMODE (AD-HOC)\n"));
			break;
		case IW_MODE_INFRA:
			if (pAdapter->StaCfg.BssType != BSS_INFRA)
			{
				// Config has changed
				if (ADHOC_ON(pAdapter)) 						  
					RTUSBEnqueueInternalCmd(pAdapter, RT_OID_LINK_DOWN, NULL, 0);
			}
			pAdapter->StaCfg.BssType = BSS_INFRA;
			DBGPRINT(RT_DEBUG_TRACE, ("===>rt_ioctl_siwmode::SIOCSIWMODE (INFRA)\n"));
			break;
		default:
			DBGPRINT(RT_DEBUG_TRACE, ("===>rt_ioctl_siwmode::SIOCSIWMODE (unknown)\n"));
			return -EINVAL;
	}
	
	// Reset Ralink supplicant to not use, it will be set to start when UI set PMK key
	pAdapter->StaCfg.WpaState = SS_NOTUSE;

	return 0;
}

int rt_ioctl_giwmode(struct net_device *dev,
		   struct iw_request_info *info,
		   __u32 *mode, char *extra)
{
	PRTMP_ADAPTER pAdapter = (PRTMP_ADAPTER) dev->priv;
	POS_COOKIE pObj = (POS_COOKIE) pAdapter->OS_Cookie;

	//check if the interface is down
	if (pObj->RTUSBCmdThr_pid < 0)
		return -ENETDOWN;

	if (ADHOC_ON(pAdapter))
		*mode = IW_MODE_ADHOC;
	else if (INFRA_ON(pAdapter))
		*mode = IW_MODE_INFRA;
	else
		*mode = IW_MODE_AUTO;

	DBGPRINT(RT_DEBUG_TRACE, ("==>rt_ioctl_giwmode\n"));
	return 0;
}

int rt_ioctl_siwsens(struct net_device *dev,
		   struct iw_request_info *info,
		   char *name, char *extra)
{
	PRTMP_ADAPTER pAdapter = (PRTMP_ADAPTER) dev->priv;
	POS_COOKIE pObj = (POS_COOKIE) pAdapter->OS_Cookie;

	//check if the interface is down
	if (pObj->RTUSBCmdThr_pid < 0)
		return -ENETDOWN;

	return 0;
}

int rt_ioctl_giwsens(struct net_device *dev,
		   struct iw_request_info *info,
		   char *name, char *extra)
{
	PRTMP_ADAPTER pAdapter = (PRTMP_ADAPTER) dev->priv;
	POS_COOKIE pObj = (POS_COOKIE) pAdapter->OS_Cookie;

	//check if the interface is down
	if (pObj->RTUSBCmdThr_pid < 0)
		return -ENETDOWN;

	return 0;
}

int rt_ioctl_giwrange(struct net_device *dev,
		   struct iw_request_info *info,
		   struct iw_point *data, char *extra)
{
	PRTMP_ADAPTER pAdapter = (PRTMP_ADAPTER) dev->priv;
	struct iw_range *range = (struct iw_range *) extra;
	POS_COOKIE pObj = (POS_COOKIE) pAdapter->OS_Cookie;
	u16 val;
	int i;

	//check if the interface is down
	if (pObj->RTUSBCmdThr_pid < 0)
		return -ENETDOWN;

	DBGPRINT(RT_DEBUG_TRACE ,("===>rt_ioctl_giwrange\n"));
	data->length = sizeof(struct iw_range);
	memset(range, 0, sizeof(struct iw_range));

	range->txpower_capa = IW_TXPOW_DBM;

	if (INFRA_ON(pAdapter)||ADHOC_ON(pAdapter))
	{
		range->min_pmp = 1 * 1024;
		range->max_pmp = 65535 * 1024;
		range->min_pmt = 1 * 1024;
		range->max_pmt = 1000 * 1024;
		range->pmp_flags = IW_POWER_PERIOD;
		range->pmt_flags = IW_POWER_TIMEOUT;
		range->pm_capa = IW_POWER_PERIOD | IW_POWER_TIMEOUT |
			IW_POWER_UNICAST_R | IW_POWER_ALL_R;
	}

	range->we_version_compiled = WIRELESS_EXT;
	range->we_version_source = 14;

	range->retry_capa = IW_RETRY_LIMIT;
	range->retry_flags = IW_RETRY_LIMIT;
	range->min_retry = 0;
	range->max_retry = 255;

	range->num_channels =  pAdapter->ChannelListNum;

	val = 0;
	for (i = 1; i <= range->num_channels; i++) 
	{
		u32 m;
		range->freq[val].i = pAdapter->ChannelList[i-1].Channel;
		MAP_CHANNEL_ID_TO_KHZ(pAdapter->ChannelList[i-1].Channel, m);
		range->freq[val].m = m * 100; /* HZ */
		
		range->freq[val].e = 1;
		val++;
		if (val == IW_MAX_FREQUENCIES)
			break;
	}
	range->num_frequency = val;

	range->max_qual.qual = 100; /* what is correct max? This was not
					* documented exactly. At least
					* 69 has been observed. */
	range->max_qual.level = 0; /* dB */
	range->max_qual.noise = 0; /* dB */

	/* What would be suitable values for "average/typical" qual? */
	range->avg_qual.qual = 20;
	range->avg_qual.level = -60;
	range->avg_qual.noise = -95;
	range->sensitivity = 3;

	range->max_encoding_tokens = NR_WEP_KEYS;
	range->num_encoding_sizes = 2;
	range->encoding_size[0] = 5;
	range->encoding_size[1] = 13;

#if 0
	over2 = 0;
	len = prism2_get_datarates(dev, rates);
	range->num_bitrates = 0;
	for (i = 0; i < len; i++) {
		if (range->num_bitrates < IW_MAX_BITRATES) {
			range->bitrate[range->num_bitrates] =
				rates[i] * 500000;
			range->num_bitrates++;
		}
		if (rates[i] == 0x0b || rates[i] == 0x16)
			over2 = 1;
	}
	/* estimated maximum TCP throughput values (bps) */
	range->throughput = over2 ? 5500000 : 1500000;
#endif
	range->min_rts = 0;
	range->max_rts = 2347;
	range->min_frag = 256;
	range->max_frag = 2346;

	return 0;
}

int rt_ioctl_giwap(struct net_device *dev,
		      struct iw_request_info *info,
		      struct sockaddr *ap_addr, char *extra)
{
	PRTMP_ADAPTER pAdapter = (PRTMP_ADAPTER) dev->priv;    
	POS_COOKIE pObj = (POS_COOKIE) pAdapter->OS_Cookie;
	
	//check if the interface is down
	if (pObj->RTUSBCmdThr_pid < 0)
		return -ENETDOWN;

	if (INFRA_ON(pAdapter) || ADHOC_ON(pAdapter))
	{
		ap_addr->sa_family = ARPHRD_ETHER;
		memcpy(ap_addr->sa_data, &pAdapter->CommonCfg.Bssid, ETH_ALEN);
	}
	else
	{
		DBGPRINT(RT_DEBUG_TRACE, ("IOCTL::SIOCGIWAP(=EMPTY)\n"));
		return -ENOTCONN;
	}

	return 0;
}

/*
 * Units are in db above the noise floor. That means the
 * rssi values reported in the tx/rx descriptors in the
 * driver are the SNR expressed in db.
 *
 * If you assume that the noise floor is -95, which is an
 * excellent assumption 99.5 % of the time, then you can
 * derive the absolute signal level (i.e. -95 + rssi). 
 * There are some other slight factors to take into account
 * depending on whether the rssi measurement is from 11b,
 * 11g, or 11a.   These differences are at most 2db and
 * can be documented.
 *
 * NB: various calculations are based on the orinoco/wavelan
 *     drivers for compatibility
 */

static void set_quality(PRTMP_ADAPTER pAdapter,
                        struct iw_quality *iq, 
                        u_int rssi)
{
	UCHAR	R66;

	iq->qual = pAdapter->Mlme.ChannelQuality;

	// signal level (dBm)
#if 0
	iq->level = abs(rssi);
	iq->level += 256 - pAdapter->BbpRssiToDbmDelta;
#else
	iq->level = rssi - pAdapter->BbpRssiToDbmDelta;
#endif
	RTUSBReadBBPRegister(pAdapter, BBP_R66, &R66);
	iq->noise = R66; 	// noise level (dBm)
	iq->noise += 256 - 143;	
    
	iq->updated = pAdapter->iw_stats.qual.updated;
}

int rt_ioctl_iwaplist(struct net_device *dev,
			struct iw_request_info *info,
			struct iw_point *data, char *extra)
{
 	PRTMP_ADAPTER pAdapter = (PRTMP_ADAPTER) dev->priv;
	POS_COOKIE pObj = (POS_COOKIE) pAdapter->OS_Cookie;
	struct sockaddr addr[IW_MAX_AP];
	struct iw_quality qual[IW_MAX_AP];
	int i;

   	//check if the interface is down
	if (pObj->RTUSBCmdThr_pid < 0)
		return -ENETDOWN;

	for (i = 0; i <IW_MAX_AP ; i++)
	{
		if (i >=  pAdapter->ScanTab.BssNr)
			break;
		addr[i].sa_family = ARPHRD_ETHER;
			memcpy(addr[i].sa_data, &pAdapter->ScanTab.BssEntry[i].Bssid, MAC_ADDR_LEN);
		set_quality(pAdapter, &qual[i], pAdapter->ScanTab.BssEntry[i].Rssi);	
	}
	data->length = i;
	memcpy(extra, &addr, i*sizeof(addr[0]));
	data->flags = 1;		/* signal quality present (sort of) */
	memcpy(extra + i*sizeof(addr[0]), &qual, i*sizeof(qual[i]));

	return 0;
}

#ifdef SIOCGIWSCAN
int rt_ioctl_siwscan(struct net_device *dev,
			struct iw_request_info *info,
			struct iw_point *data, char *extra)
{
	PRTMP_ADAPTER pAdapter = (PRTMP_ADAPTER) dev->priv;
	POS_COOKIE	pObj = (POS_COOKIE) pAdapter->OS_Cookie;
	ULONG		Now;
	int Status = NDIS_STATUS_SUCCESS;

	//check if the interface is down
	if (pObj->RTUSBCmdThr_pid < 0)
		return -ENETDOWN;

	if (RTMP_TEST_FLAG(pAdapter, fRTMP_ADAPTER_BSS_SCAN_IN_PROGRESS))
		return 0;
	do{
		NdisGetSystemUpTime(&Now);

		if (pAdapter->BulkLastOneSecCount > 50)	//enough ?
		{
			DBGPRINT(RT_DEBUG_TRACE, ("!!! Heavy traffic on TX/RX ignore this set::OID_802_11_BSSID_LIST_SCAN\n"));
			pAdapter->StaCfg.ScanCnt = 99;		// Prevent auto scan triggered by this OID
			break;
		}

		if ((OPSTATUS_TEST_FLAG(pAdapter, fOP_STATUS_MEDIA_STATE_CONNECTED)) &&
			((pAdapter->CommonCfg.AuthMode == Ndis802_11AuthModeWPA) || 
			(pAdapter->CommonCfg.AuthMode == Ndis802_11AuthModeWPAPSK) ||
			(pAdapter->CommonCfg.AuthMode == Ndis802_11AuthModeWPA2) ||
			(pAdapter->CommonCfg.AuthMode == Ndis802_11AuthModeWPA2PSK)) &&
			(pAdapter->StaCfg.PortSecured == WPA_802_1X_PORT_NOT_SECURED))
		{
			DBGPRINT(RT_DEBUG_TRACE, ("!!! Link UP, Port Not Secured! ignore this set::OID_802_11_BSSID_LIST_SCAN\n"));
			pAdapter->StaCfg.ScanCnt = 99;		// Prevent auto scan triggered by this OID
			break;
		}

		if (pAdapter->Mlme.CntlMachine.CurrState != CNTL_IDLE  && (pObj->MLMEThr_pid > 0))
		{
			MlmeEnqueue(pAdapter, 
                        MLME_CNTL_STATE_MACHINE,
                        RT_CMD_RESET_MLME,
                        0,
                        NULL);	
		}

		// Reset allowed scan retries
		pAdapter->StaCfg.ScanCnt = 0;
		pAdapter->StaCfg.LastScanTime = Now;

		MlmeEnqueue(pAdapter, 
                	MLME_CNTL_STATE_MACHINE, 
            		OID_802_11_BSSID_LIST_SCAN, 
               		0, 
              		NULL);
		RTUSBMlmeUp(pAdapter);		 

		Status = NDIS_STATUS_SUCCESS;
	}while(0);
	return 0;
}

#define MAX_CUSTOM_LEN 64  
int
rt_ioctl_giwscan(struct net_device *dev,
			struct iw_request_info *info,
			struct iw_point *data, char *extra)
{

	PRTMP_ADAPTER pAdapter = (PRTMP_ADAPTER) dev->priv;
	POS_COOKIE pObj = (POS_COOKIE) pAdapter->OS_Cookie;
	int i=2, j;
	char *current_ev = extra;
	char *end_buf = extra + IW_SCAN_MAX_DATA;
	char *current_val;
	struct iw_event iwe;

#if 0   // support bit rate, extended rate, quality and last beacon timing
	//-------------------------------------------
	char custom[MAX_CUSTOM_LEN];
	char *p;	
	char SupRateLen, ExtRateLen;
	char rate, max_rate;
	int  k;
	//-------------------------------------------
#endif

   	//check if the interface is down
	if (pObj->RTUSBCmdThr_pid < 0)
		return -ENETDOWN;
	
	if (RTMP_TEST_FLAG(pAdapter, fRTMP_ADAPTER_BSS_SCAN_IN_PROGRESS))
	{
		/*
		 * Still scanning, indicate the caller should try again.
		 */
		return -EAGAIN;
	}
	for (i = 0; i < pAdapter->ScanTab.BssNr; i++) 
	{
		if (current_ev >= end_buf)
			break;
		
		//MAC address
		//================================
		memset(&iwe, 0, sizeof(iwe));
		iwe.cmd = SIOCGIWAP;
		iwe.u.ap_addr.sa_family = ARPHRD_ETHER;
		memcpy(iwe.u.ap_addr.sa_data, &pAdapter->ScanTab.BssEntry[i].Bssid, ETH_ALEN);
		current_ev = iwe_stream_add_event(current_ev,end_buf, &iwe, IW_EV_ADDR_LEN);

		//ESSID	
		//================================
		memset(&iwe, 0, sizeof(iwe));
		iwe.cmd = SIOCGIWESSID;
		iwe.u.data.length = pAdapter->ScanTab.BssEntry[i].SsidLen;
		iwe.u.data.flags = 1;
		current_ev = iwe_stream_add_point(current_ev,end_buf, &iwe, pAdapter->ScanTab.BssEntry[i].Ssid);

		
		//Network Type 
		//================================
		memset(&iwe, 0, sizeof(iwe));
		iwe.cmd = SIOCGIWMODE;
		if (pAdapter->ScanTab.BssEntry[i].BssType == Ndis802_11IBSS)
		{
			iwe.u.mode = IW_MODE_ADHOC;
		}
		else if (pAdapter->ScanTab.BssEntry[i].BssType == Ndis802_11Infrastructure)
		{
			iwe.u.mode = IW_MODE_INFRA;
		}
		else
		{
			iwe.u.mode = IW_MODE_AUTO;
		}
		iwe.len = IW_EV_UINT_LEN;
		current_ev = iwe_stream_add_event(current_ev, end_buf, &iwe,  IW_EV_UINT_LEN);

		//Channel and Frequency
		//================================
		memset(&iwe, 0, sizeof(iwe));
		iwe.cmd = SIOCGIWFREQ;
		if (INFRA_ON(pAdapter) || ADHOC_ON(pAdapter))
			iwe.u.freq.m = pAdapter->ScanTab.BssEntry[i].Channel;
		else
			iwe.u.freq.m = pAdapter->ScanTab.BssEntry[i].Channel;
		iwe.u.freq.e = 0;
		iwe.u.freq.i = 0;
		
		current_ev = iwe_stream_add_event(current_ev,end_buf, &iwe, IW_EV_FREQ_LEN);

		//Encyption key
		//================================
		memset(&iwe, 0, sizeof(iwe));
		iwe.cmd = SIOCGIWENCODE;
		if (CAP_IS_PRIVACY_ON (pAdapter->ScanTab.BssEntry[i].CapabilityInfo ))
			iwe.u.data.flags =IW_ENCODE_ENABLED | IW_ENCODE_NOKEY;
		else
			iwe.u.data.flags = IW_ENCODE_DISABLED;
	
 		current_ev = iwe_stream_add_point(current_ev, end_buf,&iwe, (char *)pAdapter->SharedKey[BSS0][(iwe.u.data.flags & IW_ENCODE_INDEX)-1].Key);

#if 1	// support bit rate
		//Bit Rate
		//================================
		memset(&iwe, 0, sizeof(iwe));
		iwe.cmd = SIOCGIWRATE;
		current_val = current_ev + IW_EV_LCP_LEN;
		//for (j = 0; j < pAdapter->ScanTab.BssEntry[i].RatesLen;j++)
		for (j = 0; j < 1;j++)
		{
			iwe.u.bitrate.value = RateIdToMbps[pAdapter->ScanTab.BssEntry[i].SupRate[i]/2] * 1000000;
			iwe.u.bitrate.disabled = 0;
			current_val = iwe_stream_add_value(current_ev,
				current_val, end_buf, &iwe, IW_EV_PARAM_LEN);
		}


#else	// support bit rate, extended rate, quality and last beacon timing        
    	// max. of displays used IW_SCAN_MAX_DATA are about 22~24 cells
		//Bit Rate
		//================================
		memset(&iwe, 0, sizeof(iwe));
		iwe.cmd = SIOCGIWRATE;
		current_val = current_ev + IW_EV_LCP_LEN;
		
		SupRateLen = pAdapter->ScanTab.BssEntry[i].SupRateLen;
		ExtRateLen = pAdapter->ScanTab.BssEntry[i].ExtRateLen;
		
		max_rate = 0;	
		p = custom;
		p += snprintf(p, MAX_CUSTOM_LEN - (p - custom), " Rates (Mb/s): ");
		for (k = 0, j = 0; k < SupRateLen; ) 
		{
			if (j < ExtRateLen && 
				((pAdapter->ScanTab.BssEntry[i].ExtRate[j] & 0x7F) < 
		 		(pAdapter->ScanTab.BssEntry[i].SupRate[k] & 0x7F)))
			{
				rate = pAdapter->ScanTab.BssEntry[i].ExtRate[j++] & 0x7F;
			}	
			else
			{
				rate = pAdapter->ScanTab.BssEntry[i].SupRate[k++] & 0x7F;				
			}
			
			if (rate > max_rate)
				max_rate = rate;
			p += snprintf(p, MAX_CUSTOM_LEN - (p - custom), 
				"%d%s ", rate >> 1, (rate & 1) ? ".5" : "");			
		}
			
		for (; j < ExtRateLen; j++) 
		{
			rate = pAdapter->ScanTab.BssEntry[i].ExtRate[j] & 0x7F;
			p += snprintf(p, MAX_CUSTOM_LEN - (p - custom), 
				      "%d%s ", rate >> 1, (rate & 1) ? ".5" : "");
			if (rate > max_rate)
				max_rate = rate;
		}		
		iwe.u.bitrate.value = max_rate * 500000;
		iwe.u.bitrate.disabled = 0;
		current_val = iwe_stream_add_value(current_ev,
			current_val, end_buf, &iwe, IW_EV_PARAM_LEN);
		if((current_val-current_ev)>IW_EV_LCP_LEN)
			current_ev = current_val;

		//Extended Rate	
		//================================
		memset(&iwe, 0, sizeof(iwe));
		iwe.cmd = IWEVCUSTOM;
		iwe.u.data.length = p - custom;
		if (iwe.u.data.length)
		{
			current_ev = iwe_stream_add_point(current_ev, end_buf, &iwe, custom);
		}
		
		//Quality Statistics
		//================================
		memset(&iwe, 0, sizeof(iwe));
		iwe.cmd = IWEVQUAL;
		set_quality(pAdapter, &iwe.u.qual, pAdapter->ScanTab.BssEntry[i].Rssi);

		current_ev = iwe_stream_add_event(current_ev, end_buf, &iwe, IW_EV_QUAL_LEN);

		//Age to display seconds since last beacon
		//================================
		memset(&iwe, 0, sizeof(iwe));		
		iwe.cmd = IWEVCUSTOM;
		p = custom;
		p += snprintf(p, MAX_CUSTOM_LEN - (p - custom),
			      " Last beacon: %lums ago", (jiffies - pAdapter->ScanTab.BssEntry[i].LastBeaconRxTime) / (HZ / 100));
		iwe.u.data.length = p - custom;
		if (iwe.u.data.length)
		{   
			current_ev = iwe_stream_add_point(current_ev, end_buf, &iwe, custom);
		}
#endif

		//================================
		memset(&iwe, 0, sizeof(iwe));

	}
	data->length = current_ev - extra;
	DBGPRINT(RT_DEBUG_TRACE ,("===>rt_ioctl_giwscan. %d(%d) BSS returned\n",i , pAdapter->ScanTab.BssNr));
	return 0;
}
#endif

int rt_ioctl_siwessid(struct net_device *dev,
			 struct iw_request_info *info,
			 struct iw_point *data, char *essid)
{
	PRTMP_ADAPTER pAdapter = (PRTMP_ADAPTER) dev->priv;
	POS_COOKIE pObj = (POS_COOKIE) pAdapter->OS_Cookie;
	NDIS_802_11_SSID	Ssid, *pSsid=NULL;

	//check if the interface is down
	if (pObj->RTUSBCmdThr_pid < 0)
		return -ENETDOWN;

	memset(&Ssid, 0x00, sizeof(NDIS_802_11_SSID));

	if (data->flags)
	{
		if (data->length > IW_ESSID_MAX_SIZE)
		{
			return -E2BIG;
		}

		memcpy(Ssid.Ssid, essid, (data->length - 1));
		Ssid.SsidLength = data->length - 1;	//minus null character.
	}
	else    // ANY ssid
	{
		Ssid.SsidLength = 0; 
		memcpy(pSsid->Ssid, "", 0);
		// reset to infra/open/none as the user set ANY ssid 
		pAdapter->StaCfg.BssType = BSS_INFRA;
		pAdapter->CommonCfg.AuthMode = Ndis802_11AuthModeOpen;
		pAdapter->CommonCfg.WepStatus  = Ndis802_11EncryptionDisabled;		    
	}
	pSsid = &Ssid;
	if ((pAdapter->Mlme.CntlMachine.CurrState != CNTL_IDLE) && (pObj->MLMEThr_pid > 0))
	{
		MlmeEnqueue(pAdapter, 
                    MLME_CNTL_STATE_MACHINE,
                    RT_CMD_RESET_MLME,
                    0,
                    NULL);		
	}

	// tell CNTL state machine to call NdisMSetInformationComplete() after completing
	// this request, because this request is initiated by NDIS.

	// To prevent some kernel thread is very low priority ...so essid copy immediately for later wpapsk counting.
	if (pAdapter->CommonCfg.AuthMode >= Ndis802_11AuthModeWPA)
	{
		NdisMoveMemory(pAdapter->MlmeAux.Ssid, Ssid.Ssid, Ssid.SsidLength);
		pAdapter->MlmeAux.SsidLen = Ssid.SsidLength;
	}

	DBGPRINT(RT_DEBUG_TRACE ,("===>rt_ioctl_siwessid:: (Ssid.SsidLength = %d, %s)\n",Ssid.SsidLength, Ssid.Ssid));

	if (pObj->MLMEThr_pid > 0)
	{
		MlmeEnqueue(pAdapter, 
					MLME_CNTL_STATE_MACHINE, 
					OID_802_11_SSID,
					sizeof(NDIS_802_11_SSID),
					(VOID *)pSsid);
	}			
	RTUSBMlmeUp(pAdapter);
		
	return 0;
}

int rt_ioctl_giwessid(struct net_device *dev,
			 struct iw_request_info *info,
			 struct iw_point *data, char *essid)
{
	PRTMP_ADAPTER pAdapter = (PRTMP_ADAPTER) dev->priv;
	POS_COOKIE pObj = (POS_COOKIE) pAdapter->OS_Cookie;

	//check if the interface is down
	if (pObj->RTUSBCmdThr_pid < 0)
		return -ENETDOWN;

	data->flags = 1;		/* active */
	if (OPSTATUS_TEST_FLAG(pAdapter, fOP_STATUS_MEDIA_STATE_CONNECTED))
	{
		DBGPRINT(RT_DEBUG_TRACE ,("MediaState is connected\n"));
		data->length = pAdapter->CommonCfg.SsidLen;
		memcpy(essid, pAdapter->CommonCfg.Ssid, pAdapter->CommonCfg.SsidLen);
		pAdapter->CommonCfg.Ssid[pAdapter->CommonCfg.SsidLen] = '\0';
		DBGPRINT(RT_DEBUG_TRACE ,("pAdapter->CommonCfg.Ssid=%s , Ssidlen = %d\n",pAdapter->CommonCfg.Ssid, pAdapter->CommonCfg.SsidLen));
	}
	else
	{//the ANY ssid was specified
		data->length  = 0;
		DBGPRINT(RT_DEBUG_TRACE ,("MediaState is not connected, ess\n"));
	}
	DBGPRINT(RT_DEBUG_TRACE ,("===>rt_ioctl_giwessid:: (Len=%d, ssid=%s...)\n", pAdapter->CommonCfg.SsidLen, pAdapter->CommonCfg.Ssid));

	return 0;

}

#if 0 //TODO: disabled temporal
int rt_ioctl_siwnickn(struct net_device *dev,
			 struct iw_request_info *info,
			 struct iw_point *data, char *nickname)
{
	PRTMP_ADAPTER pAdapter = (PRTMP_ADAPTER) dev->priv;
	POS_COOKIE pObj = (POS_COOKIE) pAdapter->OS_Cookie;

	//check if the interface is down
	if (pObj->RTUSBCmdThr_pid < 0)
        return -ENETDOWN;   

	if (data->length > IW_ESSID_MAX_SIZE)
		return -EINVAL;

	memset(pAdapter->nickn, 0, IW_ESSID_MAX_SIZE);
	memcpy(pAdapter->nickn, nickname, data->length);


	return 0;
}

int rt_ioctl_giwnickn(struct net_device *dev,
			 struct iw_request_info *info,
			 struct iw_point *data, char *nickname)
{
	PRTMP_ADAPTER pAdapter = (PRTMP_ADAPTER) dev->priv;
	POS_COOKIE pObj = (POS_COOKIE) pAdapter->OS_Cookie;

	//check if the interface is down
	if (pObj->RTUSBCmdThr_pid < 0)
		return -ENETDOWN;   

	if (data->length > strlen(pAdapter->nickn) + 1)
		data->length = strlen(pAdapter->nickn) + 1;
	if (data->length > 0) {
		memcpy(nickname, pAdapter->nickn, data->length-1);
		nickname[data->length-1] = '\0';
	}
	return 0;
}
#endif

int rt_ioctl_siwrts(struct net_device *dev,
		       struct iw_request_info *info,
		       struct iw_param *rts, char *extra)
{
	PRTMP_ADAPTER pAdapter = (PRTMP_ADAPTER) dev->priv;
	POS_COOKIE pObj = (POS_COOKIE) pAdapter->OS_Cookie;
	u16 val;
	UINT32	MacReg[4];
	PCMDHandler_TLV pTLV = (PCMDHandler_TLV)&MacReg[0];

	//check if the interface is down
	if (pObj->RTUSBCmdThr_pid < 0)
		return -ENETDOWN;
	
	if (rts->disabled)
		val = MAX_RTS_THRESHOLD;
	else if (rts->value < 0 || rts->value > MAX_RTS_THRESHOLD)
		return -EINVAL;
	else
		val = rts->value;
	
	if (val != pAdapter->CommonCfg.RtsThreshold)
		pAdapter->CommonCfg.RtsThreshold = val;

	// +++ Config ASIC RTS threshold register
	MacReg[1] = 0x20;
	MacReg[1] |= (pAdapter->CommonCfg.RtsThreshold << 8);
	pTLV->Offset = TX_RTS_CFG;
	pTLV->Length = 4;
	RTUSBEnqueueInternalCmd(pAdapter, RT_OID_MULTI_WRITE_MAC,  &MacReg[0], 8);	

	return 0;
}

int rt_ioctl_giwrts(struct net_device *dev,
		       struct iw_request_info *info,
		       struct iw_param *rts, char *extra)
{
	PRTMP_ADAPTER pAdapter = (PRTMP_ADAPTER) dev->priv;
	POS_COOKIE pObj = (POS_COOKIE) pAdapter->OS_Cookie;

	//check if the interface is down
	if (pObj->RTUSBCmdThr_pid < 0)
		return -ENETDOWN;

	rts->value = pAdapter->CommonCfg.RtsThreshold;
	rts->disabled = (rts->value == MAX_RTS_THRESHOLD);
	rts->fixed = 1;

	return 0;
}

int rt_ioctl_siwfrag(struct net_device *dev,
			struct iw_request_info *info,
			struct iw_param *frag, char *extra)
{
	PRTMP_ADAPTER pAdapter = (PRTMP_ADAPTER) dev->priv;
	POS_COOKIE pObj = (POS_COOKIE) pAdapter->OS_Cookie;
	u16 val;

	//check if the interface is down
	if (pObj->RTUSBCmdThr_pid < 0)
		return -ENETDOWN;

	if (frag->disabled) // "off"
		val = MAX_FRAG_THRESHOLD;
	else if (frag->value >= MIN_FRAG_THRESHOLD || frag->value <= MAX_FRAG_THRESHOLD)
        val = __cpu_to_le16(frag->value & ~0x1); /* even numbers only */
//	else if (frag->value == MAX_FRAG_THRESHOLD)
//	    val = MAX_FRAG_THRESHOLD;
	else
		return -EINVAL;

	pAdapter->CommonCfg.FragmentThreshold = val;
	return 0;
}

int rt_ioctl_giwfrag(struct net_device *dev,
			struct iw_request_info *info,
			struct iw_param *frag, char *extra)
{
	PRTMP_ADAPTER pAdapter = (PRTMP_ADAPTER) dev->priv;
	POS_COOKIE pObj = (POS_COOKIE) pAdapter->OS_Cookie;

	//check if the interface is down
	if (pObj->RTUSBCmdThr_pid < 0)
		return -ENETDOWN;
		
	frag->value = pAdapter->CommonCfg.FragmentThreshold;
	frag->disabled = (frag->value == MAX_FRAG_THRESHOLD);
	frag->fixed = 1;

	return 0;
}

int rt_ioctl_siwencode(struct net_device *dev,
			  struct iw_request_info *info,
			  struct iw_point *erq, char *keybuf)
{
	PRTMP_ADAPTER		pAdapter = (PRTMP_ADAPTER) dev->priv;
	POS_COOKIE			pObj = (POS_COOKIE) pAdapter->OS_Cookie;
	PNDIS_802_11_KEY	pKey = NULL;
	ULONG				TotalLen;
	int					index, i, len;
	CHAR				kid = 0;
	RT_SET_ASIC_WCID_ATTRI 	SetAsicWcidAttri;
	
	//check if the interface is down
	if (pObj->RTUSBCmdThr_pid < 0)
        	return -ENETDOWN;


	if (erq->flags & IW_ENCODE_DISABLED)
	{
		pAdapter->CommonCfg.WepStatus	= Ndis802_11WEPDisabled;
		SetAsicWcidAttri.Cipher			= CIPHER_NONE;
	}
	else
	{
		pAdapter->CommonCfg.WepStatus	= Ndis802_11WEPEnabled;
		SetAsicWcidAttri.Cipher			= CIPHER_WEP64;
	}
	pAdapter->CommonCfg.PairCipher = pAdapter->CommonCfg.WepStatus;
	pAdapter->CommonCfg.GroupCipher = pAdapter->CommonCfg.WepStatus;
	pAdapter->CommonCfg.MixedModeGroupCipher = Cipher_Type_NONE;
	
	if (erq->flags & IW_ENCODE_RESTRICTED)
		pAdapter->CommonCfg.AuthMode = Ndis802_11AuthModeShared;
	else 
		pAdapter->CommonCfg.AuthMode = Ndis802_11AuthModeOpen;

	if(pAdapter->CommonCfg.WepStatus == Ndis802_11WEPDisabled)
		pAdapter->CommonCfg.AuthMode = Ndis802_11AuthModeOpen;
    
	if ((erq->flags & IW_ENCODE_DISABLED) == 0) 
	{
		/* Enable crypto. */
		if (erq->length > IFNAMSIZ)
			return -EINVAL;

		/* Old solution to take  default key  */
		index = (erq->flags & IW_ENCODE_INDEX) ;
		if((index < 0) || (index > NR_WEP_KEYS))
			return -EINVAL;     
		DBGPRINT(RT_DEBUG_TRACE ,(" erq->flags = %x\n",erq->flags));
		
		if (index != 0)
		{
			pAdapter->CommonCfg.DefaultKeyId = index -1;
		}

		if ((erq->length == 1) && (index == 0))
		{
			/* New solution to take  default key  when old way not work, not change KeyMaterial*/
			NdisMoveMemory(&kid, keybuf, 1 );
			if((index < 0) || (index >= NR_WEP_KEYS))
				return -EINVAL; 
   
			DBGPRINT(RT_DEBUG_TRACE ,("kid = %d (1~4) , erq->length = %d\n",kid, erq->length));
			if (kid > 0)
				pAdapter->CommonCfg.DefaultKeyId = kid-1;
			else 
				pAdapter->CommonCfg.DefaultKeyId = 0;
		}
		else
		{
			DBGPRINT(RT_DEBUG_TRACE ,("kid = %d (1~4) , erq->length = %d, flags 0x%x\n", (pAdapter->CommonCfg.DefaultKeyId+1), erq->length,erq->flags));
			len = erq->length;
			if(len > WEP_LARGE_KEY_LEN)
				len = WEP_LARGE_KEY_LEN;

			if ((len == WEP_SMALL_KEY_LEN) || (len == WEP_LARGE_KEY_LEN))
			{
					
				// prepare a ndis key
				TotalLen = sizeof(NDIS_802_11_KEY) + len - 1;
				// memory allocate
				os_alloc_mem(NULL, (PUCHAR *)&pKey, TotalLen);
				if(!pKey)
					return -ENOMEM;
		
				NdisZeroMemory(pKey, TotalLen);
				pKey->Length = TotalLen;
				pKey->KeyIndex = (0x80000000 | pAdapter->CommonCfg.DefaultKeyId);
				pKey->KeyLength = len;
				for (i=0; i<6; i++)
					pKey->BSSID[i] = 0xff;
				NdisMoveMemory(pKey->KeyMaterial, keybuf, len);
	
				// need to enqueue cmd to thread
				RTUSBEnqueueCmdFromNdis(pAdapter, OID_802_11_ADD_KEY_WEP, TRUE, pKey, TotalLen);
				
			}
		}
	}
	
	if (pKey)
		os_free_mem(NULL, (PCHAR)pKey);

	DBGPRINT(RT_DEBUG_TRACE ,("==>rt_ioctl_siwencode::AuthMode=%x	WepStatus=%x\n",
		pAdapter->CommonCfg.AuthMode, pAdapter->CommonCfg.WepStatus));
		
	return 0;
}

int
rt_ioctl_giwencode(struct net_device *dev,
			  struct iw_request_info *info,
			  struct iw_point *erq, char *key)
{
	PRTMP_ADAPTER pAdapter = (PRTMP_ADAPTER) dev->priv;
	POS_COOKIE pObj = (POS_COOKIE) pAdapter->OS_Cookie;
	int kid;
	
	//check if the interface is down
	if (pObj->RTUSBCmdThr_pid < 0)
		return -ENETDOWN;
		
	kid = erq->flags & IW_ENCODE_INDEX;
	DBGPRINT(RT_DEBUG_TRACE, ("===>rt_ioctl_giwencode %d\n", erq->flags & IW_ENCODE_INDEX));

	if (pAdapter->CommonCfg.WepStatus == Ndis802_11WEPDisabled)
	{
		erq->length = 0;
		erq->flags = IW_ENCODE_DISABLED;
	} 
	else if ((kid > 0) && (kid <=4))
	{
		// copy wep key
		erq->flags = kid ;			/* NB: base 1 */
		if (erq->length > pAdapter->SharedKey[BSS0][kid-1].KeyLen)
			erq->length = pAdapter->SharedKey[BSS0][kid-1].KeyLen;
		memcpy(key, pAdapter->SharedKey[BSS0][kid-1].Key, erq->length);
		//if ((kid == pAdapter->CommonCfg.DefaultKeyId))
		//erq->flags |= IW_ENCODE_ENABLED;	/* XXX */
		if (pAdapter->CommonCfg.AuthMode == Ndis802_11AuthModeShared)
			erq->flags |= IW_ENCODE_RESTRICTED;		/* XXX */
		else
			erq->flags |= IW_ENCODE_OPEN;		/* XXX */
		
	}
	else if (kid == 0)
	{
		if (pAdapter->CommonCfg.AuthMode == Ndis802_11AuthModeShared)
			erq->flags |= IW_ENCODE_RESTRICTED;		/* XXX */
		else
			erq->flags |= IW_ENCODE_OPEN;		/* XXX */
		erq->length = pAdapter->SharedKey[BSS0][pAdapter->CommonCfg.DefaultKeyId].KeyLen;
		memcpy(key, pAdapter->SharedKey[BSS0][pAdapter->CommonCfg.DefaultKeyId].Key, erq->length);
		// copy default key ID
		if (pAdapter->CommonCfg.AuthMode == Ndis802_11AuthModeShared)
			erq->flags |= IW_ENCODE_RESTRICTED;		/* XXX */
		else
			erq->flags |= IW_ENCODE_OPEN;		/* XXX */
		erq->flags = pAdapter->CommonCfg.DefaultKeyId + 1;			/* NB: base 1 */
		erq->flags |= IW_ENCODE_ENABLED;	/* XXX */
	}
		
	return 0;

}

static int
rt_ioctl_setparam(struct net_device *dev, struct iw_request_info *info,
			 void *w, char *extra)
{
	PRTMP_ADAPTER pAdapter = (PRTMP_ADAPTER) dev->priv;
	POS_COOKIE pObj = (POS_COOKIE) pAdapter->OS_Cookie;
	char *this_char = extra;
	char *value;
	int  Status=0;
	
	//check if the interface is down
	if (pObj->RTUSBCmdThr_pid < 0)
		return -ENETDOWN;

	if (!*this_char)                                                                                                            
		return Status;                                                                                                                  
	                                                                                                                            
	if ((value = rtstrchr(this_char, '=')) != NULL)                                                                             
	    *value++ = 0;                                                                                                           
	                                                                                                                            
	if (!value)                                                                                                      
	    return Status;                                                                                                                  

	// reject setting nothing besides ANY ssid(ssidLen=0)
    if (!*value && (strcmp(this_char, "SSID") != 0))
        return Status; 
        
	for (PRTMP_PRIVATE_SET_PROC = RTMP_PRIVATE_SUPPORT_PROC; PRTMP_PRIVATE_SET_PROC->name; PRTMP_PRIVATE_SET_PROC++)            
	{                                                                                                                           
	    if (strcmp(this_char, PRTMP_PRIVATE_SET_PROC->name) == 0)                                                               
	    {						                                                                                                
	        if(!PRTMP_PRIVATE_SET_PROC->set_proc(pAdapter, value))                                                              
	        {	//FALSE:Set private failed then return Invalid argument                                                         
			    Status = -EINVAL;                                                                                               
	        }                                                                                                                   
		    break;	//Exit for loop.                                                                                        
	    }                                                                                                                       
	}                                                                                                                           
	                                                                                                                            
	if(PRTMP_PRIVATE_SET_PROC->name == NULL)                                                                                    
	{ 	//Not found argument                                                                                                     
		Status = -EINVAL;                                                                                                       
		DBGPRINT(RT_DEBUG_TRACE, ("===>rt_ioctl_setparam:: (iwpriv) Not Support Set Command [%s=%s]\n", this_char, value));
	}                                                                                                                           
  
    return Status;
}

static const iw_handler rt_handler[] =
{
	(iw_handler) NULL,			            /* SIOCSIWCOMMIT */
	(iw_handler) rt_ioctl_giwname,			/* SIOCGIWNAME  1 */
	(iw_handler) NULL,			            /* SIOCSIWNWID */
	(iw_handler) NULL,			            /* SIOCGIWNWID */
	(iw_handler) rt_ioctl_siwfreq,		    /* SIOCSIWFREQ */
	(iw_handler) rt_ioctl_giwfreq,		    /* SIOCGIWFREQ  5 */
	(iw_handler) rt_ioctl_siwmode,		    /* SIOCSIWMODE */
	(iw_handler) rt_ioctl_giwmode,		    /* SIOCGIWMODE */
	(iw_handler) NULL,		                /* SIOCSIWSENS */
	(iw_handler) NULL,		                /* SIOCGIWSENS */
	(iw_handler) NULL /* not used */,		/* SIOCSIWRANGE */
	(iw_handler) rt_ioctl_giwrange,		    /* SIOCGIWRANGE 11 */
	(iw_handler) NULL /* not used */,		/* SIOCSIWPRIV */
	(iw_handler) NULL /* kernel code */,    /* SIOCGIWPRIV */
	(iw_handler) NULL /* not used */,		/* SIOCSIWSTATS */
	(iw_handler) NULL /* kernel code */,    /* SIOCGIWSTATS f */
	(iw_handler) NULL,		                /* SIOCSIWSPY */
	(iw_handler) NULL,		                /* SIOCGIWSPY */
	(iw_handler) NULL,				        /* -- hole -- */
	(iw_handler) NULL,				        /* -- hole -- */
	(iw_handler) NULL,		                /* SIOCSIWAP */
	(iw_handler) rt_ioctl_giwap,		    /* SIOCGIWAP    0x15*/
	(iw_handler) NULL,				        /* -- hole --   0x16 */
	(iw_handler) rt_ioctl_iwaplist,		    /* SIOCGIWAPLIST */
#ifdef SIOCGIWSCAN
	(iw_handler) rt_ioctl_siwscan,		    /* SIOCSIWSCAN  0x18*/
	(iw_handler) rt_ioctl_giwscan,		    /* SIOCGIWSCAN */
#else
	(iw_handler) NULL,				        /* SIOCSIWSCAN */
	(iw_handler) NULL,				        /* SIOCGIWSCAN */
#endif /* SIOCGIWSCAN */
	(iw_handler) rt_ioctl_siwessid,		    /* SIOCSIWESSID */
	(iw_handler) rt_ioctl_giwessid,		    /* SIOCGIWESSID */
#if 0	//TODO: disabled temporal
	(iw_handler) rt_ioctl_siwnickn,		    /* SIOCSIWNICKN */
	(iw_handler) rt_ioctl_giwnickn,		    /* SIOCGIWNICKN 1d*/
#else
	(iw_handler) NULL,		    			/* SIOCSIWNICKN */
	(iw_handler) NULL,		   				/* SIOCGIWNICKN 1d*/
#endif
	(iw_handler) NULL,				        /* -- hole -- */
	(iw_handler) NULL,				        /* -- hole -- */
	(iw_handler) NULL,		                /* SIOCSIWRATE  20*/
	(iw_handler) NULL,		                /* SIOCGIWRATE */
	(iw_handler) rt_ioctl_siwrts,		    /* SIOCSIWRTS */
	(iw_handler) rt_ioctl_giwrts,		    /* SIOCGIWRTS */
	(iw_handler) rt_ioctl_siwfrag,		    /* SIOCSIWFRAG */
	(iw_handler) rt_ioctl_giwfrag,		    /* SIOCGIWFRAG  25*/
	(iw_handler) NULL,		                /* SIOCSIWTXPOW */
	(iw_handler) NULL,		                /* SIOCGIWTXPOW */
	(iw_handler) NULL,		                /* SIOCSIWRETRY */
	(iw_handler) NULL,		                /* SIOCGIWRETRY  29*/
	(iw_handler) rt_ioctl_siwencode,		/* SIOCSIWENCODE 2a*/
	(iw_handler) rt_ioctl_giwencode,		/* SIOCGIWENCODE 2b*/
	(iw_handler) NULL,		                /* SIOCSIWPOWER  2c*/
	(iw_handler) NULL,		                /* SIOCGIWPOWER  2d*/
};

static const iw_handler rt_priv_handlers[] = {
	(iw_handler) rt_ioctl_setparam,		/* SIOCWFIRSTPRIV+2 */
	(iw_handler) NULL,
};

const struct iw_handler_def rt_iw_handler_def =
{
#define	N(a)	(sizeof (a) / sizeof (a[0]))
	.standard	= (iw_handler *) rt_handler,
	.num_standard	= sizeof(rt_handler) / sizeof(iw_handler),
	.private	= (iw_handler *) rt_priv_handlers,
	.num_private		= N(rt_priv_handlers),
	.private_args	= (struct iw_priv_args *) privtab,
	.num_private_args	= N(privtab),
#if WIRELESS_EXT > 15
//	.spy_offset	= offsetof(struct hostap_interface, spy_data),
#endif /* WIRELESS_EXT > 15 */
};

INT RTMPSetInformation(
    IN  PRTMP_ADAPTER pAdapter,
    IN  OUT struct ifreq    *rq,
    IN  INT                 cmd)
{
	struct iwreq                        *wrq = (struct iwreq *) rq;
	NDIS_802_11_SSID                    Ssid, *pSsid=NULL;
	NDIS_802_11_MAC_ADDRESS             Bssid;
	RT_802_11_PHY_MODE                  PhyMode;
	RT_802_11_STA_CONFIG                StaConfig;
	NDIS_802_11_RATES                   aryRates;
	RT_802_11_PREAMBLE                  Preamble;
	NDIS_802_11_WEP_STATUS              WepStatus;
	NDIS_802_11_AUTHENTICATION_MODE     AuthMode;
	NDIS_802_11_NETWORK_INFRASTRUCTURE  BssType;
	NDIS_802_11_RTS_THRESHOLD           RtsThresh;
	NDIS_802_11_FRAGMENTATION_THRESHOLD FragThresh;
	NDIS_802_11_POWER_MODE              PowerMode;
	NDIS_802_11_TX_POWER_LEVEL          TxPowerLevel;
	PNDIS_802_11_KEY                    pKey = NULL;
	PNDIS_802_11_REMOVE_KEY             pRemoveKey = NULL;
	NDIS_802_11_CONFIGURATION           Config, *pConfig = NULL;
	NDIS_802_11_NETWORK_TYPE            NetType;
	ULONG                               Now;
	UINT32                              KeyIdx;
	INT                                 Status = NDIS_STATUS_SUCCESS;
	ULONG                               AntDiv;
//	ULONG                               PowerTemp;
	BOOLEAN                             RadioState;
	BOOLEAN                             StateMachineTouched = FALSE;
	OID_SET_HT_PHYMODE					HT_PhyMode;	//11n ,kathy
	BOOLEAN								Cancelled;
#if WPA_SUPPLICANT_SUPPORT    
	PNDIS_802_11_WEP			        pWepKey =NULL;
	PNDIS_802_11_PMKID                  pPmkId = NULL;
	BOOLEAN				                IEEE8021xState;
	BOOLEAN				                IEEE8021x_required_keys;
	BOOLEAN                             wpa_supplicant_enable;
#endif      

	switch(cmd & 0x7FFF) 
	{
		case RT_OID_802_11_COUNTRY_REGION:
			if (wrq->u.data.length < sizeof(UCHAR))
				Status = -EINVAL;
			else if (!(pAdapter->CommonCfg.CountryRegion & 0x80) && !(pAdapter->CommonCfg.CountryRegionForABand & 0x80))	// Only avaliable when EEPROM not programming
			{
				ULONG	Country;
				UCHAR	TmpPhy;

				Status = copy_from_user(&Country, wrq->u.data.pointer, wrq->u.data.length);   
				pAdapter->CommonCfg.CountryRegion = (UCHAR)(Country & 0x000000FF);
				pAdapter->CommonCfg.CountryRegionForABand = (UCHAR)((Country >> 8) & 0x000000FF);
				TmpPhy = pAdapter->CommonCfg.PhyMode;
				pAdapter->CommonCfg.PhyMode = 0xff;
				// Build all corresponding channel information
				Status = RTUSBEnqueueCmdFromNdis(pAdapter, RT_OID_802_11_SET_PHY_MODE, TRUE, &TmpPhy, sizeof(TmpPhy));
				DBGPRINT(RT_DEBUG_TRACE, ("Set::RT_OID_802_11_SET_COUNTRY_REGION (A:%d  B/G:%d)\n", pAdapter->CommonCfg.CountryRegionForABand, 
					pAdapter->CommonCfg.CountryRegion));
			}
			break;
			
		case OID_802_11_BSSID_LIST_SCAN:
			NdisGetSystemUpTime(&Now);
			DBGPRINT(RT_DEBUG_TRACE, ("Set::OID_802_11_BSSID_LIST_SCAN, TxCnt = %ld \n", pAdapter->BulkLastOneSecCount));

			if (pAdapter->BulkLastOneSecCount > 50)	// enough ?
			{
				DBGPRINT(RT_DEBUG_TRACE, ("!!! Heavy traffic on TX/RX ignore this set::OID_802_11_BSSID_LIST_SCAN\n"));
				//Status = NDIS_STATUS_SUCCESS;
				pAdapter->StaCfg.ScanCnt = 99;		// Prevent auto scan triggered by this OID
				break;
			}
			
			if ((OPSTATUS_TEST_FLAG(pAdapter, fOP_STATUS_MEDIA_STATE_CONNECTED)) &&
				((pAdapter->CommonCfg.AuthMode == Ndis802_11AuthModeWPA) || 
				(pAdapter->CommonCfg.AuthMode == Ndis802_11AuthModeWPAPSK) ||
				(pAdapter->CommonCfg.AuthMode == Ndis802_11AuthModeWPA2) ||
				(pAdapter->CommonCfg.AuthMode == Ndis802_11AuthModeWPA2PSK)) &&
				(pAdapter->StaCfg.PortSecured == WPA_802_1X_PORT_NOT_SECURED))
			{
				DBGPRINT(RT_DEBUG_TRACE, ("!!! Link UP, Port Not Secured! ignore this set::OID_802_11_BSSID_LIST_SCAN\n"));
				//Status = NDIS_STATUS_SUCCESS;
				pAdapter->StaCfg.ScanCnt = 99;		// Prevent auto scan triggered by this OID
				break;
			}

			Status = RTUSBEnqueueCmdFromNdis(pAdapter, OID_802_11_BSSID_LIST_SCAN, TRUE, NULL, 0);
			break;
			
		case OID_802_11_SSID: 
			if (wrq->u.data.length != sizeof(NDIS_802_11_SSID))
				Status = -EINVAL;
			else
			{
				Status = copy_from_user(&Ssid, wrq->u.data.pointer, wrq->u.data.length);
				pSsid = &Ssid;

				if (pSsid->SsidLength > MAX_LEN_OF_SSID)
					Status = -EINVAL;
				else
				{
					// reset SSID to null
					if (pSsid->SsidLength == 0)
					{
						memcpy(pSsid->Ssid, "", 0);
					}

					RTUSBEnqueueCmdFromNdis(pAdapter, OID_802_11_SSID, TRUE, pSsid, sizeof(NDIS_802_11_SSID));
					DBGPRINT(RT_DEBUG_TRACE, ("Set::OID_802_11_SSID (Len=%d,Ssid=%s)\n", pSsid->SsidLength, pSsid->Ssid));
				}
			}
			break;
		case OID_802_11_BSSID: 
			if (wrq->u.data.length != sizeof(NDIS_802_11_MAC_ADDRESS))
				Status	= -EINVAL;
			else
			{
				Status = copy_from_user(&Bssid, wrq->u.data.pointer, wrq->u.data.length);
		   
				RTUSBEnqueueCmdFromNdis(pAdapter, RT_OID_802_11_BSSID, TRUE, &Bssid, wrq->u.data.length);
				DBGPRINT(RT_DEBUG_TRACE, ("Set::OID_802_11_BSSID %02x:%02x:%02x:%02x:%02x:%02x\n",
					Bssid[0], Bssid[1], Bssid[2], Bssid[3], Bssid[4], Bssid[5]));
			}
			break;
			
		case RT_OID_802_11_RADIO:
			if (wrq->u.data.length != sizeof(BOOLEAN))
				Status	= -EINVAL;
			else
			{
				Status = copy_from_user(&RadioState, wrq->u.data.pointer, wrq->u.data.length);
				DBGPRINT(RT_DEBUG_TRACE, ("Set::RT_OID_802_11_RADIO (=%d)\n", RadioState));
				if (pAdapter->StaCfg.bSwRadio != RadioState)
				{
					pAdapter->StaCfg.bSwRadio = RadioState;
					if (pAdapter->StaCfg.bRadio != (pAdapter->StaCfg.bHwRadio && pAdapter->StaCfg.bSwRadio))
					{
						pAdapter->StaCfg.bRadio = (pAdapter->StaCfg.bHwRadio && pAdapter->StaCfg.bSwRadio);
						RTUSBEnqueueCmdFromNdis(pAdapter, RT_OID_SET_RADIO, TRUE, NULL, 0);
					}
				}
			}
			break;
			
		case RT_OID_802_11_PHY_MODE:
			if (wrq->u.data.length != sizeof(RT_802_11_PHY_MODE))
				Status	= -EINVAL;
			else
			{
				Status = copy_from_user(&PhyMode, wrq->u.data.pointer, wrq->u.data.length);
				RTUSBEnqueueCmdFromNdis(pAdapter, RT_OID_802_11_SET_PHY_MODE, TRUE, &PhyMode, sizeof(RT_802_11_PHY_MODE));
				DBGPRINT(RT_DEBUG_TRACE, ("Set::RT_OID_802_11_PHY_MODE (=%d)\n", PhyMode));
			}
			break;
			
		case RT_OID_802_11_STA_CONFIG:
			if (wrq->u.data.length != sizeof(RT_802_11_STA_CONFIG))
				Status	= -EINVAL;
			else
			{	
				PRT_802_11_STA_CONFIG pStaConfig = &StaConfig;
				
				Status = copy_from_user(&StaConfig, wrq->u.data.pointer, wrq->u.data.length);
				RTUSBEnqueueCmdFromNdis(pAdapter, RT_OID_802_11_SET_STA_CONFIG, TRUE, pStaConfig, sizeof(RT_802_11_STA_CONFIG));

				DBGPRINT(RT_DEBUG_TRACE, ("Set::RT_OID_802_11_SET_STA_CONFIG (Burst=%ld,BGprot=%ld,ShortSlot=%ld,Adhoc=%ld\n",
					pStaConfig->EnableTxBurst,
					pStaConfig->UseBGProtection,
					pStaConfig->UseShortSlotTime,
					pStaConfig->AdhocMode));
			}
			break;
			
		case OID_802_11_DESIRED_RATES:
			if (wrq->u.data.length != sizeof(NDIS_802_11_RATES))
				Status  = -EINVAL;
			else
			{
				Status = copy_from_user(&aryRates, wrq->u.data.pointer, wrq->u.data.length);
				DBGPRINT(RT_DEBUG_TRACE, ("Set::OID_802_11_DESIRED_RATES (%02x,%02x,%02x,%02x,%02x,%02x,%02x,%02x)\n",
					pAdapter->CommonCfg.DesireRate[0],pAdapter->CommonCfg.DesireRate[1],
					pAdapter->CommonCfg.DesireRate[2],pAdapter->CommonCfg.DesireRate[3],
					pAdapter->CommonCfg.DesireRate[4],pAdapter->CommonCfg.DesireRate[5],
					pAdapter->CommonCfg.DesireRate[6],pAdapter->CommonCfg.DesireRate[7] ));
            	// Changing DesiredRate may affect the MAX TX rate we used to TX frames out
				RTUSBEnqueueCmdFromNdis(pAdapter, RT_OID_UPDATE_TX_RATE, TRUE, aryRates, sizeof(NDIS_802_11_RATES));
			}
			break;
			
		case RT_OID_802_11_PREAMBLE:
			if (wrq->u.data.length != sizeof(RT_802_11_PREAMBLE))
				Status  = -EINVAL;
			else
			{
				Status = copy_from_user(&Preamble, wrq->u.data.pointer, wrq->u.data.length);
				if ((Preamble == Rt802_11PreambleShort) || (Preamble == Rt802_11PreambleLong) || (Preamble == Rt802_11PreambleAuto))
				{	
					RTUSBEnqueueCmdFromNdis(pAdapter, RT_OID_802_11_SET_PREAMBLE, TRUE, &Preamble, sizeof(RT_802_11_PREAMBLE));
				}
				else
				{
					Status = -EINVAL;
					break;
				}
				DBGPRINT(RT_DEBUG_TRACE, ("Set::RT_OID_802_11_PREAMBLE (=%d)\n", Preamble));
        	}
			break;
			
		case OID_802_11_WEP_STATUS:
			if (wrq->u.data.length != sizeof(NDIS_802_11_WEP_STATUS))
				Status  = -EINVAL;
			else
			{
				RT_SET_ASIC_WCID_ATTRI 	SetAsicWcidAttri;

				Status = copy_from_user(&WepStatus, wrq->u.data.pointer, wrq->u.data.length);
 				// Since TKIP, AES, WEP are all supported. It should not have any invalid setting
				if (WepStatus <= Ndis802_11Encryption3KeyAbsent)
				{
					if (pAdapter->CommonCfg.WepStatus != WepStatus)
					{
						// Config has changed
						pAdapter->bConfigChanged = TRUE;
					}
					pAdapter->CommonCfg.WepStatus = WepStatus;
					//pAdapter->CommonCfg.OrigWepStatus = WepStatus;
					pAdapter->CommonCfg.PairCipher    = WepStatus;
					pAdapter->CommonCfg.GroupCipher   = WepStatus;
					pAdapter->CommonCfg.MixedModeGroupCipher = Cipher_Type_NONE;
					

					if (pAdapter->CommonCfg.WepStatus == Ndis802_11Encryption3Enabled)
					{	
						SetAsicWcidAttri.Cipher= CIPHER_AES;
						pAdapter->CommonCfg.CipherAlg = CIPHER_AES;
					}
					else if (pAdapter->CommonCfg.WepStatus == Ndis802_11Encryption2Enabled)
					{	
						SetAsicWcidAttri.Cipher = CIPHER_TKIP;
						pAdapter->CommonCfg.CipherAlg = CIPHER_TKIP;
					}
					else if (pAdapter->CommonCfg.WepStatus == Ndis802_11Encryption1Enabled)
					{
						if (pAdapter->MacTab.Content[BSSID_WCID].PairwiseKey.KeyLen == 5)
						{
							SetAsicWcidAttri.Cipher = CIPHER_WEP64;
							pAdapter->CommonCfg.CipherAlg = CIPHER_WEP64;
						}
					
						else if (pAdapter->MacTab.Content[BSSID_WCID].PairwiseKey.KeyLen  == 13)
						{
							SetAsicWcidAttri.Cipher = CIPHER_WEP128;
							pAdapter->CommonCfg.CipherAlg = CIPHER_WEP128;
						}
						else
						{
							SetAsicWcidAttri.Cipher = CIPHER_NONE;
							pAdapter->CommonCfg.CipherAlg = CIPHER_NONE;
						}
					}
					else
					{
						pAdapter->CommonCfg.CipherAlg = CIPHER_NONE;
						SetAsicWcidAttri.Cipher = CIPHER_NONE;
					}

					// Another adhoc joining, add to our MAC table. 
					if ( pAdapter->StaCfg.BssType == BSS_ADHOC)
					{
						SetAsicWcidAttri.WCID = BSSID_WCID;
						RTUSBEnqueueInternalCmd(pAdapter, RT_CMD_SET_ASIC_WCID_CIPHER, &SetAsicWcidAttri, sizeof(RT_SET_ASIC_WCID_ATTRI));
					}
				}
				else
				{
					Status = -EINVAL;
					break;
				}						
				DBGPRINT(RT_DEBUG_TRACE, ("Set::OID_802_11_WEP_STATUS (=%d)\n",WepStatus));
			}
			break;
			
		case OID_802_11_AUTHENTICATION_MODE:
			if (wrq->u.data.length != sizeof(NDIS_802_11_AUTHENTICATION_MODE)) 
				Status  = -EINVAL;
 			else
			{
				Status = copy_from_user(&AuthMode, wrq->u.data.pointer, wrq->u.data.length);
				if (AuthMode > Ndis802_11AuthModeMax)
				{
					Status  = -EINVAL;
					break;
				}
				else
				{
					if (pAdapter->CommonCfg.AuthMode != AuthMode)
					{
						// Config has changed
						pAdapter->bConfigChanged = TRUE;
					}
					pAdapter->CommonCfg.AuthMode = AuthMode;
				}
				pAdapter->StaCfg.PortSecured = WPA_802_1X_PORT_NOT_SECURED;
				DBGPRINT(RT_DEBUG_TRACE, ("Set::OID_802_11_AUTHENTICATION_MODE (=%d) \n",pAdapter->CommonCfg.AuthMode));
			}
			break;
			
		case OID_802_11_INFRASTRUCTURE_MODE:
			if (wrq->u.data.length != sizeof(NDIS_802_11_NETWORK_INFRASTRUCTURE))
				Status  = -EINVAL;
			else
			{
				Status = copy_from_user(&BssType, wrq->u.data.pointer, wrq->u.data.length);
				if (BssType == Ndis802_11IBSS) 
				{
					if (pAdapter->StaCfg.BssType != BSS_ADHOC)
					{
						// Config has changed
						if (INFRA_ON(pAdapter))
						{
							// Set the AutoReconnectSsid to prevent it reconnect to old SSID
							// Since calling this indicate user don't want to connect to that SSID anymore.
							pAdapter->MlmeAux.AutoReconnectSsidLen= 32;
							NdisZeroMemory(pAdapter->MlmeAux.AutoReconnectSsid, pAdapter->MlmeAux.AutoReconnectSsidLen);		
							
							RTUSBEnqueueInternalCmd(pAdapter, RT_OID_LINK_DOWN, NULL, 0);
							// First cancel linkdown timer
							RTMPCancelTimer(&pAdapter->Mlme.LinkDownTimer, &Cancelled);	
						}
					}
					pAdapter->StaCfg.BssType = BSS_ADHOC;
					DBGPRINT(RT_DEBUG_TRACE, ("Set::OID_802_11_INFRASTRUCTURE_MODE (AD-HOC)\n"));
				}
				else if (BssType == Ndis802_11Infrastructure) 
				{
					if (pAdapter->StaCfg.BssType != BSS_INFRA)
					{
						if (ADHOC_ON(pAdapter))
						{
							// Set the AutoReconnectSsid to prevent it reconnect to old SSID
							// Since calling this indicate user don't want to connect to that SSID anymore.
							pAdapter->MlmeAux.AutoReconnectSsidLen= 32;
							NdisZeroMemory(pAdapter->MlmeAux.AutoReconnectSsid, pAdapter->MlmeAux.AutoReconnectSsidLen);		

							RTUSBEnqueueInternalCmd(pAdapter, RT_OID_LINK_DOWN, NULL, 0);
						}	
					}
					pAdapter->StaCfg.BssType = BSS_INFRA;
					DBGPRINT(RT_DEBUG_TRACE, ("Set::OID_802_11_INFRASTRUCTURE_MODE (INFRA)\n"));
				}
				else
				{
					Status  = -EINVAL;
					DBGPRINT(RT_DEBUG_TRACE, ("Set::OID_802_11_INFRASTRUCTURE_MODE (unknown)\n"));
				}
			}
			// Reset Ralink supplicant to not use, it will be set to start when UI set PMK key
			pAdapter->StaCfg.WpaState = SS_NOTUSE;
			break;
			
		case OID_802_11_REMOVE_WEP:
			DBGPRINT(RT_DEBUG_TRACE, ("Set::OID_802_11_REMOVE_WEP\n"));
			if (wrq->u.data.length != sizeof(NDIS_802_11_KEY_INDEX))
			{
				Status = -EINVAL;
			}
			else 
			{
				Status = copy_from_user(&KeyIdx, wrq->u.data.pointer, wrq->u.data.length);
				Status = RTUSBEnqueueCmdFromNdis(pAdapter, OID_802_11_REMOVE_WEP, TRUE, &KeyIdx, sizeof(NDIS_802_11_KEY_INDEX));
			}
			break;
			
		case RT_OID_802_11_RESET_COUNTERS:
			NdisZeroMemory(&pAdapter->WlanCounters, sizeof(COUNTER_802_11));
			NdisZeroMemory(&pAdapter->Counters8023, sizeof(COUNTER_802_3));
			NdisZeroMemory(&pAdapter->RalinkCounters, sizeof(COUNTER_RALINK));
			pAdapter->Counters8023.RxNoBuffer = 0;
			pAdapter->Counters8023.GoodReceives = 0;
			pAdapter->Counters8023.RxNoBuffer = 0;
			pAdapter->BulkOutComplete	= 0;
			pAdapter->BulkOutCompleteOther= 0;
			pAdapter->BulkOutCompleteCancel = 0;
			pAdapter->BulkOutReq = 0;
			pAdapter->BulkInReq= 0;
			pAdapter->BulkInComplete = 0;
			pAdapter->BulkInCompleteFail = 0;
			DBGPRINT(RT_DEBUG_TRACE, ("Set::RT_OID_802_11_RESET_COUNTERS \n"));
			break;
			
		case OID_802_11_RTS_THRESHOLD:
			if (wrq->u.data.length != sizeof(NDIS_802_11_RTS_THRESHOLD))
				Status  = -EINVAL;
			else
			{
				UINT32	MacReg[4];
				PCMDHandler_TLV pTLV = (PCMDHandler_TLV)&MacReg[0];
			
				Status = copy_from_user(&RtsThresh, wrq->u.data.pointer, wrq->u.data.length);
				if (RtsThresh > MAX_RTS_THRESHOLD)
					Status  = -EINVAL;
				else
					pAdapter->CommonCfg.RtsThreshold = (USHORT)RtsThresh;

				// Config ASIC RTS threshold register
				MacReg[1] = 0x20;
				MacReg[1] |= (pAdapter->CommonCfg.RtsThreshold << 8);
				pTLV->Offset = TX_RTS_CFG;
				pTLV->Length = 4;
				RTUSBEnqueueInternalCmd(pAdapter, RT_OID_MULTI_WRITE_MAC,  &MacReg[0], 8);
			}
			DBGPRINT(RT_DEBUG_TRACE, ("Set::OID_802_11_RTS_THRESHOLD (=%ld)\n",RtsThresh));
			break;
			
		case OID_802_11_FRAGMENTATION_THRESHOLD:
			if (wrq->u.data.length != sizeof(NDIS_802_11_FRAGMENTATION_THRESHOLD))
				Status  = -EINVAL;
			else
			{
				Status = copy_from_user(&FragThresh, wrq->u.data.pointer, wrq->u.data.length);
				pAdapter->CommonCfg.bUseZeroToDisableFragment = FALSE;
				if (FragThresh > MAX_FRAG_THRESHOLD || FragThresh < MIN_FRAG_THRESHOLD)
				{
					if (FragThresh == 0)
					{
						pAdapter->CommonCfg.FragmentThreshold = MAX_FRAG_THRESHOLD;
						pAdapter->CommonCfg.bUseZeroToDisableFragment = TRUE;
					}
					else
						Status  = -EINVAL;
				}
				else
					pAdapter->CommonCfg.FragmentThreshold = (USHORT)FragThresh;
			}
			DBGPRINT(RT_DEBUG_TRACE, ("Set::OID_802_11_FRAGMENTATION_THRESHOLD (=%ld) \n",FragThresh));
			break;
			
		case OID_802_11_POWER_MODE:
			if (wrq->u.data.length != sizeof(NDIS_802_11_POWER_MODE))
				Status = -EINVAL;
			else
			{
				Status = copy_from_user(&PowerMode, wrq->u.data.pointer, wrq->u.data.length);
				if ((PowerMode == Ndis802_11PowerModeCAM) ||
					(PowerMode == Ndis802_11PowerModeMAX_PSP) ||
					(PowerMode == Ndis802_11PowerModeFast_PSP))
				{
					Status = RTUSBEnqueueCmdFromNdis(pAdapter, OID_802_11_POWER_MODE, TRUE, &PowerMode, sizeof(NDIS_802_11_POWER_MODE));
				}
				else
					Status = -EINVAL;
			}
			DBGPRINT(RT_DEBUG_TRACE, ("Set::OID_802_11_POWER_MODE (=%d)\n",PowerMode));
			break;
			
		case OID_802_11_TX_POWER_LEVEL:
			if (wrq->u.data.length != sizeof(NDIS_802_11_TX_POWER_LEVEL))
				Status	= -EINVAL;
			else
			{
				Status = copy_from_user(&TxPowerLevel, wrq->u.data.pointer, wrq->u.data.length);
				if (TxPowerLevel > MAX_TX_POWER_LEVEL)
					Status	= -EINVAL;
				else
					pAdapter->CommonCfg.TxPower = (UCHAR)TxPowerLevel;
			}
			DBGPRINT(RT_DEBUG_TRACE, ("Set::OID_802_11_TX_POWER_LEVEL (=%ld) \n",TxPowerLevel));
			break;
#if 0			
		case RT_OID_802_11_TX_POWER_LEVEL_1:
			if (wrq->u.data.length	< sizeof(ULONG))
				Status = -EINVAL;
			else
			{
				ULONG	PowerTemp;
				
				Status = copy_from_user(&PowerTemp, wrq->u.data.pointer, wrq->u.data.length);
				if (PowerTemp > 100)
					PowerTemp = 0xffffffff;  // AUTO
				pAdapter->CommonCfg.TxPowerDefault = PowerTemp; //keep current setting.

				// Only update TxPowerPercentage if the value is smaller than current AP setting
// TODO: 2005-03-08 john removed the following line. 
//				if (pAdapter->CommonCfg.TxPowerDefault < pAdapter->CommonCfg.TxPowerPercentage)
					pAdapter->CommonCfg.TxPowerPercentage = pAdapter->CommonCfg.TxPowerDefault;			
				DBGPRINT(RT_DEBUG_TRACE, ("Set::RT_OID_802_11_TX_POWER_LEVEL_1 (=%d)\n", pAdapter->CommonCfg.TxPowerPercentage));
			}	
			break;
#endif			
		case OID_802_11_PRIVACY_FILTER:
			if (wrq->u.data.length != sizeof(NDIS_802_11_PRIVACY_FILTER))
				Status = -EINVAL;
			else 
			{	
				NDIS_802_11_PRIVACY_FILTER	Filter;
				
				Status = copy_from_user(&Filter, wrq->u.data.pointer, wrq->u.data.length);
				if ((Filter == Ndis802_11PrivFilterAcceptAll) || (Filter == Ndis802_11PrivFilter8021xWEP))
					pAdapter->CommonCfg.PrivacyFilter = Filter;
				else
					Status = -EINVAL;
			}
			DBGPRINT(RT_DEBUG_TRACE, ("Set::OID_802_11_PRIVACY_FILTER (=%d) \n",pAdapter->CommonCfg.PrivacyFilter));
			break;
			
		case OID_802_11_NETWORK_TYPE_IN_USE:  
			if (wrq->u.data.length != sizeof(NDIS_802_11_NETWORK_TYPE))
				Status = -EINVAL;
			else 
			{
				Status = copy_from_user(&NetType, wrq->u.data.pointer, wrq->u.data.length);
				RTUSBEnqueueCmdFromNdis(pAdapter, OID_802_11_NETWORK_TYPE_IN_USE, TRUE, &NetType, wrq->u.data.length);
				DBGPRINT(RT_DEBUG_TRACE, ("Set::OID_802_11_NETWORK_TYPE_IN_USE (=%d)\n",NetType));
			}		
			break;
	
		case OID_802_11_RX_ANTENNA_SELECTED:   
			if (wrq->u.data.length != sizeof(NDIS_802_11_ANTENNA))
				Status = -EINVAL;
			else 
			{  
				Status = copy_from_user(&AntDiv, wrq->u.data.pointer, wrq->u.data.length);
				RTUSBEnqueueCmdFromNdis(pAdapter, OID_802_11_RX_ANTENNA_SELECTED, FALSE, &AntDiv, wrq->u.data.length);
			}
			break;
			
		case OID_802_11_TX_ANTENNA_SELECTED:	   
			if (wrq->u.data.length != sizeof(NDIS_802_11_ANTENNA))
				Status = -EINVAL;
			else 
			{
				Status = copy_from_user(&AntDiv, wrq->u.data.pointer, wrq->u.data.length);
				RTUSBEnqueueCmdFromNdis(pAdapter, OID_802_11_TX_ANTENNA_SELECTED, FALSE, &AntDiv, wrq->u.data.length);
			}
			break;
			
		// Add WPA-PSK/PMK key
		case RT_OID_802_11_ADD_WPA:
			DBGPRINT(RT_DEBUG_ERROR, ("!!!!!!!!!!!!!!!!!!!!!Set::RT_OID_802_11_ADD_WPA !!\n"));
			os_alloc_mem(NULL, (PUCHAR *)&pKey, wrq->u.data.length);
			if(pKey == NULL)
			{
				Status = -ENOMEM;
				break;
			}
			
			Status = copy_from_user(pKey, wrq->u.data.pointer, wrq->u.data.length);
			if (pKey->Length != wrq->u.data.length)
			{
				Status	= -EINVAL;
				DBGPRINT(RT_DEBUG_TRACE, ("Set::RT_OID_802_11_ADD_WPA, Failed!!\n"));
			}
			else
			{
				if ((pAdapter->CommonCfg.AuthMode != Ndis802_11AuthModeWPAPSK) &&\
					(pAdapter->CommonCfg.AuthMode != Ndis802_11AuthModeWPA2PSK) &&\
					(pAdapter->CommonCfg.AuthMode != Ndis802_11AuthModeWPANone) )
				{	 
					Status = -EOPNOTSUPP;
					DBGPRINT(RT_DEBUG_TRACE, ("Set::RT_OID_802_11_ADD_WPA, Failed!! [AuthMode != WPAPSK/WPA2PSK/WPANONE]\n"));
				}
				else if ((pAdapter->CommonCfg.AuthMode == Ndis802_11AuthModeWPAPSK) ||\
						(pAdapter->CommonCfg.AuthMode == Ndis802_11AuthModeWPA2PSK) ) 	// Only for WPA PSK mode
				{
					INT i;
					
					NdisMoveMemory(pAdapter->StaCfg.PMK, &pKey->KeyMaterial, pKey->KeyLength);
					// Use RaConfig as PSK agent.
					// Start STA supplicant state machine
					pAdapter->StaCfg.WpaState = SS_START;

					for (i = 0; i < 32; i++)
					{
						DBGPRINT_RAW(RT_DEBUG_TRACE,("%02x:", pAdapter->StaCfg.PMK[i]));
					}
					DBGPRINT(RT_DEBUG_TRACE,("\n"));						
					// Use RaConfig as PSK agent.
					// Start STA supplicant state machine
					pAdapter->StaCfg.WpaState = SS_START;
					DBGPRINT(RT_DEBUG_TRACE, ("Set::RT_OID_802_11_ADD_WPA (id=0x%x, Len=%d-byte)\n", pKey->KeyIndex, pKey->KeyLength));
				}
				else
				{
					Status = RTUSBEnqueueCmdFromNdis(pAdapter, OID_802_11_ADD_KEY, TRUE, pKey, pKey->Length);
				}
			}
			os_free_mem(NULL, (PCHAR)pKey);
			break;
			
		case OID_802_11_REMOVE_KEY:
			os_alloc_mem(NULL, (PUCHAR *)&pRemoveKey, wrq->u.data.length);
			if(pRemoveKey == NULL)
			{
				Status = -ENOMEM;
				break;
			}
			
			Status = copy_from_user(pRemoveKey, wrq->u.data.pointer, wrq->u.data.length);
			if (pRemoveKey->Length != wrq->u.data.length)
			{
				Status = -EINVAL;
				DBGPRINT(RT_DEBUG_TRACE, ("Set::OID_802_11_REMOVE_KEY, Failed!!\n"));
			}
			else
			{
				Status = RTMPRemoveKeySanity(pAdapter, pRemoveKey);
				if (Status == NDIS_STATUS_SUCCESS)
				{
					RTUSBEnqueueCmdFromNdis(pAdapter, OID_802_11_REMOVE_KEY, TRUE, pRemoveKey, wrq->u.data.length);
				}
			}	
			DBGPRINT(RT_DEBUG_TRACE, ("Set::OID_802_11_REMOVE_KEY (id=0x%x, Len=%d-byte)\n", pRemoveKey->KeyIndex, pRemoveKey->Length));	 
			os_free_mem(NULL, (PUCHAR)pRemoveKey);
			break;
			
		//  Add WPA KEY(after 4 ways) or WEP KEY
		case OID_802_11_ADD_KEY: 
			DBGPRINT(RT_DEBUG_ERROR, ("!!!!!!!!!!!!!!!!!!!!!Set::OID_802_11_ADD_KEY !!\n"));
			os_alloc_mem(NULL, (PUCHAR *)&pKey, wrq->u.data.length);
			if(pKey == NULL)
			{
				Status = -ENOMEM;
				break;
			}
			
			Status = copy_from_user(pKey, wrq->u.data.pointer, wrq->u.data.length);
			if (pKey->Length != wrq->u.data.length)
			{
				Status	= -EINVAL;
				DBGPRINT(RT_DEBUG_TRACE, ("Set::OID_802_11_ADD_KEY, Failed!!\n"));
			}
			else
			{		
				if (pAdapter->CommonCfg.AuthMode >= Ndis802_11AuthModeWPA)
				{
					// Probably CommonCfg.Bssid reset to zero as linkdown, 
					// Set pKey.BSSID to Broadcast bssid in order to ensure AsicAddSharedKeyEntry done 
					if(pAdapter->CommonCfg.AuthMode == Ndis802_11AuthModeWPANone)
					{
						NdisMoveMemory(pKey->BSSID, BROADCAST_ADDR, 6);
					}
				
					RTUSBEnqueueCmdFromNdis(pAdapter, OID_802_11_ADD_KEY, TRUE, pKey, pKey->Length);
				}
				else	// Old WEP stuff
				{
					Status = RTMPWPAWepKeySanity(pAdapter, pKey);
					if (Status == NDIS_STATUS_SUCCESS)
						RTUSBEnqueueCmdFromNdis(pAdapter, OID_802_11_ADD_KEY_WEP, TRUE, pKey, wrq->u.data.length);		
				}
				
				KeyIdx = pKey->KeyIndex & 0x0fffffff;
				DBGPRINT(RT_DEBUG_TRACE, ("Set::OID_802_11_ADD_KEY (id=0x%x, Len=%d-byte)\n", KeyIdx, pKey->KeyLength));		  
			}
			os_free_mem(NULL, (PUCHAR)pKey);
			break;

        case OID_802_11_CONFIGURATION:
            if (wrq->u.data.length != sizeof(NDIS_802_11_CONFIGURATION))
                Status  = -EINVAL;
            else
            {
                Status = copy_from_user(&Config, wrq->u.data.pointer, wrq->u.data.length);
                pConfig = &Config;

                if ((pConfig->BeaconPeriod >= 20) && (pConfig->BeaconPeriod <=400))
                     pAdapter->CommonCfg.BeaconPeriod = (USHORT) pConfig->BeaconPeriod;
                
                pAdapter->StaActive.AtimWin = (USHORT) pConfig->ATIMWindow;
                MAP_KHZ_TO_CHANNEL_ID(pConfig->DSConfig, pAdapter->CommonCfg.Channel);
                //
				// Save the channel on MlmeAux for CntlOidRTBssidProc used.
				//
				pAdapter->MlmeAux.Channel = pAdapter->CommonCfg.Channel;
				
                DBGPRINT(RT_DEBUG_TRACE, ("Set::OID_802_11_CONFIGURATION (BeacnPeriod=%ld,AtimW=%ld,Ch=%d)\n",
                    pConfig->BeaconPeriod, pConfig->ATIMWindow, pAdapter->CommonCfg.Channel));
                // Config has changed
                pAdapter->bConfigChanged = TRUE;
            }
            break;

		case RT_OID_802_11_SET_HT_PHYMODE:
			if (wrq->u.data.length	!= sizeof(OID_SET_HT_PHYMODE))
				Status = -EINVAL;
			else 
			{
			    POID_SET_HT_PHYMODE	pHTPhyMode = &HT_PhyMode;
                
				Status = copy_from_user(&HT_PhyMode, wrq->u.data.pointer, wrq->u.data.length);				
				DBGPRINT(RT_DEBUG_TRACE, ("Set::pHTPhyMode	(PhyMode = %d,TransmitNo = %d, HtMode =	%d,	ExtOffset =	%d , MCS = %d, BW =	%d,	STBC = %d, SHORTGI = %d) \n", 
				pHTPhyMode->PhyMode, pHTPhyMode->TransmitNo,pHTPhyMode->HtMode,pHTPhyMode->ExtOffset,
				pHTPhyMode->MCS, pHTPhyMode->BW, pHTPhyMode->STBC,	pHTPhyMode->SHORTGI));
				if (pAdapter->CommonCfg.PhyMode	>= PHY_11ABGN_MIXED)
					RTMPSetHT(pAdapter,	pHTPhyMode);
			}
			DBGPRINT(RT_DEBUG_TRACE, ("Set::RT_OID_802_11_SET_HT_PHYMODE(MCS=%d,BW=%d,SGI=%d,STBC=%d)\n", 
				pAdapter->CommonCfg.HTPhyMode.field.MCS, pAdapter->CommonCfg.HTPhyMode.field.BW,pAdapter->CommonCfg.HTPhyMode.field.ShortGI,
				pAdapter->CommonCfg.HTPhyMode.field.STBC));
			break;


			
		// Add WEP Key (from wpa supplicant)		    
#if WPA_SUPPLICANT_SUPPORT	    
		case OID_802_11_ADD_WEP:
			DBGPRINT(RT_DEBUG_ERROR, ("!!!!!!!!!!!!!!!!!!!!!Set::OID_802_11_ADD_WEP !!\n"));
			
			os_alloc_mem(NULL, (PUCHAR *)&pWepKey, wrq->u.data.length);	
			if(pWepKey == NULL)
			{
				Status = -ENOMEM;
				DBGPRINT(RT_DEBUG_TRACE, ("Set::OID_802_11_ADD_WEP, Failed!!\n"));
				break;
			}
			Status = copy_from_user(pWepKey, wrq->u.data.pointer, wrq->u.data.length);	        
			if (pWepKey->Length != wrq->u.data.length)
			{
				Status  = -EINVAL;
				DBGPRINT(RT_DEBUG_TRACE, ("Set::OID_802_11_ADD_WEP, Failed (length mismatch)!!\n"));
			}
			else
			{
				KeyIdx = pWepKey->KeyIndex & 0x0fffffff;
			    	
				// it is a shared key
				if ((KeyIdx >= 4) || ((pWepKey->KeyLength != 5) && (pWepKey->KeyLength != 13)))
				{
					Status = -EINVAL;
					DBGPRINT(RT_DEBUG_TRACE, ("Set::OID_802_11_ADD_WEP, Failed (KeyIdx and KeyLength are invalid)!!\n"));						
				}
				else
				{
					// After receiving eap-success in 802.1x mode, PortSecured will be TRUE.
					// At this moment, wpa_supplicant will set dynamic wep key to driver.
					// Otherwise, driver only records it, not set to Asic. 
					if(pAdapter->StaCfg.PortSecured == WPA_802_1X_PORT_SECURED)
					{
	            							
						if (pWepKey->KeyIndex & 0x80000000)
						{
							// Default key for tx (shared key)
							pAdapter->CommonCfg.DefaultKeyId = (UCHAR) KeyIdx;
						}
						
				        Status = RTUSBEnqueueCmdFromNdis(pAdapter, OID_802_11_ADD_WEP, TRUE, pWepKey, wrq->u.data.length);
					}
					else // PortSecured is NOT SECURED
					{
						UCHAR CipherAlg;
						
						pAdapter->StaCfg.DesireSharedKey[KeyIdx].KeyLen = (UCHAR) pWepKey->KeyLength;
						NdisMoveMemory(pAdapter->StaCfg.DesireSharedKey[KeyIdx].Key, &pWepKey->KeyMaterial, pWepKey->KeyLength);
			    
						if (pWepKey->KeyLength == 5)
							CipherAlg = CIPHER_WEP64;
						else
							CipherAlg = CIPHER_WEP128;
	                
						pAdapter->StaCfg.DesireSharedKey[KeyIdx].CipherAlg = CipherAlg;
					
						if (pWepKey->KeyIndex & 0x80000000)
						{
							// Default key for tx (shared key)
							pAdapter->CommonCfg.DefaultKeyId = (UCHAR) KeyIdx;
						}
		
						DBGPRINT(RT_DEBUG_TRACE, ("Set::OID_802_11_ADD_WEP (id=0x%x, Len=%d-byte), Port Not Secured\n", pWepKey->KeyIndex, pWepKey->KeyLength));																
					}
				}
			}
			os_free_mem(NULL, (PCHAR)pWepKey);
			break;
#endif //WPA_SUPPLICANT_SUPPORT

		case OID_802_11_DISASSOCIATE:
		// Set to immediately send the media disconnect event
		pAdapter->MlmeAux.CurrReqIsFromNdis = TRUE; 			

		DBGPRINT(RT_DEBUG_TRACE, ("Set::OID_802_11_DISASSOCIATE \n"));

		if (INFRA_ON(pAdapter))
		{
			if (pAdapter->Mlme.CntlMachine.CurrState != CNTL_IDLE)
			{
				MlmeEnqueue(pAdapter, 
							MLME_CNTL_STATE_MACHINE,
							RT_CMD_RESET_MLME,
							0,
							NULL);	
			}

			MlmeEnqueue(pAdapter, 
						MLME_CNTL_STATE_MACHINE, 
						OID_802_11_DISASSOCIATE, 
						0, 
						NULL);

			StateMachineTouched = TRUE;
		}
		break;

		case RT_OID_802_11_SET_IMME_BA_CAP:
				if (wrq->u.data.length != sizeof(OID_BACAP_STRUC))
					Status = -EINVAL;
				else
				{
					OID_BACAP_STRUC Orde ;
					Status = copy_from_user(&Orde, wrq->u.data.pointer, wrq->u.data.length);
					if (Orde.Policy > BA_NOTUSE)
					{
						Status = NDIS_STATUS_INVALID_DATA;
					}
					else if (Orde.Policy == BA_NOTUSE)
					{
						pAdapter->CommonCfg.BACapability.field.Policy = BA_NOTUSE;
						pAdapter->CommonCfg.BACapability.field.MpduDensity = Orde.MpduDensity;
						pAdapter->CommonCfg.DesiredHtPhy.MpduDensity = Orde.MpduDensity;
						pAdapter->CommonCfg.DesiredHtPhy.AmsduEnable = Orde.AmsduEnable;
						pAdapter->CommonCfg.DesiredHtPhy.AmsduSize= Orde.AmsduSize;
						pAdapter->CommonCfg.DesiredHtPhy.MimoPs= Orde.MMPSmode;
						pAdapter->CommonCfg.BACapability.field.MMPSmode = Orde.MMPSmode;
						// UPdata to HT IE
						pAdapter->CommonCfg.HtCapability.HtCapInfo.MimoPs = Orde.MMPSmode;
						pAdapter->CommonCfg.HtCapability.HtCapInfo.AMsduSize = Orde.AmsduSize;
						pAdapter->CommonCfg.HtCapability.HtCapParm.MpduDensity = Orde.MpduDensity;
					}
					else
					{
                        pAdapter->CommonCfg.BACapability.field.AutoBA = Orde.AutoBA;
						pAdapter->CommonCfg.BACapability.field.Policy = IMMED_BA; // we only support immediate BA.
						pAdapter->CommonCfg.BACapability.field.MpduDensity = Orde.MpduDensity;
						pAdapter->CommonCfg.DesiredHtPhy.MpduDensity = Orde.MpduDensity;
						pAdapter->CommonCfg.DesiredHtPhy.AmsduEnable = Orde.AmsduEnable;
						pAdapter->CommonCfg.DesiredHtPhy.AmsduSize= Orde.AmsduSize;
						pAdapter->CommonCfg.DesiredHtPhy.MimoPs = Orde.MMPSmode;
						pAdapter->CommonCfg.BACapability.field.MMPSmode = Orde.MMPSmode;
							
						// UPdata to HT IE
						pAdapter->CommonCfg.HtCapability.HtCapInfo.MimoPs = Orde.MMPSmode;
						pAdapter->CommonCfg.HtCapability.HtCapInfo.AMsduSize = Orde.AmsduSize;
						pAdapter->CommonCfg.HtCapability.HtCapParm.MpduDensity = Orde.MpduDensity;
						
						if (pAdapter->CommonCfg.BACapability.field.RxBAWinLimit > MAX_RX_REORDERBUF)
							pAdapter->CommonCfg.BACapability.field.RxBAWinLimit = MAX_RX_REORDERBUF;

					}

					pAdapter->CommonCfg.REGBACapability.word = pAdapter->CommonCfg.BACapability.word;
					DBGPRINT(RT_DEBUG_TRACE, ("Set::(Orde.AutoBA = %d) (Policy=%d)(ReBAWinLimit=%d)(TxBAWinLimit=%d)(AutoMode=%d)\n",Orde.AutoBA, pAdapter->CommonCfg.BACapability.field.Policy,
						pAdapter->CommonCfg.BACapability.field.RxBAWinLimit,pAdapter->CommonCfg.BACapability.field.TxBAWinLimit, pAdapter->CommonCfg.BACapability.field.AutoBA));
					DBGPRINT(RT_DEBUG_TRACE, ("Set::(MimoPs = %d)(AmsduEnable = %d) (AmsduSize=%d)(MpduDensity=%d)\n",pAdapter->CommonCfg.DesiredHtPhy.MimoPs, pAdapter->CommonCfg.DesiredHtPhy.AmsduEnable,
						pAdapter->CommonCfg.DesiredHtPhy.AmsduSize, pAdapter->CommonCfg.DesiredHtPhy.MpduDensity));
					DBGPRINT(RT_DEBUG_INFO, ("Set::RT_OID_802_11_SET_IMME_BA_CAP (=%d)\n", Orde.Policy));
				}

				break;
		case RT_OID_802_11_ADD_IMME_BA:
			DBGPRINT(RT_DEBUG_TRACE, (" Set :: RT_OID_802_11_ADD_IMME_BA \n"));
			if (wrq->u.data.length != sizeof(OID_ADD_BA_ENTRY))
					Status = -EINVAL;
			else 
			{
				UCHAR		        index;
				OID_ADD_BA_ENTRY    BA;
				MAC_TABLE_ENTRY     *pEntry;
//                BA_ORI_ENTRY        *pBAEntry = NULL;

				Status = copy_from_user(&BA, wrq->u.data.pointer, wrq->u.data.length);
				if (BA.TID > 15)
				{
					Status = NDIS_STATUS_INVALID_DATA;
					break;
				}
				else
				{
					//BATableInsertEntry
					//As ad-hoc mode, BA pair is not limited to only BSSID. so add via OID. 
					index = BA.TID;
					// in ad hoc mode, when adding BA pair, we should insert this entry into MACEntry too
					pEntry = MacTableLookup(pAdapter, BA.MACAddr);
					if (!pEntry)
					{
						DBGPRINT(RT_DEBUG_TRACE, ("RT_OID_802_11_ADD_IMME_BA. break on no connection.----:%x:%x\n", BA.MACAddr[4], BA.MACAddr[5]));
						break;
					}
					if (BA.IsRecipient == FALSE)
					{
					    if (pEntry->bIAmBadAtheros == TRUE)
							pAdapter->CommonCfg.BACapability.field.RxBAWinLimit = 0x10;

						BAOriSessionSetUp(pAdapter, pEntry, index, 0, 100, TRUE);
					}
					else 
					{
						//BATableInsertEntry(pAdapter, pEntry->Aid, BA.MACAddr, 0, 0xffff, BA.TID, BA.nMSDU, BA.IsRecipient);
					}

					DBGPRINT(RT_DEBUG_TRACE, ("Set::RT_OID_802_11_ADD_IMME_BA. Rec = %d. Mac = %x:%x:%x:%x:%x:%x . \n",
						BA.IsRecipient, BA.MACAddr[0], BA.MACAddr[1], BA.MACAddr[2], BA.MACAddr[2]
						, BA.MACAddr[4], BA.MACAddr[5]));
				}
			}
			break;

		case RT_OID_802_11_TEAR_IMME_BA:
			DBGPRINT(RT_DEBUG_TRACE, ("Set :: RT_OID_802_11_TEAR_IMME_BA \n"));
			if (wrq->u.data.length != sizeof(OID_ADD_BA_ENTRY))
					Status = -EINVAL;
			else 
			{
				POID_ADD_BA_ENTRY	pBA;
//				BA_REC_ENTRY	*pBAEntry;
				MAC_TABLE_ENTRY *pEntry;
				
				pBA = kmalloc(wrq->u.data.length, MEM_ALLOC_FLAG);

				if (pBA == NULL)
				{
					DBGPRINT(RT_DEBUG_TRACE, ("Set :: RT_OID_802_11_TEAR_IMME_BA kmalloc() can't allocate enough memory\n"));
					Status = NDIS_STATUS_FAILURE;
				}
				else
				{
					Status = copy_from_user(pBA, wrq->u.data.pointer, wrq->u.data.length);
					DBGPRINT(RT_DEBUG_TRACE, ("Set :: RT_OID_802_11_TEAR_IMME_BA(TID=%d, bAllTid=%d)\n", pBA->TID, pBA->bAllTid));
					
					if (!pBA->bAllTid && (pBA->TID > 15))
					{
						Status = NDIS_STATUS_INVALID_DATA;
						break;
					}
					
					if (pBA->IsRecipient == FALSE)
					{
						pEntry = MacTableLookup(pAdapter, pBA->MACAddr);
						DBGPRINT(RT_DEBUG_TRACE, (" pBA->IsRecipient == FALSE\n"));
						if (pEntry)
						{
							DBGPRINT(RT_DEBUG_TRACE, (" pBA->pEntry\n"));
							BAOriSessionTearDown(pAdapter, pEntry->Aid, pBA->TID, FALSE, TRUE);
						}
						else
							DBGPRINT(RT_DEBUG_TRACE, ("Set :: Not found pEntry \n"));
					}
					else
					{
						pEntry = MacTableLookup(pAdapter, pBA->MACAddr);
						if (pEntry)
						{
							BARecSessionTearDown( pAdapter, (UCHAR)pEntry->Aid, pBA->TID, TRUE);
						}
						else
							DBGPRINT(RT_DEBUG_TRACE, ("Set :: Not found pEntry \n"));
					}
					kfree(pBA);
				}
            }
            break;


		
#if WPA_SUPPLICANT_SUPPORT
		case OID_802_11_SET_IEEE8021X:
			if (wrq->u.data.length != sizeof(BOOLEAN))
				Status  = -EINVAL;
			else
			{
				Status = copy_from_user(&IEEE8021xState, wrq->u.data.pointer, wrq->u.data.length);                				
				pAdapter->StaCfg.IEEE8021X = IEEE8021xState;									


				// set WEP key to ASIC for static wep mode
				if(pAdapter->StaCfg.IEEE8021X == FALSE && pAdapter->CommonCfg.AuthMode < Ndis802_11AuthModeWPA )
				{
					int idx;
      
					idx = pAdapter->CommonCfg.DefaultKeyId;
					//for (idx=0; idx < 4; idx++)
					{
						DBGPRINT_RAW(RT_DEBUG_TRACE, ("Set WEP key to Asic for static wep mode =>\n"));
          
						if(pAdapter->StaCfg.DesireSharedKey[idx].KeyLen != 0)
						{
							pAdapter->SharedKey[BSS0][idx].KeyLen = pAdapter->StaCfg.DesireSharedKey[idx].KeyLen;
							NdisMoveMemory(pAdapter->SharedKey[BSS0][idx].Key, pAdapter->StaCfg.DesireSharedKey[idx].Key, pAdapter->SharedKey[BSS0][idx].KeyLen);
           
							pAdapter->SharedKey[BSS0][idx].CipherAlg = pAdapter->StaCfg.DesireSharedKey[idx].CipherAlg;
       
							AsicAddSharedKeyEntry(pAdapter, 0, (UCHAR)idx, pAdapter->SharedKey[BSS0][idx].CipherAlg, pAdapter->SharedKey[BSS0][idx].Key, NULL, NULL); 
						}
					}
				}
    
				DBGPRINT(RT_DEBUG_TRACE, ("Set::OID_802_11_SET_IEEE8021X (=%d)\n", pAdapter->StaCfg.IEEE8021X));									
			}	
			break;
			
		case OID_802_11_SET_IEEE8021X_REQUIRE_KEY:	
			if (wrq->u.data.length != sizeof(BOOLEAN))
				 Status  = -EINVAL;
			else
			{
				Status = copy_from_user(&IEEE8021x_required_keys, wrq->u.data.pointer, wrq->u.data.length);                				
				pAdapter->StaCfg.IEEE8021x_required_keys = IEEE8021x_required_keys;				
				DBGPRINT(RT_DEBUG_TRACE, ("Set::OID_802_11_SET_IEEE8021X_REQUIRE_KEY (%d)\n", pAdapter->StaCfg.IEEE8021x_required_keys));									
			}	
			break;
			
		case OID_SET_COUNTERMEASURES: 
			if (wrq->u.param.value)
			{
				pAdapter->StaCfg.bBlockAssoc = TRUE;
				DBGPRINT(RT_DEBUG_TRACE, ("Set::OID_SET_COUNTERMEASURES bBlockAssoc=TRUE \n"));
			}
			else
			{
				// WPA MIC error should block association attempt for 60 seconds
				pAdapter->StaCfg.bBlockAssoc = FALSE;
				DBGPRINT(RT_DEBUG_TRACE, ("Set::OID_SET_COUNTERMEASURES bBlockAssoc=FALSE \n"));
			}
			break;
			
		case OID_802_11_PMKID:
			os_alloc_mem(NULL, (PUCHAR *)&pPmkId, wrq->u.data.length);

			if(pPmkId == NULL) {
				Status = -ENOMEM;
				break;
			}
			Status = copy_from_user(pPmkId, wrq->u.data.pointer, wrq->u.data.length);

			// check the PMKID information
			if (pPmkId->BSSIDInfoCount == 0)
				break;
			else
			{
				PBSSID_INFO	pBssIdInfo;
		        UINT		BssIdx;
		        UINT		CachedIdx;

				for (BssIdx = 0; BssIdx < pPmkId->BSSIDInfoCount; BssIdx++)
				{
					// point to the indexed BSSID_INFO structure
			        pBssIdInfo = (PBSSID_INFO) ((PUCHAR) pPmkId + 2 * sizeof(UINT) + BssIdx * sizeof(BSSID_INFO));
					// Find the entry in the saved data base.
					for (CachedIdx = 0; CachedIdx < pAdapter->StaCfg.SavedPMKNum; CachedIdx++)
					{
						// compare the BSSID
						if (NdisEqualMemory(pBssIdInfo->BSSID, pAdapter->StaCfg.SavedPMK[CachedIdx].BSSID, sizeof(NDIS_802_11_MAC_ADDRESS)))
							break;			
					}

					// Found, replace it
					if (CachedIdx < PMKID_NO)
					{
						DBGPRINT(RT_DEBUG_OFF, ("Update OID_802_11_PMKID, idx = %d\n", CachedIdx));
						NdisMoveMemory(&pAdapter->StaCfg.SavedPMK[CachedIdx], pBssIdInfo, sizeof(BSSID_INFO));
						pAdapter->StaCfg.SavedPMKNum++;
					}
					// Not found, replace the last one
					else
					{
						// Randomly replace one
						CachedIdx = (pBssIdInfo->BSSID[5] % PMKID_NO);
						DBGPRINT(RT_DEBUG_OFF, ("Update OID_802_11_PMKID, idx = %d\n", CachedIdx));
						NdisMoveMemory(&pAdapter->StaCfg.SavedPMK[CachedIdx], pBssIdInfo, sizeof(BSSID_INFO));
					}				
    	        }
	        }
	        os_free_mem(NULL, (PCHAR)pPmkId);
            break;
            
		case RT_OID_WPA_SUPPLICANT_SUPPORT:
			if (wrq->u.data.length != sizeof(BOOLEAN))
				Status  = -EINVAL;
			else
			{
				Status = copy_from_user(&wpa_supplicant_enable, wrq->u.data.pointer, wrq->u.data.length);                				
				pAdapter->StaCfg.WPA_Supplicant = wpa_supplicant_enable;									
				DBGPRINT(RT_DEBUG_TRACE, ("Set::RT_OID_WPA_SUPPLICANT_SUPPORT (=%d)\n", pAdapter->StaCfg.WPA_Supplicant));									
			}
			break;
#endif // WPA_SUPPLICANT_SUPPORT //

		default:
			DBGPRINT(RT_DEBUG_TRACE, ("Set::unknown IOCTL's subcmd = 0x%08x\n", cmd));
			Status = -EOPNOTSUPP;
			break;
	}
	return Status;
}

INT RTMPQueryInformation(
	IN	PRTMP_ADAPTER pAdapter,
	IN	OUT struct ifreq	*rq,
	IN	INT			cmd)
{
	struct iwreq					*wrq = (struct iwreq *) rq;
	NDIS_802_11_BSSID_LIST_EX			*pBssidList = NULL;
	PNDIS_WLAN_BSSID_EX 				pBss;
	NDIS_802_11_SSID				Ssid;
	NDIS_802_11_CONFIGURATION			Configuration;
	RT_802_11_LINK_STATUS				LinkStatus;
	RT_802_11_STA_CONFIG				StaConfig;
	NDIS_802_11_STATISTICS				Statistics;
	NDIS_802_11_RTS_THRESHOLD			RtsThresh;
	NDIS_802_11_FRAGMENTATION_THRESHOLD		FragThresh;
	NDIS_802_11_POWER_MODE				PowerMode;
	NDIS_802_11_NETWORK_INFRASTRUCTURE		BssType;
	RT_802_11_PREAMBLE				PreamType;
	NDIS_802_11_AUTHENTICATION_MODE			AuthMode;
	NDIS_802_11_WEP_STATUS				WepStatus;
	RT_VERSION_INFO					DriverVersionInfo; 
	NDIS_MEDIA_STATE				MediaState;
	ULONG						BssBufSize;
    USHORT                              BssLen = 0; // length in iw_point is u16
	ULONG						ulInfo = 0;
	PUCHAR    	    	    	    	    	pBuf = NULL;
	PUCHAR    	    	    	    	    	pPtr;
	INT    	    	    	    	    	    	Status = NDIS_STATUS_SUCCESS;
	//UCHAR    	    	    	    	    	Padding=0;
	UINT    	    	    	    	    	i;
	BOOLEAN    	    	    	    	    	RadioState;
	ULONG    	    	    	    	    	NetworkTypeList[4];
	UINT    	    	    	    	    	we_version_compiled;

	switch(cmd) 
	{
		case RT_OID_DEVICE_NAME:
			DBGPRINT(RT_DEBUG_INFO, ("Query::RT_OID_DEVICE_NAME\n"));
			wrq->u.data.length = sizeof(NIC_DEVICE_NAME);
			Status = copy_to_user(wrq->u.data.pointer, NIC_DEVICE_NAME, wrq->u.data.length);
			break;
	  
		case RT_OID_VERSION_INFO:
			DBGPRINT(RT_DEBUG_INFO, ("Query::RT_OID_VERSION_INFO \n"));
			DriverVersionInfo.DriverVersionW = DRV_MAJORVERSION;
			DriverVersionInfo.DriverVersionX = DRV_MINORVERSION;
			DriverVersionInfo.DriverVersionY = DRV_SUBVERSION;
			DriverVersionInfo.DriverVersionZ = DRV_TESTVERSION;
			DriverVersionInfo.DriverBuildYear	= DRV_YEAR;
			DriverVersionInfo.DriverBuildMonth	= DRV_MONTH;
			DriverVersionInfo.DriverBuildDay	= DRV_DAY;
			wrq->u.data.length = sizeof(RT_VERSION_INFO);
			Status = copy_to_user(wrq->u.data.pointer, &DriverVersionInfo, wrq->u.data.length);
			break;

		case OID_802_11_BSSID_LIST:
			DBGPRINT(RT_DEBUG_TRACE, ("Query::OID_802_11_BSSID_LIST (%d BSS returned)\n",pAdapter->ScanTab.BssNr));
			// Claculate total buffer size required
			BssBufSize = sizeof(ULONG);
			
			for (i = 0; i < pAdapter->ScanTab.BssNr; i++) 
			{
				// Align pointer to 4 bytes boundary.
                //Padding = 4 - (pAdapter->ScanTab.BssEntry[i].VarIELen & 0x0003);
                //if (Padding == 4)
                //    Padding = 0;
				BssBufSize += (sizeof(NDIS_WLAN_BSSID_EX) - 1 + sizeof(NDIS_802_11_FIXED_IEs) + pAdapter->ScanTab.BssEntry[i].VarIELen); // + Padding
			}

			// For safety issue, we add 256 bytes just in case
			BssBufSize += 256;
			// Allocate the same size as passed from higher layer
            pBuf = kmalloc(BssBufSize, MEM_ALLOC_FLAG);
			if(pBuf == NULL)
			{
				Status = -ENOMEM;
				break;
			}
			// Init 802_11_BSSID_LIST_EX structure
			NdisZeroMemory(pBuf, BssBufSize);
			pBssidList = (PNDIS_802_11_BSSID_LIST_EX) pBuf;
			
			// Calculate total buffer length
			BssLen = 4; // Consist of NumberOfItems
			// Point to start of NDIS_WLAN_BSSID_EX
			// pPtr = pBuf + sizeof(ULONG);
			pPtr = (PUCHAR) &pBssidList->Bssid[0];
			for (i = 0; i < pAdapter->ScanTab.BssNr; i++) 
			{
				pBss = (PNDIS_WLAN_BSSID_EX) pPtr;
                NdisMoveMemory(&pBss->MacAddress, &pAdapter->ScanTab.BssEntry[i].Bssid, MAC_ADDR_LEN);
				if ((pAdapter->ScanTab.BssEntry[i].Hidden == 1) && (pAdapter->StaCfg.bShowHiddenSSID == FALSE))
				{
					//
					// We must return this SSID during 4way handshaking, otherwise Aegis will failed to parse WPA infomation
					// and then failed to send EAPOl farame.
					//
					if ((pAdapter->CommonCfg.AuthMode >= Ndis802_11AuthModeWPA) && (pAdapter->StaCfg.PortSecured != WPA_802_1X_PORT_SECURED))
					{
						pBss->Ssid.SsidLength = pAdapter->ScanTab.BssEntry[i].SsidLen;
						NdisMoveMemory(pBss->Ssid.Ssid, pAdapter->ScanTab.BssEntry[i].Ssid, pAdapter->ScanTab.BssEntry[i].SsidLen);
					}
					else
						pBss->Ssid.SsidLength = 0;
				}
				else
				{
					pBss->Ssid.SsidLength = pAdapter->ScanTab.BssEntry[i].SsidLen;
                    //NdisZeroMemory(pBss->Ssid.Ssid, NDIS_802_11_LENGTH_SSID);
					NdisMoveMemory(pBss->Ssid.Ssid, pAdapter->ScanTab.BssEntry[i].Ssid, pAdapter->ScanTab.BssEntry[i].SsidLen);
				}
				pBss->Privacy = pAdapter->ScanTab.BssEntry[i].Privacy;
				pBss->Rssi = pAdapter->ScanTab.BssEntry[i].Rssi; // - 121; for HCT TEST , fix it in future;

				pBss->NetworkTypeInUse = NetworkTypeInUseSanity(pAdapter->ScanTab.BssEntry[i].Channel, 
																pAdapter->ScanTab.BssEntry[i].SupRate,
																pAdapter->ScanTab.BssEntry[i].SupRateLen,
																pAdapter->ScanTab.BssEntry[i].ExtRate,
																pAdapter->ScanTab.BssEntry[i].ExtRateLen);
				pBss->Configuration.Length = sizeof(NDIS_802_11_CONFIGURATION);
				pBss->Configuration.BeaconPeriod = pAdapter->ScanTab.BssEntry[i].BeaconPeriod;	
				pBss->Configuration.ATIMWindow = pAdapter->ScanTab.BssEntry[i].AtimWin;

				MAP_CHANNEL_ID_TO_KHZ(pAdapter->ScanTab.BssEntry[i].Channel, pBss->Configuration.DSConfig);

				if (pAdapter->ScanTab.BssEntry[i].BssType == BSS_INFRA) 
					pBss->InfrastructureMode = Ndis802_11Infrastructure;
				else
					pBss->InfrastructureMode = Ndis802_11IBSS;

				NdisMoveMemory(pBss->SupportedRates, pAdapter->ScanTab.BssEntry[i].SupRate, pAdapter->ScanTab.BssEntry[i].SupRateLen);
// TODO: 2004-09-13 john -	should we copy ExtRate into this array? if not, some APs annouced all 8 11g rates
// in ExtRateIE which may be mis-treated as 802.11b AP by ZeroConfig
				NdisMoveMemory(pBss->SupportedRates + pAdapter->ScanTab.BssEntry[i].SupRateLen,
							   pAdapter->ScanTab.BssEntry[i].ExtRate,
							   pAdapter->ScanTab.BssEntry[i].ExtRateLen);

                DBGPRINT(RT_DEBUG_INFO,("BSS#%d - %s, Ch %d = %ld Khz, Sup+Ext rate# = %d\n",
					i,pBss->Ssid.Ssid,
					pAdapter->ScanTab.BssEntry[i].Channel,
					pBss->Configuration.DSConfig,
					pAdapter->ScanTab.BssEntry[i].SupRateLen + pAdapter->ScanTab.BssEntry[i].ExtRateLen));

				if (pAdapter->ScanTab.BssEntry[i].VarIELen == 0)
				{
					pBss->IELength = sizeof(NDIS_802_11_FIXED_IEs);
					NdisMoveMemory(pBss->IEs, &pAdapter->ScanTab.BssEntry[i].FixIEs, sizeof(NDIS_802_11_FIXED_IEs));
					// 'packed' alignment to the previous one
					pPtr = pPtr + sizeof(NDIS_WLAN_BSSID_EX) - 1 + sizeof(NDIS_802_11_FIXED_IEs);
				}
				else
				{
					pBss->IELength = sizeof(NDIS_802_11_FIXED_IEs) + pAdapter->ScanTab.BssEntry[i].VarIELen;
					// 'packed' alignment to the previous one
					pPtr = pPtr + sizeof(NDIS_WLAN_BSSID_EX) - 1 + sizeof(NDIS_802_11_FIXED_IEs);
					NdisMoveMemory(pBss->IEs, &pAdapter->ScanTab.BssEntry[i].FixIEs, sizeof(NDIS_802_11_FIXED_IEs));
                    //NdisMoveMemory(pPtr, pAdapter->ScanTab.BssEntry[i].VarIEs, pAdapter->ScanTab.BssEntry[i].VarIELen);
                    NdisMoveMemory(pBss->IEs + sizeof(NDIS_802_11_FIXED_IEs), pAdapter->ScanTab.BssEntry[i].VarIEs, pAdapter->ScanTab.BssEntry[i].VarIELen);
					pPtr += pAdapter->ScanTab.BssEntry[i].VarIELen;
				}
				// Align pointer to 4 bytes boundary.
                /*Padding = 4 - (pAdapter->ScanTab.BssEntry[i].VarIELen & 0x0003);
				if (Padding == 4)
					Padding = 0;
                pPtr += Padding;*/
				pBss->Length = sizeof(NDIS_WLAN_BSSID_EX) - 1 + sizeof(NDIS_802_11_FIXED_IEs) + pAdapter->ScanTab.BssEntry[i].VarIELen;// + Padding
                
                if ((BssLen + pBss->Length) < wrq->u.data.length)
                    BssLen += pBss->Length;
                else
                    break;
			}
			pBssidList->NumberOfItems = i;//pAdapter->ScanTab.BssNr;
			wrq->u.data.length = BssLen;
			Status = copy_to_user(wrq->u.data.pointer, pBssidList, wrq->u.data.length);
            kfree(pBssidList);
			break;

		case OID_802_3_CURRENT_ADDRESS:
			wrq->u.data.length = MAC_ADDR_LEN;
			Status = copy_to_user(wrq->u.data.pointer, &pAdapter->CurrentAddress, wrq->u.data.length);
			DBGPRINT(RT_DEBUG_INFO, ("Query::OID_802_3_CURRENT_ADDRESS \n"));
			break;

		case OID_GEN_MEDIA_CONNECT_STATUS:
			DBGPRINT(RT_DEBUG_INFO, ("Query::OID_GEN_MEDIA_CONNECT_STATUS \n"));

			if (OPSTATUS_TEST_FLAG(pAdapter, fOP_STATUS_MEDIA_STATE_CONNECTED))
				MediaState = NdisMediaStateConnected;
			else
				MediaState = NdisMediaStateDisconnected;
				
			wrq->u.data.length = sizeof(NDIS_MEDIA_STATE);
			Status = copy_to_user(wrq->u.data.pointer, &MediaState, wrq->u.data.length);
			break;
	 
		case OID_802_11_BSSID:
			if (INFRA_ON(pAdapter) || ADHOC_ON(pAdapter))
			{
				wrq->u.data.length = sizeof(NDIS_802_11_MAC_ADDRESS);
				Status = copy_to_user(wrq->u.data.pointer, &pAdapter->CommonCfg.Bssid, wrq->u.data.length);

				DBGPRINT(RT_DEBUG_INFO, ("IOCTL::SIOCGIWAP(=%02x:%02x:%02x:%02x:%02x:%02x)\n",
						pAdapter->CommonCfg.Bssid[0],pAdapter->CommonCfg.Bssid[1],pAdapter->CommonCfg.Bssid[2],
						pAdapter->CommonCfg.Bssid[3],pAdapter->CommonCfg.Bssid[4],pAdapter->CommonCfg.Bssid[5]));

			}
			else
			{
				DBGPRINT(RT_DEBUG_TRACE, ("Query::OID_802_11_BSSID(=EMPTY)\n"));
				Status = -ENOTCONN;
			}
			break;

		case OID_802_11_SSID:
			Ssid.SsidLength = pAdapter->CommonCfg.SsidLen;
			NdisZeroMemory(Ssid.Ssid, MAX_LEN_OF_SSID);
			NdisMoveMemory(Ssid.Ssid, pAdapter->CommonCfg.Ssid, Ssid.SsidLength);
			wrq->u.data.length = sizeof(NDIS_802_11_SSID);
			Status = copy_to_user(wrq->u.data.pointer, &Ssid, wrq->u.data.length);
			DBGPRINT(RT_DEBUG_TRACE, ("Query::OID_802_11_SSID (Len=%d, ssid=%s)\n", Ssid.SsidLength,Ssid.Ssid));
			break;

		case RT_OID_802_11_QUERY_LINK_STATUS:
			LinkStatus.CurrTxRate = RateIdTo500Kbps[pAdapter->CommonCfg.TxRate];	 // unit : 500 kbps
			LinkStatus.ChannelQuality = pAdapter->Mlme.ChannelQuality;
			LinkStatus.RxByteCount = pAdapter->RalinkCounters.ReceivedByteCount;
			LinkStatus.TxByteCount = pAdapter->RalinkCounters.TransmittedByteCount;
			LinkStatus.CentralChannel = pAdapter->CommonCfg.CentralChannel;
			wrq->u.data.length = sizeof(RT_802_11_LINK_STATUS);
			Status = copy_to_user(wrq->u.data.pointer, &LinkStatus, wrq->u.data.length);
			DBGPRINT(RT_DEBUG_TRACE, ("Query::RT_OID_802_11_QUERY_LINK_STATUS\n"));
			break;
		case OID_802_11_CONFIGURATION:
			Configuration.Length = sizeof(NDIS_802_11_CONFIGURATION);
			Configuration.BeaconPeriod = pAdapter->CommonCfg.BeaconPeriod;
			Configuration.ATIMWindow = pAdapter->StaActive.AtimWin;
			MAP_CHANNEL_ID_TO_KHZ(pAdapter->CommonCfg.Channel, Configuration.DSConfig);
			wrq->u.data.length = sizeof(NDIS_802_11_CONFIGURATION);
			Status = copy_to_user(wrq->u.data.pointer, &Configuration, wrq->u.data.length);
			DBGPRINT(RT_DEBUG_TRACE, ("Query::OID_802_11_CONFIGURATION(BeaconPeriod=%ld,AtimW=%ld,Channel=%d) \n", 
    	    	    	    	Configuration.BeaconPeriod, Configuration.ATIMWindow, pAdapter->CommonCfg.Channel));
			break;

		case RT_OID_802_11_SNR_0:
			{
				ulInfo = ((0xeb	- pAdapter->StaCfg.LastSNR0) * 3) /	16 ;
				wrq->u.data.length = sizeof(ulInfo);
				Status = copy_to_user(wrq->u.data.pointer, &ulInfo,	wrq->u.data.length);
				DBGPRINT(RT_DEBUG_TRACE, ("Query::RT_OID_802_11_SNR_0(0x=%lx)\n", ulInfo));
			}
			break;

		case RT_OID_802_11_SNR_1:
			if ((pAdapter->Antenna.field.TxPath	> 1))
			{
				ulInfo = ((0xeb	- pAdapter->StaCfg.LastSNR1) * 3) /	16 ;
				wrq->u.data.length = sizeof(ulInfo);
				Status = copy_to_user(wrq->u.data.pointer, &ulInfo,	wrq->u.data.length);
				DBGPRINT(RT_DEBUG_INFO,	("Query::RT_OID_802_11_SNR_1(0x=%lx)\n",	ulInfo));
			}
			else
				Status = NDIS_STATUS_FAILURE;
			break;

		case OID_802_11_RSSI_TRIGGER:
			ulInfo = pAdapter->StaCfg.LastRssi- pAdapter->BbpRssiToDbmDelta;
			wrq->u.data.length = sizeof(ulInfo);
			Status = copy_to_user(wrq->u.data.pointer, &ulInfo, wrq->u.data.length);
			DBGPRINT(RT_DEBUG_TRACE, ("Query::OID_802_11_RSSI_TRIGGER(=%ld)\n", ulInfo));
			break;

		case OID_802_11_RSSI:
        case RT_OID_802_11_RSSI:
			ulInfo = pAdapter->StaCfg.LastRssi;
			wrq->u.data.length = sizeof(ulInfo);
			Status = copy_to_user(wrq->u.data.pointer, &ulInfo,	wrq->u.data.length);
			DBGPRINT(RT_DEBUG_INFO,	("Query::OID_802_11_RSSI(=%ld)\n", ulInfo));
			break;

		case RT_OID_802_11_RSSI_1:
			DBGPRINT(RT_DEBUG_INFO,	("Query::RT_OID_802_11_RSSI_1"));
			if (pAdapter->Antenna.field.RxPath > 1)
			{
				UCHAR	BBPValue = 0;

				//RTMP_BBP_IO_READ8_BY_REG_ID(pAdapter, BBP_R3, &BBPValue);
				RTUSBWriteBBPRegister(pAdapter, (UCHAR)BBP_R3,(UCHAR) BBPValue);
				if (((BBPValue & 0x18) >> 3) >=	1)
					ulInfo = pAdapter->StaCfg.LastRssi2;
				else
					ulInfo = -200;

				wrq->u.data.length = sizeof(ulInfo);
				Status = copy_to_user(wrq->u.data.pointer, &ulInfo,	wrq->u.data.length);
				DBGPRINT(RT_DEBUG_INFO,	("Query::RT_OID_802_11_RSSI_1(=%ld)\n", ulInfo));
			}
			else
				Status = NDIS_STATUS_FAILURE;
			break;

        case RT_OID_802_11_RSSI_2:
			if (pAdapter->Antenna.field.RxPath > 2)
			{
				UCHAR	BBPValue = 0;
					
				//RTMP_BBP_IO_READ8_BY_REG_ID(pAdapter, BBP_R3, &BBPValue);
				RTUSBWriteBBPRegister(pAdapter, (UCHAR)BBP_R3,(UCHAR) BBPValue);
				if (((BBPValue & 0x18) >> 3) ==	2)
					ulInfo = pAdapter->StaCfg.LastRssi2;
				else
					ulInfo = -200;

				wrq->u.data.length = sizeof(ulInfo);
				Status = copy_to_user(wrq->u.data.pointer, &ulInfo,	wrq->u.data.length);
				DBGPRINT(RT_DEBUG_INFO, ("Query::RT_OID_802_11_RSSI_2(=%ld)\n", ulInfo));
			}
			else
				Status = NDIS_STATUS_FAILURE;
			break;

		case OID_802_11_STATISTICS:
			DBGPRINT(RT_DEBUG_TRACE, ("Query::OID_802_11_STATISTICS \n"));
			Status = RTUSBEnqueueCmdFromNdis(pAdapter, OID_802_11_STATISTICS, FALSE, &Statistics, sizeof(NDIS_802_11_STATISTICS));
            // Sanity check for calculation of sucessful count
            if (pAdapter->WlanCounters.TransmittedFragmentCount.QuadPart < pAdapter->WlanCounters.RetryCount.QuadPart)
                pAdapter->WlanCounters.TransmittedFragmentCount.QuadPart = pAdapter->WlanCounters.RetryCount.QuadPart;

            Statistics.TransmittedFragmentCount.QuadPart = pAdapter->WlanCounters.TransmittedFragmentCount.QuadPart;
            Statistics.MulticastTransmittedFrameCount.QuadPart = pAdapter->WlanCounters.MulticastTransmittedFrameCount.QuadPart;
            Statistics.FailedCount.QuadPart = pAdapter->WlanCounters.FailedCount.QuadPart;
            Statistics.RetryCount.QuadPart = pAdapter->WlanCounters.RetryCount.QuadPart;
            Statistics.MultipleRetryCount.QuadPart = pAdapter->WlanCounters.MultipleRetryCount.QuadPart;
            Statistics.RTSSuccessCount.QuadPart = pAdapter->WlanCounters.RTSSuccessCount.QuadPart;
            Statistics.RTSFailureCount.QuadPart = pAdapter->WlanCounters.RTSFailureCount.QuadPart;
            Statistics.ACKFailureCount.QuadPart = pAdapter->WlanCounters.ACKFailureCount.QuadPart;
            Statistics.FrameDuplicateCount.QuadPart = pAdapter->WlanCounters.FrameDuplicateCount.QuadPart;
            Statistics.ReceivedFragmentCount.QuadPart = pAdapter->WlanCounters.ReceivedFragmentCount.QuadPart;
            Statistics.MulticastReceivedFrameCount.QuadPart = pAdapter->WlanCounters.MulticastReceivedFrameCount.QuadPart;
#ifdef DBG	
            Statistics.FCSErrorCount = pAdapter->RalinkCounters.RealFcsErrCount;
#else
            Statistics.FCSErrorCount.QuadPart = pAdapter->WlanCounters.FCSErrorCount.QuadPart;
            Statistics.FrameDuplicateCount.LowPart = pAdapter->WlanCounters.FrameDuplicateCount.LowPart / 100;
#endif
			wrq->u.data.length = sizeof(NDIS_802_11_STATISTICS);
			Status = copy_to_user(wrq->u.data.pointer, &Statistics, wrq->u.data.length);
			break;
			 
		case OID_GEN_RCV_OK:
			DBGPRINT(RT_DEBUG_INFO, ("Query::OID_GEN_RCV_OK \n"));
			ulInfo = pAdapter->Counters8023.GoodReceives;
			wrq->u.data.length = sizeof(ulInfo);
			Status = copy_to_user(wrq->u.data.pointer, &ulInfo, wrq->u.data.length);
			break;
		case OID_GEN_RCV_NO_BUFFER:
			DBGPRINT(RT_DEBUG_INFO, ("Query::OID_GEN_RCV_NO_BUFFER \n"));
			ulInfo = pAdapter->Counters8023.RxNoBuffer;
			wrq->u.data.length = sizeof(ulInfo);
			Status = copy_to_user(wrq->u.data.pointer, &ulInfo, wrq->u.data.length);
			break;

		case RT_OID_802_11_PHY_MODE:
			ulInfo = (ULONG)pAdapter->CommonCfg.PhyMode;
			wrq->u.data.length = sizeof(ulInfo);
			Status = copy_to_user(wrq->u.data.pointer, &ulInfo, wrq->u.data.length);
			DBGPRINT(RT_DEBUG_TRACE, ("Query::RT_OID_802_11_PHY_MODE (=%ld)\n", ulInfo));
			break;

		case RT_OID_802_11_STA_CONFIG:
			DBGPRINT(RT_DEBUG_TRACE, ("Query::RT_OID_802_11_STA_CONFIG\n"));
			StaConfig.EnableTxBurst = pAdapter->CommonCfg.bEnableTxBurst;
            StaConfig.EnableTurboRate = 0; //pAdapter->PortCfg.EnableTurboRate;
			StaConfig.UseBGProtection = pAdapter->CommonCfg.UseBGProtection;
			StaConfig.UseShortSlotTime = pAdapter->CommonCfg.bUseShortSlotTime;
			StaConfig.AdhocMode = pAdapter->StaCfg.AdhocMode;
			StaConfig.HwRadioStatus = (pAdapter->StaCfg.bHwRadio == TRUE) ? 1 : 0;
			StaConfig.Rsv1 = (pAdapter->bPromiscuous == TRUE) ? 1 : 0;
			StaConfig.SystemErrorBitmap = pAdapter->SystemErrorBitmap;
			wrq->u.data.length = sizeof(RT_802_11_STA_CONFIG);
			Status = copy_to_user(wrq->u.data.pointer, &StaConfig, wrq->u.data.length);
			break;

		case OID_802_11_RTS_THRESHOLD:
			RtsThresh = pAdapter->CommonCfg.RtsThreshold;
			wrq->u.data.length = sizeof(RtsThresh);
			Status = copy_to_user(wrq->u.data.pointer, &RtsThresh, wrq->u.data.length);
			DBGPRINT(RT_DEBUG_TRACE, ("Query::OID_802_11_RTS_THRESHOLD(=%ld)\n", RtsThresh));
			break;

		case OID_802_11_FRAGMENTATION_THRESHOLD:
			FragThresh = pAdapter->CommonCfg.FragmentThreshold;
			if (pAdapter->CommonCfg.bUseZeroToDisableFragment == TRUE)
				FragThresh = 0;
			wrq->u.data.length = sizeof(FragThresh);
			Status = copy_to_user(wrq->u.data.pointer, &FragThresh, wrq->u.data.length);
			DBGPRINT(RT_DEBUG_TRACE, ("Query::OID_802_11_FRAGMENTATION_THRESHOLD(=%ld)\n", FragThresh));
			break;

		case OID_802_11_POWER_MODE:
			PowerMode = pAdapter->StaCfg.WindowsPowerMode;
			wrq->u.data.length = sizeof(PowerMode);
			Status = copy_to_user(wrq->u.data.pointer, &PowerMode, wrq->u.data.length);
			DBGPRINT(RT_DEBUG_TRACE, ("Query::OID_802_11_POWER_MODE(=%d)\n", PowerMode));
			break;

		case RT_OID_802_11_RADIO:
			RadioState = (BOOLEAN) pAdapter->StaCfg.bSwRadio;
			wrq->u.data.length = sizeof(RadioState);
			Status = copy_to_user(wrq->u.data.pointer, &RadioState, wrq->u.data.length);
			DBGPRINT(RT_DEBUG_TRACE, ("Query::RT_OID_802_11_QUERY_RADIO (=%d)\n", RadioState));
			break;

		case OID_802_11_INFRASTRUCTURE_MODE:
			if (ADHOC_ON(pAdapter))
				BssType = Ndis802_11IBSS;
			else if (INFRA_ON(pAdapter))
				BssType = Ndis802_11Infrastructure;
			else
				BssType = Ndis802_11AutoUnknown;

			wrq->u.data.length = sizeof(BssType);
			Status = copy_to_user(wrq->u.data.pointer, &BssType, wrq->u.data.length);
			DBGPRINT(RT_DEBUG_TRACE, ("Query::OID_802_11_INFRASTRUCTURE_MODE(=%d)\n", BssType));
			break;

		case RT_OID_802_11_PREAMBLE:
			PreamType = pAdapter->CommonCfg.TxPreamble;
			wrq->u.data.length = sizeof(PreamType);
			Status = copy_to_user(wrq->u.data.pointer, &PreamType, wrq->u.data.length);
			DBGPRINT(RT_DEBUG_TRACE, ("Query::RT_OID_802_11_PREAMBLE(=%d)\n", PreamType));
			break;

		case OID_802_11_AUTHENTICATION_MODE:
			AuthMode = pAdapter->CommonCfg.AuthMode;
			wrq->u.data.length = sizeof(AuthMode);
			Status = copy_to_user(wrq->u.data.pointer, &AuthMode, wrq->u.data.length);
			DBGPRINT(RT_DEBUG_TRACE, ("Query::OID_802_11_AUTHENTICATION_MODE(=%d)\n", AuthMode));
			break;

		case OID_802_11_WEP_STATUS:
			WepStatus = pAdapter->CommonCfg.WepStatus;
			wrq->u.data.length = sizeof(WepStatus);
			Status = copy_to_user(wrq->u.data.pointer, &WepStatus, wrq->u.data.length);
			DBGPRINT(RT_DEBUG_TRACE, ("Query::OID_802_11_WEP_STATUS(=%d)\n", WepStatus));
			break;

		case OID_802_11_TX_POWER_LEVEL:
			wrq->u.data.length = sizeof(ULONG);
			Status = copy_to_user(wrq->u.data.pointer, &pAdapter->CommonCfg.TxPower, wrq->u.data.length);
			DBGPRINT(RT_DEBUG_TRACE, ("Query::OID_802_11_TX_POWER_LEVEL %x\n",pAdapter->CommonCfg.TxPower));
			break;

		case RT_OID_802_11_TX_POWER_LEVEL_1:
			wrq->u.data.length = sizeof(ULONG);
			Status = copy_to_user(wrq->u.data.pointer, &pAdapter->CommonCfg.TxPowerPercentage, wrq->u.data.length);
			DBGPRINT(RT_DEBUG_TRACE, ("Query::RT_OID_802_11_TX_POWER_LEVEL_1 (=%ld)\n", pAdapter->CommonCfg.TxPowerPercentage));
			break;

		case OID_802_11_NETWORK_TYPES_SUPPORTED:
			if ((pAdapter->RfIcType == RFIC_2850) || (pAdapter->RfIcType == RFIC_2750))
			{
				NetworkTypeList[0] = 3;				// NumberOfItems = 3
				NetworkTypeList[1] = Ndis802_11DS;		// NetworkType[1] = 11b
				NetworkTypeList[2] = Ndis802_11OFDM24;		// NetworkType[2] = 11g
				NetworkTypeList[3] = Ndis802_11OFDM5;		// NetworkType[3] = 11a
				wrq->u.data.length = 16;
				Status = copy_to_user(wrq->u.data.pointer, &NetworkTypeList[0], wrq->u.data.length);
			}
			else
			{
				NetworkTypeList[0] = 2;				// NumberOfItems = 2
				NetworkTypeList[1] = Ndis802_11DS;		// NetworkType[1] = 11b
				NetworkTypeList[2] = Ndis802_11OFDM24;		// NetworkType[2] = 11g
				wrq->u.data.length = 12;
				Status = copy_to_user(wrq->u.data.pointer, &NetworkTypeList[0], wrq->u.data.length);
			}
			DBGPRINT(RT_DEBUG_TRACE, ("Query::OID_802_11_NETWORK_TYPES_SUPPORTED\n"));
			break;

		case OID_802_11_NETWORK_TYPE_IN_USE:
			wrq->u.data.length = sizeof(ULONG);
			if (pAdapter->CommonCfg.PhyMode == PHY_11A)
				ulInfo = Ndis802_11OFDM5;
			else if ((pAdapter->CommonCfg.PhyMode == PHY_11BG_MIXED) || (pAdapter->CommonCfg.PhyMode == PHY_11ABGN_MIXED)|| (pAdapter->CommonCfg.PhyMode == PHY_11G))
				ulInfo = Ndis802_11OFDM24;
			else
				ulInfo = Ndis802_11DS;
			Status = copy_to_user(wrq->u.data.pointer, &ulInfo, wrq->u.data.length);
			DBGPRINT(RT_DEBUG_INFO, ("Query::OID_802_11_NETWORK_TYPE_IN_USE(=%ld)\n", ulInfo));
			break;

		case RT_OID_802_11_QUERY_LAST_RX_RATE:
			ulInfo = (ULONG)pAdapter->LastRxRate;
			wrq->u.data.length = sizeof(ulInfo);
			Status = copy_to_user(wrq->u.data.pointer, &ulInfo, wrq->u.data.length);
			DBGPRINT(RT_DEBUG_TRACE, ("Query::RT_OID_802_11_QUERY_LAST_RX_RATE (=%ld)\n", ulInfo));
			break;

		case RT_OID_802_11_QUERY_LAST_TX_RATE:
			ulInfo = pAdapter->LastTxRate;
			wrq->u.data.length = sizeof(ulInfo);
			Status = copy_to_user(wrq->u.data.pointer, &ulInfo,	wrq->u.data.length);
			DBGPRINT(RT_DEBUG_TRACE, ("Query::RT_OID_802_11_QUERY_LAST_TX_RATE (=%lx)\n", ulInfo));
			break;

		case RT_OID_802_11_QUERY_EEPROM_VERSION:
			wrq->u.data.length = sizeof(ULONG);
			Status = copy_to_user(wrq->u.data.pointer, &pAdapter->EepromVersion, wrq->u.data.length);
			DBGPRINT(RT_DEBUG_INFO, ("Query::RT_OID_802_11_QUERY_EEPROM_VERSION (=%ld)\n", pAdapter->EepromVersion));
			break;

		case RT_OID_802_11_QUERY_FIRMWARE_VERSION:
			wrq->u.data.length = sizeof(ULONG);
			Status = copy_to_user(wrq->u.data.pointer, &pAdapter->FirmwareVersion, wrq->u.data.length);
			DBGPRINT(RT_DEBUG_INFO, ("Query::RT_OID_802_11_QUERY_FIRMWARE_VERSION (=%ld)\n", pAdapter->FirmwareVersion));
			break;

		case RT_OID_802_11_QUERY_NOISE_LEVEL:
			// TODO: how to measure NOISE LEVEL now?????
			wrq->u.data.length = sizeof(UCHAR);
			Status = copy_to_user(wrq->u.data.pointer, &pAdapter->BbpWriteLatch[66], wrq->u.data.length);
			DBGPRINT(RT_DEBUG_TRACE, ("Query::RT_OID_802_11_QUERY_NOISE_LEVEL (=%d)\n", pAdapter->BbpWriteLatch[66]));
			break;

		case RT_OID_802_11_EXTRA_INFO:
			wrq->u.data.length = sizeof(ULONG);
			Status = copy_to_user(wrq->u.data.pointer, &pAdapter->ExtraInfo, wrq->u.data.length);
			DBGPRINT(RT_DEBUG_TRACE, ("Query::RT_OID_802_11_EXTRA_INFO (=%ld)\n", pAdapter->ExtraInfo));
			break;
#if 0 //TODO: disabled temporal
		case RT_OID_802_11_QUERY_PIDVID:
			wrq->u.data.length = sizeof(ULONG);
			Status = copy_to_user(wrq->u.data.pointer, &pAdapter->VendorDesc, wrq->u.data.length);
			DBGPRINT(RT_DEBUG_INFO, ("Query::RT_OID_802_11_QUERY_PIDVID (=%d)\n", pAdapter->VendorDesc));
			break;
#endif
		case RT_OID_WE_VERSION_COMPILED:
			wrq->u.data.length = sizeof(UINT);
			we_version_compiled = WIRELESS_EXT;
			Status = copy_to_user(wrq->u.data.pointer, &we_version_compiled, wrq->u.data.length);
			DBGPRINT(RT_DEBUG_INFO, ("Query::RT_OID_WE_VERSION_COMPILED (=%d)\n", we_version_compiled));
			break;

		default:
			DBGPRINT(RT_DEBUG_TRACE, ("Query::unknown IOCTL's subcmd = 0x%08x\n", cmd));
			Status = -EOPNOTSUPP;
			break;
	}
	return Status;
}

INT rt2870_ioctl(
	IN	struct net_device	*net_dev, 
	IN	OUT	struct ifreq	*rq, 
	IN	INT			cmd)
{
	RTMP_ADAPTER						*pAd = net_dev->priv;
	struct iwreq						*wrq = (struct iwreq *) rq;
	struct iw_point 					*erq = NULL;
	struct iw_freq						*frq = NULL;
	NDIS_802_11_SSID					Ssid, *pSsid=NULL;
	NDIS_802_11_NETWORK_INFRASTRUCTURE		BssType = Ndis802_11Infrastructure;
	NDIS_802_11_RTS_THRESHOLD				RtsThresh;
	NDIS_802_11_FRAGMENTATION_THRESHOLD		FragThresh;
	NDIS_802_11_MAC_ADDRESS					Bssid;
	BOOLEAN									StateMachineTouched = FALSE;
	INT										Status = NDIS_STATUS_SUCCESS;
	USHORT									subcmd;
	int										chan=-1, index=0, len=0, i=0;
	POS_COOKIE								pObj = (POS_COOKIE) pAd->OS_Cookie;
	RT_SET_ASIC_WCID_ATTRI					SetAsicWcidAttri;
	
	if ( (RTMP_TEST_FLAG(pAd , fRTMP_ADAPTER_NIC_NOT_EXIST)) || 
		 (RTMP_TEST_FLAG(pAd , fRTMP_ADAPTER_RESET_IN_PROGRESS)))
	{
		DBGPRINT(RT_DEBUG_TRACE, ("IOCTL::remove in progress!\n"));
		return -ENETDOWN;
	}
	if (pObj->RTUSBCmdThr_pid < 0)
		return -ENETDOWN;
		
	switch(cmd)
	{			
		case SIOCGIFHWADDR:     //get  MAC addresses
			DBGPRINT(RT_DEBUG_TRACE, ("IOCTL::SIOCGIFHWADDR\n"));
			memcpy(wrq->u.name, pAd->CurrentAddress, ETH_ALEN);
			DBGPRINT(RT_DEBUG_TRACE, ("IOCTL::SIOCGIFHWADDR(=%02x:%02x:%02x:%02x:%02x:%02x)\n",
				pAd->CurrentAddress[0],pAd->CurrentAddress[1],pAd->CurrentAddress[2],
				pAd->CurrentAddress[3],pAd->CurrentAddress[4],pAd->CurrentAddress[5]));
			break;

		case SIOCGIWNAME:
			DBGPRINT(RT_DEBUG_TRACE, ("IOCTL::SIOCGIWNAME\n"));
			strcpy(wrq->u.name, "RT2870 WLAN");
			break;

		case SIOCSIWESSID:	//Set ESSID
			erq = &wrq->u.essid;
			memset(&Ssid, 0x00, sizeof(NDIS_802_11_SSID));
			if (erq->flags)
			{
				if (erq->length > IW_ESSID_MAX_SIZE)
				{
					Status = -E2BIG;
					break;
				}

				Status = copy_from_user(Ssid.Ssid, erq->pointer, (erq->length - 1));
				Ssid.SsidLength = erq->length - 1;	//minus null character.
			}
			else
			{	
				Ssid.SsidLength = 0;  // ANY ssid 
				memcpy(pSsid->Ssid, "", 0);	    
			}
			pSsid = &Ssid;
			if (pAd->Mlme.CntlMachine.CurrState != CNTL_IDLE)
			{
				MlmeEnqueue(pAd, 
					MLME_CNTL_STATE_MACHINE,
					RT_CMD_RESET_MLME,
					0,
					NULL);
			}
				
			// To prevent some kernel thread is very low priority ...so essid copy immediately for later wpapsk counting.
			if (pAd->CommonCfg.AuthMode >= Ndis802_11AuthModeWPA)
			{
				NdisMoveMemory(pAd->MlmeAux.Ssid, Ssid.Ssid, Ssid.SsidLength);
				pAd->MlmeAux.SsidLen = Ssid.SsidLength;
			}
				
			MlmeEnqueue(pAd, 
					MLME_CNTL_STATE_MACHINE, 
					OID_802_11_SSID,
					sizeof(NDIS_802_11_SSID),
					(VOID *)pSsid);
					
			Status = NDIS_STATUS_SUCCESS;
			StateMachineTouched = TRUE;
			DBGPRINT(RT_DEBUG_TRACE, ("IOCTL::SIOCSIWESSID[cmd=0x%x] (Len=%d,Ssid=%s)\n", SIOCSIWESSID, pSsid->SsidLength, pSsid->Ssid));
			break;

		case SIOCGIWESSID:	//Get ESSID
			erq = &wrq->u.essid;

			if (OPSTATUS_TEST_FLAG(pAd, fOP_STATUS_MEDIA_STATE_CONNECTED))
			{
				erq->flags=1;
				erq->length = pAd->CommonCfg.SsidLen;
				Status = copy_to_user(erq->pointer, pAd->CommonCfg.Ssid, erq->length);
			}
			else
			{	//the ANY ssid was specified
				erq->flags=0;
				erq->length=0;
			}
			DBGPRINT(RT_DEBUG_TRACE, ("IOCTL::SIOCGIWESSID (Len=%d, ssid=%lu...)\n", erq->length, (unsigned long)erq->pointer));
			break;
	   
		case SIOCSIWNWID:	// set network id (the cell)
		case SIOCGIWNWID:	// get network id
			Status = -EOPNOTSUPP;
			break;

		case SIOCSIWFREQ:	//set channel/frequency (Hz)
			frq = &wrq->u.freq;
			if((frq->e == 0) && (frq->m <= 1000))
				chan = frq->m;	// Setting by channel number 
			else
				MAP_KHZ_TO_CHANNEL_ID( (frq->m /100) , chan); // Setting by frequency - search the table , like 2.412G, 2.422G, 
			pAd->CommonCfg.Channel = chan;
			DBGPRINT(RT_DEBUG_TRACE, ("IOCTL::SIOCSIWFREQ[cmd=0x%x] (Channel=%d)\n", SIOCSIWFREQ, pAd->CommonCfg.Channel));
			break;

		case SIOCGIWFREQ:	// get channel/frequency (Hz)
			wrq->u.freq.m = pAd->CommonCfg.Channel;
			wrq->u.freq.e = 0;
			wrq->u.freq.i = 0;
			break;

#if 0 // Snowpin: TODO, disabled temporal 2006.07.18
		case SIOCSIWNICKN: //set node name/nickname
			erq = &wrq->u.data;
			if (erq->flags)
			{
				if (erq->length <= IW_ESSID_MAX_SIZE)
					Status = copy_from_user(pAd->nickn, erq->pointer, erq->length);
				else
					Status = -E2BIG;
			}
			break;

		case SIOCGIWNICKN: //get node name/nickname
			erq = &wrq->u.data;
			erq->length = strlen(pAd->nickn);
			Status = copy_to_user(erq->pointer, pAd->nickn, erq->length);
			break;
#endif		
		case SIOCGIWRATE:	//get default bit rate (bps)
			wrq->u.bitrate.value = GetTxRate(pAd);
			wrq->u.bitrate.disabled = 0;
			break;

		case SIOCSIWRATE:  //set default bit rate (bps)
			RTMPSetDesiredRates(pAd, wrq->u.bitrate.value);
			break;

		case SIOCGIWRTS:  // get RTS/CTS threshold (bytes)
			wrq->u.rts.value = (INT) pAd->CommonCfg.RtsThreshold;
			wrq->u.rts.disabled = (wrq->u.rts.value == MAX_RTS_THRESHOLD);
			wrq->u.rts.fixed = 1;
			break;

		case SIOCSIWRTS:  //set RTS/CTS threshold (bytes)
		{
			UINT32				MacReg[4];
			PCMDHandler_TLV pTLV = (PCMDHandler_TLV)&MacReg[0];

			RtsThresh = wrq->u.rts.value;
			if (wrq->u.rts.disabled) // "off"
				RtsThresh = MAX_RTS_THRESHOLD;
			if((RtsThresh < 0) || (RtsThresh > MAX_RTS_THRESHOLD))
			{	//illegal RtsThreshold so we set it to default
				RtsThresh = MAX_RTS_THRESHOLD;
			}
			pAd->CommonCfg.RtsThreshold = (USHORT)RtsThresh;

			// +++ Config ASIC RTS threshold register
			MacReg[1] = 0x20;
			MacReg[1] |= (pAd->CommonCfg.RtsThreshold << 8);
			pTLV->Offset = TX_RTS_CFG;
			pTLV->Length = 4;
			RTUSBEnqueueInternalCmd(pAd, RT_OID_MULTI_WRITE_MAC,  &MacReg[0], 8);	

			DBGPRINT(RT_DEBUG_TRACE, ("IOCTL::SIOCSIWRTS (=%d)\n", pAd->CommonCfg.RtsThreshold));
			break;
		}
		case SIOCGIWFRAG:  //get fragmentation thr (bytes)
			wrq->u.frag.value = (INT) pAd->CommonCfg.FragmentThreshold;
			wrq->u.frag.disabled = (wrq->u.frag.value == MAX_FRAG_THRESHOLD);
			wrq->u.frag.fixed = 1;
			break;

		case SIOCSIWFRAG:  //set fragmentation thr (bytes)
			FragThresh = wrq->u.frag.value;
			pAd->CommonCfg.bUseZeroToDisableFragment = FALSE;

			if (wrq->u.rts.disabled) // "off"
			{
				FragThresh = MAX_FRAG_THRESHOLD;
				pAd->CommonCfg.bUseZeroToDisableFragment = TRUE;
			}
			if (FragThresh > MAX_FRAG_THRESHOLD || FragThresh < MIN_FRAG_THRESHOLD)
			{//illegal FragThresh so we set it to default
				FragThresh = MAX_FRAG_THRESHOLD;
			}
			pAd->CommonCfg.FragmentThreshold = (USHORT)FragThresh;
			DBGPRINT(RT_DEBUG_TRACE, ("IOCTL::SIOCSIWFRAG (=%d)\n", pAd->CommonCfg.FragmentThreshold));
			break;

		case SIOCGIWENCODE:  //get encoding token & mode
			index = (wrq->u.encoding.flags & IW_ENCODE_INDEX) - 1;
			if ((index < 0) || (index >= NR_WEP_KEYS))
				index = pAd->CommonCfg.DefaultKeyId; // Default key for tx (shared key)

			if (pAd->CommonCfg.AuthMode == Ndis802_11AuthModeOpen)
				wrq->u.encoding.flags = IW_ENCODE_OPEN;
			else if (pAd->CommonCfg.AuthMode == Ndis802_11AuthModeShared)
				wrq->u.encoding.flags = IW_ENCODE_RESTRICTED;

			if (pAd->CommonCfg.WepStatus == Ndis802_11WEPDisabled)
				wrq->u.encoding.flags |= IW_ENCODE_DISABLED;
			else
			{
				if(wrq->u.encoding.pointer)
				{
					wrq->u.encoding.length = pAd->SharedKey[BSS0][index].KeyLen;
					Status = copy_to_user(wrq->u.encoding.pointer, 
						pAd->SharedKey[BSS0][index].Key,
						pAd->SharedKey[BSS0][index].KeyLen);
					wrq->u.encoding.flags |= (index + 1);
				}
			}
			break;

		case SIOCSIWENCODE:  //set encoding token & mode
			index = (wrq->u.encoding.flags & IW_ENCODE_INDEX) - 1;
			/* take the old default key if index is invalid */
			if((index < 0) || (index >= NR_WEP_KEYS))
				index = pAd->CommonCfg.DefaultKeyId;	   // Default key for tx (shared key)

			pAd->CommonCfg.DefaultKeyId = (UCHAR) index;
			// wep status
			if (wrq->u.encoding.flags & IW_ENCODE_DISABLED)
			{
				pAd->CommonCfg.WepStatus = Ndis802_11WEPDisabled;
				SetAsicWcidAttri.Cipher = CIPHER_NONE;
			}	
			else
			{
				pAd->CommonCfg.WepStatus = Ndis802_11WEPEnabled;
				SetAsicWcidAttri.Cipher = CIPHER_WEP64;
			}
			pAd->CommonCfg.PairCipher = pAd->CommonCfg.WepStatus;
			pAd->CommonCfg.GroupCipher = pAd->CommonCfg.WepStatus;
			pAd->CommonCfg.MixedModeGroupCipher = Cipher_Type_NONE;

			// authentication mode
			if (wrq->u.encoding.flags & IW_ENCODE_RESTRICTED)
				pAd->CommonCfg.AuthMode = Ndis802_11AuthModeShared;
			else 
				pAd->CommonCfg.AuthMode = Ndis802_11AuthModeOpen;

			if(pAd->CommonCfg.WepStatus == Ndis802_11WEPDisabled)
				pAd->CommonCfg.AuthMode = Ndis802_11AuthModeOpen;

			// add key
			if(wrq->u.encoding.pointer)
			{	
				PNDIS_802_11_KEY	pKey = NULL;
				ULONG				TotalLen;
				
				len = wrq->u.encoding.length;
				if((len !=  WEP_LARGE_KEY_LEN) ||(len !=  WEP_SMALL_KEY_LEN))
				{
					Status = -EINVAL;
					break;
				}
				
				// prepare a ndis key
				TotalLen = sizeof(NDIS_802_11_KEY) + len - 1;
				// memory allocate
				os_alloc_mem(NULL, (PUCHAR *)&pKey, TotalLen);
				if(!pKey)
				{
					Status = -ENOMEM;
					break;
				}
				
				NdisZeroMemory(pKey, TotalLen);
				pKey->Length = TotalLen;
				pKey->KeyIndex = (0x80000000 | pAd->CommonCfg.DefaultKeyId);
				pKey->KeyLength = len;
				Status = copy_from_user(pKey->KeyMaterial, wrq->u.encoding.pointer, len);
				for (i=0; i<6; i++)
					pKey->BSSID[i] = 0xff;
				// need to enqueue cmd to thread
				RTUSBEnqueueCmdFromNdis(pAd, OID_802_11_ADD_KEY_WEP, TRUE, pKey, TotalLen);
		
				os_free_mem(NULL, (PUCHAR)pKey);
			}	
			break;

		case SIOCGIWAP: 	//get access point MAC addresses
			if (INFRA_ON(pAd) || ADHOC_ON(pAd))
			{
				wrq->u.ap_addr.sa_family = ARPHRD_ETHER;
				memcpy(wrq->u.ap_addr.sa_data, &pAd->CommonCfg.Bssid, ETH_ALEN);
				DBGPRINT(RT_DEBUG_TRACE, ("IOCTL::SIOCGIWAP(=%02x:%02x:%02x:%02x:%02x:%02x)\n",
					pAd->CommonCfg.Bssid[0],pAd->CommonCfg.Bssid[1],pAd->CommonCfg.Bssid[2],
					pAd->CommonCfg.Bssid[3],pAd->CommonCfg.Bssid[4],pAd->CommonCfg.Bssid[5]));
			}
			else
			{
				DBGPRINT(RT_DEBUG_TRACE, ("IOCTL::SIOCGIWAP(=EMPTY)\n"));
				Status = -ENOTCONN;
			}
			break;

		case SIOCSIWAP:  //set access point MAC addresses
			Status = copy_from_user(&Bssid, &wrq->u.ap_addr.sa_data, sizeof(NDIS_802_11_MAC_ADDRESS));
			if (pAd->Mlme.CntlMachine.CurrState != CNTL_IDLE)
			{
				MlmeEnqueue(pAd, 
					        MLME_CNTL_STATE_MACHINE,
 					        RT_CMD_RESET_MLME,
					        0,
					        NULL);					
			}

			MlmeEnqueue(pAd, 
						MLME_CNTL_STATE_MACHINE, 
						OID_802_11_BSSID, 
						sizeof(NDIS_802_11_MAC_ADDRESS),
						(VOID *)&Bssid);
			Status = NDIS_STATUS_SUCCESS;
			StateMachineTouched = TRUE;
			DBGPRINT(RT_DEBUG_TRACE, ("IOCTL::SIOCSIWAP %02x:%02x:%02x:%02x:%02x:%02x\n",
				Bssid[0], Bssid[1], Bssid[2], Bssid[3], Bssid[4], Bssid[5]));
			break;

		case SIOCGIWMODE:	//get operation mode
			if (ADHOC_ON(pAd))
			{
				BssType = Ndis802_11IBSS;
				wrq->u.mode = IW_MODE_ADHOC;
			}
			else if (INFRA_ON(pAd))
			{
				BssType = Ndis802_11Infrastructure;
				wrq->u.mode = IW_MODE_INFRA;
			}
			else
			{
				BssType = Ndis802_11AutoUnknown;
				wrq->u.mode = IW_MODE_AUTO;
			}
			DBGPRINT(RT_DEBUG_TRACE, ("IOCTL::SIOCGIWMODE(=%d)\n", BssType));
			break;

		case SIOCSIWMODE:	//set operation mode
			if(wrq->u.mode == IW_MODE_ADHOC)
			{
				if (pAd->StaCfg.BssType != BSS_ADHOC)
				{
					// Config has changed
					pAd->bConfigChanged = TRUE;
				}
				pAd->StaCfg.BssType = BSS_ADHOC;
				DBGPRINT(RT_DEBUG_TRACE, ("IOCTL::SIOCSIWMODE (AD-HOC)\n"));
			}
			else if (wrq->u.mode == IW_MODE_INFRA)
			{
				if (pAd->StaCfg.BssType != BSS_INFRA)
				{
					// Config has changed
					pAd->bConfigChanged = TRUE;
				}
				pAd->StaCfg.BssType = BSS_INFRA;
				DBGPRINT(RT_DEBUG_TRACE, ("IOCTL::SIOCSIWMODE (INFRA)\n"));
			}
			else
			{
				Status	= -EINVAL;
				DBGPRINT(RT_DEBUG_TRACE, ("IOCTL::SIOCSIWMODE (unknown)\n"));
			}
			// Reset Ralink supplicant to not use, it will be set to start when UI set PMK key
			pAd->StaCfg.WpaState = SS_NOTUSE;
			break;

		case SIOCGIWSENS:	//get sensitivity (dBm)
		case SIOCSIWSENS:	//set sensitivity (dBm)
		case SIOCGIWPOWER:	//get Power Management settings
		case SIOCSIWPOWER:	//set Power Management settings
		case SIOCGIWTXPOW:	//get transmit power (dBm)
		case SIOCSIWTXPOW:	//set transmit power (dBm)
		case SIOCGIWRANGE:	//Get range of parameters
		case SIOCGIWRETRY:	//get retry limits and lifetime
		case SIOCSIWRETRY:	//set retry limits and lifetime
			Status = -EOPNOTSUPP;
			break;
		
		case RT_PRIV_IOCTL:
			subcmd = wrq->u.data.flags;
			if( subcmd & OID_GET_SET_TOGGLE)
				Status = RTMPSetInformation(pAd, rq, subcmd);
			else
				Status = RTMPQueryInformation(pAd, rq, subcmd);
			break;
	
		case SIOCGIWPRIV:
			if (wrq->u.data.pointer) 
			{
				if ( access_ok(VERIFY_WRITE, wrq->u.data.pointer, sizeof(privtab)) != TRUE)
					break;
				wrq->u.data.length = sizeof(privtab) / sizeof(privtab[0]);
				if (copy_to_user(wrq->u.data.pointer, privtab, sizeof(privtab)))
					Status = -EFAULT;
			}
			break;

		case RTPRIV_IOCTL_SET:
			{				
				CHAR *this_char;
				CHAR *value;
				
				if( access_ok(VERIFY_READ, wrq->u.data.pointer, wrq->u.data.length)!=TRUE )   
					break;

				os_alloc_mem(NULL, (PUCHAR *)&this_char, wrq->u.data.length);
				if(this_char == NULL)
				{
					Status = -ENOMEM;
					break;
				}
				
				Status = copy_from_user(this_char, wrq->u.data.pointer, wrq->u.data.length);
							
				if (!*this_char)
					break;

				if ((value = rtstrchr(this_char, '=')) != NULL)  
					*value++ = 0;

				if (!value)
					break;

				// reject setting nothing besides ANY ssid(ssidLen=0)
				if (!*value && (strcmp(this_char, "SSID") != 0))
					break;

				for (PRTMP_PRIVATE_SET_PROC = RTMP_PRIVATE_SUPPORT_PROC; PRTMP_PRIVATE_SET_PROC->name; PRTMP_PRIVATE_SET_PROC++)
				{
					if (!strcmp(this_char, PRTMP_PRIVATE_SET_PROC->name)) 
					{	
						if(!PRTMP_PRIVATE_SET_PROC->set_proc(pAd, value))
				        {   
				            //FALSE:Set private failed then return Invalid argument 								
							Status = -EINVAL;
						}
						break;	//Exit for loop.
					}
				}								
					
				if(PRTMP_PRIVATE_SET_PROC->name == NULL)
				{  //Not found argument
					Status = -EINVAL;
					DBGPRINT(RT_DEBUG_TRACE, ("IOCTL::(iwpriv) Command not Support [%s=%s]\n", this_char, value));
					break;
				}				
				os_free_mem(NULL, (PUCHAR)this_char);		
			}
			break;
	
		case RTPRIV_IOCTL_GSITESURVEY:
			RTMPIoctlGetSiteSurvey(pAd, wrq);
			break;
		
		case RTPRIV_IOCTL_STATISTICS:
			RTMPIoctlStatistics(pAd, wrq);
			break;
#ifdef DBG
		case RTPRIV_IOCTL_BBP:
			RTMPIoctlBBP(pAd, wrq);
			break;
			
		case RTPRIV_IOCTL_MAC:
			RTMPIoctlMAC(pAd, wrq);
			break;		

		case RTPRIV_IOCTL_E2P:
			RTMPIoctlE2PROM(pAd, wrq);
			break;		
#endif

		case RTPRIV_IOCTL_HTINFO:
			RTMPIoctlHtInfo(pAd, wrq);
			break;

		default:
			DBGPRINT(RT_DEBUG_TRACE, ("IOCTL::unknown IOCTL's cmd = 0x%08x\n", cmd));
			if (cmd == 0x89F1)
				Status = NDIS_STATUS_SUCCESS; // ignore default config by some of platforms, e.g. SuSE
			else 
				Status = -EOPNOTSUPP;
				
			break;
	}

	if(StateMachineTouched) // Upper layer sent a MLME-related operations
		RTUSBMlmeUp(pAd);


	return Status;
}

VOID	RTMPSetDesiredRates(
	IN	PRTMP_ADAPTER	pAdapter,
	IN	LONG			Rates)
{
	NDIS_802_11_RATES aryRates;

	memset(&aryRates, 0x00, sizeof(NDIS_802_11_RATES));
	switch (pAdapter->CommonCfg.PhyMode)
	{
		case PHY_11A:
		case PHY_11G:
		case PHY_11GN_MIXED:
		case PHY_11AN_MIXED:
		case PHY_11AGN_MIXED:
			switch (Rates)
			{
				case 6000000: //6M
					aryRates[0] = 0x0c; // 6M
					break;
				case 9000000: //9M
					aryRates[0] = 0x12; // 9M
					break;
				case 12000000: //12M
					aryRates[0] = 0x18; // 12M
					break;
				case 18000000: //18M
					aryRates[0] = 0x24; // 18M
					break;
				case 24000000: //24M
					aryRates[0] = 0x30; // 24M
					break;
				case 36000000: //36M
					aryRates[0] = 0x48; // 36M
					break;
				case 48000000: //48M
					aryRates[0] = 0x60; // 48M
					break;
				case 54000000: //54M
					aryRates[0] = 0x6c; // 54M
					break;
				case -1: //Auto
				default:
					aryRates[0] = 0x6c; // 54Mbps
					aryRates[1] = 0x60; // 48Mbps
					aryRates[2] = 0x48; // 36Mbps
					aryRates[3] = 0x30; // 24Mbps
					aryRates[4] = 0x24; // 18M
					aryRates[5] = 0x18; // 12M
					aryRates[6] = 0x12; // 9M
					aryRates[7] = 0x0c; // 6M
					break;
			}
			break;
			
		case PHY_11B:	
		case PHY_11BG_MIXED:
		case PHY_11ABG_MIXED:
		case PHY_11ABGN_MIXED:
		case PHY_11BGN_MIXED:
		default:
			switch (Rates)
			{
				case 1000000: //1M
					aryRates[0] = 0x02;
					break;
				case 2000000: //2M
					aryRates[0] = 0x04;
					break;
				case 5000000: //5.5M
					aryRates[0] = 0x0b; // 5.5M
					break;
				case 11000000: //11M
					aryRates[0] = 0x16; // 11M
					break;
				case 6000000: //6M
					aryRates[0] = 0x0c; // 6M
					break;
				case 9000000: //9M
					aryRates[0] = 0x12; // 9M
					break;
				case 12000000: //12M
					aryRates[0] = 0x18; // 12M
					break;
				case 18000000: //18M
					aryRates[0] = 0x24; // 18M
					break;
				case 24000000: //24M
					aryRates[0] = 0x30; // 24M
					break;
				case 36000000: //36M
					aryRates[0] = 0x48; // 36M
					break;
				case 48000000: //48M
					aryRates[0] = 0x60; // 48M
					break;
				case 54000000: //54M
					aryRates[0] = 0x6c; // 54M
					break;
				case -1: //Auto
				default:
					if (pAdapter->CommonCfg.PhyMode == PHY_11B)
					{ //B Only
						aryRates[0] = 0x16; // 11Mbps
						aryRates[1] = 0x0b; // 5.5Mbps
						aryRates[2] = 0x04; // 2Mbps
						aryRates[3] = 0x02; // 1Mbps
					}
					else
					{ //(B/G) Mixed or (A/B/G) Mixed
						aryRates[0] = 0x6c; // 54Mbps
						aryRates[1] = 0x60; // 48Mbps
						aryRates[2] = 0x48; // 36Mbps
						aryRates[3] = 0x30; // 24Mbps
						aryRates[4] = 0x16; // 11Mbps
						aryRates[5] = 0x0b; // 5.5Mbps
						aryRates[6] = 0x04; // 2Mbps
						aryRates[7] = 0x02; // 1Mbps
					}
					break;
			}
			break;
	}

	NdisZeroMemory(pAdapter->CommonCfg.DesireRate, MAX_LEN_OF_SUPPORTED_RATES);
	NdisMoveMemory(pAdapter->CommonCfg.DesireRate, &aryRates, sizeof(NDIS_802_11_RATES));
	DBGPRINT(RT_DEBUG_TRACE, (" RTMPSetDesiredRates (%02x,%02x,%02x,%02x,%02x,%02x,%02x,%02x)\n",
		pAdapter->CommonCfg.DesireRate[0],pAdapter->CommonCfg.DesireRate[1],
		pAdapter->CommonCfg.DesireRate[2],pAdapter->CommonCfg.DesireRate[3],
		pAdapter->CommonCfg.DesireRate[4],pAdapter->CommonCfg.DesireRate[5],
		pAdapter->CommonCfg.DesireRate[6],pAdapter->CommonCfg.DesireRate[7] ));

	// Changing DesiredRate may affect the MAX TX rate we used to TX frames out
	MlmeUpdateTxRates(pAdapter, FALSE);
	MlmeUpdateHtTxRates(pAdapter, 0xff);

//	if (ADHOC_ON(pAdapter))
//		MakeIbssBeacon(pAdapter);

}

/* 
 * **************************************************************************
 *	Ralink's iwpriv commands :
 *	$iwpriv [interface] set [Parameter]=arg
 * ************************************************************************** 
 */
 
/* 
	==========================================================================
	Description:
		Show Driver Version, any integer input
	Return:
		TRUE if all parameters are OK, FALSE otherwise
	==========================================================================
*/
 INT Set_DriverVersion_Proc(
	IN	PRTMP_ADAPTER	pAd, 
	IN	PUCHAR			arg)
{
	DBGPRINT(RT_DEBUG_TRACE, ("Driver version-%s\n", DRIVER_VERSION));
	
	return TRUE;
}

/* 
	==========================================================================
	Description:
		Set Country Region.
		This command will not work, if the field of CountryRegion in eeprom is programmed.
	Return:
		TRUE if all parameters are OK, FALSE otherwise
	==========================================================================
*/
INT Set_CountryRegion_Proc(
	IN	PRTMP_ADAPTER	pAd, 
	IN	PUCHAR			arg)
{
	ULONG		region;
		
	region = simple_strtol(arg, 0, 10);

	// Country can be set only when EEPROM not programmed
	if (pAd->CommonCfg.CountryRegion & 0x80)
	{
		DBGPRINT(RT_DEBUG_ERROR, ("Set_CountryRegion_Proc::parameter of CountryRegion in eeprom is programmed \n"));
		return FALSE;
	}
	
	if(region <= REGION_MAXIMUM_BG_BAND)
	{
		pAd->CommonCfg.CountryRegion = (UCHAR) region;
	}
	else
	{
		DBGPRINT(RT_DEBUG_ERROR, ("Set_CountryRegion_Proc::parameters out of range\n"));
		return FALSE;
	}

	// if set country region, driver needs to be reset
	BuildChannelList(pAd);

	DBGPRINT(RT_DEBUG_TRACE, ("Set_CountryRegion_Proc::(CountryRegion=%d)\n", pAd->CommonCfg.CountryRegion));

	return TRUE;
}

/* 
	==========================================================================
	Description:
		Set Country Region for A band.
		This command will not work, if the field of CountryRegion in eeprom is programmed.
	Return:
		TRUE if all parameters are OK, FALSE otherwise
	==========================================================================
*/
INT Set_CountryRegionABand_Proc(
	IN	PRTMP_ADAPTER	pAd, 
	IN	PUCHAR			arg)
{
	ULONG		region;
		
	region = simple_strtol(arg, 0, 10);

	// Country can be set only when EEPROM not programmed
	if (pAd->CommonCfg.CountryRegionForABand & 0x80)
	{
		DBGPRINT(RT_DEBUG_ERROR, ("Set_CountryRegionABand_Proc::parameter of CountryRegion in eeprom is programmed \n"));
		return FALSE;
	}
	
	if(region <= REGION_MAXIMUM_A_BAND)
	{
		pAd->CommonCfg.CountryRegionForABand = (UCHAR) region;
	}
	else
	{
		DBGPRINT(RT_DEBUG_ERROR, ("Set_CountryRegionABand_Proc::parameters out of range\n"));
		return FALSE;
	}

	// if set country region, driver needs to be reset
	BuildChannelList(pAd);

	DBGPRINT(RT_DEBUG_TRACE, ("Set_CountryRegionABand_Proc::(CountryRegion=%d)\n", pAd->CommonCfg.CountryRegionForABand));

	return TRUE;
}

/* 
	==========================================================================
	Description:
		Set SSID
	Return:
		TRUE if all parameters are OK, FALSE otherwise
	==========================================================================
*/
INT Set_SSID_Proc(
	IN	PRTMP_ADAPTER	pAdapter, 
	IN	PUCHAR			arg)
{
	NDIS_802_11_SSID		Ssid, *pSsid=NULL;
	BOOLEAN					StateMachineTouched = FALSE;
	int						success = TRUE;

	if( strlen(arg) <= MAX_LEN_OF_SSID)
	{

		NdisZeroMemory(&Ssid, MAX_LEN_OF_SSID);
		if (strlen(arg) != 0)
		{
			NdisMoveMemory(Ssid.Ssid, arg, strlen(arg));
			Ssid.SsidLength = strlen(arg);
		}
		else //ANY ssid
		{
			Ssid.SsidLength = 0; 
			memcpy(Ssid.Ssid, "", 0);
			
			// reset to infra/open/none as the user sets ANY ssid
			pAdapter->StaCfg.BssType = BSS_INFRA;	
			pAdapter->CommonCfg.AuthMode = Ndis802_11AuthModeOpen;
			pAdapter->CommonCfg.WepStatus  = Ndis802_11EncryptionDisabled;		    
		}
		pSsid = &Ssid;

		if (pAdapter->Mlme.CntlMachine.CurrState != CNTL_IDLE)
		{
			MlmeEnqueue(pAdapter, 
                        MLME_CNTL_STATE_MACHINE,
                        RT_CMD_RESET_MLME,
                        0,
                        NULL);					
		}

		// To prevent some kernel thread is very low priority ...so essid copy immediately for later wpapsk counting.
		if (pAdapter->CommonCfg.AuthMode >= Ndis802_11AuthModeWPA)
		{
			NdisMoveMemory(pAdapter->MlmeAux.Ssid, Ssid.Ssid, Ssid.SsidLength);
			pAdapter->MlmeAux.SsidLen = Ssid.SsidLength;
		}
		
		MlmeEnqueue(pAdapter, 
					MLME_CNTL_STATE_MACHINE, 
					OID_802_11_SSID,
					sizeof(NDIS_802_11_SSID),
					(VOID *)pSsid);

		StateMachineTouched = TRUE;
		DBGPRINT(RT_DEBUG_TRACE, ("Set_SSID_Proc::(Len=%d,Ssid=%s)\n", Ssid.SsidLength, Ssid.Ssid));
	}
	else
		success = FALSE;

	if (StateMachineTouched) // Upper layer sent a MLME-related operations
		RTUSBMlmeUp(pAdapter);

	return success;
}

/* 
	==========================================================================
	Description:
		Set Wireless Mode
	Return:
		TRUE if all parameters are OK, FALSE otherwise
	==========================================================================
*/
INT Set_WirelessMode_Proc(
	IN	PRTMP_ADAPTER	pAdapter, 
	IN	PUCHAR			arg)
{
	ULONG			WirelessMode, PhyMode;
	int				success = TRUE;

	WirelessMode = simple_strtol(arg, 0, 10);

	/* 
	 * BG-Band : b/g mixed(0), b only(1), b/g/n mixed(5)
	 * A-Band  : a only(2), a/b/g mixed(3), a/b/g/n mixed(4)
	 */
	switch(WirelessMode)
	{
		case 0:
			PhyMode = PHY_11BG_MIXED;
			DBGPRINT(RT_DEBUG_TRACE, ("Set_WirelessMode_Proc::(%s)\n", "B/G mixed"));
			break;
		case 1:
			PhyMode = PHY_11B;
			DBGPRINT(RT_DEBUG_TRACE, ("Set_WirelessMode_Proc::(%s)\n", "B only"));
			break;
		case 2:
			PhyMode = PHY_11A;
			DBGPRINT(RT_DEBUG_TRACE, ("Set_WirelessMode_Proc::(%s)\n", "A only"));
			break;
		case 3:
			PhyMode = PHY_11ABG_MIXED;
			DBGPRINT(RT_DEBUG_TRACE, ("Set_WirelessMode_Proc::(%s)\n", "A/B/G mixed"));
			break;
		case 4:
			PhyMode = PHY_11ABGN_MIXED;
			DBGPRINT(RT_DEBUG_TRACE, ("Set_WirelessMode_Proc::(%s)\n", "A/B/G/N mixed"));
			break;
		case 5:	
		default:
			PhyMode = PHY_11BGN_MIXED;
			DBGPRINT(RT_DEBUG_TRACE, ("Set_WirelessMode_Proc::(%s)\n", "B/G/N mixed"));
			break;
	}
	
	RTMPSetPhyMode(pAdapter, PhyMode);	  
	return success;

}

/* 
	==========================================================================
	Description:
		Set TxRate
	Return:
		TRUE if all parameters are OK, FALSE otherwise
	==========================================================================
*/
INT Set_TxRate_Proc(
	IN	PRTMP_ADAPTER	pAdapter, 
	IN	PUCHAR			arg)
{
	ULONG			TxRate;
	int				success = TRUE;
   	UCHAR			PhyMode;
   	
	TxRate = simple_strtol(arg, 0, 10);
	PhyMode = pAdapter->CommonCfg.PhyMode;
	
	switch (PhyMode)
	{
		case PHY_11B:
			RTMPSetDesiredRates(pAdapter, ((TxRate > 0) && (TxRate <= 4)) ? (LONG)(RateIdToMbps[TxRate-1] * 1000000) : (-1));
			break;

		case PHY_11BG_MIXED:
		case PHY_11ABG_MIXED:
		case PHY_11ABGN_MIXED:
		case PHY_11BGN_MIXED:
			RTMPSetDesiredRates(pAdapter, ((TxRate > 0) && (TxRate <= 12)) ? (LONG)(RateIdToMbps[TxRate-1] * 1000000) : (-1));
			break;

		case PHY_11A:
		case PHY_11G:
		case PHY_11GN_MIXED:
		case PHY_11AN_MIXED:
		case PHY_11AGN_MIXED:
			RTMPSetDesiredRates(pAdapter, ((TxRate > 4) && (TxRate <= 12)) ? (LONG)(RateIdToMbps[TxRate-1] * 1000000) : (-1));
			break;
			
		default:	// Auto
			RTMPSetDesiredRates(pAdapter, -1);
			break;

	}
	
	DBGPRINT(RT_DEBUG_TRACE, ("Set_TxRate_Proc::(TxRate=%ld)\n", TxRate));
	return success;
}

/* 
	==========================================================================
	Description:
		Set Channel
	Return:
		TRUE if all parameters are OK, FALSE otherwise
	==========================================================================
*/
INT Set_Channel_Proc(
	IN	PRTMP_ADAPTER	pAdapter, 
	IN	PUCHAR			arg)
{
	int				success = TRUE;
	UCHAR			Channel;

	Channel = (UCHAR) simple_strtol(arg, 0, 10);

	if (ChannelSanity(pAdapter, Channel) == TRUE)
	{
		pAdapter->CommonCfg.Channel = Channel;
		
		if (pAdapter->StaCfg.BssType == BSS_ADHOC)
			pAdapter->CommonCfg.AdhocChannel = Channel;

		DBGPRINT(RT_DEBUG_TRACE, ("Set_Channel_Proc::(Channel=%d)\n", Channel));
	}
	else
		success = FALSE;

	return success;
}

#ifdef DBG
/* 
	==========================================================================
	Description:
		For Debug information
	Return:
		TRUE if all parameters are OK, FALSE otherwise
	==========================================================================
*/
INT	Set_Debug_Proc(
	IN	PRTMP_ADAPTER	pAd, 
	IN	PUCHAR			arg)
{
	DBGPRINT(RT_DEBUG_TRACE, ("==> Set_Debug_Proc *******************\n"));

	if(simple_strtol(arg, 0, 10) <= RT_DEBUG_LOUD)
		RTDebugLevel = simple_strtol(arg, 0, 10);	

	DBGPRINT(RT_DEBUG_TRACE, ("<== Set_Debug_Proc(RTDebugLevel = %ld)\n", RTDebugLevel));

	return TRUE;
}
#endif

/* 
	==========================================================================
	Description:
		Set 11B/11G Protection
	Return:
		TRUE if all parameters are OK, FALSE otherwise
	==========================================================================
*/
INT Set_BGProtection_Proc(
	IN	PRTMP_ADAPTER	pAdapter, 
	IN	PUCHAR			arg)

{
	switch (simple_strtol(arg, 0, 10))
	{
		case 0: //AUTO
			pAdapter->CommonCfg.UseBGProtection = 0;
			break;
		case 1: //Always On
			pAdapter->CommonCfg.UseBGProtection = 1;
			break;
		case 2: //Always OFF
			pAdapter->CommonCfg.UseBGProtection = 2;
			break;		
		default:  //Invalid argument 
			return FALSE;
	}
	DBGPRINT(RT_DEBUG_TRACE, ("Set_BGProtection_Proc::(BGProtection=%ld)\n", pAdapter->CommonCfg.UseBGProtection));

	return TRUE;
}

/* 
	==========================================================================
	Description:
		Set TxPreamble
	Return:
		TRUE if all parameters are OK, FALSE otherwise
	==========================================================================
*/
INT Set_TxPreamble_Proc(
	IN	PRTMP_ADAPTER	pAdapter, 
	IN	PUCHAR			arg)
{
	RT_802_11_PREAMBLE			Preamble;

	Preamble = simple_strtol(arg, 0, 10);
	switch (Preamble)
	{
		case Rt802_11PreambleShort:
			pAdapter->CommonCfg.TxPreamble = Preamble;
			MlmeSetTxPreamble(pAdapter, Rt802_11PreambleShort);
			break;
		case Rt802_11PreambleLong:
		case Rt802_11PreambleAuto:
			// if user wants AUTO, initialize to LONG here, then change according to AP's
			// capability upon association.
			pAdapter->CommonCfg.TxPreamble = Preamble;
			MlmeSetTxPreamble(pAdapter, Rt802_11PreambleLong);
			break;
		default: //Invalid argument 
			return FALSE;
	}

	DBGPRINT(RT_DEBUG_TRACE, ("Set_TxPreamble_Proc::(TxPreamble=%d)\n", Preamble));

	return TRUE;
}

/* 
	==========================================================================
	Description:
		Set RTS Threshold
	Return:
		TRUE if all parameters are OK, FALSE otherwise
	==========================================================================
*/
INT Set_RTSThreshold_Proc(
	IN	PRTMP_ADAPTER	pAdapter, 
	IN	PUCHAR			arg)
{
	NDIS_802_11_RTS_THRESHOLD			RtsThresh;
	UINT32			MacReg[4];
	PCMDHandler_TLV pTLV = (PCMDHandler_TLV)&MacReg[0];
	
	RtsThresh = simple_strtol(arg, 0, 10);

	if((RtsThresh < 0) && (RtsThresh > MAX_RTS_THRESHOLD))
	{
		//illegal RtsThreshold so we set it to default
		RtsThresh = MAX_RTS_THRESHOLD;
	}

	pAdapter->CommonCfg.RtsThreshold = (USHORT)RtsThresh;

	// +++ Config ASIC RTS threshold register
	MacReg[1] = 0x20;
	MacReg[1] |= (pAdapter->CommonCfg.RtsThreshold << 8);
	pTLV->Offset = TX_RTS_CFG;
	pTLV->Length = 4;
	RTUSBEnqueueInternalCmd(pAdapter, RT_OID_MULTI_WRITE_MAC,  &MacReg[0], 8);	

	DBGPRINT(RT_DEBUG_TRACE, ("Set_RTSThreshold_Proc::(RTSThreshold=%d)\n", pAdapter->CommonCfg.RtsThreshold));
	return TRUE;
}

/* 
	==========================================================================
	Description:
		Set Fragment Threshold
	Return:
		TRUE if all parameters are OK, FALSE otherwise
	==========================================================================
*/
INT Set_FragThreshold_Proc(
	IN	PRTMP_ADAPTER	pAdapter, 
	IN	PUCHAR			arg)
{
	NDIS_802_11_FRAGMENTATION_THRESHOLD	FragThresh;

	FragThresh = simple_strtol(arg, 0, 10);
	pAdapter->CommonCfg.bUseZeroToDisableFragment = FALSE;
	
	if ((FragThresh > MAX_FRAG_THRESHOLD) || (FragThresh < MIN_FRAG_THRESHOLD))
	{ //illegal FragThresh so we set it to default
		FragThresh = MAX_FRAG_THRESHOLD;
		pAdapter->CommonCfg.bUseZeroToDisableFragment = TRUE;
	}

	pAdapter->CommonCfg.FragmentThreshold = (USHORT)FragThresh;
	DBGPRINT(RT_DEBUG_TRACE, ("Set_FragThreshold_Proc::(FragThreshold=%ld)\n", FragThresh));
	return TRUE;
}

/* 
	==========================================================================
	Description:
		Set TxBurst
	Return:
		TRUE if all parameters are OK, FALSE otherwise
	==========================================================================
*/
INT Set_TxBurst_Proc(
	IN	PRTMP_ADAPTER	pAdapter, 
	IN	PUCHAR			arg)
{
	ULONG			TxBurst;

	TxBurst = simple_strtol(arg, 0, 10);

	if (TxBurst == 1)
		pAdapter->CommonCfg.bEnableTxBurst = TRUE;
	else if (TxBurst == 0)
		pAdapter->CommonCfg.bEnableTxBurst = FALSE;
	else
		return FALSE;  //Invalid argument 
	
	DBGPRINT(RT_DEBUG_TRACE, ("Set_TxBurst_Proc::(TxBurst=%d)\n", pAdapter->CommonCfg.bEnableTxBurst));

	return TRUE;
}
#if 0 //TODO: not ready
/* 
	==========================================================================
	Description:
		Set AdhocMode support Rate can or can not exceed 11Mbps against WiFi spec.
	Return:
		TRUE if all parameters are OK, FALSE otherwise
	==========================================================================
*/
INT Set_AdhocModeRate_Proc(
	IN	PRTMP_ADAPTER	pAdapter, 
	IN	PUCHAR			arg)
{
	ULONG		AdhocMode;

	AdhocMode = (ULONG)simple_strtol(arg, 0, 10);

	if (AdhocMode > 4)
		return FALSE;  //Invalid argument 
		
	if (pAdapter->StaCfg.AdhocMode != AdhocMode)
	{
		pAdapter->StaCfg.AdhocMode = AdhocMode;
		MlmeUpdateTxRates(pAdapter, FALSE);
		MakeIbssBeacon(pAdapter);			// re-build BEACON frame
		AsicEnableIbssSync(pAdapter);		// copy to on-chip memory
	}
	
	DBGPRINT(RT_DEBUG_TRACE, ("Set_AdhocModeRate_Proc::(AdhocMode=%d)\n", pAdapter->StaCfg.AdhocMode));
	
	return TRUE;
}
#endif

#ifdef AGGREGATION_SUPPORT
/* 
	==========================================================================
	Description:
		Set Aggregation  Enable or Disable
	Return:
		TRUE if all parameters are OK, FALSE otherwise
	==========================================================================
*/
INT	Set_PktAggregate_Proc(
	IN	PRTMP_ADAPTER	pAd, 
	IN	PUCHAR			arg)
{
	ULONG aggre;

	aggre = simple_strtol(arg, 0, 10);

	if (aggre == 1)
		pAd->CommonCfg.bAggregationCapable = TRUE;
	else if (aggre == 0)
		pAd->CommonCfg.bAggregationCapable = FALSE;
	else
		return FALSE;  //Invalid argument 
	
	DBGPRINT(RT_DEBUG_TRACE, ("Set_PktAggregate_Proc::(AGGRE=%d)\n", pAd->CommonCfg.bAggregationCapable));

	return TRUE;
} 
#endif /* AGGREGATION_SUPPORT */

#ifdef WMM_SUPPORT
/* 
	==========================================================================
	Description:
		Set WmmCapable Enable or Disable
	Return:
		TRUE if all parameters are OK, FALSE otherwise
	==========================================================================
*/
INT	Set_WmmCapable_Proc(
	IN	PRTMP_ADAPTER	pAd, 
	IN	PUCHAR			arg)
{
	BOOLEAN		bWmmCapable;

	bWmmCapable = simple_strtol(arg, 0, 10);

	if ((bWmmCapable == 1) && (pAd->NumberOfPipes >= 5))
		pAd->CommonCfg.bWmmCapable = TRUE;
	else
		pAd->CommonCfg.bWmmCapable = FALSE; 
	
	DBGPRINT(RT_DEBUG_TRACE, ("Set_WmmCapable_Proc::(bWmmCapable=%d)\n", pAd->CommonCfg.bWmmCapable));

	return TRUE;
}
#endif // WMM_SUPPORT //

#if 0 //TODO: not ready!
/* 
    ==========================================================================
    Description:
        Only use in WIFI APSD-STAUT. 
        It's configured by "pgen test program".
    Return:
        TRUE if all parameters are OK, FALSE otherwise.
	Usage in the file of pgen.c :
		Windows client:		./raoid.exe pm var
		Linux client:		iwpriv rausb0 set APSDPsm=var
		where var= {0, 1}
    ==========================================================================
*/
INT	Set_APSDPsm_Proc(
	IN	PRTMP_ADAPTER	pAd, 
	IN	PUCHAR			arg)
{
	BOOLEAN		APSDPsmBit;

	if (pAd->CommonCfg.bAPSDCapable == FALSE)
		return FALSE;	// do nothing!
		
	APSDPsmBit = simple_strtol(arg, 0, 10);
	if ((APSDPsmBit == 0) || (APSDPsmBit == 1))
	{
		// Driver needs to notify AP when PSM changes
		pAd->CommonCfg.bAPSDForcePowerSave = APSDPsmBit;
		if (pAd->CommonCfg.bAPSDForcePowerSave != pAd->CommonCfg.Psm)
		{
			MlmeSetPsm(pAd, pAd->CommonCfg.bAPSDForcePowerSave);
			RTMPSendNullFrame(pAd, pAd->CommonCfg.TxRate, TRUE);
		}

		DBGPRINT(RT_DEBUG_TRACE, ("Set_APSDPsm_Proc::(bAPSDForcePowerSave=%d)\n", 
			pAd->CommonCfg.bAPSDForcePowerSave));
			
		return TRUE;
	}
	else
		return FALSE;  //Invalid argument 
}
#endif

/* 
	==========================================================================
	Description:
		Set IEEE80211H.
		This parameter is 1 when needs radar detection, otherwise 0
	Return:
		TRUE if all parameters are OK, FALSE otherwise
	==========================================================================
*/
INT	Set_IEEE80211H_Proc(
	IN	PRTMP_ADAPTER	pAd, 
	IN	PUCHAR			arg)
{
	ULONG	ieee80211h;

	ieee80211h = simple_strtol(arg, 0, 10);

	if (ieee80211h == 1)
		pAd->CommonCfg.bIEEE80211H = TRUE;
	else if (ieee80211h == 0)
		pAd->CommonCfg.bIEEE80211H = FALSE;
	else
		return FALSE;  //Invalid argument 
	
	DBGPRINT(RT_DEBUG_TRACE, ("Set_IEEE80211H_Proc::(IEEE80211H=%d)\n", pAd->CommonCfg.bIEEE80211H));

	return TRUE;
}

/* 
	==========================================================================
	Description:
		Set Network Type(Infrastructure/Adhoc mode)
	Return:
		TRUE if all parameters are OK, FALSE otherwise
	==========================================================================
*/
INT Set_NetworkType_Proc(
	IN	PRTMP_ADAPTER	pAdapter, 
	IN	PUCHAR			arg)
{
	if (strcmp(arg, "Adhoc") == 0)
	{
		if (pAdapter->StaCfg.BssType != BSS_ADHOC)	
		{
			// Config has changed
			if (INFRA_ON(pAdapter))
				RTUSBEnqueueInternalCmd(pAdapter, RT_OID_LINK_DOWN, NULL, 0);
		}		
		pAdapter->StaCfg.BssType = BSS_ADHOC;	  
	}
	else
	{
		if (pAdapter->StaCfg.BssType != BSS_INFRA)	
		{
			// Config has changed
			if (ADHOC_ON(pAdapter)) 						  
				RTUSBEnqueueInternalCmd(pAdapter, RT_OID_LINK_DOWN, NULL, 0);
		}
		pAdapter->StaCfg.BssType = BSS_INFRA;
	}

	// Reset Ralink supplicant to not use, it will be set to start when UI set PMK key
	pAdapter->StaCfg.WpaState = SS_NOTUSE;

	DBGPRINT(RT_DEBUG_TRACE, ("Set_NetworkType_Proc::(NetworkType=%d)\n", pAdapter->StaCfg.BssType));

	return TRUE;
}

/* 
	==========================================================================
	Description:
		Set Authentication mode
	Return:
		TRUE if all parameters are OK, FALSE otherwise
	==========================================================================
*/
INT Set_AuthMode_Proc(
	IN	PRTMP_ADAPTER	pAdapter, 
	IN	PUCHAR			arg)
{
	if ((strcmp(arg, "WEPAUTO") == 0) || (strcmp(arg, "wepauto") == 0))
		pAdapter->CommonCfg.AuthMode = Ndis802_11AuthModeAutoSwitch;
	else if ((strcmp(arg, "OPEN") == 0) || (strcmp(arg, "open") == 0))
		pAdapter->CommonCfg.AuthMode = Ndis802_11AuthModeOpen;
	else if ((strcmp(arg, "SHARED") == 0) || (strcmp(arg, "shared") == 0))
		pAdapter->CommonCfg.AuthMode = Ndis802_11AuthModeShared;
	else if ((strcmp(arg, "WPAPSK") == 0) || (strcmp(arg, "wpapsk") == 0))
		pAdapter->CommonCfg.AuthMode = Ndis802_11AuthModeWPAPSK;
	else if ((strcmp(arg, "WPANONE") == 0) || (strcmp(arg, "wpanone") == 0))
		pAdapter->CommonCfg.AuthMode = Ndis802_11AuthModeWPANone;
	else if ((strcmp(arg, "WPA2PSK") == 0) || (strcmp(arg, "wpa2psk") == 0))
		pAdapter->CommonCfg.AuthMode = Ndis802_11AuthModeWPA2PSK;    
	else
		return FALSE;  

	pAdapter->StaCfg.PortSecured = WPA_802_1X_PORT_NOT_SECURED;

	DBGPRINT(RT_DEBUG_TRACE, ("Set_AuthMode_Proc::(AuthMode=%d)\n", pAdapter->CommonCfg.AuthMode));

	return TRUE;
}

/* 
	==========================================================================
	Description:
		Set Encryption Type
	Return:
		TRUE if all parameters are OK, FALSE otherwise
	==========================================================================
*/
INT Set_EncrypType_Proc(
	IN	PRTMP_ADAPTER	pAdapter, 
	IN	PUCHAR			arg)
{
	RT_SET_ASIC_WCID_ATTRI 	SetAsicWcidAttri;
	
	if ((strcmp(arg, "NONE") == 0) || (strcmp(arg, "none") == 0))
	{			 
		pAdapter->CommonCfg.WepStatus	= Ndis802_11WEPDisabled;
		SetAsicWcidAttri.Cipher 		= CIPHER_NONE;
	}
	else if ((strcmp(arg, "WEP") == 0) || (strcmp(arg, "wep") == 0))
	{			 
		pAdapter->CommonCfg.WepStatus   = Ndis802_11WEPEnabled;
		SetAsicWcidAttri.Cipher 		= CIPHER_WEP64;
	}
	else if ((strcmp(arg, "TKIP") == 0) || (strcmp(arg, "tkip") == 0))
	{			 
		pAdapter->CommonCfg.WepStatus   = Ndis802_11Encryption2Enabled;
		SetAsicWcidAttri.Cipher			= CIPHER_TKIP;
	}
	else if ((strcmp(arg, "AES") == 0) || (strcmp(arg, "aes") == 0))
	{			 
		pAdapter->CommonCfg.WepStatus   = Ndis802_11Encryption3Enabled;
		SetAsicWcidAttri.Cipher 		= CIPHER_AES;
	}
	else
		return FALSE;

	pAdapter->CommonCfg.PairCipher  = pAdapter->CommonCfg.WepStatus;
	pAdapter->CommonCfg.GroupCipher = pAdapter->CommonCfg.WepStatus;
	pAdapter->CommonCfg.MixedModeGroupCipher = Cipher_Type_NONE;

	RTMPMakeRSNIE(pAdapter, pAdapter->CommonCfg.GroupCipher);

	DBGPRINT(RT_DEBUG_TRACE, ("Set_EncrypType_Proc::(EncrypType=%d)\n", pAdapter->CommonCfg.WepStatus));

	return TRUE;
}

/* 
	==========================================================================
	Description:
		Set Default Key ID
	Return:
		TRUE if all parameters are OK, FALSE otherwise
	==========================================================================
*/
INT Set_DefaultKeyID_Proc(
	IN	PRTMP_ADAPTER	pAdapter, 
	IN	PUCHAR			arg)
{
	ULONG				KeyIdx;

	KeyIdx = simple_strtol(arg, 0, 10);
	if((KeyIdx >= 1 ) && (KeyIdx <= 4))
		pAdapter->CommonCfg.DefaultKeyId = (UCHAR) (KeyIdx - 1 );
	else
		return FALSE;  //Invalid argument 

	DBGPRINT(RT_DEBUG_TRACE, ("Set_DefaultKeyID_Proc::(DefaultKeyID(0~3)=%d)\n", pAdapter->CommonCfg.DefaultKeyId));

	return TRUE;
}

/* 
	==========================================================================
	Description:
		Set WEP KEY1
	Return:
		TRUE if all parameters are OK, FALSE otherwise
	==========================================================================
*/
INT Set_Key1_Proc(
	IN	PRTMP_ADAPTER	pAdapter, 
	IN	PUCHAR			arg)
{
	INT					KeyLen, KeyIdx;
	UCHAR				KeyMaterial[32];
	UCHAR				CipherAlg = CIPHER_WEP64;
	INT					i;
	PNDIS_802_11_KEY	pKey = NULL;
	ULONG				TotalLen;
	
	KeyLen = strlen(arg);
	KeyIdx = 0;	// Key 1


	if ((pAdapter->CommonCfg.WepStatus != Ndis802_11WEPEnabled) ||
		(pAdapter->CommonCfg.AuthMode >= Ndis802_11AuthModeWPA) ||
		(pAdapter->CommonCfg.DefaultKeyId != KeyIdx))
		return FALSE;	// error combination

	NdisZeroMemory(KeyMaterial, 32);
	switch (KeyLen)
	{
		case 5: //wep 40 Ascii type
			memcpy(KeyMaterial, arg, KeyLen);
			CipherAlg = CIPHER_WEP64;
			DBGPRINT(RT_DEBUG_TRACE, ("%s::(Key%d=%s and type=%s)\n", __FUNCTION__, KeyIdx, arg, "Ascii"));
			break;
		case 10: //wep 40 Hex type
			for(i=0; i < KeyLen; i++)
			{
				if( !isxdigit(*(arg+i)) )
					return FALSE;  //Not Hex value;
			}
			KeyLen = KeyLen / 2 ;
			AtoH(arg, KeyMaterial, KeyLen);
			CipherAlg = CIPHER_WEP64;
			DBGPRINT(RT_DEBUG_TRACE, ("%s::(Key%d=%s and type=%s)\n", __FUNCTION__, KeyIdx, arg, "Hex"));
			break;
		case 13: //wep 104 Ascii type
			memcpy(KeyMaterial, arg, KeyLen);
			CipherAlg = CIPHER_WEP128;
			DBGPRINT(RT_DEBUG_TRACE, ("%s::(Key%d=%s and type=%s)\n", __FUNCTION__, KeyIdx, arg, "Ascii"));
			break;
		case 26: //wep 104 Hex type
			for(i=0; i < KeyLen; i++)
			{
				if( !isxdigit(*(arg+i)) )
					return FALSE;  //Not Hex value;
			}
			KeyLen = KeyLen / 2 ;
			AtoH(arg, KeyMaterial, KeyLen);
			CipherAlg = CIPHER_WEP128;
			DBGPRINT(RT_DEBUG_TRACE, ("%s::(Key%d=%s and type=%s)\n", __FUNCTION__, KeyIdx, arg, "Hex"));
			break;
		default: //Invalid argument 
			DBGPRINT(RT_DEBUG_TRACE, ("%s::Invalid argument (=%s)\n", __FUNCTION__, arg));
			return FALSE;
	}
	
	// prepare a ndis key
	TotalLen = sizeof(NDIS_802_11_KEY) + KeyLen - 1;
	// memory allocate
	os_alloc_mem(NULL, (PUCHAR *)&pKey, TotalLen);
	if(!pKey)
		return FALSE;
		
	NdisZeroMemory(pKey, TotalLen);
	pKey->Length = TotalLen;
	pKey->KeyIndex = (0x80000000 | KeyIdx);
	pKey->KeyLength = KeyLen;
	for (i=0; i<6; i++)
		pKey->BSSID[i] = 0xff;
	NdisMoveMemory(pKey->KeyMaterial, KeyMaterial, KeyLen);
	
	// need to enqueue cmd to thread
	RTUSBEnqueueCmdFromNdis(pAdapter, OID_802_11_ADD_KEY_WEP, TRUE, pKey, TotalLen);
	os_free_mem(NULL, (PCHAR)pKey);


	return TRUE;
}

/* 
	==========================================================================
	Description:
		Set WEP KEY2
	Return:
		TRUE if all parameters are OK, FALSE otherwise
	==========================================================================
*/
INT Set_Key2_Proc(
	IN	PRTMP_ADAPTER	pAdapter, 
	IN	PUCHAR			arg)
{
	INT					KeyLen, KeyIdx;
	UCHAR				KeyMaterial[32];
	UCHAR				CipherAlg = CIPHER_WEP64;
	INT					i;
	PNDIS_802_11_KEY	pKey = NULL;
	ULONG				TotalLen;

	KeyLen = strlen(arg);
	KeyIdx = 1;	// Key 2


	if ((pAdapter->CommonCfg.WepStatus != Ndis802_11WEPEnabled) ||
		(pAdapter->CommonCfg.AuthMode >= Ndis802_11AuthModeWPA) ||
		(pAdapter->CommonCfg.DefaultKeyId != KeyIdx))
		return FALSE;	// error combination

	NdisZeroMemory(KeyMaterial, 32);
	switch (KeyLen)
	{
		case 5: //wep 40 Ascii type
			memcpy(KeyMaterial, arg, KeyLen);
			CipherAlg = CIPHER_WEP64;
			DBGPRINT(RT_DEBUG_TRACE, ("%s::(Key%d=%s and type=%s)\n", __FUNCTION__, KeyIdx, arg, "Ascii"));
			break;
		case 10: //wep 40 Hex type
			for(i=0; i < KeyLen; i++)
			{
				if( !isxdigit(*(arg+i)) )
					return FALSE;  //Not Hex value;
			}
			KeyLen = KeyLen / 2 ;
			AtoH(arg, KeyMaterial, KeyLen);
			CipherAlg = CIPHER_WEP64;
			DBGPRINT(RT_DEBUG_TRACE, ("%s::(Key%d=%s and type=%s)\n", __FUNCTION__, KeyIdx, arg, "Hex"));
			break;
		case 13: //wep 104 Ascii type
			memcpy(KeyMaterial, arg, KeyLen);
			CipherAlg = CIPHER_WEP128;
			DBGPRINT(RT_DEBUG_TRACE, ("%s::(Key%d=%s and type=%s)\n", __FUNCTION__, KeyIdx, arg, "Ascii"));
			break;
		case 26: //wep 104 Hex type
			for(i=0; i < KeyLen; i++)
			{
				if( !isxdigit(*(arg+i)) )
					return FALSE;  //Not Hex value;
			}
			KeyLen = KeyLen / 2 ;
			AtoH(arg, KeyMaterial, KeyLen);
			CipherAlg = CIPHER_WEP128;
			DBGPRINT(RT_DEBUG_TRACE, ("%s::(Key%d=%s and type=%s)\n", __FUNCTION__, KeyIdx, arg, "Hex"));
			break;
		default: //Invalid argument 
			DBGPRINT(RT_DEBUG_TRACE, ("%s::Invalid argument (=%s)\n", __FUNCTION__, arg));
			return FALSE;
	}
	
	// prepare a ndis key
	TotalLen = sizeof(NDIS_802_11_KEY) + KeyLen - 1;
	// memory allocate
	os_alloc_mem(NULL, (PUCHAR *)&pKey, TotalLen);
	if(!pKey)
		return FALSE;
		
	NdisZeroMemory(pKey, TotalLen);
	pKey->Length = TotalLen;
	pKey->KeyIndex = (0x80000000 | KeyIdx);
	pKey->KeyLength = KeyLen;
	for (i=0; i<6; i++)
		pKey->BSSID[i] = 0xff;
	NdisMoveMemory(pKey->KeyMaterial, KeyMaterial, KeyLen);
	
	// need to enqueue cmd to thread
	RTUSBEnqueueCmdFromNdis(pAdapter, OID_802_11_ADD_KEY_WEP, TRUE, pKey, TotalLen);		
	os_free_mem(NULL, (PCHAR)pKey);


	return TRUE;
}

/* 
	==========================================================================
	Description:
		Set WEP KEY3
	Return:
		TRUE if all parameters are OK, FALSE otherwise
	==========================================================================
*/
INT Set_Key3_Proc(
	IN	PRTMP_ADAPTER	pAdapter, 
	IN	PUCHAR			arg)
{
	INT					KeyLen, KeyIdx;
	UCHAR				KeyMaterial[32];
	UCHAR				CipherAlg = CIPHER_WEP64;
	INT					i;
	PNDIS_802_11_KEY	pKey = NULL;
	ULONG				TotalLen;
	
	KeyLen = strlen(arg);
	KeyIdx = 2;	// Key 3


	if ((pAdapter->CommonCfg.WepStatus != Ndis802_11WEPEnabled) ||
		(pAdapter->CommonCfg.AuthMode >= Ndis802_11AuthModeWPA) ||
		(pAdapter->CommonCfg.DefaultKeyId != KeyIdx))
		return FALSE;	// error combination

	NdisZeroMemory(KeyMaterial, 32);
	switch (KeyLen)
	{
		case 5: //wep 40 Ascii type
			memcpy(KeyMaterial, arg, KeyLen);
			CipherAlg = CIPHER_WEP64;
			DBGPRINT(RT_DEBUG_TRACE, ("%s::(Key%d=%s and type=%s)\n", __FUNCTION__, KeyIdx, arg, "Ascii"));
			break;
		case 10: //wep 40 Hex type
			for(i=0; i < KeyLen; i++)
			{
				if( !isxdigit(*(arg+i)) )
					return FALSE;  //Not Hex value;
			}
			KeyLen = KeyLen / 2 ;
			AtoH(arg, KeyMaterial, KeyLen);
			CipherAlg = CIPHER_WEP64;
			DBGPRINT(RT_DEBUG_TRACE, ("%s::(Key%d=%s and type=%s)\n", __FUNCTION__, KeyIdx, arg, "Hex"));
			break;
		case 13: //wep 104 Ascii type
			memcpy(KeyMaterial, arg, KeyLen);
			CipherAlg = CIPHER_WEP128;
			DBGPRINT(RT_DEBUG_TRACE, ("%s::(Key%d=%s and type=%s)\n", __FUNCTION__, KeyIdx, arg, "Ascii"));
			break;
		case 26: //wep 104 Hex type
			for(i=0; i < KeyLen; i++)
			{
				if( !isxdigit(*(arg+i)) )
					return FALSE;  //Not Hex value;
			}
			KeyLen = KeyLen / 2 ;
			AtoH(arg, KeyMaterial, KeyLen);
			CipherAlg = CIPHER_WEP128;
			DBGPRINT(RT_DEBUG_TRACE, ("%s::(Key%d=%s and type=%s)\n", __FUNCTION__, KeyIdx, arg, "Hex"));
			break;
		default: //Invalid argument 
			DBGPRINT(RT_DEBUG_TRACE, ("%s::Invalid argument (=%s)\n", __FUNCTION__, arg));
			return FALSE;
	}
	
	// prepare a ndis key
	TotalLen = sizeof(NDIS_802_11_KEY) + KeyLen - 1;
	// memory allocate
	os_alloc_mem(NULL, (PUCHAR *)&pKey, TotalLen);
	if(!pKey)
		return FALSE;
		
	NdisZeroMemory(pKey, TotalLen);
	pKey->Length = TotalLen;
	pKey->KeyIndex = (0x80000000 | KeyIdx);
	pKey->KeyLength = KeyLen;
	for (i=0; i<6; i++)
		pKey->BSSID[i] = 0xff;
	NdisMoveMemory(pKey->KeyMaterial, KeyMaterial, KeyLen);
	
	// need to enqueue cmd to thread
	RTUSBEnqueueCmdFromNdis(pAdapter, OID_802_11_ADD_KEY_WEP, TRUE, pKey, TotalLen);		
	os_free_mem(NULL, (PCHAR)pKey);


	return TRUE;
}

/* 
	==========================================================================
	Description:
		Set WEP KEY4
	Return:
		TRUE if all parameters are OK, FALSE otherwise
	==========================================================================
*/
INT Set_Key4_Proc(
	IN	PRTMP_ADAPTER	pAdapter, 
	IN	PUCHAR			arg)
{
	INT					KeyLen, KeyIdx;
	UCHAR				KeyMaterial[32];
	UCHAR				CipherAlg = CIPHER_WEP64;
	INT					i;
	PNDIS_802_11_KEY	pKey = NULL;
	ULONG				TotalLen;
	
	KeyLen = strlen(arg);
	KeyIdx = 3;	// Key 4


	if ((pAdapter->CommonCfg.WepStatus != Ndis802_11WEPEnabled) ||
		(pAdapter->CommonCfg.AuthMode >= Ndis802_11AuthModeWPA) ||
		(pAdapter->CommonCfg.DefaultKeyId != KeyIdx))
		return FALSE;	// error combination

	NdisZeroMemory(KeyMaterial, 32);
	switch (KeyLen)
	{
		case 5: //wep 40 Ascii type
			memcpy(KeyMaterial, arg, KeyLen);
			CipherAlg = CIPHER_WEP64;
			DBGPRINT(RT_DEBUG_TRACE, ("%s::(Key%d=%s and type=%s)\n", __FUNCTION__, KeyIdx, arg, "Ascii"));
			break;
		case 10: //wep 40 Hex type
			for(i=0; i < KeyLen; i++)
			{
				if( !isxdigit(*(arg+i)) )
					return FALSE;  //Not Hex value;
			}
			KeyLen = KeyLen / 2 ;
			AtoH(arg, KeyMaterial, KeyLen);
			CipherAlg = CIPHER_WEP64;
			DBGPRINT(RT_DEBUG_TRACE, ("%s::(Key%d=%s and type=%s)\n", __FUNCTION__, KeyIdx, arg, "Hex"));
			break;
		case 13: //wep 104 Ascii type
			memcpy(KeyMaterial, arg, KeyLen);
			CipherAlg = CIPHER_WEP128;
			DBGPRINT(RT_DEBUG_TRACE, ("%s::(Key%d=%s and type=%s)\n", __FUNCTION__, KeyIdx, arg, "Ascii"));
			break;
		case 26: //wep 104 Hex type
			for(i=0; i < KeyLen; i++)
			{
				if( !isxdigit(*(arg+i)) )
					return FALSE;  //Not Hex value;
			}
			KeyLen = KeyLen / 2 ;
			AtoH(arg, KeyMaterial, KeyLen);
			CipherAlg = CIPHER_WEP128;
			DBGPRINT(RT_DEBUG_TRACE, ("%s::(Key%d=%s and type=%s)\n", __FUNCTION__, KeyIdx, arg, "Hex"));
			break;
		default: //Invalid argument 
			DBGPRINT(RT_DEBUG_TRACE, ("%s::Invalid argument (=%s)\n", __FUNCTION__, arg));
			return FALSE;
	}
	
	// prepare a ndis key
	TotalLen = sizeof(NDIS_802_11_KEY) + KeyLen - 1;
	// memory allocate
	os_alloc_mem(NULL, (PUCHAR *)&pKey, TotalLen);
	if(!pKey)
		return FALSE;
		
	NdisZeroMemory(pKey, TotalLen);
	pKey->Length = TotalLen;
	pKey->KeyIndex = (0x80000000 | KeyIdx);
	pKey->KeyLength = KeyLen;
	for (i=0; i<6; i++)
		pKey->BSSID[i] = 0xff;
	NdisMoveMemory(pKey->KeyMaterial, KeyMaterial, KeyLen);
	
	// need to enqueue cmd to thread
	RTUSBEnqueueCmdFromNdis(pAdapter, OID_802_11_ADD_KEY_WEP, TRUE, pKey, TotalLen);
	os_free_mem(NULL, (PCHAR)pKey);


	return TRUE;
}

/* 
	==========================================================================
	Description:
		Set WPA PSK key
	Return:
		TRUE if all parameters are OK, FALSE otherwise
	==========================================================================
*/
INT Set_WPAPSK_Proc(
	IN	PRTMP_ADAPTER	pAdapter, 
	IN	PUCHAR			arg)
{
	UCHAR				keyMaterial[40];
	INT 				Status;
	
	if ((pAdapter->CommonCfg.AuthMode != Ndis802_11AuthModeWPAPSK) &&\
		(pAdapter->CommonCfg.AuthMode != Ndis802_11AuthModeWPA2PSK) &&\
		(pAdapter->CommonCfg.AuthMode != Ndis802_11AuthModeWPANone) )
		return TRUE;	// do nothing
	
	DBGPRINT(RT_DEBUG_TRACE, ("Set_WPAPSK_Proc::(WPAPSK=%s)\n", arg));

	NdisZeroMemory(keyMaterial, 40);

	// the end of this string
	arg[strlen(arg)]='\0';
	if ((strlen(arg) < 8) || (strlen(arg) > 64))
	{
		DBGPRINT(RT_DEBUG_TRACE, ("Set failed!!(WPAPSK=%s), WPAPSK key-string required 8 ~ 64 characters \n", arg));
		return FALSE;
	}

	if (strlen(arg) == 64) // 64 Hex
	{
		AtoH(arg, keyMaterial, 32);
		NdisMoveMemory(pAdapter->StaCfg.PMK, keyMaterial, 32);
	}
	else  // passphrase
	{		
		PasswordHash((char *)arg, pAdapter->MlmeAux.Ssid, pAdapter->MlmeAux.SsidLen, keyMaterial);
		NdisMoveMemory(pAdapter->StaCfg.PMK, keyMaterial, 32);
	}

	RTMPMakeRSNIE(pAdapter, pAdapter->CommonCfg.GroupCipher);
	
	if ((pAdapter->StaCfg.BssType == BSS_ADHOC) &&\
	   (pAdapter->CommonCfg.AuthMode == Ndis802_11AuthModeWPANone) &&\
	   (pAdapter->MlmeAux.SsidLen != 0))
	{
		Status = RTMPWPANoneAddKeyProc(pAdapter, &keyMaterial[0]);
		if (Status != NDIS_STATUS_SUCCESS)
			return FALSE;
			
		pAdapter->StaCfg.WpaState = SS_NOTUSE; 
	}
	else	// Use RaConfig as PSK agent.
	{
		// Start STA supplicant state machine
		pAdapter->StaCfg.WpaState = SS_START;
	}
	
	return TRUE;
}

/* 
	==========================================================================
	Description:
		Reset statistics counter

	Arguments:
		pAdapter			Pointer to our adapter
		arg 				

	Return:
		TRUE if all parameters are OK, FALSE otherwise
	==========================================================================
*/
INT	Set_ResetStatCounter_Proc(
	IN	PRTMP_ADAPTER	pAd, 
	IN	PUCHAR			arg)
{
	DBGPRINT(RT_DEBUG_TRACE, ("==>Set_ResetStatCounter_Proc\n"));
	
	// add the most up-to-date h/w raw counters into software counters
	NICUpdateRawCounters(pAd);
	
	NdisZeroMemory(&pAd->WlanCounters, sizeof(COUNTER_802_11));
	NdisZeroMemory(&pAd->Counters8023, sizeof(COUNTER_802_3));
	NdisZeroMemory(&pAd->RalinkCounters, sizeof(COUNTER_RALINK));

	return TRUE;
}

/* 
	==========================================================================
	Description:
		Set Power Saving mode
	Return:
		TRUE if all parameters are OK, FALSE otherwise
	==========================================================================
*/
INT Set_PSMode_Proc(
	IN	PRTMP_ADAPTER	pAdapter, 
	IN	PUCHAR			arg)
{
	ULONG	PowerSaveMode;

	PowerSaveMode = simple_strtol(arg, 0, 10);
	
	if (pAdapter->StaCfg.BssType == BSS_INFRA)
	{
		if ((strcmp(arg, "MAX_PSP") == 0) || (strcmp(arg, "max_psp") == 0))
		{
			// do NOT turn on PSM bit here, wait until MlmeCheckForPsmChange()
			// to exclude certain situations.
			//	   MlmeSetPsm(pAdapter, PWR_SAVE);
			if (pAdapter->StaCfg.bWindowsACCAMEnable == FALSE)
				pAdapter->StaCfg.WindowsPowerMode = Ndis802_11PowerModeMAX_PSP;
			pAdapter->StaCfg.WindowsBatteryPowerMode = Ndis802_11PowerModeMAX_PSP;
			OPSTATUS_SET_FLAG(pAdapter, fOP_STATUS_RECEIVE_DTIM);
			pAdapter->StaCfg.DefaultListenCount = 5;
		
		}
		else if ((strcmp(arg, "Fast_PSP") == 0) || (strcmp(arg, "fast_psp") == 0) ||
				 (strcmp(arg, "FAST_PSP") == 0))
		{
			// do NOT turn on PSM bit here, wait until MlmeCheckForPsmChange()
			// to exclude certain situations.
			//	   MlmeSetPsm(pAdapter, PWR_SAVE);
			OPSTATUS_SET_FLAG(pAdapter, fOP_STATUS_RECEIVE_DTIM);
			if (pAdapter->StaCfg.bWindowsACCAMEnable == FALSE)
				pAdapter->StaCfg.WindowsPowerMode = Ndis802_11PowerModeFast_PSP;
			pAdapter->StaCfg.WindowsBatteryPowerMode = Ndis802_11PowerModeFast_PSP;
			pAdapter->StaCfg.DefaultListenCount = 3;
		}
		else
		{
			//Default Ndis802_11PowerModeCAM
			// clear PSM bit immediately
			MlmeSetPsm(pAdapter, PWR_ACTIVE);
			OPSTATUS_SET_FLAG(pAdapter, fOP_STATUS_RECEIVE_DTIM);
			if (pAdapter->StaCfg.bWindowsACCAMEnable == FALSE)
				pAdapter->StaCfg.WindowsPowerMode = Ndis802_11PowerModeCAM;
			pAdapter->StaCfg.WindowsBatteryPowerMode = Ndis802_11PowerModeCAM;
		}
			
		DBGPRINT(RT_DEBUG_TRACE, ("Set_PSMode_Proc::(PSMode=%ld)\n", pAdapter->StaCfg.WindowsPowerMode));
	}
	else
		return FALSE;

		
	return TRUE;
}

#ifdef DBG
#if 1
VOID RTMPIoctlBBP(
	IN	PRTMP_ADAPTER	pAdapter,
	IN	struct iwreq	*wrq)
{
	CHAR				*this_char;
	CHAR				*value;
	UCHAR				regBBP = 0;
	CHAR				msg[2048]= {0};
	CHAR				arg[255]={0};
	LONG				bbpId;
	LONG				bbpValue;
	BOOLEAN				bIsPrintAllBBP = FALSE;
	INT 				Status = 0;

	DBGPRINT(RT_DEBUG_INFO, ("==>RTMPIoctlBBP\n"));
    
	memset(msg, 0x00, 2048);
	if (wrq->u.data.length > 1) //Check if parameters exist after "iwpriv rausb0 bbp".
	{   	    
        Status = copy_from_user(arg, wrq->u.data.pointer, (wrq->u.data.length > 255) ? 255 : wrq->u.data.length);
		sprintf(msg, "\n");
		
		//Parsing Read or Write
		this_char = arg;
		DBGPRINT(RT_DEBUG_INFO, ("this_char=%s\n", this_char));
		if (!*this_char)                                                                            
			goto next;
			
		if ((value = rtstrchr(this_char, '=')) != NULL)                                                 
			*value++ = 0;		
		
		if (!value || !*value)                                                                      
		{ //Read                                                                                    
			DBGPRINT(RT_DEBUG_INFO, ("this_char=%s, value=%s\n", this_char, value));
			if (sscanf(this_char, "%ld", &(bbpId)) == 1)                                             
			{  
				if (bbpId <= 108)                                                                   
				{                                                                                   
					RTMP_BBP_IO_READ8_BY_REG_ID(pAdapter, bbpId, &regBBP);                          
					sprintf(msg+strlen(msg), "R%ld[0x%lx]:%02X  ", bbpId, bbpId*2, regBBP);
					DBGPRINT(RT_DEBUG_INFO, ("msg=%s\n", msg));
				}                                                                                   
				else                                                                                
				{//Invalid parametes, so default printk all bbp                                     
					bIsPrintAllBBP = TRUE;
					goto next;                                                                          
				}                                                                                   
			}                                                                                       
			else                                                                                    
			{ //Invalid parametes, so default printk all bbp                                        
				bIsPrintAllBBP = TRUE;
				goto next;                                                                              
			}                                                                                       
		}                                                                                           
		else                                                                                        
		{ //Write                                                                                   
			DBGPRINT(RT_DEBUG_INFO, ("this_char=%s, value=%s\n", this_char, value));
			if ((sscanf(this_char, "%ld", &(bbpId)) == 1) && (sscanf(value, "%lx", &(bbpValue)) == 1))
			{                                                                                       
				DBGPRINT(RT_DEBUG_INFO, ("bbpID=%ld, value=0x%lx\n", bbpId, bbpValue));               
				if (bbpId <= 108)                                                                   
				{                                                                                   
					RTMP_BBP_IO_WRITE8_BY_REG_ID(pAdapter, (UCHAR)bbpId,(UCHAR) bbpValue);          
					//Read it back for showing                                                      
					RTMP_BBP_IO_READ8_BY_REG_ID(pAdapter, bbpId, &regBBP);                          
					sprintf(msg+strlen(msg), "R%ld[0x%lx]:%02X\n", bbpId, bbpId*2, regBBP);       
					DBGPRINT(RT_DEBUG_INFO, ("msg=%s\n", msg));                                       
				}                                                                                   
				else                                                                                
				{//Invalid parametes, so default printk all bbp                                     
					bIsPrintAllBBP = TRUE;                                                          
					goto next;                                                                          
				}                                                                                   
			}                                                                                       
			else                                                                                    
			{ //Invalid parametes, so default printk all bbp                                        
				bIsPrintAllBBP = TRUE;                                                              
				goto next;                                                                              
			}                                                                                       
		}                             
	}
	else
		bIsPrintAllBBP = TRUE;

next:    
	if (bIsPrintAllBBP)
	{   
		memset(msg, 0x00, 2048);
		sprintf(msg, "\n");
		for (bbpId = 0; bbpId <= 108; bbpId++)
		{
			RTMP_BBP_IO_READ8_BY_REG_ID(pAdapter, bbpId, &regBBP);
			sprintf(msg+strlen(msg), "R%ld[0x%lx]:%02X    ", bbpId, bbpId*2, regBBP);
			if (bbpId%5 == 4)
				sprintf(msg+strlen(msg), "\n");
		}
		// Copy the information into the user buffer
		DBGPRINT(RT_DEBUG_TRACE, ("strlen(msg)=%d\n", strlen(msg)));
		wrq->u.data.length = strlen(msg);
		Status = copy_to_user(wrq->u.data.pointer, msg, wrq->u.data.length);
	}
	else
	{
		DBGPRINT(RT_DEBUG_INFO, ("copy to user [msg=%s]\n", msg));
		// Copy the information into the user buffer
		DBGPRINT(RT_DEBUG_INFO, ("strlen(msg) =%d\n", strlen(msg)));
		wrq->u.data.length = strlen(msg);
		Status = copy_to_user(wrq->u.data.pointer, msg, wrq->u.data.length);
	}
	DBGPRINT(RT_DEBUG_TRACE, ("<==RTMPIoctlBBP\n\n"));	
}
#else
/* 
	==========================================================================
	Description:
		Read / Write BBP
	Arguments:
		pAdapter					Pointer to our adapter
		wrq 						Pointer to the ioctl argument

	Return Value:
		None

	Note:
		Usage: 
			   1.) iwpriv rausb0 bbp			   ==> read all BBP
			   2.) iwpriv rausb0 bbp 1			   ==> read BBP where RegID=1
			   3.) iwpriv rausb0 bbp 1=10		   ==> write BBP R1=0x10
	==========================================================================
*/
VOID RTMPIoctlBBP(
	IN	PRTMP_ADAPTER	pAdapter,
	IN	struct iwreq	*wrq)
{
	CHAR				*this_char;
	CHAR				*value;
	UCHAR				regBBP = 0;
	CHAR				msg[2048] = {0};
	CHAR				arg[255]= {0};
	LONG				bbpId;
	LONG				bbpValue;
	BOOLEAN				bIsPrintAllBBP = FALSE;
	INT 				Status = 0;
	
	DBGPRINT(RT_DEBUG_INFO, ("==>RTMPIoctlBBP\n"));
	
	memset(msg, 0x00, 2048);
	if (wrq->u.data.length > 1) //No parameters.
	{			
		Status = copy_from_user(arg, wrq->u.data.pointer, (wrq->u.data.length > 255) ? 255 : wrq->u.data.length);
		sprintf(msg, "\n");
		
		//Parsing Read or Write
		this_char = arg;
		DBGPRINT(RT_DEBUG_INFO, ("this_char=%s\n", this_char));										
		if (!*this_char)																			
			goto next;
			
		if ((value = rtstrchr(this_char, '=')) != NULL) 												
			*value++ = 0;		
		
		if (!value || !*value)																		
		{ //Read																					
			DBGPRINT(RT_DEBUG_INFO, ("this_char=%s, value=%s\n", this_char, value));
			if (sscanf(this_char, "%d", &(bbpId)) == 1) 											
			{  
				if (bbpId <= 108)																	
				{																					
					RTUSBReadBBPRegister(pAdapter, bbpId, &regBBP);
					sprintf(msg+strlen(msg), "R%02d[0x%02X]:%02X  ", bbpId, bbpId*2, regBBP);		
					DBGPRINT(RT_DEBUG_INFO, ("msg=%s\n", msg));
				}																					
				else																				
				{//Invalid parametes, so default printk all bbp 									
					bIsPrintAllBBP = TRUE;
					goto next;																			
				}																					
			}																						
			else																					
			{ //Invalid parametes, so default printk all bbp										
				bIsPrintAllBBP = TRUE;
				goto next;																				
			}																						
		}																							
		else																						
		{ //Write																					
			DBGPRINT(RT_DEBUG_INFO, ("this_char=%s, value=%s\n", this_char, value));
			if ((sscanf(this_char, "%d", &(bbpId)) == 1) && (sscanf(value, "%x", &(bbpValue)) == 1))
			{																						
				DBGPRINT(RT_DEBUG_INFO, ("bbpID=%02d, value=0x%x\n", bbpId, bbpValue));
				if (bbpId <= 108)																	
				{																					
					RTUSBWriteBBPRegister(pAdapter, (UCHAR)bbpId,(UCHAR) bbpValue);
					//Read it back for showing														
					RTUSBReadBBPRegister(pAdapter, bbpId, &regBBP); 
					sprintf(msg+strlen(msg), "R%02d[0x%02X]:%02X\n", bbpId, bbpId*2, regBBP);		
					DBGPRINT(RT_DEBUG_INFO, ("msg=%s\n", msg));
				}																					
				else																				
				{//Invalid parametes, so default printk all bbp 									
					bIsPrintAllBBP = TRUE;															
					goto next;																			
				}																					
			}																						
			else																					
			{ //Invalid parametes, so default printk all bbp										
				bIsPrintAllBBP = TRUE;																
				goto next;																				
			}																						
		}							  
	}
	else
		bIsPrintAllBBP = TRUE;

next:	 
	if (bIsPrintAllBBP)
	{	
		memset(msg, 0x00, 2048);
		sprintf(msg, "\n");
		for (bbpId = 0; bbpId <= 108; bbpId++)
		{
			RTUSBReadBBPRegister(pAdapter, bbpId, &regBBP);
			sprintf(msg+strlen(msg), "R%02d[0x%02X]:%02X	", bbpId, bbpId*2, regBBP);
			if (bbpId%5 == 4)
				sprintf(msg+strlen(msg), "\n");
		}
		// Copy the information into the user buffer
		DBGPRINT(RT_DEBUG_TRACE, ("strlen(msg)=%d\n", strlen(msg)));
		wrq->u.data.length = strlen(msg);
		Status = copy_to_user(wrq->u.data.pointer, msg, wrq->u.data.length);
	}
	else
	{
		DBGPRINT(RT_DEBUG_INFO, ("copy to user [msg=%s]\n", msg));
		// Copy the information into the user buffer
		DBGPRINT(RT_DEBUG_INFO, ("strlen(msg) =%d\n", strlen(msg)));
		wrq->u.data.length = strlen(msg);
		Status =  copy_to_user(wrq->u.data.pointer, msg, wrq->u.data.length);
	}
	DBGPRINT(RT_DEBUG_TRACE, ("<==RTMPIoctlBBP\n\n"));	
}
#endif

/* 
	==========================================================================
	Description:
		Read / Write MAC
	Arguments:
		pAdapter					Pointer to our adapter
		wrq 						Pointer to the ioctl argument

	Return Value:
		None

	Note:
		Usage: 
			   1.) iwpriv rausb0 mac 0		  ==> read MAC where Addr=0x0
			   2.) iwpriv rausb0 mac 0=12	  ==> write MAC where Addr=0x0, value=12
	==========================================================================
*/
#if 1
VOID RTMPIoctlMAC(
	IN	PRTMP_ADAPTER	pAdapter, 
	IN	struct iwreq	*wrq)
{
	CHAR				*this_char;
	CHAR				*value;
	INT					j = 0, k = 0;
	CHAR				msg[1024];
	CHAR				arg[255];
	ULONG				macAddr = 0;
	UCHAR				temp[16], temp2[16];
	UINT32				macValue = 0;
	INT					Status;

	DBGPRINT(RT_DEBUG_INFO, ("==>RTMPIoctlMAC\n"));
	memset(msg, 0x00, 1024);
	if (wrq->u.data.length > 1) //No parameters.
	{   
	    Status = copy_from_user(arg, wrq->u.data.pointer, (wrq->u.data.length > 255) ? 255 : wrq->u.data.length);
		sprintf(msg, "\n");
		
		//Parsing Read or Write
	    this_char = arg;
		DBGPRINT(RT_DEBUG_INFO, ("this_char=%s\n", this_char));
		if (!*this_char)
			goto next;

		if ((value = rtstrchr(this_char, '=')) != NULL)
			*value++ = 0;

		if (!value || !*value)
		{ //Read
			DBGPRINT(RT_DEBUG_INFO, ("Read: this_char=%s, strlen=%d\n", this_char, strlen(this_char)));

			// Sanity check
			if(strlen(this_char) > 4)
				goto next;

			j = strlen(this_char);
			while(j-- > 0)
			{
				if(this_char[j] > 'f' || this_char[j] < '0')
					return;
			}

			// Mac Addr
			k = j = strlen(this_char);
			while(j-- > 0)
			{
				this_char[4-k+j] = this_char[j];
			}
			
			while(k < 4)
				this_char[3-k++]='0';
			this_char[4]='\0';

			if(strlen(this_char) == 4)
			{
				AtoH(this_char, temp, 4);
				macAddr = *temp*256 + temp[1];					
				if (macAddr < 0xFFFF)
				{
					RTMP_IO_READ32(pAdapter, macAddr, &macValue);
					DBGPRINT(RT_DEBUG_TRACE, ("MacAddr=%lx, MacValue=%x\n", macAddr, macValue));
					sprintf(msg+strlen(msg), "[0x%lx]:%08X  ", macAddr , macValue);
					DBGPRINT(RT_DEBUG_INFO, ("msg=%s\n", msg));
				}
				else
				{//Invalid parametes, so default printk all bbp
					goto next;
				}
			}
		}
		else
		{ //Write
			DBGPRINT(RT_DEBUG_INFO, ("Write: this_char=%s, strlen(value)=%d, value=%s\n", this_char, strlen(value), value));
			memcpy(&temp2, value, strlen(value));
			temp2[strlen(value)] = '\0';

			// Sanity check
			if((strlen(this_char) > 4) || strlen(temp2) > 8)
				goto next;

			j = strlen(this_char);
			while(j-- > 0)
			{
				if(this_char[j] > 'f' || this_char[j] < '0')
					return;
			}

			j = strlen(temp2);
			while(j-- > 0)
			{
				if(temp2[j] > 'f' || temp2[j] < '0')
					return;
			}

			//MAC Addr
			k = j = strlen(this_char);
			while(j-- > 0)
			{
				this_char[4-k+j] = this_char[j];
			}

			while(k < 4)
				this_char[3-k++]='0';
			this_char[4]='\0';

			//MAC value
			k = j = strlen(temp2);
			while(j-- > 0)
			{
				temp2[8-k+j] = temp2[j];
			}
			
			while(k < 8)
				temp2[7-k++]='0';
			temp2[8]='\0';

			{
				AtoH(this_char, temp, 4);
				macAddr = *temp*256 + temp[1];

				AtoH(temp2, temp, 8);
				macValue = *temp*256*256*256 + temp[1]*256*256 + temp[2]*256 + temp[3];

				// debug mode
				if (macAddr == (HW_DEBUG_SETTING_BASE + 4))
				{
					// 0x2bf4: byte0 non-zero: enable R17 tuning, 0: disable R17 tuning
                    if (macValue & 0x000000ff) 
                    {
                        pAdapter->BbpTuning.bEnable = TRUE;
                        DBGPRINT(RT_DEBUG_TRACE,("turn on R17 tuning\n"));
                    }
                    else
                    {
                        UCHAR R66;
                        pAdapter->BbpTuning.bEnable = FALSE;
                        R66 = 0x26 + GET_LNA_GAIN(pAdapter);
						RTMP_BBP_IO_WRITE8_BY_REG_ID(pAdapter, BBP_R66, (0x26 + GET_LNA_GAIN(pAdapter)));
                        DBGPRINT(RT_DEBUG_TRACE,("turn off R17 tuning, restore to 0x%02x\n", R66));
                    }
					return;
				}

				DBGPRINT(RT_DEBUG_TRACE, ("MacAddr=%lx, MacValue=0x%x\n", macAddr, macValue));
				
				RTMP_IO_WRITE32(pAdapter, macAddr, macValue);
				sprintf(msg+strlen(msg), "[0x%lx]:%08X  ", macAddr, macValue);
				DBGPRINT(RT_DEBUG_INFO, ("msg=%s\n", msg));
			}
		}
	}
next:
	if(strlen(msg) == 1)
		sprintf(msg+strlen(msg), "===>Error command format!");
	DBGPRINT(RT_DEBUG_INFO, ("copy to user [msg=%s]\n", msg));
	// Copy the information into the user buffer
	DBGPRINT(RT_DEBUG_INFO, ("strlen(msg) =%d\n", strlen(msg)));
	wrq->u.data.length = strlen(msg);
	Status = copy_to_user(wrq->u.data.pointer, msg, wrq->u.data.length);
	
	DBGPRINT(RT_DEBUG_TRACE, ("<==RTMPIoctlMAC\n\n"));
}
#else
VOID RTMPIoctlMAC(
	IN	PRTMP_ADAPTER	pAdapter, 
	IN	struct iwreq	*wrq)
{
	CHAR				*this_char;
	CHAR				*value;
	INT					j = 0, k = 0;
	CHAR				msg[1024] = {0};
	CHAR				arg[255] = {0};
	ULONG				macAddr = 0;
	UCHAR				temp[16], temp2[16];
	ULONG				macValue = 0;
	INT 				Status = 0;

	DBGPRINT(RT_DEBUG_INFO, ("==>RTMPIoctlMAC\n"));
	memset(msg, 0x00, 1024);
	if (wrq->u.data.length > 1) //No parameters.
	{	
		Status = copy_from_user(arg, wrq->u.data.pointer, (wrq->u.data.length > 255) ? 255 : wrq->u.data.length);
		sprintf(msg, "\n");
		
		//Parsing Read or Write
		this_char = arg;
		DBGPRINT(RT_DEBUG_INFO, ("this_char=%s\n", this_char));
		if (!*this_char)
			goto next;

		if ((value = rtstrchr(this_char, '=')) != NULL)
			*value++ = 0;

		if (!value || !*value)
		{ //Read
			DBGPRINT(RT_DEBUG_INFO, ("Read: this_char=%s, strlen=%d\n", this_char, strlen(this_char)));

			// Sanity check
			if(strlen(this_char) > 4)
				goto next;

			j = strlen(this_char);
			while(j-- > 0)
			{
				if(this_char[j] > 'f' || this_char[j] < '0')
					return;
			}

			// Mac Addr
			k = j = strlen(this_char);
			while(j-- > 0)
			{
				this_char[4-k+j] = this_char[j];
			}
			
			while(k < 4)
				this_char[3-k++]='0';
			this_char[4]='\0';

			if(strlen(this_char) == 4)
			{
				AtoH(this_char, temp, 4);
				macAddr = *temp*256 + temp[1];					
				if (macAddr < 0xFFFF)
				{
					RTUSBReadMACRegister(pAdapter, macAddr, &macValue);
					DBGPRINT(RT_DEBUG_TRACE, ("MacAddr=%x, MacValue=%x\n", macAddr, macValue));
					sprintf(msg+strlen(msg), "[0x%08X]:%08X  ", macAddr , macValue);
					DBGPRINT(RT_DEBUG_INFO, ("msg=%s\n", msg));
				}
				else
				{//Invalid parametes, so default printk all bbp
					goto next;
				}
			}
		}
		else
		{ //Write
			DBGPRINT(RT_DEBUG_INFO, ("Write: this_char=%s, strlen(value)=%d, value=%s\n", this_char, strlen(value), value));
			memcpy(&temp2, value, strlen(value));
			temp2[strlen(value)] = '\0';

			// Sanity check
			if((strlen(this_char) > 4) || strlen(temp2) > 8)
				goto next;

			j = strlen(this_char);
			while(j-- > 0)
			{
				if(this_char[j] > 'f' || this_char[j] < '0')
					return;
			}

			j = strlen(temp2);
			while(j-- > 0)
			{
				if(temp2[j] > 'f' || temp2[j] < '0')
					return;
			}

			//MAC Addr
			k = j = strlen(this_char);
			while(j-- > 0)
			{
				this_char[4-k+j] = this_char[j];
			}

			while(k < 4)
				this_char[3-k++]='0';
			this_char[4]='\0';

			//MAC value
			k = j = strlen(temp2);
			while(j-- > 0)
			{
				temp2[8-k+j] = temp2[j];
			}
			
			while(k < 8)
				temp2[7-k++]='0';
			temp2[8]='\0';

			{
				AtoH(this_char, temp, 4);
				macAddr = *temp*256 + temp[1];

				AtoH(temp2, temp, 8);
				macValue = *temp*256*256*256 + temp[1]*256*256 + temp[2]*256 + temp[3];

				// debug mode
				if (macAddr == (HW_DEBUG_SETTING_BASE + 4))
				{
					// 0x2bf4: byte0 non-zero: enable R17 tuning, 0: disable R17 tuning
					if (macValue & 0x000000ff) 
					{
						pAdapter->BbpTuning.bEnable = TRUE;
						DBGPRINT(RT_DEBUG_TRACE,("turn on R17 tuning\n"));
					}
					else
					{
						UCHAR R17;
						pAdapter->BbpTuning.bEnable = FALSE;
						if (pAdapter->CommonCfg.Channel > 14)
							R17 = pAdapter->BbpTuning.R17LowerBoundA;
						else
							R17 = pAdapter->BbpTuning.R17LowerBoundG;
						RTUSBWriteBBPRegister(pAdapter, 17, R17);
						DBGPRINT(RT_DEBUG_TRACE,("turn off R17 tuning, restore to 0x%02x\n", R17));
					}
					return;
				}

				DBGPRINT(RT_DEBUG_TRACE, ("MacAddr=%02x, MacValue=0x%x\n", macAddr, macValue));
				
				RTUSBWriteMACRegister(pAdapter, macAddr, macValue);
				sprintf(msg+strlen(msg), "[0x%08X]:%08X  ", macAddr, macValue);
				DBGPRINT(RT_DEBUG_INFO, ("msg=%s\n", msg));
			}
		}
	}
next:
	if(strlen(msg) == 1)
		sprintf(msg+strlen(msg), "===>Error command format!");
	DBGPRINT(RT_DEBUG_INFO, ("copy to user [msg=%s]\n", msg));
	// Copy the information into the user buffer
	DBGPRINT(RT_DEBUG_INFO, ("strlen(msg) =%d\n", strlen(msg)));
	wrq->u.data.length = strlen(msg);
	Status = copy_to_user(wrq->u.data.pointer, msg, wrq->u.data.length);
	
	DBGPRINT(RT_DEBUG_TRACE, ("<==RTMPIoctlMAC\n\n"));
}
#endif

/* 
    ==========================================================================
    Description:
        Read / Write E2PROM
    Arguments:
        pAdapter                    Pointer to our adapter
        wrq                         Pointer to the ioctl argument

    Return Value:
        None

    Note:
        Usage: 
               1.) iwpriv rausb0 e2p 0     		==> read E2PROM where Addr=0x0
               2.) iwpriv rausb0 e2p 0=1234	==> write E2PROM where Addr=0x0, value=1234
    ==========================================================================
*/
VOID RTMPIoctlE2PROM(
	IN	PRTMP_ADAPTER	pAdapter, 
	IN	struct iwreq	*wrq)
{
	CHAR				*this_char;
	CHAR				*value;
	INT					j = 0, k = 0;
	CHAR				msg[1024];
	CHAR				arg[255];
	USHORT				eepAddr = 0;
	UCHAR				temp[16], temp2[16];
	USHORT				eepValue;
	int					Status;

	DBGPRINT(RT_DEBUG_INFO, ("==>RTMPIoctlE2PROM\n"));
	memset(msg, 0x00, 1024);
	if (wrq->u.data.length > 1) //No parameters.
	{   
	    Status = copy_from_user(arg, wrq->u.data.pointer, (wrq->u.data.length > 255) ? 255 : wrq->u.data.length);
		sprintf(msg, "\n");

	    //Parsing Read or Write
		this_char = arg;
		DBGPRINT(RT_DEBUG_INFO, ("this_char=%s\n", this_char));

		//Check parameters
		if (!*this_char)
			goto next;

		if ((value = rtstrchr(this_char, '=')) != NULL)
			*value++ = 0;

		if (!value || !*value)
		{ //Read
			DBGPRINT(RT_DEBUG_INFO, ("Read: this_char=%s, strlen=%d\n", this_char, strlen(this_char)));

			// Sanity check
			if(strlen(this_char) > 4)
				goto next;

			j = strlen(this_char);
			while(j-- > 0)
			{
				if(this_char[j] > 'f' || this_char[j] < '0')
					return;
			}

			// E2PROM addr
			k = j = strlen(this_char);
			while(j-- > 0)
			{
				this_char[4-k+j] = this_char[j];
			}
			
			while(k < 4)
				this_char[3-k++]='0';
			this_char[4]='\0';

			if(strlen(this_char) == 4)
			{
				AtoH(this_char, temp, 4);			
				eepAddr = *temp*256 + temp[1];					
				if (eepAddr < 0xFFFF)
				{
					RTUSBReadEEPROM(pAdapter, eepAddr, (PUCHAR)&eepValue, 2);
					DBGPRINT(RT_DEBUG_INFO, ("eepAddr=%x, eepValue=0x%x\n", eepAddr, eepValue));
					sprintf(msg+strlen(msg), "[0x%04X]:0x%02X  ", eepAddr , eepValue);	
					DBGPRINT(RT_DEBUG_INFO, ("msg=%s\n", msg));
				}
				else
				{//Invalid parametes, so default printk all bbp
					goto next;
				}
			}
		}				
		else
		{ //Write
			DBGPRINT(RT_DEBUG_INFO, ("Write: this_char=%s, strlen(value)=%d, value=%s\n", this_char, strlen(value), value));
			memcpy(&temp2, value, strlen(value));
			temp2[strlen(value)] = '\0';

			// Sanity check
			if((strlen(this_char) > 4) || strlen(temp2) > 8)
				goto next;

			j = strlen(this_char);
			while(j-- > 0)
			{
				if(this_char[j] > 'f' || this_char[j] < '0')
					return;
			}
			j = strlen(temp2);
			while(j-- > 0)
			{
				if(temp2[j] > 'f' || temp2[j] < '0')
					return;
			}

			//MAC Addr
			k = j = strlen(this_char);
			while(j-- > 0)
			{
				this_char[4-k+j] = this_char[j];
			}

			while(k < 4)
				this_char[3-k++]='0';
			this_char[4]='\0';

			//MAC value
			k = j = strlen(temp2);
			while(j-- > 0)
			{
				temp2[4-k+j] = temp2[j];
			}
			
			while(k < 4)
				temp2[3-k++]='0';
			temp2[4]='\0';

			AtoH(this_char, temp, 4);
			eepAddr = *temp*256 + temp[1];

			AtoH(temp2, temp, 4);
			eepValue = *temp*256 + temp[1];

			DBGPRINT(RT_DEBUG_INFO, ("eepAddr=%02x, eepValue=0x%x\n", eepAddr, eepValue));
			
			RTUSBWriteEEPROM(pAdapter, eepAddr, (PUCHAR)&eepValue, sizeof(eepValue));
			sprintf(msg+strlen(msg), "[0x%02X]:%02X  ", eepAddr, eepValue);
			DBGPRINT(RT_DEBUG_INFO, ("msg=%s\n", msg));
		}
	}
next:
	if(strlen(msg) == 1)
		sprintf(msg+strlen(msg), "===>Error command format!");

	// Copy the information into the user buffer
	DBGPRINT(RT_DEBUG_INFO, ("copy to user [msg=%s], msg_length=%d\n", msg, strlen(msg)));
	wrq->u.data.length = strlen(msg);		
	Status =  copy_to_user(wrq->u.data.pointer, msg, wrq->u.data.length);
	
	DBGPRINT(RT_DEBUG_TRACE, ("<==RTMPIoctlE2PROM\n"));
}
#endif //#ifdef DBG

/* 
	==========================================================================
	Description:
		Read statistics counter
	Arguments:
		pAdapter					Pointer to our adapter
		wrq 						Pointer to the ioctl argument

	Return Value:
		None

	Note:
		Usage: 						iwpriv rausb0 stat
	==========================================================================
*/
VOID RTMPIoctlStatistics(
	IN	PRTMP_ADAPTER	pAd, 
	IN	struct iwreq	*wrq)
{
	INT			Status=0;
	char			*msg;
	
	os_alloc_mem(NULL, (PUCHAR *)&msg, sizeof(CHAR)*(2048));
	if (msg == NULL) 
		return;

	// add the most up-to-date h/w raw counters into software counters
	NICUpdateRawCounters(pAd);		
	// Sanity check for calculation of sucessful count
	if (pAd->WlanCounters.TransmittedFragmentCount.QuadPart < pAd->WlanCounters.RetryCount.QuadPart)
		pAd->WlanCounters.TransmittedFragmentCount = pAd->WlanCounters.RetryCount;

	memset(msg, 0x00, 2048);
	sprintf(msg, "\n");
	
	sprintf(msg+strlen(msg), "[Statistics Counters]\n");
	sprintf(msg+strlen(msg), "Tx success\t\t\t\t%ld\n", (ULONG)pAd->WlanCounters.TransmittedFragmentCount.QuadPart);
	sprintf(msg+strlen(msg), "Tx success without retry\t\t%ld\n", (ULONG)(pAd->WlanCounters.TransmittedFragmentCount.QuadPart - pAd->WlanCounters.RetryCount.QuadPart));
	sprintf(msg+strlen(msg), "Tx success after retry\t\t\t%ld\n", (ULONG)pAd->WlanCounters.RetryCount.QuadPart);
	sprintf(msg+strlen(msg), "Tx fail to Rcv ACK after retry\t\t%ld\n", (ULONG)pAd->WlanCounters.FailedCount.QuadPart);
	sprintf(msg+strlen(msg), "RTS Success Rcv CTS\t\t\t%ld\n", (ULONG)pAd->WlanCounters.RTSSuccessCount.QuadPart);
	sprintf(msg+strlen(msg), "RTS Fail Rcv CTS\t\t\t%ld\n", (ULONG)pAd->WlanCounters.RTSFailureCount.QuadPart);

	sprintf(msg+strlen(msg), "Rx success\t\t\t\t%ld\n", (ULONG)pAd->WlanCounters.ReceivedFragmentCount.QuadPart);
	sprintf(msg+strlen(msg), "Rx with CRC\t\t\t\t%ld\n", (ULONG)pAd->WlanCounters.FCSErrorCount.QuadPart);
	sprintf(msg+strlen(msg), "Rx drop due to out of resource\t\t%ld\n", (ULONG)pAd->Counters8023.RxNoBuffer);
	sprintf(msg+strlen(msg), "Rx duplicate frame\t\t\t%ld\n", (ULONG)pAd->WlanCounters.FrameDuplicateCount.QuadPart);

	sprintf(msg+strlen(msg), "False CCA (one second)\t\t\t%ld\n", (ULONG)pAd->RalinkCounters.OneSecFalseCCACnt);

#if 0
#ifdef RALINK_ATE
	if(pAd->ate.Mode != ATE_STASTART)
	{
		if (pAd->ate.RxAntennaSel == 0)
		{
    		sprintf(msg+strlen(msg), "RSSI-A                          = %ld\n", (LONG)(pAd->ate.LastRssi - pAd->BbpRssiToDbmDelta));
			sprintf(msg+strlen(msg), "RSSI-B (if available)           = %ld\n", (LONG)(pAd->ate.LastRssi2 - pAd->BbpRssiToDbmDelta));
			sprintf(msg+strlen(msg), "RSSI-C (if available)           = %ld\n\n", (LONG)(pAd->ate.LastRssi3 - pAd->BbpRssiToDbmDelta));
		}
		else
		{
    		sprintf(msg+strlen(msg), "RSSI                            = %ld\n", (LONG)(pAd->ate.LastRssi - pAd->BbpRssiToDbmDelta));
		}
	}
	else
#endif // RALINK_ATE //
#endif
	{
		sprintf(msg+strlen(msg), "RSSI-A\t\t\t\t\t%ld\n", (LONG)(pAd->StaCfg.LastRssi - pAd->BbpRssiToDbmDelta));
		sprintf(msg+strlen(msg), "RSSI-B (if available)\t\t\t%ld\n", (LONG)(pAd->StaCfg.LastRssi2 - pAd->BbpRssiToDbmDelta));
		sprintf(msg+strlen(msg), "RSSI-C (if available)\t\t\t%ld\n\n", (LONG)(pAd->StaCfg.LastRssi3 - pAd->BbpRssiToDbmDelta));
	}
	// Copy the information into the user buffer
	DBGPRINT(RT_DEBUG_INFO, ("copy to user [msg=%s]\n", msg));
	wrq->u.data.length = strlen(msg);
	Status = copy_to_user(wrq->u.data.pointer, msg, wrq->u.data.length);
	os_free_mem(NULL, (PUCHAR)msg);
	DBGPRINT(RT_DEBUG_TRACE, ("<==RTMPIoctlStatistics\n"));
}

#if 0 // move to cmm_info.c
/* 
    ==========================================================================
    Description:
        Parse encryption type
Arguments:
    pAdapter                    Pointer to our adapter
    wrq                         Pointer to the ioctl argument

    Return Value:
        None

    Note:
    ==========================================================================
*/
static CHAR *GetEncryptType(CHAR enc, CHAR encBitMode)
{
    /*** parse TKIP/AES  mixed mode ***/
    if (encBitMode == (TKIPBIT | CCMPBIT))
        return "TKIP,AES";
        
    if(enc == Ndis802_11WEPDisabled)
		return "None";
    if(enc == Ndis802_11WEPEnabled)
    	return "WEP";
    if(enc == Ndis802_11Encryption2Enabled)
    	return "TKIP";
    if(enc == Ndis802_11Encryption3Enabled)
    	return "AES";
    else
		return "Unknown";
}

/* 
	==========================================================================
	Description:
		Parse authentication type with AuthBitMode
	==========================================================================
*/
static CHAR *GetAuthMode(CHAR auth, CHAR authBitMode)
{
	/*** parse WPA1/WPA2 mixed mode ***/
	if (authBitMode == (WPA1PSKAKMBIT | WPA2PSKAKMBIT))
		return "WPA(2)PSK";
	if (authBitMode == (WPA1AKMBIT | WPA2AKMBIT))
		return "WPA(2)";
#if 0        
	/*** parse SSN/SSNPSK mixed mode ***/
	if (authBitMode == (WPA1AKMBIT | WPA1PSKAKMBIT))
		return "WPA/WPA-PSK";
	if (authBitMode == (WPA2AKMBIT | WPA2PSKAKMBIT))
		return "WPA2/WPA2-PSK";     
	if (authBitMode == (WPA1AKMBIT | WPA1PSKAKMBIT | WPA2AKMBIT | WPA2PSKAKMBIT))
		return "WPA(2)/WPA(2)-PSK";
#endif
//	if(auth == Ndis802_11AuthModeOpen)
//		return "OPEN";
//	if(auth == Ndis802_11AuthModeShared)
//		return "SHARED";
    if(auth == Ndis802_11AuthModeWPA)
    	return "WPA";
    if(auth == Ndis802_11AuthModeWPAPSK)
		return "WPAPSK";
    if(auth == Ndis802_11AuthModeWPANone)
    	return "WPANONE";
    if(auth == Ndis802_11AuthModeWPA2)
    	return "WPA2";
    if(auth == Ndis802_11AuthModeWPA2PSK)
		return "WPA2PSK";
    else
		return "Unknown";
}		

/* 
    ==========================================================================
    Description:
        Get site survey results
	Arguments:
	    pAdapter                    Pointer to our adapter
	    wrq                         Pointer to the ioctl argument

    Return Value:
        None

    Note:
        Usage:
        		1.) UI needs to wait 4 seconds after issue a site survey command
        		2.) iwpriv ra0 get_site_survey
        		3.) UI needs to prepare at least 4096bytes to get the results
    ==========================================================================
*/
#define	LINE_LEN	(8+8+36+20+12+12+12)	// Channel+RSSI+SSID+Bssid+WepStatus+AuthMode+NetworkType
VOID RTMPIoctlGetSiteSurvey(
	IN	PRTMP_ADAPTER	pAdapter, 
	IN	struct iwreq	*wrq)
{
	CHAR		*msg;
    INT 		i=0;    
    INT			Status; 
	CHAR		strSsid[MAX_LEN_OF_SSID+1]; // ssid with null terminator

    
    msg = (CHAR *) kmalloc(sizeof(CHAR)*((MAX_LEN_OF_BSS_TABLE)*LINE_LEN), MEM_ALLOC_FLAG);

    memset(msg, 0 ,(MAX_LEN_OF_BSS_TABLE)*LINE_LEN );
    sprintf(msg,"%s","\n");
    sprintf(msg+strlen(msg),"%-8s%-8s%-36s%-20s%-12s%-12s%-12s\n", 
	        "Channel", "RSSI", "SSID", "BSSID", "Enc", "Auth", "NetworkType");
    for(i=0;i<MAX_LEN_OF_BSS_TABLE;i++)
    {
		if( pAdapter->ScanTab.BssEntry[i].Channel==0)
	    break;

		if((strlen(msg)+LINE_LEN ) >= ((MAX_LEN_OF_BSS_TABLE)*LINE_LEN) )
	        break;	
			
		sprintf(msg+strlen(msg),"%-8d", pAdapter->ScanTab.BssEntry[i].Channel);
		sprintf(msg+strlen(msg),"%-8d", pAdapter->ScanTab.BssEntry[i].Rssi - pAdapter->BbpRssiToDbmDelta);	
		memcpy(strSsid, pAdapter->ScanTab.BssEntry[i].Ssid, pAdapter->ScanTab.BssEntry[i].SsidLen); 		
		strSsid[pAdapter->ScanTab.BssEntry[i].SsidLen]='\0';
		sprintf(msg+strlen(msg),"%-36s", pAdapter->ScanTab.BssEntry[i].Ssid);      
		sprintf(msg+strlen(msg),"%02x:%02x:%02x:%02x:%02x:%02x   ", 
			pAdapter->ScanTab.BssEntry[i].Bssid[0], 
			pAdapter->ScanTab.BssEntry[i].Bssid[1],
			pAdapter->ScanTab.BssEntry[i].Bssid[2], 
			pAdapter->ScanTab.BssEntry[i].Bssid[3], 
			pAdapter->ScanTab.BssEntry[i].Bssid[4], 
			pAdapter->ScanTab.BssEntry[i].Bssid[5]);
		sprintf(msg+strlen(msg),"%-12s",GetEncryptType(pAdapter->ScanTab.BssEntry[i].WepStatus));
		sprintf(msg+strlen(msg),"%-12s",GetAuthMode(pAdapter->ScanTab.BssEntry[i].AuthMode));
        if (pAdapter->ScanTab.BssEntry[i].BssType == BSS_ADHOC)
            sprintf(msg+strlen(msg),"%-12s\n", "Adhoc");
        else
		    sprintf(msg+strlen(msg),"%-12s\n", "Infra");
    }

    wrq->u.data.length = strlen(msg);
    Status = copy_to_user(wrq->u.data.pointer, msg, wrq->u.data.length);
	kfree(msg);
}
#endif


NDIS_STATUS RTMPWPANoneAddKeyProc(
    IN  PRTMP_ADAPTER   pAd,
    IN	PVOID			pBuf)
{    
	PNDIS_802_11_KEY        pKey;
	ULONG                   KeyLen;
	ULONG                   BufLen;
	NDIS_STATUS             Status = NDIS_STATUS_SUCCESS;
	int                     i;
            
	KeyLen = 32;
	BufLen = sizeof(NDIS_802_11_KEY) + KeyLen - 1;

	os_alloc_mem(NULL, (PUCHAR *)&pKey, BufLen);
	if (pKey == NULL)
	{
		DBGPRINT(RT_DEBUG_TRACE, ("RTMPWPANoneAddKeyProc() allocate memory failed \n"));
		Status = NDIS_STATUS_FAILURE;
		return  Status;
	}
    
	NdisZeroMemory(pKey, BufLen);
	pKey->Length = BufLen;
	pKey->KeyIndex  = 0x80000000;
	pKey->KeyLength = KeyLen;
	for (i=0; i<6; i++)
		pKey->BSSID[i] = 0xff;
        
	NdisMoveMemory(pKey->KeyMaterial, pBuf, 32);
	RTMPWPAAddKeyProc(pAd, pKey);
	os_free_mem(NULL, (PUCHAR)pKey);

	return Status;
}

static CHAR *PhyRateMode(CHAR mode)
{
    if (mode == MODE_HTGREENFIELD)
        return "Green Filed";    
	if(mode == MODE_HTMIX)
		return "Mixed Mode";
	if(mode == MODE_OFDM)
		return "OFDM";
	else
		return "CCK";
}

/* 
	==========================================================================
	Description:
		Read high throughput settings and BA
	Arguments:
		pAdapter					Pointer to our adapter
		wrq 						Pointer to the ioctl argument

	Return Value:
		None

	Note:
		Usage: 						iwpriv rausb0 get_ht
	==========================================================================
*/
VOID RTMPIoctlHtInfo(
	IN	PRTMP_ADAPTER	pAd, 
	IN	struct iwreq	*wrq)
{
	INT				Status=0;
	char			*msg;
	INT				i, j;
	UCHAR			BAWinSize=0;
	
	os_alloc_mem(NULL, (PUCHAR *)&msg, sizeof(CHAR)*(2048));
	if (msg == NULL) 
		return;

	memset(msg, 0x00, 2048);
	sprintf(msg, "\n");
	
	sprintf(msg+strlen(msg), "[HT Physical Mode]\n");
	sprintf(msg+strlen(msg), "Phy Rate Mode\t%s\n", PhyRateMode((CHAR)(pAd->MacTab.Content[BSSID_WCID].HTPhyMode.field.MODE)));
	sprintf(msg+strlen(msg), "BW\t\t%s\n", (pAd->MacTab.Content[BSSID_WCID].HTPhyMode.field.BW == BW_20) ? "20 MHz" : "20/40 MHz");
	sprintf(msg+strlen(msg), "GI\t\t%s\n", (pAd->MacTab.Content[BSSID_WCID].HTPhyMode.field.ShortGI == GI_800) ? "Long" : "Short");
	sprintf(msg+strlen(msg), "STBC\t\t%s\n", (pAd->MacTab.Content[BSSID_WCID].HTPhyMode.field.STBC == STBC_NONE) ? "None" : "Used");
	sprintf(msg+strlen(msg), "MCS\t\t%d\n", (pAd->MacTab.Content[BSSID_WCID].HTPhyMode.field.MCS));
	sprintf(msg+strlen(msg), "\n");

	sprintf(msg+strlen(msg), "[BA Table]\n");
	sprintf(msg+strlen(msg), "BA Mode\t\t%s\n", (pAd->CommonCfg.BACapability.field.AutoBA == FALSE) ? "Manual" : "Auto");


	if (pAd->MacTab.Content[BSSID_WCID].Sst == SST_ASSOC)
	{
		// Originator >>
		//
		sprintf(msg+strlen(msg),"%s\n", "Originator of");
		sprintf(msg+strlen(msg),"%-8s%-20s%-48s\n", "Aid", "MAC", "Buffer Size(TID_0 ~ TID_7)");
		for (i=0;i<MAX_LEN_OF_MAC_TABLE;i++)
		{
			PMAC_TABLE_ENTRY pEntry = &pAd->MacTab.Content[i];
			
			if ((pEntry->ValidAsCLI == TRUE) && (pEntry->TXBAbitmap))
			{
				sprintf(msg+strlen(msg),"%-8d", pEntry->Aid);
	
				sprintf(msg+strlen(msg),"%02x:%02x:%02x:%02x:%02x:%02x   ", 
						pEntry->Addr[0], pEntry->Addr[1], pEntry->Addr[2], 
						pEntry->Addr[3], pEntry->Addr[4], pEntry->Addr[5]);

				for (j=0; j < NUM_OF_TID; j++)
				{
					BAWinSize = pAd->BATable.BAOriEntry[pAd->MacTab.Content[i].BAOriWcidArray[j]].BAWinSize;
					if (pEntry->TXBAbitmap & (1 << j))
						sprintf(msg+strlen(msg),"%2d  ", BAWinSize);
					else
						sprintf(msg+strlen(msg),"%2s  ", "-");
					
					if(j == (NUM_OF_TID-1))
						sprintf(msg+strlen(msg), "\n");

				}
			}
		}
		
		// Recipient>>
		//
		sprintf(msg+strlen(msg),"%s\n", "Recipient of");
		sprintf(msg+strlen(msg),"%-8s%-20s%-48s\n", "Aid", "MAC", "Buffer Size(TID_0 ~ TID_7)");
		for (i=0;i<MAX_LEN_OF_MAC_TABLE;i++)		
		{
			PMAC_TABLE_ENTRY pEntry = &pAd->MacTab.Content[i];
			
			if ((pEntry->ValidAsCLI == TRUE) && (pEntry->RXBAbitmap))
			{
				sprintf(msg+strlen(msg),"%-8d", pEntry->Aid);
				sprintf(msg+strlen(msg),"%02x:%02x:%02x:%02x:%02x:%02x   ", 
						pEntry->Addr[0], pEntry->Addr[1], pEntry->Addr[2], 
						pEntry->Addr[3], pEntry->Addr[4], pEntry->Addr[5]);

				for (j=0; j < NUM_OF_TID; j++)
				{
					BAWinSize = pAd->BATable.BARecEntry[pAd->MacTab.Content[i].BARecWcidArray[j]].BAWinSize;
					if (pEntry->RXBAbitmap & (1 << j))
						sprintf(msg+strlen(msg),"%2d  ", BAWinSize);
					else
						sprintf(msg+strlen(msg),"%2s  ", "-");
					
					if(j == (NUM_OF_TID-1))
						sprintf(msg+strlen(msg), "\n");

				}
			}
		}
	} 

	// Copy the information into the user buffer
	DBGPRINT(RT_DEBUG_INFO, ("copy to user [msg=%s]\n", msg));
	wrq->u.data.length = strlen(msg);
	Status = copy_to_user(wrq->u.data.pointer, msg, wrq->u.data.length);
	os_free_mem(NULL, (PUCHAR)msg);
	
	DBGPRINT(RT_DEBUG_TRACE, ("<==RTMPIoctlHtInfo\n"));
}
